/* cache module for binary function on natural numbers*/
/* the cache is implemented as a two level map        */

#if VDM

is_in_cache  :  Nat0  x  Nat0  x  Map2  --> (Bool  x  [Nat0]) 
is_in_cache(x,y,c) =
  if x e dom c 
   & y e dom c(x) 
  then (TRUE ,c(x)(y)) 
  else (FALSE,NIL    )

extend_cache :  Nat0  x  Nat0  x  Nat0  x  Map2  -->  Map2
extend_cache(x,y,z,c) =
  if x e dom c
  then c + [x :-> c(x) + [y :-> z]]
  else c U [x :-> [y :-> z]]

#endif

#include "map2.h"

Bool is_in_cache(x,y,c,r) Nat0 x,y; Map2 c; Nat0 * r;
  {Map1 m1;
   return is_in_dom_map2(x,c,&m1) && is_in_dom_map1(y,m1,r);
  } 

Map2 extend_cache(x,y,z,c) Nat0 x,y,z; Map2 c;
  {Map1 m1;
   return is_in_dom_map2(x,c,&m1)
            ? ovwrt1_map2(c,x,ovwrt1_map1(m1,y,z))
            : union1_map2(c,x,mk_one_map1(y,z));
  }
