
/* import all Domains  */
#include "dir.h"

main(argc,argv)
 int argc;
 char * argv[];
{
  Str dirname,dir2name;
  Str strrep;
  Db dir,dir2;
  Bool ok;
  
  if (argc <=2 )
    {printf("usage %s <source_dir> <dest_dir>\n",argv[0]);
     exit(1);
    }
  dirname = mkc_str(argv[1]);
  dir2name = mkc_str(argv[2]);

  printf("reading database : ");pr_str(dirname);printf("\n");
  dir     = fread_db(dirname);

  printf("database content of database ");pr_str(dirname);
  printf(" is\n");/*pr_db(dir);*/

  printf("database content converterted to a Str value\n");
  strrep=cvtotupl_db(copy_db(dir));
  dir2=cvfromtupl_db(strrep);
  printf("Str value converted back to a database:\n");pr_db(dir2);

  printf("writing database into dir : ");pr_str(dir2name);printf("\n");
  ok = fwrite_db(dir2,dir2name);
  if (! ok) printf("error during writing the database\n");
  
  del_db(dir2);
  del_db(dir);
  del_str(dirname); del_str(dir2name);

  profile_db();
  profile_adt();
  profile_impl();
  profile_opr();
  profile_str();
  return 0;
}

