/* demo_tup.c --- Jan Peter Mohr --- WI 4487   */

/* Erzeugung des Pascal-Dreiecks n.ter Ordnung */
/* n ist Kommandozeilenparameter               */

/* Row = Nat1* */
/* Tri = Row * */

#include <stdio.h>
#include "jp-tup.h"

/*----------------- semantische Funktion 'mk_pascal' ----------------------*/
/* Parameter 'tri' wird zerstoert !                                        */
/* PRE: n > 2, tri == pascal(2)                                            */
/*-------------------------------------------------------------------------*/

Tri mk_pascal (tri,n)
Tri tri;
Nat1 n;
{
 Row row,last;
 int i, len;

 if (n < 3)
    return(tri);
 else {
    row = mk_one_row(1);
    len = len_tri(tri);
    last = sel_tri(tri,len);  /* bisher letzte Zeile des Dreiecks */
    for (i = 1; i < len; i++)
       row = appr_row(row,sel_row(last,i)+sel_row(last,i+1));
    
    row = appr_row(row,1); 
    tri = appr_tri(tri,row);

    return(mk_pascal(tri,n-1));
 }
} /* end of 'mk_pascal' */

int main(argc,argv) /*----------------- Hauptprogramm ---------------------*/
int argc;
char *argv[];
{
 Tri  tri;
 Row  row,row2;
 Nat0 n;

 if (argc < 2) {                                   
    printf("Geben Sie die Ordnung des Dreiecks als Parameter an !\n");
    return(1);
 }
 n = atoi(argv[1]);
 printf("\nVDM-Demo Jan Peter Mohr\n");
 printf("Erzeugung des Pascal-Dreiecks %1d.ter Ordnung\n\n",n);

 row = mk_one_row(1);                /* Zeile 1: <1> */
 tri = mk_one_tri(row);

 if (n <= 1) {
    pr_tri(tri);
    return(0);
 }
 
 row = appr_row(mk_one_row(1),1);   /* Zeile 2: <1,1> */
 tri = appr_tri(tri,row);
 if (n == 2) {
    pr_tri(tri);
    return(0);
 }
 tri = mk_pascal(tri,n);
 pr_tri(tri);
 return(0);
} /* Ende */
