// $Id: beispielstueckliste.cc,v 1.1 1996/09/19 15:46:53 vdm Exp $

#include "stueckliste.hpp"

// siehe Prolog Beispiel fr Listen: stueckliste.pl

STUECKLISTE
beispielStueckListe()
{
  STUECKLISTE s(empty);

  // einfache Teile
  s.neuesTeil("felge");
  s.neuesTeil("speichen");
  s.neuesTeil("hintererRahmen");
  s.neuesTeil("achse");
  s.neuesTeil("kugeln");
  s.neuesTeil("gabel");
  s.neuesTeil("klingel");
  s.neuesTeil("griff");
  s.neuesTeil("bremsgriff");
  s.neuesTeil("bremsbacken");
  s.neuesTeil("rohr");
  s.neuesTeil("zahnkranz");

  // zusammengesetzte Teile
  s.neuesBestandTeil("fahrrad","rad",1);
  s.neuesBestandTeil("fahrrad","hinterrad",1);
  s.neuesBestandTeil("fahrrad","rahmen",1);
  s.neuesBestandTeil("rad","speichen",20);
  s.neuesBestandTeil("rad","felge",1);
  s.neuesBestandTeil("rad","nabe",1);
  s.neuesBestandTeil("hinterrad","rad",1);
  s.neuesBestandTeil("hinterrad","zahnkranz",7);
  s.neuesBestandTeil("nabe","achse",1);
  s.neuesBestandTeil("nabe","lager",2);
  s.neuesBestandTeil("lager","kugeln",12);
  s.neuesBestandTeil("rahmen","hintererRahmen",1);
  s.neuesBestandTeil("rahmen","vordererRahmen",1);
  s.neuesBestandTeil("vordererRahmen","gabel",1);
  s.neuesBestandTeil("vordererRahmen","lenker",1);
  s.neuesBestandTeil("vordererRahmen","bremse",1);
  s.neuesBestandTeil("hintererRahmen","bremse",1);
  s.neuesBestandTeil("hintererRahmen","sattel",1);
  s.neuesBestandTeil("lenker","klingel",1);
  s.neuesBestandTeil("lenker","griff",2);
  s.neuesBestandTeil("lenker","rohr",1);
  s.neuesBestandTeil("bremse","bremsgriff",1);
  s.neuesBestandTeil("bremse","bremsbacken",2);
  s.neuesBestandTeil("kette","kette",1);		// inkonsistente Eintrge
  s.neuesBestandTeil("kette","kettenglied",56);
  s.neuesBestandTeil("kettenglied","kette",1);

  return s;
}

STUECKLISTE
beispielKonsistenteStueckListe()
{
  STUECKLISTE s = beispielStueckListe();

  s -= TEILENR("kette");
  s -= TEILENR("kettenglied");

  s.neuesTeil("sattel");

  return s;
}

