/*----------------------------------------------------------------------*/

/* Modul:                  @(#)tool.h */
/* Version:                2.1 */
/* Ersteller:              Gerrit Petrich, WI 8215, WS 93 */
/* Datum der letzten */
/* Aenderung:              93/03/29 */

/*----------------------------------------------------------------------*/

/* Aufgabe:   "tool.h" ist der Header fuer die Einfuege- und Loesch-*/
/*            funktionen der VDM-Klassenbibliothek. */

/*----------------------------------------------------------------------*/

/* Aenderungen: */
/* wann:                 warum: */
/*----------------------------------------------------------------------*/

#ifndef TOOL
#define TOOL

#include "gen.h"
#include "proto.h"

extern unsigned char gptrace;

Bool write_Vdmdb H2(Vdmdbname,Vdmdb);

Vdmdb create_Vdmdb H1(Vdmdbname);
Vdmdb create_Adt H2(Vdmdbname,Adtname);
Vdmdb create_Impl H3(Vdmdbname,Adtname,Implname);
Vdmdb create_Operation H4(Vdmdbname,Adtname,Implname,Opname);
Vdmdb insert_Component H6(Vdmdbname,Adtname,Implname,Opname,Compname,Component);

Bool rm_Component H5(Vdmdbname,Adtname,Implname,Opname,Compname);
Bool rm_Operation H4(Vdmdbname,Adtname,Implname,Opname);
Bool rm_Impl H3(Vdmdbname,Adtname,Implname);
Bool rm_Adt H2(Vdmdbname,Adtname);
Bool rm_Vdmdb H1(Vdmdbname);

#endif

