#include "gen1.h"
#ifndef VDM_header_tmp
#define VDM_header_tmp


/* ------- PHASE1 ------------------ */
/*
module generated from VDM Class Library
$Revision: 1.100 $
$Date: 1996/09/18 13:13:42 $
*/
typedef struct Struct_crossref * Crossref;
typedef struct Struct_rootvals * Rootvals;
typedef struct Struct_params * Params;
typedef struct Struct_depend * Depend;
typedef struct Struct_elems * Elems;
typedef struct Struct_operations * Operations;
typedef struct Struct_dependgraph * Dependgraph;
typedef struct Struct_dominfo * Dominfo;

/* ------- PHASE2 ------------------ */
struct Struct_info {

Str f_defined;

Nat0 f_line;

};

typedef struct Struct_info Info;

struct Struct_crossref {
Crossref f_next;
Str f_info;
Info f_attr;
};

struct Struct_fileval {

Str f_fdomain;

Str f_fconstr;

Str f_fimplid;

Str f_foperationid;

Nat0 f_lines;

Nat0 f_linenr;

};

typedef struct Struct_fileval Fileval;

struct Struct_rootvals {
Rootvals f_next;
Fileval f_info;

};

struct Struct_params {
Params f_next;
Str f_info;
Str f_attr;
};

extern Cvtext_vdmlib cvlines3_params_str_str ( Str x1, Str x2 ) ;
typedef Str Implid;

struct Struct_depend {
Depend f_next;
Str f_info;

};

#define cvlines2_depend(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_elems {
Elems f_next;
Str f_info;

};

#define cvlines2_elems(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_domain {

Str f_constr;

Elems f_elems;

Depend f_depend;

};

typedef struct Struct_domain Domain;

#define cvlines2_domain(x1,x2) cvlines2_vdmlib(x1,x2)
#define Comments Params

struct Struct_operations {
Operations f_next;
Str f_info;
Params f_attr;
};

extern Cvtext_vdmlib cvlines3_operations_str_params ( Str x1, Params x2 ) ;
struct Struct_implementation {

Implid f_implid;

Params f_iparams;

Operations f_operations;

};

typedef struct Struct_implementation Implementation;

#define cvlines2_implementation(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_dependgraph {
Dependgraph f_next;
Str f_info;
Depend f_attr;
};

extern Cvtext_vdmlib cvlines3_dependgraph_str_depend ( Str x1, Depend x2 ) ;
struct Struct_description {

Domain f_domain;

Implementation f_implem;

};

typedef struct Struct_description Description;

#define cvlines2_description(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_dominfo {
Dominfo f_next;
Str f_info;
Description f_attr;
};

extern Cvtext_vdmlib cvlines3_dominfo_str_description ( Str x1, Description x2 ) ;

/* ------- PHASE3 ------------------ */
extern Crossref alloc_crossref ( void );
extern void free_crossref ( Crossref x1 );

#define ref_crossref(x1) (x1)

#define profile_crossref()

extern Rootvals alloc_rootvals ( void );
extern void free_rootvals ( Rootvals x1 );

#define ref_rootvals(x1) (x1)

#define profile_rootvals()

extern Operations alloc_operations ( void );
extern void free_operations ( Operations x1 );

#define ref_operations(x1) (x1)

#define profile_operations()

extern Params alloc_params ( void );
extern void free_params ( Params x1 );

#define ref_params(x1) (x1)

#define profile_params()

extern Dependgraph alloc_dependgraph ( void );
extern void free_dependgraph ( Dependgraph x1 );

#define ref_dependgraph(x1) (x1)

#define profile_dependgraph()

extern Depend alloc_depend ( void );
extern void free_depend ( Depend x1 );

#define ref_depend(x1) (x1)

#define profile_depend()

extern Elems alloc_elems ( void );
extern void free_elems ( Elems x1 );

#define ref_elems(x1) (x1)

#define profile_elems()

extern Dominfo alloc_dominfo ( void );
extern void free_dominfo ( Dominfo x1 );

#define ref_dominfo(x1) (x1)

#define profile_dominfo()

extern Bool is_eq_info ( Info x1 , Info x2 );
extern Info mk_info

(

Str x1_defined
,
Nat0 x1_line

)

;
extern Bool is_in_dom_crossref ( Str x1 , Crossref x2 , Info *x3 );
extern Crossref union1_crossref ( Crossref x1 , Str x2 , Info x3 );
extern Bool is_in_crossref ( Str x1 , Crossref x2 );
extern Crossref mk1_crossref ( Str x1 , Info x2 );
extern Fileval mk_fileval

(

Str x1_fdomain
,
Str x1_fconstr
,
Str x1_fimplid
,
Str x1_foperationid
,
Nat0 x1_lines
,
Nat0 x1_linenr

)

;
extern void del_fileval ( Fileval x1 );
extern Rootvals conc_rootvals ( Rootvals x1 , Rootvals x2 );
extern Nat0 len_rootvals ( Rootvals x1 );
extern Fileval sel_rootvals ( Rootvals x1 , Nat1 x2 );
extern Rootvals mk1_rootvals ( Fileval x1 );
extern void del_rootvals ( Rootvals x1 );

extern Cvtext_vdmlib cvlines1_params ( Params x1 );

extern Bool is_submap_params ( Params x1 , Params x2 );
extern Params ovwrt1d_params ( Params x1 , Str x2 , Str x3 );

extern Params copy_params ( Params x1 );
extern Params sub1d_params ( Params x1 , Str x2 );
extern Params union1d_params ( Params x1 , Str x2 , Str x3 );
extern Params ovwrt_params ( Params x1 , Params x2 );

extern Params merge_params ( Params x1 , Params x2 );

extern Bool is_domsubmap_params ( Params x1 , Params px1 );

extern Params ovwrt1_params ( Params x1 , Str x2 , Str x3 );
extern Params union_params ( Params x1 , Params x2 );
extern Str sel_params ( Params x1 , Str x2 );
extern Params mk1_params ( Str x1 , Str x2 );
extern Params sub1_params ( Params x1 , Str x2 );
extern Params union1_params ( Params x1 , Str x2 , Str x3 );
extern Bool is_in_params ( Str x1 , Params x2 );
extern Bool is_in_dom_params ( Str x1 , Params x2 , Str *x3 );

extern Str gen_params ( Params x1 );

extern void del_params ( Params x1 );
extern Params uniond_params ( Params x1 , Params x2 );
extern Params ovwrtd_params ( Params x1 , Params x2 );

extern Bool is_eq_params ( Params x1 , Params x2 );
extern Nat0 card_params ( Params x1 );
extern Cvtext_vdmlib cvlines_params ( Params x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Cvtext_vdmlib cvlines_implid ( Implid x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Bool is_opt_implid ( Implid x1 , Str *x2 );
extern Bool is_eq_implid ( Implid x1 , Implid x2 );
extern void del_implid ( Implid x1 );
extern Implid copy_implid ( Implid x1 );

extern Cvtext_vdmlib cvlines1_depend ( Depend x1 );

extern Cvtext_vdmlib cvlines_depend ( Depend x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Depend copy_depend ( Depend x1 );
extern void del_depend ( Depend x1 );
extern Bool is_in_depend ( Str x1 , Depend x2 );
extern Depend union1_depend ( Depend x1 , Str x2 );

extern Nat0 card_depend ( Depend x1 );

extern Depend intersd_depend ( Depend x1 , Depend x2 );
extern Depend diff_depend ( Depend x1 , Depend x2 );
extern Str sel_depend ( Depend x1 );

extern Bool is_domsub_depend ( Depend x1 );

extern Bool is_indomforward_depend ( Depend x1 , Depend px1 , Dominfo px2 );

extern Depend gen_deps_depend ( Depend x1 , Dominfo px1 );

extern Bool cyclic_dep_depend ( Depend x1 , Dominfo px1 );

typedef Str (*_T2cv_coll_depends_depend) ( Str y1    );
extern Str coll_depends_depend ( Depend x1 , _T2cv_coll_depends_depend Pvcvfct );

extern Str gen_depend ( Depend x1 , Str px1 );

extern Bool is_subset_depend ( Depend x1 , Depend x2 );
extern Depend union_depend ( Depend x1 , Depend x2 );
extern Depend mk1_depend ( Str x1 );
extern Depend diffd_depend ( Depend x1 , Depend x2 );
extern Depend sub1_depend ( Depend x1 , Str x2 );

extern Str make_print_depend ( Depend x1 );

extern Bool gen_order1_depend ( Depend x1 , Dominfo px1 );

extern Str tofile_depend ( Depend x1 );

extern Bool gen_order2_depend ( Depend x1 , Dominfo px1 );

extern Str coll_includes_depend ( Depend x1 , Str px1 );

extern Elems sort_depend ( Depend x1 );

extern Depend uniond_depend ( Depend x1 , Depend x2 );
extern Depend copy1_depend ( Depend x1 );

#ifdef __cplusplus
extern void fpr_depend ( ostream & x1 , Depend x2 );
#else
extern void fpr_depend ( FILE *x1 , Depend x2 );
#endif

#define mk_one_depend mk1_depend
extern Bool is_eq_depend ( Depend x1 , Depend x2 );
extern Depend sub1d_depend ( Depend x1 , Str x2 );
extern Depend union1d_depend ( Depend x1 , Str x2 );

extern Cvtext_vdmlib cvlines1_elems ( Elems x1 );

extern Bool is_eq_elems ( Elems x1 , Elems x2 );
extern Elems copy1_elems ( Elems x1 );
extern Elems insert_elems ( Elems x1 , Nat1 x2 , Str x3 );
extern Elems rmv1d_elems ( Elems x1 , Nat1 x2 );

extern Elems copy_elems ( Elems x1 );
extern Nat0 index_elems ( Elems x1 , Str x2 );

extern Params get_tree_elems ( Elems x1 , Str px1 );

extern Str gen_tree_elems ( Elems x1 , Str px1 );

extern Depend get_unique_elems ( Elems x1 , Str px1 );

extern Dominfo mk_sig_dominfo_elems ( Elems x1 , Elems px1 , Elems px2 , Str px3 );

extern Depend get_elems ( Elems x1 , Str px1 );

extern Str gen_fct_elems ( Elems x1 , Nat0 px1 );

extern Params get_fct_elems ( Elems x1 , Nat1 px1 );

extern Elems sub_tupd_elems ( Elems x1 , Nat1 x2 , Nat0 x3 );
extern Elems mk1_elems ( Str x1 );
extern Elems conc_elems ( Elems x1 , Elems x2 );
extern void del_elems ( Elems x1 );
extern Str sel_elems ( Elems x1 , Nat1 x2 );

extern Params get_union_elems ( Elems x1 );

extern Str gen_union_elems ( Elems x1 , Str px1 );

extern Depend make_elems ( Elems x1 );

extern Str make_cyc_elems ( Elems x1 );

extern Str gen_tokuni_elems ( Elems x1 , Nat0 px1 );

extern Str get_tokuni_elems ( Elems x1 , Nat1 px1 );

#define elems_elems_str(x1) mk_one_depend(copy_str(x1))

extern Depend elems_elems ( Elems x1 );

#define ran_elems elems_elems
extern Nat0 len_elems ( Elems x1 );
#ifdef __cplusplus
extern void fpr_elems ( ostream & x1 , Elems x2 );
#else
extern void fpr_elems ( FILE *x1 , Elems x2 );
#endif
typedef void (* T2_forindex_elems) ( Str y1, Nat1 y2 ) ;
extern void forindex_elems ( Elems x1, T2_forindex_elems x2 ) ;
extern Cvtext_vdmlib cvlines_elems ( Elems x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Elems sub_tup_elems ( Elems x1 , Nat1 x2 , Nat0 x3 );

extern Cvtext_vdmlib cvlines1_domain ( Domain x1 );

extern Bool is_eq_domain ( Domain x1 , Domain x2 );
extern Domain mk_domain

(

Str x1_constr
,
Elems x1_elems
,
Depend x1_depend

)

;
extern void smk_domain

(
Domain x1,

Str *x1_constr
,
Elems *x1_elems
,
Depend *x1_depend

)

;
extern void del_domain ( Domain x1 );
extern Domain copy_domain ( Domain x1 );
extern Cvtext_vdmlib cvlines_domain ( Domain x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#define is_in_dom_comments is_in_dom_params
#define sub1d_comments sub1d_params
#define mk_empty_comments mk_empty_params
#define ovwrt1_comments ovwrt1_params
#define union1_comments union1_params

extern Cvtext_vdmlib cvlines1_operations ( Operations x1 );

extern Operations copy_operations ( Operations x1 );
extern void del_operations ( Operations x1 );
extern Operations sub1_operations ( Operations x1 , Str x2 );
extern Bool is_in_dom_operations ( Str x1 , Operations x2 , Params *x3 );
extern Operations sub1d_operations ( Operations x1 , Str x2 );
extern Operations union1d_operations ( Operations x1 , Str x2 , Params x3 );
extern Params sel_operations ( Operations x1 , Str x2 );

extern Operations update_alias_operations ( Operations x1 , Operations x2 );

extern Operations select_constructors_operations ( Operations x1 , Operations x2 );
extern Operations ovwrt1d_operations ( Operations x1 , Str x2 , Params x3 );
extern Operations mk1_operations ( Str x1 , Params x2 );
extern Operations copy1_operations ( Operations x1 );
extern Operations subd_operations ( Operations x1 , Operations x2 );

extern Operations merge_operations ( Operations x1 , Operations x2 );

extern Str gen_operations ( Operations x1 );

extern Bool is_submap_operations ( Operations x1 , Operations x2 );
extern Operations sub_operations ( Operations x1 , Operations x2 );
extern Nat0 card_operations ( Operations x1 );
extern Bool is_eq_operations ( Operations x1 , Operations x2 );
extern Cvtext_vdmlib cvlines_operations ( Operations x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Cvtext_vdmlib cvlines1_implementation ( Implementation x1 );

extern Bool is_eq_implementation ( Implementation x1 , Implementation x2 );
extern Implementation mk_implementation

(

Implid x1_implid
,
Params x1_iparams
,
Operations x1_operations

)

;
extern void smk_implementation

(
Implementation x1,

Implid *x1_implid
,
Params *x1_iparams
,
Operations *x1_operations

)

;
extern void del_implementation ( Implementation x1 );
extern Implementation copy_implementation ( Implementation x1 );
extern Cvtext_vdmlib cvlines_implementation ( Implementation x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Cvtext_vdmlib cvlines1_dependgraph ( Dependgraph x1 );

extern Cvtext_vdmlib cvlines_dependgraph ( Dependgraph x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#ifdef __cplusplus
extern void fpr_dependgraph ( ostream & x1 , Dependgraph x2 );
#else
extern void fpr_dependgraph ( FILE *x1 , Dependgraph x2 );
#endif
extern Dependgraph copy_dependgraph ( Dependgraph x1 );
extern Dependgraph union1_dependgraph ( Dependgraph x1 , Str x2 , Depend x3 );
extern Dependgraph ovwrt1d_dependgraph ( Dependgraph x1 , Str x2 , Depend x3 );
extern Depend sel_dependgraph ( Dependgraph x1 , Str x2 );
extern Dependgraph sub1d_dependgraph ( Dependgraph x1 , Str x2 );
extern Dependgraph ovwrt1_dependgraph ( Dependgraph x1 , Str x2 , Depend x3 );
extern void del_dependgraph ( Dependgraph x1 );
extern Dependgraph mk1_dependgraph ( Str x1 , Depend x2 );
extern Dependgraph union1d_dependgraph ( Dependgraph x1 , Str x2 , Depend x3 );
extern Bool is_in_dom_dependgraph ( Str x1 , Dependgraph x2 , Depend *x3 );

#define dom_dependgraph_str_depend(x1,x2) mk_one_depend(x1)

extern Depend dom_dependgraph ( Dependgraph x1 );

extern Bool is_in_dependgraph ( Str x1 , Dependgraph x2 );
extern Dependgraph sub1_dependgraph ( Dependgraph x1 , Str x2 );
extern Dependgraph copy1_dependgraph ( Dependgraph x1 );

extern Cvtext_vdmlib cvlines1_description ( Description x1 );

extern Bool is_eq_description ( Description x1 , Description x2 );
extern void del_description ( Description x1 );
extern Description mk_description

(

Domain x1_domain
,
Implementation x1_implem

)

;
extern Description copy_description ( Description x1 );
extern Cvtext_vdmlib cvlines_description ( Description x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Cvtext_vdmlib cvlines1_dominfo ( Dominfo x1 );

extern Dominfo ovwrt1_dominfo ( Dominfo x1 , Str x2 , Description x3 );
extern Nat0 card_dominfo ( Dominfo x1 );

extern Dominfo union1_dominfo ( Dominfo x1 , Str x2 , Description x3 );

extern Dominfo copy_dominfo ( Dominfo x1 );
extern Bool is_in_dom_dominfo ( Str x1 , Dominfo x2 , Description *x3 );
extern Bool is_in_dominfo ( Str x1 , Dominfo x2 );

extern Dominfo del_predef_dominfo ( Dominfo x1 , Dominfo x2 );

extern Str gen_domain_dominfo ( Dominfo x1 , Str px1 );

extern Bool complete_depends_dominfo ( Dominfo x1 );

extern Bool is_enriched_by_dominfo ( Dominfo x1 , Dominfo px1 );

extern Bool domain_check_dominfo ( Dominfo x1 );

extern Str gen_includes_dominfo ( Dominfo x1 , Str px1 );

extern Dominfo diff_dominfo ( Dominfo x1 , Dominfo x2 );
extern Dominfo union1d_dominfo ( Dominfo x1 , Str x2 , Description x3 );
extern Dominfo intersd_dominfo ( Dominfo x1 , Dominfo x2 );
extern Dominfo sub1_dominfo ( Dominfo x1 , Str x2 );
extern Dominfo mk1_dominfo ( Str x1 , Description x2 );
extern Dominfo ovwrt_dominfo ( Dominfo x1 , Dominfo x2 );
extern Description sel_dominfo ( Dominfo x1 , Str x2 );
extern Dominfo ovwrt1d_dominfo ( Dominfo x1 , Str x2 , Description x3 );

#define dom_dominfo_str_description(x1,x2) mk_one_depend(x1)

extern Depend dom_dominfo ( Dominfo x1 );

extern Dominfo update_alias_dominfo ( Dominfo x1 , Dominfo x2 );

extern Str gen_implementation_dominfo ( Dominfo x1 , Str px1 );

extern Bool nounique_elems_dominfo ( Dominfo x1 , Dominfo px1 );

extern Depend unique_elems_dominfo ( Dominfo x1 );

extern Bool casesen_domid_dominfo ( Dominfo x1 , Dominfo px1 );

extern Dominfo add_constructors_for_isa_dominfo ( Dominfo x1 , Dominfo x2 );

extern Dominfo merge_dominfo ( Dominfo x1 , Dominfo x2 );
extern Dominfo sub1d_dominfo ( Dominfo x1 , Str x2 );
extern Bool is_eq_dominfo ( Dominfo x1 , Dominfo x2 );
extern void del_dominfo ( Dominfo x1 );
extern Dominfo copy1_dominfo ( Dominfo x1 );
extern Dominfo union_dominfo ( Dominfo x1 , Dominfo x2 );
#ifdef __cplusplus
extern void fpr_dominfo ( ostream & x1 , Dominfo x2 );
#else
extern void fpr_dominfo ( FILE *x1 , Dominfo x2 );
#endif

typedef Bool (*_T2cv_exist_dominfo) ( Str y1, Description y2    );
extern Bool exist_dominfo ( Dominfo x1 , _T2cv_exist_dominfo Pvcvfct );

typedef Bool (*_T2cv_all_dominfo) ( Str y1, Description y2    );
extern Bool all_dominfo ( Dominfo x1 , _T2cv_all_dominfo Pvcvfct );

extern Bool is_submap_dominfo ( Dominfo x1 , Dominfo x2 );

extern Cvtext_vdmlib cvlines_dominfo ( Dominfo x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

/* ------- PHASE4 ------------------ */
#define forall_dominfo(x1,x2){Dominfo _x1=x1;for(;_x1!=(Dominfo)0;_x1=_x1->f_next) x2(ref_dominfo(_x1)->f_info,_x1->f_attr);}
#define mk_empty_dominfo() ((Dominfo)0)
#define is_empty_dominfo(x1) (! (x1))
#ifdef __cplusplus
#define pr_dominfo(x1) fpr_dominfo(cout,x1)
#else
#define pr_dominfo(x1) fpr_dominfo(stdout,x1)
#endif
#define sel_dom_dominfo(x1) ((ref_dominfo(x1))->f_info)
#define del1_dominfo(x1) {Dominfo _y1=x1;while (_y1!=(Dominfo)0) {Dominfo _x1=_y1;_y1=ref_dominfo(_y1)->f_next;free_dominfo(_x1);}}
#define del1_description(x1)

#define s_domain(x) (x).f_domain

#define s_implem(x) (x).f_implem

#define del1_domain(x1)

#define s_constr(x) (x).f_constr

#define s_elems(x) (x).f_elems

#define s_depend(x) (x).f_depend

#define del1_elems(x1) {Elems _y1=x1;while (_y1!=(Elems)0) {Elems _x1=_y1;_y1=ref_elems(_y1)->f_next;free_elems(_x1);}}
#define mk2_elems(x1,x2) appr_elems(mk1_elems(x1),x2)
#define tld_elems(x1) rmv1d_elems(x1,1)
#define hd_elems(x1) sel_elems(x1,(Nat1)1)
#define appr_elems(x1,x2) conc_elems(x1,mk1_elems(x2))
#ifdef __cplusplus
#define pr_elems(x1) fpr_elems(cout,x1)
#else
#define pr_elems(x1) fpr_elems(stdout,x1)
#endif
#define last_elems(x1) sel_elems(x1,(Nat1)(len_elems(x1)))
#define appl_elems(x1,x2) conc_elems(mk1_elems(x1),x2)
#define mk_empty_elems() ((Elems)0)

#define forall_elems(x1,x2){Elems _x1=x1;for(;_x1!=(Elems)0;_x1=_x1->f_next) x2(ref_elems(_x1)->f_info);}
#define is_empty_elems(x1) (! (x1))
#define mk_empty_depend() ((Depend)0)
#define del1_depend(x1) {Depend _y1=x1;while (_y1!=(Depend)0) {Depend _x1=_y1;_y1=ref_depend(_y1)->f_next;free_depend(_x1);}}
#ifdef __cplusplus
#define pr_depend(x1) fpr_depend(cout,x1)
#else
#define pr_depend(x1) fpr_depend(stdout,x1)
#endif
#define is_empty_depend(x1) (! (x1))

#define forall_depend(x1,x2){Depend _x1=x1;for(;_x1!=(Depend)0;_x1=_x1->f_next) x2(ref_depend(_x1)->f_info);}
#ifdef __cplusplus
#define pr_dependgraph(x1) fpr_dependgraph(cout,x1)
#else
#define pr_dependgraph(x1) fpr_dependgraph(stdout,x1)
#endif
#define del1_dependgraph(x1) {Dependgraph _y1=x1;while (_y1!=(Dependgraph)0) {Dependgraph _x1=_y1;_y1=ref_dependgraph(_y1)->f_next;free_dependgraph(_x1);}}
#define mk_empty_dependgraph() ((Dependgraph)0)

#define forall_dependgraph(x1,x2){Dependgraph _x1=x1;for(;_x1!=(Dependgraph)0;_x1=_x1->f_next) x2(ref_dependgraph(_x1)->f_info,_x1->f_attr);}
#define is_empty_dependgraph(x1) (! (x1))
#define del1_implementation(x1)

#define s_implid(x) (x).f_implid

#define s_iparams(x) (x).f_iparams

#define s_operations(x) (x).f_operations

#define s_str_implid(x1) (x1)
#define mk_nil_implid() ((Implid)0)
#define is_nil_implid(x1) (! (x1))
#define mk_opt_implid(x1) (x1)
#define del1_implid(x1)
#define del1_params(x1) {Params _y1=x1;while (_y1!=(Params)0) {Params _x1=_y1;_y1=ref_params(_y1)->f_next;free_params(_x1);}}
#define sel_dom_params(x1) ((ref_params(x1))->f_info)
#define is_empty_params(x1) (! (x1))
#define mk_empty_params() ((Params)0)

#define forall_params(x1,x2){Params _x1=x1;for(;_x1!=(Params)0;_x1=_x1->f_next) x2(ref_params(_x1)->f_info,_x1->f_attr);}
#define mk_empty_operations() ((Operations)0)
#define is_empty_operations(x1) (! (x1))
#define sel_dom_operations(x1) ((ref_operations(x1))->f_info)
#define del1_operations(x1) {Operations _y1=x1;while (_y1!=(Operations)0) {Operations _x1=_y1;_y1=ref_operations(_y1)->f_next;free_operations(_x1);}}

#define forall_operations(x1,x2){Operations _x1=x1;for(;_x1!=(Operations)0;_x1=_x1->f_next) x2(ref_operations(_x1)->f_info,_x1->f_attr);}

#define forall_rootvals(x1,x2){Rootvals _x1=x1;for(;_x1!=(Rootvals)0;_x1=_x1->f_next) x2(ref_rootvals(_x1)->f_info);}
#define mk_empty_rootvals() ((Rootvals)0)
#define is_empty_rootvals(x1) (! (x1))
#define appr_rootvals(x1,x2) conc_rootvals(x1,mk1_rootvals(x2))
#define del1_rootvals(x1) {Rootvals _y1=x1;while (_y1!=(Rootvals)0) {Rootvals _x1=_y1;_y1=ref_rootvals(_y1)->f_next;free_rootvals(_x1);}}
#define del1_fileval(x1)

#define s_fdomain(x) (x).f_fdomain

#define s_fconstr(x) (x).f_fconstr

#define s_fimplid(x) (x).f_fimplid

#define s_foperationid(x) (x).f_foperationid

#define s_lines(x) (x).f_lines

#define s_linenr(x) (x).f_linenr

#define mk_empty_crossref() ((Crossref)0)

#define s_defined(x) (x).f_defined

#define s_line(x) (x).f_line

#endif
