/*----------------------------------------------------------------------*/

/* Modulname: @(#)domdb.h	2.1 */

/* Aufgabe  : Deklarationsdatei fuer domdb.c */

/*----------------------------------------------------------------------*/
/* Parameter */

/* Eingabe  : */

/* Ausgabe  : */

/*----------------------------------------------------------------------*/

/* Ersteller: Kai Steinau */

/* Datum letzte Bearbeitung: @(#) */

/*----------------------------------------------------------------------*/

/* Aenderungen: 93/02/11: Include-Direktive fuer dbs.h ohne Pfadname */

/*----------------------------------------------------------------------*/

#ifndef DOMDB
#define DOMDB

#include "dbs.h"

Str    define H2(Str, Params);
Str    undefine H2(Str, Params);
Str    include H6(Str, Str, Str, Str, Str, Str);
Str    get_component H4(Str, Implid, Str, Str);
Str    get_adttype H1(Str);
Str    get_signature H3(Str, Str, Str);
Bool   exists_component H4(Str, Implid, Str, Str);
Bool   exists_operation H3(Str, Implid, Str);
Bool   exists_implementation H2(Str, Implid);
Bool   exists_adt H1(Str);
Bool   is_in_components H2(Str, Str);
Params get_params H3(Str, Str, Str);
Params get_all_params H3(Str, Str, Str);
Bool   param_defined H3(Str,Str,Dominfo);
Bool   is_forward_allowed H2(Str,Dominfo);

Bool   open_vdmdb H1(Str);
void   delete_vdmdb H0();

extern Vdmdbs vdmdbs;

#endif
