/* $Id: ppid.c,v 1.1 1996/09/05 07:03:26 vdm Exp $ */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include "proto.h"

int Tcl_ppidCmd(ClientData clientData,Tcl_Interp *interp,int argc,char *argv[])
{
    pid_t pid;
    
    if (argc != 1) {
	interp->result = "wrong # args";
	return TCL_ERROR;
    }
	
    if ((pid = getppid()) == -1) {
	Tcl_PosixError(interp); 
	return TCL_ERROR;
    } 
    sprintf(interp->result, "%d", pid);
    return TCL_OK;
}

