#ifndef _TCL_CMDS_PROTO_H
#define _TCL_CMDS_PROTO_H

#include <tcl.h>

int Tcl_daemonCmd(ClientData,Tcl_Interp*,int,char **);
int Tcl_reopenCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_dupCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_forkCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_reapCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_pipeCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_nottyCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl__exitCmd(ClientData,Tcl_Interp*,int,char**);
void Tcl_killCmdInit();
int Tcl_killCmd(ClientData,Tcl_Interp*,int,char**);
void Tcl_signalCmdInit();
int Tcl_signalCmd(ClientData,Tcl_Interp*,int,char**);
void Tcl_signalCmdDone();
int Tcl_setpgrpCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_waitCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_waitpidCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_vtCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_ppidCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_watchdogCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_debugCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_getuidCmd(ClientData,Tcl_Interp*,int,char**);
int Tcl_getgidCmd(ClientData,Tcl_Interp*,int,char**);

#endif /* _TCL_CMDS_PROTO_H */

