#include <unistd.h>
#include "proto.h"
#include "systype.h"

int Tcl_setpgrpCmd(ClientData clientData,Tcl_Interp *interp,int argc,char *argv[])
{
    if (argc != 1) {
	interp->result = "wrong # args";
	return TCL_ERROR;
    }

    if
#ifdef BSD 
	   (setpgrp(0,getpid()) == -1)
#else /* SYS5 */
	   (setpgrp() == -1)
#endif
	{
	    Tcl_PosixError(interp);
	    return TCL_ERROR;
	}
	
    return TCL_OK;
}

