#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h> 
#include <tcl.h>
#include "proto.h"

int Tcl_waitCmd(ClientData clientData,Tcl_Interp *interp,int argc,char *argv[])
{
    int status;
    pid_t pid;
		
    if (argc != 1) {
	interp->result = "wrong # args";
	return TCL_ERROR;
    }

    pid=wait(&status); 
    sprintf(interp->result, "%d", pid);  
    return TCL_OK;
}

