#if __cplusplus
#include "dbm.hpp"
#else
#include "dbm.h"
#endif

/*LINTLIBRARY*/

#define C_implementation_file

/*
module generated from VDM Class Library
$Revision: 1.100 $
$Date: 1996/09/18 13:13:42 $
*/

Rep_contextmap alloc_rep_contextmap (void)
{Rep_contextmap x1; x1 = (Rep_contextmap)0;
while (! (x1 = (Rep_contextmap)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_rep_contextmap");
;
;
return x1;
}

void free_rep_contextmap (Rep_contextmap x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Rep_context alloc_rep_context (void)
{Rep_context x1; x1 = (Rep_context)0;
while (! (x1 = (Rep_context)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_rep_context");
;
;
return x1;
}

void free_rep_context (Rep_context x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Rep_vdmdb alloc_rep_vdmdb (void)
{Rep_vdmdb x1; x1 = (Rep_vdmdb)0;
while (! (x1 = (Rep_vdmdb)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_rep_vdmdb");
;
;
return x1;
}

void free_rep_vdmdb (Rep_vdmdb x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Rep_adt alloc_rep_adt (void)
{Rep_adt x1; x1 = (Rep_adt)0;
while (! (x1 = (Rep_adt)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_rep_adt");
;
;
return x1;
}

void free_rep_adt (Rep_adt x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Rep_impl alloc_rep_impl (void)
{Rep_impl x1; x1 = (Rep_impl)0;
while (! (x1 = (Rep_impl)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_rep_impl");
;
;
return x1;
}

void free_rep_impl (Rep_impl x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Rep_operation alloc_rep_operation (void)
{Rep_operation x1; x1 = (Rep_operation)0;
while (! (x1 = (Rep_operation)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_rep_operation");
;
;
return x1;
}

void free_rep_operation (Rep_operation x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Rep_strings alloc_rep_strings (void)
{Rep_strings x1; x1 = (Rep_strings)0;
while (! (x1 = (Rep_strings)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_rep_strings");
;
;
return x1;
}

void free_rep_strings (Rep_strings x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Rep_stringl alloc_rep_stringl (void)
{Rep_stringl x1; x1 = (Rep_stringl)0;
while (! (x1 = (Rep_stringl)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_rep_stringl");
;
;
return x1;
}

void free_rep_stringl (Rep_stringl x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

static Nat0 len_mfree_str = 0;

static Nat0 cnt_alloc_str = 0;
static Nat0 cnt_free_str = 0;
static Nat0 cnt_mallc_str = 0;
static Nat0 cnt_mfree_str = 0;

void profile_str (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Str");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_str);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_str);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_str);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_str);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_str);
fprintf(stderr,"\n");
}

static VOIDptr freelist_str = (VOIDptr)0;

Str alloc_str (void)
{Str x1;
cnt_alloc_str ++;
if (! freelist_str)
{while (! (x1 = (Str)ALLOCMEM_vdmlib(sizeof(struct Handle_str)))) heap_oflw_vdmlib("Heap_str");
cnt_mallc_str ++;
return x1;
}
freelist_str = *((VOIDptr *)(x1 = (Str) freelist_str));
len_mfree_str --;
return x1;
}

void free_str (Str x1)
{len_mfree_str ++;
cnt_free_str ++;
*((VOIDptr *)x1) = freelist_str;
freelist_str = (VOIDptr)x1;
if (len_mfree_str > 100)
{while (len_mfree_str > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_str);
FREEMEM_vdmlib(freelist_str,sizeof(struct Handle_str));
freelist_str = lx1;
len_mfree_str --;
cnt_mfree_str ++;
}
}
}

#if __cplusplus
NILETC empty, nil, new_val;
#endif

static Nat0 len_mfree_contextmap = 0;

static Nat0 cnt_alloc_contextmap = 0;
static Nat0 cnt_free_contextmap = 0;
static Nat0 cnt_mallc_contextmap = 0;
static Nat0 cnt_mfree_contextmap = 0;

void profile_contextmap (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","ContextMap");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_contextmap);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_contextmap);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_contextmap);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_contextmap);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_contextmap);
fprintf(stderr,"\n");
}

static VOIDptr freelist_contextmap = (VOIDptr)0;

ContextMap alloc_contextmap (void)
{ContextMap x1;
cnt_alloc_contextmap ++;
if (! freelist_contextmap)
{while (! (x1 = (ContextMap)ALLOCMEM_vdmlib(sizeof(struct Handle_contextmap)))) heap_oflw_vdmlib("Heap_contextmap");
cnt_mallc_contextmap ++;
return x1;
}
freelist_contextmap = *((VOIDptr *)(x1 = (ContextMap) freelist_contextmap));
len_mfree_contextmap --;
return x1;
}

void free_contextmap (ContextMap x1)
{len_mfree_contextmap ++;
cnt_free_contextmap ++;
*((VOIDptr *)x1) = freelist_contextmap;
freelist_contextmap = (VOIDptr)x1;
if (len_mfree_contextmap > 100)
{while (len_mfree_contextmap > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_contextmap);
FREEMEM_vdmlib(freelist_contextmap,sizeof(struct Handle_contextmap));
freelist_contextmap = lx1;
len_mfree_contextmap --;
cnt_mfree_contextmap ++;
}
}
}

static Nat0 len_mfree_vdmdb = 0;

static Nat0 cnt_alloc_vdmdb = 0;
static Nat0 cnt_free_vdmdb = 0;
static Nat0 cnt_mallc_vdmdb = 0;
static Nat0 cnt_mfree_vdmdb = 0;

void profile_vdmdb (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Vdmdb");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_vdmdb);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_vdmdb);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_vdmdb);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_vdmdb);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_vdmdb);
fprintf(stderr,"\n");
}

static VOIDptr freelist_vdmdb = (VOIDptr)0;

Vdmdb alloc_vdmdb (void)
{Vdmdb x1;
cnt_alloc_vdmdb ++;
if (! freelist_vdmdb)
{while (! (x1 = (Vdmdb)ALLOCMEM_vdmlib(sizeof(struct Handle_vdmdb)))) heap_oflw_vdmlib("Heap_vdmdb");
cnt_mallc_vdmdb ++;
return x1;
}
freelist_vdmdb = *((VOIDptr *)(x1 = (Vdmdb) freelist_vdmdb));
len_mfree_vdmdb --;
return x1;
}

void free_vdmdb (Vdmdb x1)
{len_mfree_vdmdb ++;
cnt_free_vdmdb ++;
*((VOIDptr *)x1) = freelist_vdmdb;
freelist_vdmdb = (VOIDptr)x1;
if (len_mfree_vdmdb > 100)
{while (len_mfree_vdmdb > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_vdmdb);
FREEMEM_vdmlib(freelist_vdmdb,sizeof(struct Handle_vdmdb));
freelist_vdmdb = lx1;
len_mfree_vdmdb --;
cnt_mfree_vdmdb ++;
}
}
}

static Nat0 len_mfree_adt = 0;

static Nat0 cnt_alloc_adt = 0;
static Nat0 cnt_free_adt = 0;
static Nat0 cnt_mallc_adt = 0;
static Nat0 cnt_mfree_adt = 0;

void profile_adt (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Adt");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_adt);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_adt);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_adt);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_adt);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_adt);
fprintf(stderr,"\n");
}

static VOIDptr freelist_adt = (VOIDptr)0;

Adt alloc_adt (void)
{Adt x1;
cnt_alloc_adt ++;
if (! freelist_adt)
{while (! (x1 = (Adt)ALLOCMEM_vdmlib(sizeof(struct Handle_adt)))) heap_oflw_vdmlib("Heap_adt");
cnt_mallc_adt ++;
return x1;
}
freelist_adt = *((VOIDptr *)(x1 = (Adt) freelist_adt));
len_mfree_adt --;
return x1;
}

void free_adt (Adt x1)
{len_mfree_adt ++;
cnt_free_adt ++;
*((VOIDptr *)x1) = freelist_adt;
freelist_adt = (VOIDptr)x1;
if (len_mfree_adt > 100)
{while (len_mfree_adt > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_adt);
FREEMEM_vdmlib(freelist_adt,sizeof(struct Handle_adt));
freelist_adt = lx1;
len_mfree_adt --;
cnt_mfree_adt ++;
}
}
}

static Nat0 len_mfree_impl = 0;

static Nat0 cnt_alloc_impl = 0;
static Nat0 cnt_free_impl = 0;
static Nat0 cnt_mallc_impl = 0;
static Nat0 cnt_mfree_impl = 0;

void profile_impl (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Impl");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_impl);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_impl);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_impl);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_impl);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_impl);
fprintf(stderr,"\n");
}

static VOIDptr freelist_impl = (VOIDptr)0;

Impl alloc_impl (void)
{Impl x1;
cnt_alloc_impl ++;
if (! freelist_impl)
{while (! (x1 = (Impl)ALLOCMEM_vdmlib(sizeof(struct Handle_impl)))) heap_oflw_vdmlib("Heap_impl");
cnt_mallc_impl ++;
return x1;
}
freelist_impl = *((VOIDptr *)(x1 = (Impl) freelist_impl));
len_mfree_impl --;
return x1;
}

void free_impl (Impl x1)
{len_mfree_impl ++;
cnt_free_impl ++;
*((VOIDptr *)x1) = freelist_impl;
freelist_impl = (VOIDptr)x1;
if (len_mfree_impl > 100)
{while (len_mfree_impl > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_impl);
FREEMEM_vdmlib(freelist_impl,sizeof(struct Handle_impl));
freelist_impl = lx1;
len_mfree_impl --;
cnt_mfree_impl ++;
}
}
}

static Nat0 len_mfree_operation = 0;

static Nat0 cnt_alloc_operation = 0;
static Nat0 cnt_free_operation = 0;
static Nat0 cnt_mallc_operation = 0;
static Nat0 cnt_mfree_operation = 0;

void profile_operation (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Operation");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_operation);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_operation);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_operation);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_operation);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_operation);
fprintf(stderr,"\n");
}

static VOIDptr freelist_operation = (VOIDptr)0;

Operation alloc_operation (void)
{Operation x1;
cnt_alloc_operation ++;
if (! freelist_operation)
{while (! (x1 = (Operation)ALLOCMEM_vdmlib(sizeof(struct Handle_operation)))) heap_oflw_vdmlib("Heap_operation");
cnt_mallc_operation ++;
return x1;
}
freelist_operation = *((VOIDptr *)(x1 = (Operation) freelist_operation));
len_mfree_operation --;
return x1;
}

void free_operation (Operation x1)
{len_mfree_operation ++;
cnt_free_operation ++;
*((VOIDptr *)x1) = freelist_operation;
freelist_operation = (VOIDptr)x1;
if (len_mfree_operation > 100)
{while (len_mfree_operation > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_operation);
FREEMEM_vdmlib(freelist_operation,sizeof(struct Handle_operation));
freelist_operation = lx1;
len_mfree_operation --;
cnt_mfree_operation ++;
}
}
}

static Nat0 len_mfree_strings = 0;

static Nat0 cnt_alloc_strings = 0;
static Nat0 cnt_free_strings = 0;
static Nat0 cnt_mallc_strings = 0;
static Nat0 cnt_mfree_strings = 0;

void profile_strings (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Strings");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_strings);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_strings);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_strings);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_strings);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_strings);
fprintf(stderr,"\n");
}

static VOIDptr freelist_strings = (VOIDptr)0;

Strings alloc_strings (void)
{Strings x1;
cnt_alloc_strings ++;
if (! freelist_strings)
{while (! (x1 = (Strings)ALLOCMEM_vdmlib(sizeof(struct Handle_strings)))) heap_oflw_vdmlib("Heap_strings");
cnt_mallc_strings ++;
return x1;
}
freelist_strings = *((VOIDptr *)(x1 = (Strings) freelist_strings));
len_mfree_strings --;
return x1;
}

void free_strings (Strings x1)
{len_mfree_strings ++;
cnt_free_strings ++;
*((VOIDptr *)x1) = freelist_strings;
freelist_strings = (VOIDptr)x1;
if (len_mfree_strings > 100)
{while (len_mfree_strings > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_strings);
FREEMEM_vdmlib(freelist_strings,sizeof(struct Handle_strings));
freelist_strings = lx1;
len_mfree_strings --;
cnt_mfree_strings ++;
}
}
}

static Nat0 len_mfree_stringl = 0;

static Nat0 cnt_alloc_stringl = 0;
static Nat0 cnt_free_stringl = 0;
static Nat0 cnt_mallc_stringl = 0;
static Nat0 cnt_mfree_stringl = 0;

void profile_stringl (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Stringl");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_stringl);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_stringl);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_stringl);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_stringl);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_stringl);
fprintf(stderr,"\n");
}

static VOIDptr freelist_stringl = (VOIDptr)0;

Stringl alloc_stringl (void)
{Stringl x1;
cnt_alloc_stringl ++;
if (! freelist_stringl)
{while (! (x1 = (Stringl)ALLOCMEM_vdmlib(sizeof(struct Handle_stringl)))) heap_oflw_vdmlib("Heap_stringl");
cnt_mallc_stringl ++;
return x1;
}
freelist_stringl = *((VOIDptr *)(x1 = (Stringl) freelist_stringl));
len_mfree_stringl --;
return x1;
}

void free_stringl (Stringl x1)
{len_mfree_stringl ++;
cnt_free_stringl ++;
*((VOIDptr *)x1) = freelist_stringl;
freelist_stringl = (VOIDptr)x1;
if (len_mfree_stringl > 100)
{while (len_mfree_stringl > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_stringl);
FREEMEM_vdmlib(freelist_stringl,sizeof(struct Handle_stringl));
freelist_stringl = lx1;
len_mfree_stringl --;
cnt_mfree_stringl ++;
}
}
}

#ifdef __cplusplus
#define outerrstr_vdmlib(x1) cerr << x1
#define outerrint_vdmlib(x1) cerr << x1
#define outerrme1_vdmlib(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << " "
#define outerrmes_vdmlib(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << "\n"
#else
#define outerrstr_vdmlib(x1) fprintf(stderr,"%s",x1)
#define outerrint_vdmlib(x1) fprintf(stderr,"%ld",x1)
#define outerrme1_vdmlib(x1,x2) fprintf(stderr,"\n\n%s : %s ",x2,x1)
#define outerrmes_vdmlib(x1,x2) fprintf(stderr,"\n\n%s : %s\n",x2,x1)
#endif
void err_empty_iterator_vdmlib (char * x1)
{
outerrmes_vdmlib("no more elements to process by an iterator",x1);
abort_vdmlib(VDM_ERR_EMPTYIT);
}
void err_smap_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to select an element that is not in the domain of a map",x1);
abort_vdmlib(VDM_ERR_SELMAP);
}

Bool supress_cvlines_vdmlib = TRUE;
Nat0 curr_linelen_vdmlib;
char *start_structure_vdmlib;
char *end_structure_vdmlib;

void adj_linelen_vdmlib (Nat0 x1)
{ curr_linelen_vdmlib = (curr_linelen_vdmlib > x1) ? (curr_linelen_vdmlib - x1) : 0;}

Str ident_prefix_vdmlib (Str x1,Nat0 x2)
{ return conc_str(mkn_str(' ',x2 - len_str(x1)), x1); }

Cvtext_vdmlib ident_lines_vdmlib (Cvtext_vdmlib x1,Str x2)
{ Str lx1;Nat1 lx2;

lx1 = mkn_str(' ',len_str(x2));
x1 = ovwrt1_cvtext_vdmlib( x1
, (Nat1)1
, conc_str(x2,sel_cvtext_vdmlib(x1,(Nat1)1)));
for(lx2 = 2;lx2 <= len_cvtext_vdmlib(x1); lx2++)
x1 = ovwrt1_cvtext_vdmlib( x1
, lx2
, conc_str( copy_str(lx1)
, sel_cvtext_vdmlib(x1,lx2)));
del_str(lx1);
return x1;
}

Cvtext_vdmlib close_struct_vdmlib (Cvtext_vdmlib x1,Str x2,Nat0 x3)
{ Nat0 lx1 = len_cvtext_vdmlib(x1);
Str lx2 = sel_cvtext_vdmlib(x1,(Nat1)lx1);
Nat0 lx3 = 1;

if (lx1 <= 2)
return ovwrt1_cvtext_vdmlib(x1,(Nat1)lx1,conc_str(lx2,x2));

while(sel_str(lx2,lx3) == ' ') lx3++;
if ( len_str(x2) == 1
&& sel_str(lx2,lx3) == hd_str(x2)
)
{ return ovwrt1_cvtext_vdmlib(x1
,(Nat1)lx1
,ovwrt1_str(lx2,x3,hd_str(x2)));
}

return appr_cvtext_vdmlib(x1,ident_prefix_vdmlib(x2,x3));
}

Cvtext_vdmlib append_lastline_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{ if (len_cvtext_vdmlib(x2) != 1)
{
outerrstr_vdmlib("error in 2nd parameter of 'append_lastline'");
abort_vdmlib(VDM_ERR_CVLINES);
}
{ Nat0 lx1 = len_cvtext_vdmlib(x1);

x1 = ovwrt1_cvtext_vdmlib( x1
, (Nat1)lx1
, conc_str( sel_cvtext_vdmlib(x1,(Nat1)lx1)
, conc_str( mkc_str(",")
, hd_cvtext_vdmlib(x2))));
del1_cvtext_vdmlib(x2);
return x1;
}
}

static Bool last_was_simple_vdmlib (Cvtext_vdmlib x1,Nat0 x2)
{ return ( len_cvtext_vdmlib(x1) == 1
|| index_str(last_cvtext_vdmlib(x1),',') == x2
);
}

Cvtext_vdmlib cvlines2_cvtext_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{ if (is_empty_cvtext_vdmlib(x1))
return ident_lines_vdmlib(x2,mkc_str(start_structure_vdmlib));
else
{ if ( len_cvtext_vdmlib(x2) == 1
&& len_str(hd_cvtext_vdmlib(x2))
+ len_str(last_cvtext_vdmlib(x1))
< curr_linelen_vdmlib
&& last_was_simple_vdmlib(x1,(Nat0)strlen(start_structure_vdmlib))
)
return append_lastline_vdmlib(x1,x2);
else
return conc_cvtext_vdmlib
(x1,ident_lines_vdmlib
(x2,ident_prefix_vdmlib( mkc_str(",")
, (Nat0)strlen(start_structure_vdmlib))));
}
}

#ifdef __cplusplus
void fprint_lines_vdmlib (ostream & x1,Cvtext_vdmlib x2)
#else
void fprint_lines_vdmlib (FILE * x1,Cvtext_vdmlib x2)
#endif
{ Nat1 lx1;

for (lx1 = 1;lx1 <= len_cvtext_vdmlib(x2); lx1++)
{ Nat1 lx3;
Str lx4;

lx4 = sel_cvtext_vdmlib(x2,lx1);
for (lx3 = 1; lx3 <= len_str(lx4); lx3++)
#ifdef __cplusplus
{x1 << (char)(sel_str(lx4,lx3));}
x1 << "\n";
#else
{fprintf(x1,"%c",sel_str(lx4,lx3));}
fprintf(x1,"\n");
#endif
}
}
void err_hd_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to take 'hd' of an empty tuple",x1);
abort_vdmlib(VDM_ERR_EMPTYHD);
}
void err_tl_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to take 'tl' of an empty tuple",x1);
abort_vdmlib(VDM_ERR_EMPTYTL);
}
void err_nv_hdl_vdmlib (char * x1)
{
outerrmes_vdmlib("accessed object contains no valid data",x1);
abort_vdmlib(VDM_ERR_NV_HDL);
}

void abort_vdmlib (Nat0 x1)
{
exit(1);
}
void heap_oflw_vdmlib (char * x1)
{
outerrmes_vdmlib("no more heap space available",x1);
abort_vdmlib(VDM_ERR_HEAPOFL);
}
void err_sel_vdmlib (Nat1 x1,Nat0 x2,char * x3)
{
outerrme1_vdmlib("attempt to select element",x3);
outerrint_vdmlib((long)x1);
outerrstr_vdmlib(" of tuple with length ");
outerrint_vdmlib((long)x2);
outerrstr_vdmlib("\n");
abort_vdmlib(VDM_ERR_SELECT);
}
void err_umap_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to union elements [d :-> r1] and [d :->r2] of a map",x1);
abort_vdmlib(VDM_ERR_UNION);
}
Bool not_bool (Bool x1)  {return !x1;}
Bool is_gr_bool (Bool x1,Bool x2)   {return (x1>x2);}
Bool xor_bool (Bool x1,Bool x2)   {return x1 ^ x2;}
Cvtext_vdmlib cvlines_bool (Bool x1)
{return mk1_cvtext_vdmlib(mkc_str(((x1) ? "TRUE" : "FALSE")));}

#ifdef __cplusplus
void fpr_bool (ostream & x1,Bool x2)
#else
void fpr_bool (FILE * x1,Bool x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_bool(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}
Bool and_bool (Bool x1,Bool x2)   {return x1 & x2;}
Bool is_eq_bool (Bool x1,Bool x2)   {return (x1==x2);}
Bool is_ge_bool (Bool x1,Bool x2)   {return (x1>=x2);}
Bool or_bool (Bool x1,Bool x2)   {return x1 | x2;}
Byte pred_byte (Byte x1)  { return (x1) - 1; }
Bool is_eq_byte (Byte x1,Byte x2)   {return (x1==x2);}
Bool is_lt_byte (Byte x1,Byte x2)   { return is_gr_byte((x2),(x1)); }
Bool is_ge_byte (Byte x1,Byte x2)   {return (x1>=x2);}
Byte times_byte (Byte x1,Byte x2)   { return (x1)*(x2); }
Byte plus_byte (Byte x1,Byte x2)   {return x1 + x2;}
Byte succ_byte (Byte x1)  { return (x1) + 1; }
Byte mod_byte (Byte x1,Byte x2)   { return (x1)%(x2); }
Bool is_le_byte (Byte x1,Byte x2)   { return is_ge_byte((x2),(x1)); }
Bool is_gr_byte (Byte x1,Byte x2)   {return (x1>x2);}
Byte div_byte (Byte x1,Byte x2)   { return (x1)/(x2); }
Byte minus_byte (Byte x1,Byte x2)   { return (x1)-(x2); }
Intg pred_intg (Intg x1)  { return (x1) - 1; }
Bool is_eq_intg (Intg x1,Intg x2)   {return (x1==x2);}
Bool is_lt_intg (Intg x1,Intg x2)   { return is_gr_intg((x2),(x1)); }
Bool is_ge_intg (Intg x1,Intg x2)   {return (x1>=x2);}
Intg times_intg (Intg x1,Intg x2)   { return (x1)*(x2); }
Intg plus_intg (Intg x1,Intg x2)   {return x1 + x2;}
void del_intg (Intg x1)  {}

Rep_str cvrep_str_intg (Intg x1)
{char lx1[50];
sprintf(lx1,printformat_intg,(long)x1);
return mkc_rep_str(lx1);
}

Str cvstr_intg (Intg x1)
{ Str lx;
lx = alloc_str();
lx->f_rc = 1;
lx->f_rep = cvrep_str_intg(x1);
return lx;
}

Intg copy_intg (Intg x1)  {return x1;}
char * printformat_intg = "%ld";

void set_print_format_intg (char * x1)
{ printformat_intg = (x1) ? x1 : "%ld"; }
Intg succ_intg (Intg x1)  { return (x1) + 1; }
Intg mod_intg (Intg x1,Intg x2)   { return (x1)%(x2); }
Bool is_le_intg (Intg x1,Intg x2)   { return is_ge_intg((x2),(x1)); }
Bool is_gr_intg (Intg x1,Intg x2)   {return (x1>x2);}
Intg div_intg (Intg x1,Intg x2)   { return (x1)/(x2); }
Intg minus_intg (Intg x1,Intg x2)   { return (x1)-(x2); }
Nat1 pred_nat1 (Nat1 x1)  { return (x1) - 1; }
Bool is_eq_nat1 (Nat1 x1,Nat1 x2)   {return (x1==x2);}
Bool is_lt_nat1 (Nat1 x1,Nat1 x2)   { return is_gr_nat1((x2),(x1)); }
Bool is_ge_nat1 (Nat1 x1,Nat1 x2)   {return (x1>=x2);}
Nat1 times_nat1 (Nat1 x1,Nat1 x2)   { return (x1)*(x2); }
Nat1 plus_nat1 (Nat1 x1,Nat1 x2)   {return x1 + x2;}
Nat1 succ_nat1 (Nat1 x1)  { return (x1) + 1; }
Nat1 mod_nat1 (Nat1 x1,Nat1 x2)   { return (x1)%(x2); }
Bool is_le_nat1 (Nat1 x1,Nat1 x2)   { return is_ge_nat1((x2),(x1)); }
Bool is_gr_nat1 (Nat1 x1,Nat1 x2)   {return (x1>x2);}
Nat1 div_nat1 (Nat1 x1,Nat1 x2)   { return (x1)/(x2); }
Nat1 minus_nat1 (Nat1 x1,Nat1 x2)   { return (x1)-(x2); }
Char pred_char (Char x1)  { return (x1) - 1; }
Bool is_eq_char (Char x1,Char x2)   {return (x1==x2);}
Bool is_lt_char (Char x1,Char x2)   { return is_gr_char((x2),(x1)); }
Bool is_ge_char (Char x1,Char x2)   {return (x1>=x2);}
Char times_char (Char x1,Char x2)   { return (x1)*(x2); }
Char plus_char (Char x1,Char x2)   {return x1 + x2;}
Char copy_char (Char x1)  {return x1;}
void del_char (Char x1)  {}
Char succ_char (Char x1)  { return (x1) + 1; }
Char mod_char (Char x1,Char x2)   { return (x1)%(x2); }
Bool is_le_char (Char x1,Char x2)   { return is_ge_char((x2),(x1)); }
Bool is_gr_char (Char x1,Char x2)   {return (x1>x2);}
Char div_char (Char x1,Char x2)   { return (x1)/(x2); }
Char minus_char (Char x1,Char x2)   { return (x1)-(x2); }
void cond_clone_str (Str * x1)
{
if ((*x1)->f_rc > 1)
{
Str clone = alloc_str();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_str((*x1)->f_rep);
*x1 = clone;
}
}

Str ovwrt1_str (Str x1,Nat1 x2,Char x3)
{
check_handle_str(x1);
cond_clone_str(&x1);
x3 = copy_char(x3);
x1->f_rep = ovwrt1d_rep_str (x1->f_rep,x2,x3) ;
return x1;
}

Str cvfromtup1_str (Inbytes * x1)
{
Str lx = alloc_str();
lx->f_rc = 1;
lx->f_rep = cvfromtup1_rep_str(x1);
return lx;
}

Bool is_gr_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x2);
return is_gr_rep_str (x1->f_rep , x2->f_rep ) ;
}

Cvtext_vdmlib cvlines_str (Str x1)
{
check_handle_str(x1);
return cvlines_rep_str (x1->f_rep  ) ;
}

Str appr_str (Str x1,Char x2)
{
check_handle_str(x1);
cond_clone_str(&x1);
x2 = copy_char(x2);
x1->f_rep = appr_rep_str (x1->f_rep,x2) ;
return x1;
}

Char hd_str (Str x1)
{
check_handle_str(x1);
return copy_char(hd_rep_str (x1->f_rep));
}

Str mk_empty_str (void)
{
Str l = alloc_str();
l->f_rc = 1;
l->f_rep = mk_empty_rep_str ();
return l;
}

void cpc_str (Str x1,char * x2)
{
check_handle_str(x1);
cpc_rep_str(x1->f_rep, x2);
}
void del_str (Str x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_str(x1->f_rep);
free_str(x1);
}
}

Nat0 len_str (Str x1)
{
check_handle_str(x1);
return len_rep_str (x1->f_rep  ) ;
}

Str sub_tup_str (Str x1,Nat1 x2,Nat0 x3)
{
check_handle_str(x1);
cond_clone_str(&x1);
x1->f_rep = sub_tupd_rep_str (x1->f_rep,x2,x3) ;
return x1;
}

Nat0 index_list_from_str (Str x1,Str x2,Nat1 x3)
{
check_handle_str(x1);
check_handle_str(x2);
return index_list_from_rep_str (x1->f_rep , x2->f_rep , x3) ;
}

Str fread_str (Str x1)
{
Str l = alloc_str();
l->f_rc = 1;
l->f_rep = fread_rep_str(x1);
return l;
}

Bool fwrite_str (Str x1,Str x2)
{
check_handle_str(x1);
return fwrite_rep_str (x1->f_rep , x2 ) ;
}

Nat0 index_list_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x2);
return index_list_rep_str (x1->f_rep , x2->f_rep ) ;
}

Str conc_path_auto_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x2);
{
Rep_str lrep2 = copy_rep_str(x2->f_rep);
cond_clone_str(&x1);
x1->f_rep = conc_path_rep_str(x1->f_rep,lrep2);
}
return x1;
}

Str conc_path_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x1);
cond_clone_str(&x1);
x1->f_rep = conc_path_rep_str(x1->f_rep,x2->f_rep);
free_str(x2);
return x1;
}

Str mk_sub_tup_str (Str x1,Nat1 x2,Nat0 x3)
{
check_handle_str(x1);
Str lx = alloc_str();
lx->f_rc = 1;
lx->f_rep = mk_sub_tup_rep_str(x1->f_rep,x2,x3);
return lx;
}

#ifdef __cplusplus
void fpr_str (ostream & x1,Str x2)
#else
void fpr_str (FILE * x1,Str x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_str(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}
Str mkn_str (Char x1,Nat0 x2)
{
Str l = alloc_str();
l->f_rc = 1;
l->f_rep = mknc_rep_str(x1,x2);
return l;
}
#ifdef __cplusplus
void puts_str (Str x1,ostream & x2)
#else
void puts_str (Str x1,FILE * x2)
#endif
{
check_handle_str(x1);
puts_rep_str(x1->f_rep, x2);
}

Nat0 index_str (Str x1,Char x2)
{
check_handle_str(x1);
return index_rep_str (x1->f_rep , x2 ) ;
}

Str conc_auto_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x2);
{
Rep_str lrep2 = copy_rep_str(x2->f_rep);
cond_clone_str(&x1);
x1->f_rep = conc_rep_str(x1->f_rep,lrep2);
}
return x1;
}

Str conc_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x1);
cond_clone_str(&x1);
x1->f_rep = conc_rep_str(x1->f_rep,x2->f_rep);
free_str(x2);
return x1;
}

Str copy_str (Str x1)
{
check_handle_str(x1);
x1->f_rc++;
return x1;
}

Str mkc_str (char * x1)
{
Str l = alloc_str();
l->f_rc = 1;
l->f_rep = mkc_rep_str(x1);
return l;
}

Bool is_empty_str (Str x1)
{
check_handle_str(x1);
return is_empty_rep_str (x1->f_rep  ) ;
}

Str appl_str (Char x1,Str x2)
{
check_handle_str(x2);
cond_clone_str(&x2);
x1 = copy_char(x1);
x2->f_rep = appl_rep_str(x1,x2->f_rep);
return x2;
}
Str tl_str (Str x1)
{
check_handle_str(x1);
cond_clone_str(&x1);
x1->f_rep = tld_rep_str(x1->f_rep);
return x1;
}

Str mk1_str (Char x1)
{
Str l = alloc_str();
l->f_rc = 1;
x1 = copy_char(x1);
l->f_rep = mk1_rep_str (x1);
return l;
}

Char sel_str (Str x1,Nat0 x2)
{
check_handle_str(x1);
return copy_char(sel_rep_str (x1->f_rep,x2));
}

Outbytes cvtotup1_str (Outbytes x1,Str x2)
{
check_handle_str(x2);
return cvtotup1_rep_str(x1, x2->f_rep);
}

Bool is_eq_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x2);
return is_eq_rep_str (x1->f_rep , x2->f_rep ) ;
}

Outbytes write_buffer_outbytes (Outbytes x1)
{
if (x1->f_ioerr == 0)
{ Intg lx1 = write((int)(x1->f_fdes),
(char *)(x1->f_buff),
(x1->f_buffelems) * sizeof(Byte));

if (lx1 != (Intg)(x1->f_buffelems * sizeof(Byte)))
{
x1->f_ioerr = 1;
x1->f_errno = errno;
}
}

x1->f_buffelems = 0;
return x1;
}

Bool fwrite_outbytes (Outbytes x1,Str x2)
{ Intg lx1;

x1 = write_buffer_outbytes(ref_outbytes(x1));
lx1 = close((int)(x1->f_fdes));

if (x1->f_ioerr) { errno = (int)(x1->f_errno); return 0; }
if (lx1 == -1)
{
return 0;
}

{ char lx2[128];

cpc_str(x2,lx2);
if (strcmp(x1->f_deffn,lx2))
{ if (unlink(lx2) && errno != ENOENT) { return 0; }
if (link(x1->f_deffn,lx2)) { return 0; }
if (unlink(x1->f_deffn)) { return 0; }
}
}

return 1;
}

static void get_deffn_outbytes (char * x1,Nat0 x2)   { sprintf(x1,"tmp_%lu_outbytes!",x2); }

Outbytes mk_empty_outbytes (void)
{ static Nat0 f_opencnt = 0;
Outbytes lx1 = alloc_outbytes();

get_deffn_outbytes(lx1->f_deffn,f_opencnt++);
lx1->f_fdes = open(lx1->f_deffn,O_WRONLY | O_CREAT,0x01A4);

if (lx1->f_fdes == -1)
{ lx1->f_ioerr = 1; lx1->f_errno = errno;
}
else
{ lx1->f_ioerr = 0; lx1->f_errno = 0; }

lx1->f_buffelems = 0;
return lx1;
}

Inbytes read_buffer_inbytes (Inbytes x1)
{
Nat0 lx1;
Nat0 lx2;
Intg lx3;

lx1 = (x1->f_elfile > 4096) ? 4096 : x1->f_elfile;
lx2 = lx1 * sizeof(Byte);
lx3 = read((int)(x1->f_fdes),
(char *)(x1->f_buff),
lx2);

if (lx3 != (Intg)lx2)
{
err_tl_vdmlib("Inbytes");
}

x1->f_currelem = &x1->f_buff[0];
x1->f_buffelems = lx1;
x1->f_elfile -= lx1;

return x1;
}
void del_inbytes (Inbytes x1)
{ if (ref_inbytes(x1)->f_fdes != -1) { close((int)(x1->f_fdes)); }
free_inbytes(ref_inbytes(x1));
}
void del1_inbytes (Inbytes x1)
{ if (ref_inbytes(x1)->f_fdes != -1) { close((int)(x1->f_fdes)); }
free_inbytes(ref_inbytes(x1));
}

Inbytes fread_inbytes (Str x1)
{ Inbytes lx1 = alloc_inbytes();

lx1->f_elfile = 0;
lx1->f_buffelems = 0;

{ char *lx2 = (char *)ALLOCMEM_vdmlib(len_str(x1) + 5);

cpc_str(x1,lx2);
lx1->f_fdes = open(lx2,O_RDONLY);
FREEMEM_vdmlib(lx2,len_str(x1) + 5);
}

if (lx1->f_fdes == -1) { return lx1; }

{ struct stat lx2;

if (fstat((int)(lx1->f_fdes),&lx2) == -1) { return lx1; }

lx1->f_elfile = lx2.st_size / sizeof(Byte);
}

lx1 = read_buffer_inbytes(lx1);
return lx1;
}
Nat0 len_inbytes (Inbytes x1)
{ return ref_inbytes(x1)->f_buffelems + ref_inbytes(x1)->f_elfile; }

Cvtext_vdmlib alloc_cvtext_vdmlib (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_cvtext_vdmlib) + (x1 + 0) * sizeof(Str);
Nat0 len2 = 4;
Cvtext_vdmlib lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Cvtext_vdmlib) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Cvtext_vdmlib");
lx1->f_max = ((len2 - sizeof(struct Struct_cvtext_vdmlib))/sizeof(Str));
lx1->f_len = x1;
;
;
return lx1;
}

void free_cvtext_vdmlib (Cvtext_vdmlib x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_cvtext_vdmlib) + x1->f_max*sizeof(Str));
}

Rep_str alloc_rep_str (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_str) + (x1 + 0) * sizeof(Char);
Nat0 len2 = 4;
Rep_str lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_str) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_str");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_str))/sizeof(Char));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_str (Rep_str x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_str) + x1->f_max*sizeof(Char));
}

void forall_cvtext_vdmlib (Cvtext_vdmlib x1,T2_forall_cvtext_vdmlib x2)
{Nat0 lx1 = ref_cvtext_vdmlib(x1)->f_len;
Str * px1 = (Str * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

Nat0 len_cvtext_vdmlib (Cvtext_vdmlib x1)  {return (ref_cvtext_vdmlib(x1)->f_len);}
Bool is_empty_cvtext_vdmlib (Cvtext_vdmlib x1)
{return (ref_cvtext_vdmlib(x1)->f_len == 0);}

static Cvtext_vdmlib _tt1_del_cvtext_vdmlib;

static void _ff1_del_cvtext_vdmlib(Str y1)

{del_str(y1);}

void del_cvtext_vdmlib(Cvtext_vdmlib x1)

{
{Cvtext_vdmlib lt1; lt1 = _tt1_del_cvtext_vdmlib;
{
{_tt1_del_cvtext_vdmlib = x1;

{
forall_cvtext_vdmlib(x1,_ff1_del_cvtext_vdmlib);
del1_cvtext_vdmlib(x1);
_tt1_del_cvtext_vdmlib = lt1;

}}}}}

Str hd_cvtext_vdmlib (Cvtext_vdmlib x1)  {return sel_cvtext_vdmlib(x1,(Nat1)1);}

Cvtext_vdmlib ovwrt1_cvtext_vdmlib (Cvtext_vdmlib x1,Nat1 x2,Str x3)
{
if (x2 > ref_cvtext_vdmlib(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Cvtext_vdmlib");
;
*( ((Str *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Cvtext_vdmlib mk1_cvtext_vdmlib(Str x1)
{Cvtext_vdmlib lx1 = alloc_cvtext_vdmlib((Nat0)1);
*((Str *)(lx1+1)) = x1;
return lx1;
}

Cvtext_vdmlib appr_cvtext_vdmlib (Cvtext_vdmlib x1,Str x2)
{ Nat0 lx1 = ref_cvtext_vdmlib(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Str *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_cvtext_vdmlib(x1,mk1_cvtext_vdmlib(x2)); }
}

Cvtext_vdmlib conc_cvtext_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{Nat0 ll1 = ref_cvtext_vdmlib(x1)->f_len;
Nat0 ll = ll1 + ref_cvtext_vdmlib(x2)->f_len;
if (ll > x1->f_max)
{Cvtext_vdmlib lx3 = alloc_cvtext_vdmlib(ll);
register Nat0 i = ll1;
register Str * px3 = (Str *)(lx3 + 1);
register Str * px1 = (Str *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_cvtext_vdmlib(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Str * px1 = ((Str *)( x1 + 1)) + ll1;
register Str * px2 = (Str *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_cvtext_vdmlib(x2);
}
return x1;
}

Cvtext_vdmlib mk_empty_cvtext_vdmlib (void)
{return alloc_cvtext_vdmlib((Nat0)0);}
Str last_cvtext_vdmlib (Cvtext_vdmlib x1)
{return sel_cvtext_vdmlib(x1,(Nat1)(len_cvtext_vdmlib(x1)));}
Str sel_cvtext_vdmlib (Cvtext_vdmlib x1,Nat1 x2)
{

if (x2 > ref_cvtext_vdmlib(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Cvtext_vdmlib");
return *( ((Str *)(x1 + 1)) + x2 -1);
}
void del1_cvtext_vdmlib (Cvtext_vdmlib x1)  {free_cvtext_vdmlib(x1);}
Rep_str mkn_empty_rep_str (Nat0 x1)  { Rep_str lx1 = alloc_rep_str(x1); lx1->f_len = 0; return lx1;; }

Rep_str ovwrt1d_rep_str (Rep_str x1,Nat1 x2,Char x3)
{
if (x2 > ref_rep_str(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_str");
;
*( ((Char *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef mk1_str_char
extern Str mk1_str_char ( Char y1    ) ;
#endif

static Str _rr1_cvstr_rep_str;
static void _rf1_cvstr_rep_str(Char y1 )

{_rr1_cvstr_rep_str = conc_str(_rr1_cvstr_rep_str,mk1_str_char(y1 )  );}

Str cvstr_rep_str(Rep_str x1     )

{Str lr1;
lr1 = _rr1_cvstr_rep_str;
_rr1_cvstr_rep_str = mk_empty_str();
forall_rep_str(x1,_rf1_cvstr_rep_str);
{Str lr2 = _rr1_cvstr_rep_str; _rr1_cvstr_rep_str = lr1; return lr2;}
}

Rep_str cvfromtup1_rep_str (Inbytes * x1)
{ register Nat0 lx1 = cvfromtup1_nat0(x1);
register Rep_str lx2;

lx2 = mkn_empty_rep_str(lx1);
for (; lx1 >= 1; lx1--) {
*( ((Char *)(lx2 + 1)) + lx2->f_len++) = hd_inbytes(*x1);
*x1 = tld_inbytes(*x1);
}
return lx2;
}

Char sel_rep_str (Rep_str x1,Nat1 x2)
{

if (x2 > ref_rep_str(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_str");
return *( ((Char *)(x1 + 1)) + x2 -1);
}
void del1_rep_str (Rep_str x1)  {free_rep_str(x1);}
Bool is_gr_rep_str (Rep_str x1,Rep_str x2)
{Nat0 lx1 = ref_rep_str(x1)->f_len;
Nat0 lx2 = ref_rep_str(x2)->f_len;
register Nat0 i = 0;
register Char * px1 = (Char *)(x1+1);
register Char * px2 = (Char *)(x2+1);
while (1)
{if (i == lx1) return 0;
if (i == lx2) return 1;
{Char le1 = * (px1++);
Char le2 = * (px2++);
if (is_eq_char(le1,le2)) i++;
else return is_ge_char(le1,le2);
}
}
}

Rep_str mk1_rep_str(Char x1)
{Rep_str lx1 = alloc_rep_str((Nat0)1);
*((Char *)(lx1+1)) = x1;
return lx1;
}

Char hd_rep_str (Rep_str x1)  {return sel_rep_str(x1,(Nat1)1);}
Rep_str mk_empty_rep_str (void)
{return alloc_rep_str((Nat0)0);}

Rep_str mk_sub_tup_rep_str (Rep_str x1,Nat1 x2,Nat0 x3)
{ Rep_str lx1;
Nat0 len1;
if (x3 > ref_rep_str(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
len1 = x3 - x2 + 1;
lx1 = alloc_rep_str(len1);
lx1->f_len = len1;
{ register Char * plx1 = (Char *)(lx1+1);
register Char * px1 =((Char *)( x1+1)) + (x2 - 1);
register Char * pend = plx1 + len1;
while (plx1 != pend) { *(plx1++) = *(px1++); }
}
return lx1;
}

Bool fwrite_rep_str (Rep_str x1,Str x2)
{char path[256];
FILE * fd;
cpc_str(x2,path);
if ((fd = fopen(path,"w")))
{if (fwrite((char *)(x1+1) ,sizeof(Char) ,(size_t)(x1->f_len) ,fd ) != x1->f_len) return 0;
fclose(fd);
return 1;
}
else return 0;
}

Rep_str fread_rep_str (Str x1)
{char path[256];
FILE * fd;
cpc_str(x1,path);
if ( (fd = fopen(path,"r")) != 0)
{Rep_str t1;
t1 = mk_empty_rep_str();
{int space; int cnt; while (space = (int)(t1->f_max - t1->f_len), (cnt = fread((char *)(((Char *)(t1 + 1)) + t1->f_len), sizeof(Char), (size_t)space,fd)) == space) {Rep_str t2; t2 = alloc_rep_str((Nat0)((t1->f_max)*2 + 1)); t2->f_len = t1->f_max; {register Nat0 i = t1->f_max; register Char * px3 = (Char *)(t2 + 1); register Char * px1 = (Char *)(t1 + 1); while (i--) *(px3++) = *(px1++); } del1_rep_str(t1); t1 = t2; } t1->f_len += cnt; }
fclose(fd);
return t1;
}
else return mk_empty_rep_str();
}

Nat0 index_list_from_rep_str (Rep_str x1,Rep_str x2,Nat1 x3)
{
Nat0 ix = x3-1;
Nat0 lenx1 = len_rep_str(x1);
Nat0 lenx2 = len_rep_str(x2);

if ( lenx1 >= lenx2 + ix ) {
Nat0 diff = lenx1 - lenx2;
while ( ix <= diff ) {
Nat0 j = 1;
while ( j <= lenx2 && is_eq_char(sel_rep_str(x2,j),sel_rep_str(x1,j+ix)) )
j++;
ix++;
if ( j > lenx2 )
return ix;
}
}
return 0;
}

Rep_str sub_tupd_rep_str (Rep_str x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_str(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }

{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Char * px1 = (Char *)(x1+1);
/* start of array */
register Char * px2 = px1 + (x2 - 1);
/* start of substring */
register Char * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

Nat0 len_rep_str (Rep_str x1)  {return (ref_rep_str(x1)->f_len);}
Rep_str mkc_rep_str (Char * x1)
{register Nat0 li = 0;
register Char * lx1 = (Char *)x1;
while (*(lx1++)) li++;
{Rep_str x2 = alloc_rep_str(li);
register Char * lx2 = (Char *)(x2 + 1);
lx1 = (Char *)x1;
while (li--) *(lx2++) = *(lx1++);
return x2;
}
}

Rep_str copy_rep_str (Rep_str x1)
{Nat0 l1 = ref_rep_str(x1)->f_len;
Rep_str x2 = alloc_rep_str(l1);
register Char * px1 = (Char *)(x1+1);
register Char * px2 = (Char *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = *(px1++);
return x2;
}

void cpc_rep_str (Rep_str x1,Char * x2)
{register Nat0 li = ref_rep_str(x1)->f_len;
register Char * px1 = (Char *)(x1 + 1);
register Char * px2 = (Char *)x2;
while (li--) *(px2++) = *(px1++);
*(px2) = 0;
}
void del_rep_str (Rep_str x1)  {del1_rep_str(x1);}

Rep_str conc_rep_str (Rep_str x1,Rep_str x2)
{Nat0 ll1 = ref_rep_str(x1)->f_len;
Nat0 ll = ll1 + ref_rep_str(x2)->f_len;
if (ll > x1->f_max)
{Rep_str lx3 = alloc_rep_str(ll);
register Nat0 i = ll1;
register Char * px3 = (Char *)(lx3 + 1);
register Char * px1 = (Char *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_str(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Char * px1 = ((Char *)( x1 + 1)) + ll1;
register Char * px2 = (Char *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_str(x2);
}
return x1;
}

static Nat0 _rr1_index_rep_str;
static Rep_str _tt1_index_rep_str; static Char _tt2_index_rep_str;

static void _ff1_index_rep_str(Char y1,Nat1 y2)

{if ((_rr1_index_rep_str == 0) && is_eq_char(y1,_tt2_index_rep_str)) _rr1_index_rep_str = y2;}

Nat0 index_rep_str(Rep_str x1,Char x2)

{Nat0 lr1; lr1 = _rr1_index_rep_str;
{Rep_str lt1; Char lt2; lt1 = _tt1_index_rep_str; lt2 = _tt2_index_rep_str;
{
{_tt1_index_rep_str = x1; _tt2_index_rep_str = x2;

{_rr1_index_rep_str = 0;
forindex_rep_str(x1,_ff1_index_rep_str);

_tt1_index_rep_str = lt1; _tt2_index_rep_str = lt2;
{Nat0 lr2; lr2 = _rr1_index_rep_str; _rr1_index_rep_str = lr1; return lr2;}
}}}}}

#ifdef __cplusplus
void puts_rep_str (Rep_str x1,ostream & x2)
#else
void puts_rep_str (Rep_str x1,FILE * x2)
#endif
{Nat0 li = x1->f_len;
Char * lx1 = (Char *)(x1 + 1);
while (li--)
#ifdef __cplusplus
x2 << (char)(*(lx1++));
#else
fputc((char)(*(lx1++)),x2);
#endif
}

Rep_str mknc_rep_str (Char x1,Nat0 x2)
{ Rep_str y1 = alloc_rep_str(x2);
Char* y2 = ((Char *)(y1 + 1));

while(x2--) { *(y2++) = copy_char(x1); }
return y1;
}

Nat0 index_list_rep_str (Rep_str x1,Rep_str x2)
{
Nat0 ix = 0;
Nat0 lenx1 = len_rep_str(x1);
Nat0 lenx2 = len_rep_str(x2);

if ( lenx1 >= lenx2 ) {
Nat0 diff = lenx1 - lenx2;
while ( ix <= diff ) {
Nat0 j = 1;
while ( j <= lenx2 && is_eq_char(sel_rep_str(x2,j),sel_rep_str(x1,j+ix)) )
j++;
ix++;
if ( j > lenx2 )
return ix;
}
}
return 0;
}
#if defined(__DOS__)
#define VDMpathdel '\\'
#else
#define VDMpathdel '/'
#endif

Rep_str conc_path_rep_str (Rep_str x1,Rep_str x2)
{return conc_rep_str(appr_rep_str(x1,VDMpathdel),x2);}

#undef VDMpathdel
Bool is_empty_rep_str (Rep_str x1)
{return (ref_rep_str(x1)->f_len == 0);}
Rep_str appl_rep_str (Char x1,Rep_str x2)
{return conc_rep_str(mk1_rep_str(x1),x2);}

Rep_str tld_rep_str (Rep_str x1)
{
if (ref_rep_str(x1)->f_len == 0) { err_tl_vdmlib("Rep_str"); }
return sub_tupd_rep_str(x1,(Nat1)2,x1->f_len);
}

Cvtext_vdmlib cvlines_rep_str (Rep_str x1)
{ return mk1_cvtext_vdmlib( conc_str( mkc_str("\"")
, conc_str( cvstr_rep_str(x1)
, mkc_str("\"")
) ) );
}

static Rep_str _tt1_forindex_rep_str; static T2_forindex_rep_str _tt2_forindex_rep_str; static Nat1 _ll1_forindex_rep_str;

static void _ff1_forindex_rep_str(Char y1)

{(*_tt2_forindex_rep_str)(y1,_ll1_forindex_rep_str++);}

void forindex_rep_str(Rep_str x1,T2_forindex_rep_str x2)

{
{Rep_str lt1; T2_forindex_rep_str lt2; lt1 = _tt1_forindex_rep_str; lt2 = _tt2_forindex_rep_str;
{Nat1 ll1; ll1 = _ll1_forindex_rep_str;
{_tt1_forindex_rep_str = x1; _tt2_forindex_rep_str = x2;
_ll1_forindex_rep_str = 1;
{
forall_rep_str(x1,_ff1_forindex_rep_str);

_tt1_forindex_rep_str = lt1; _tt2_forindex_rep_str = lt2; _ll1_forindex_rep_str = ll1;

}}}}}

Rep_str appr_rep_str (Rep_str x1,Char x2)
{ Nat0 lx1 = ref_rep_str(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Char *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_str(x1,mk1_rep_str(x2)); }
}

Outbytes cvtotup1_rep_str (Outbytes x1,Rep_str x2)
{ return cvtotupelems_rep_str(cvtotup1_nat0(x1,len_rep_str(x2)),x2); }

Bool is_eq_rep_str (Rep_str x1,Rep_str x2)
{register Nat0 lx1 = ref_rep_str(x1)->f_len;
if (lx1 != ref_rep_str(x2)->f_len) return 0;
{Nat0 i = 0;
register Char * px1 = (Char *)(x1+1);
register Char * px2 = (Char *)(x2+1);
while (i != lx1)
{if (! is_eq_char(*(px1++),*(px2++))) return 0;
i++;
}
return 1;
}
}
void forall_rep_str (Rep_str x1,T2_forall_rep_str x2)
{Nat0 lx1 = ref_rep_str(x1)->f_len;
Char * px1 = (Char * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

#ifndef appr_outbytes
extern Outbytes appr_outbytes ( Outbytes x1, Char x2 );
#endif

static Outbytes _rr1_cvtotupelems_rep_str;
static void _rf1_cvtotupelems_rep_str(Char y1)  {_rr1_cvtotupelems_rep_str = appr_outbytes(_rr1_cvtotupelems_rep_str,y1);}

Outbytes cvtotupelems_rep_str (Outbytes x1,Rep_str x2)
{Outbytes lr1 = _rr1_cvtotupelems_rep_str;
_rr1_cvtotupelems_rep_str = x1;
forall_rep_str(x2,_rf1_cvtotupelems_rep_str);
{Outbytes lr2 = _rr1_cvtotupelems_rep_str; _rr1_cvtotupelems_rep_str = lr1; return lr2;}
}

Nat0 pred_nat0 (Nat0 x1)  { return (x1) - 1; }
Bool is_eq_nat0 (Nat0 x1,Nat0 x2)   {return (x1==x2);}
Bool is_lt_nat0 (Nat0 x1,Nat0 x2)   { return is_gr_nat0((x2),(x1)); }
Bool is_ge_nat0 (Nat0 x1,Nat0 x2)   {return (x1>=x2);}
Nat0 times_nat0 (Nat0 x1,Nat0 x2)   { return (x1)*(x2); }
Nat0 plus_nat0 (Nat0 x1,Nat0 x2)   {return x1 + x2;}

Nat0 cvfromtup1_nat0 (Inbytes * x1)
{ register unsigned long lx1;
register unsigned long int lx2 = 0;

lx1 = hd_inbytes(*x1); *x1 = tld_inbytes(*x1);
if (sizeof(Nat0) == 1 || lx1 < 128)
{ return (Nat0)lx1; }
else if ((unsigned char)lx1 == 192)
{ lx2 = ((unsigned long)hd_inbytes(*x1) & 255);
*x1 = tld_inbytes(*x1);
lx2 |= ((unsigned long)hd_inbytes(*x1) & 255) << 8;
*x1 = tld_inbytes(*x1);
return (Nat0)lx2;
}
else
{ for (lx1 = 0; lx1 < sizeof(Nat0); lx1++)
{ lx2 |= (((unsigned long)hd_inbytes(*x1)) & 255) << (lx1*8);
*x1 = tld_inbytes(*x1);
}
return (Nat0)lx2;
}
}

Outbytes cvtotup1_nat0 (Outbytes x1,Nat0 x2)
{
if ( sizeof(x2) == 1 || (unsigned long)x2 < 128 )
{
return appr_outbytes(x1, (unsigned char)x2);
}

if ( (unsigned long)x2 < 32768 )
{
x1 = appr_outbytes(x1,192);
x1 = appr_outbytes(x1,((unsigned int)x2) & 255);
x1 = appr_outbytes(x1,(((unsigned int)x2) >> 8) & 255);
return x1;
}

{
register Nat0 i;
x1 = appr_outbytes(x1,128);
for (i = 1; i <= (Nat0)sizeof(Nat0); i++)
{
x1 = appr_outbytes(x1,(((unsigned int) x2) & 255));
x2 = (Nat0)(((unsigned int) x2) >> 8);
}
return x1;
}
}

Nat0 succ_nat0 (Nat0 x1)  { return (x1) + 1; }
Nat0 mod_nat0 (Nat0 x1,Nat0 x2)   { return (x1)%(x2); }
Bool is_le_nat0 (Nat0 x1,Nat0 x2)   { return is_ge_nat0((x2),(x1)); }
Bool is_gr_nat0 (Nat0 x1,Nat0 x2)   {return (x1>x2);}
Nat0 div_nat0 (Nat0 x1,Nat0 x2)   { return (x1)/(x2); }
Nat0 minus_nat0 (Nat0 x1,Nat0 x2)   { return (x1)-(x2); }

static Rep_stringl _tt1_forindex_rep_stringl; static T2_forindex_rep_stringl _tt2_forindex_rep_stringl; static Nat1 _ll1_forindex_rep_stringl;

static void _ff1_forindex_rep_stringl(Str y1)

{(*_tt2_forindex_rep_stringl)(y1,_ll1_forindex_rep_stringl++);}

void forindex_rep_stringl(Rep_stringl x1,T2_forindex_rep_stringl x2)

{
{Rep_stringl lt1; T2_forindex_rep_stringl lt2; lt1 = _tt1_forindex_rep_stringl; lt2 = _tt2_forindex_rep_stringl;
{Nat1 ll1; ll1 = _ll1_forindex_rep_stringl;
{_tt1_forindex_rep_stringl = x1; _tt2_forindex_rep_stringl = x2;
_ll1_forindex_rep_stringl = 1;
{
forall_rep_stringl(x1,_ff1_forindex_rep_stringl);

_tt1_forindex_rep_stringl = lt1; _tt2_forindex_rep_stringl = lt2; _ll1_forindex_rep_stringl = ll1;

}}}}}

Rep_stringl sub_tup_rep_stringl (Rep_stringl x1,Nat1 x2,Nat0 x3)
{Rep_stringl lx1 = mk_empty_rep_stringl();
Nat0 lx2 = len_rep_stringl(x1);
Nat0 lx3 = x2;
if (lx2 < x3)
x3 = lx2;
while (lx3 <= x3)
lx1 = appr_rep_stringl(lx1,sel_rep_stringl(x1,lx3++));

del1_rep_stringl(x1);
return lx1;
}

static Rep_stringl _rr1_rmv1d_rep_stringl;
static Rep_stringl _tt1_rmv1d_rep_stringl; static Nat1 _tt2_rmv1d_rep_stringl;

static void _ff1_rmv1d_rep_stringl(Str y1,Nat1 y2)

{if (y2 == _tt2_rmv1d_rep_stringl) del_str(y1); else _rr1_rmv1d_rep_stringl = appr_rep_stringl(_rr1_rmv1d_rep_stringl,y1);}

Rep_stringl rmv1d_rep_stringl(Rep_stringl x1,Nat1 x2)

{Rep_stringl lr1; lr1 = _rr1_rmv1d_rep_stringl;
{Rep_stringl lt1; Nat1 lt2; lt1 = _tt1_rmv1d_rep_stringl; lt2 = _tt2_rmv1d_rep_stringl;
{
{_tt1_rmv1d_rep_stringl = x1; _tt2_rmv1d_rep_stringl = x2;

{_rr1_rmv1d_rep_stringl = mk_empty_rep_stringl();
forindex_rep_stringl(x1,_ff1_rmv1d_rep_stringl);
del1_rep_stringl(x1);
_tt1_rmv1d_rep_stringl = lt1; _tt2_rmv1d_rep_stringl = lt2;
{Rep_stringl lr2; lr2 = _rr1_rmv1d_rep_stringl; _rr1_rmv1d_rep_stringl = lr1; return lr2;}
}}}}}

Str sel_rep_stringl (Rep_stringl x1,Nat1 x2)
{
Nat0 len = 0;

while (x1)
{
if (++len == x2)
return ref_rep_stringl(x1)->f_info;

x1=x1->f_next;
}

err_sel_vdmlib(x2,len,"Rep_stringl");

return x1->f_info;
}

Nat0 len_rep_stringl (Rep_stringl x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_rep_stringl(x1)->f_next;}
return lx1;
}

static Rep_stringl _tt1_del_rep_stringl;

static void _ff1_del_rep_stringl(Str y1)

{del_str(y1);}

void del_rep_stringl(Rep_stringl x1)

{
{Rep_stringl lt1; lt1 = _tt1_del_rep_stringl;
{
{_tt1_del_rep_stringl = x1;

{
forall_rep_stringl(x1,_ff1_del_rep_stringl);
del1_rep_stringl(x1);
_tt1_del_rep_stringl = lt1;

}}}}}

Rep_stringl conc_rep_stringl (Rep_stringl x1,Rep_stringl x2)
{Rep_stringl * px1 = & x1;
while (*px1)
{ Rep_stringl lx1 = ref_rep_stringl(*px1);
px1 = &(lx1->f_next);
}
*px1 = x2;
return x1;
}

Rep_stringl sub_tupd_rep_stringl (Rep_stringl x1,Nat1 x2,Nat0 x3)
{Rep_stringl lx1 = mk_empty_rep_stringl();
Nat0 lx2 = len_rep_stringl(x1);
Nat0 lx3 = x2;
if (lx2 < x3)
x3 = lx2;
while (lx3 <= x3)
lx1 = appr_rep_stringl(lx1,sel_rep_stringl(x1,lx3++));
{ Nat0 i=1; while (i != x2 ) del_str(sel_rep_stringl(x1,(i++))); } { Nat0 i=x3; while (i != lx2) del_str(sel_rep_stringl(x1,(++i))); }
del1_rep_stringl(x1);
return lx1;
}

Rep_stringl copy_rep_stringl (Rep_stringl x1)
{Rep_stringl x2 = (Rep_stringl)0;
register Rep_stringl * px2 = & x2;
while (x1)
{*px2 = alloc_rep_stringl();
*(*px2) = *(ref_rep_stringl(x1));
(*px2)->f_info = copy_str((*px2)->f_info);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Rep_stringl mk1_rep_stringl(Str x1)

{Rep_stringl lx1 = alloc_rep_stringl();
lx1->f_next = (Rep_stringl)0;
lx1->f_info = x1;
return lx1;
}

Rep_stringl insert_rep_stringl (Rep_stringl x1,Nat1 x2,Str x3)
{ Nat0 lx1 = len_rep_stringl(x1);
Rep_stringl lx2 = copy1_rep_stringl(x1);

if (x2 > lx1 + 1) err_sel_vdmlib(x2,lx1,"Rep_stringl");
return conc_rep_stringl(appr_rep_stringl(sub_tup_rep_stringl(lx2,1,x2-1)
,x3)
,sub_tup_rep_stringl(x1,x2,lx1));
}

Rep_stringl copy1_rep_stringl (Rep_stringl x1)
{Rep_stringl x2 = (Rep_stringl)0;
register Rep_stringl * px2 = & x2;
while (x1)
{*px2 = alloc_rep_stringl();
*(*px2) = *(ref_rep_stringl(x1));

px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Outbytes alloc_outbytes (void)
{Outbytes x1; x1 = (Outbytes)0;
while (! (x1 = (Outbytes)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_outbytes");
;
;
return x1;
}

void free_outbytes (Outbytes x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Inbytes alloc_inbytes (void)
{Inbytes x1; x1 = (Inbytes)0;
while (! (x1 = (Inbytes)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_inbytes");
;
;
return x1;
}

void free_inbytes (Inbytes x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

void cond_clone_stringl (Stringl * x1)
{
if ((*x1)->f_rc > 1)
{
Stringl clone = alloc_stringl();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_stringl((*x1)->f_rep);
*x1 = clone;
}
}
void del_stringl (Stringl x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_stringl(x1->f_rep);
free_stringl(x1);
}
}

Stringl mk1_stringl (Str x1)
{
Stringl l = alloc_stringl();
l->f_rc = 1;
x1 = copy_str(x1);
l->f_rep = mk1_rep_stringl (x1);
return l;
}

Str sel_stringl (Stringl x1,Nat0 x2)
{
check_handle_stringl(x1);
return copy_str(sel_rep_stringl (x1->f_rep,x2));
}
Stringl tl_stringl (Stringl x1)
{
check_handle_stringl(x1);
cond_clone_stringl(&x1);
x1->f_rep = tld_rep_stringl(x1->f_rep);
return x1;
}

Stringl conc_stringl (Stringl x1,Stringl x2)
{
check_handle_stringl(x1);
check_handle_stringl(x2);
{
Rep_stringl lrep2 = copy_rep_stringl(x2->f_rep);
cond_clone_stringl(&x1);
x1->f_rep = conc_rep_stringl(x1->f_rep,lrep2);
}
return x1;
}

Str hd_stringl (Stringl x1)
{
check_handle_stringl(x1);
return copy_str(hd_rep_stringl (x1->f_rep));
}

Stringl mk_empty_stringl (void)
{
Stringl l = alloc_stringl();
l->f_rc = 1;
l->f_rep = mk_empty_rep_stringl ();
return l;
}

Stringl sub_tup_stringl (Stringl x1,Nat1 x2,Nat0 x3)
{
check_handle_stringl(x1);
cond_clone_stringl(&x1);
x1->f_rep = sub_tupd_rep_stringl (x1->f_rep,x2,x3) ;
return x1;
}

Bool is_empty_stringl (Stringl x1)
{
check_handle_stringl(x1);
return is_empty_rep_stringl (x1->f_rep  ) ;
}

Stringl appl_stringl (Str x1,Stringl x2)
{
check_handle_stringl(x2);
cond_clone_stringl(&x2);
x1 = copy_str(x1);
x2->f_rep = appl_rep_stringl(x1,x2->f_rep);
return x2;
}

Stringl appr_stringl (Stringl x1,Str x2)
{
check_handle_stringl(x1);
cond_clone_stringl(&x1);
x2 = copy_str(x2);
x1->f_rep = appr_rep_stringl (x1->f_rep,x2) ;
return x1;
}

Nat0 len_stringl (Stringl x1)
{
check_handle_stringl(x1);
return len_rep_stringl (x1->f_rep  ) ;
}

Iter_rep_str mk_iter_rep_str (Rep_str x1)  {
Iter_rep_str lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_str (Iter_rep_str * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_str");
x1->f_curser++;
}

Char sel_iter_rep_str (Iter_rep_str * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_str");

return
*(((Char *)(x1->f_array +1)) + x1->f_curser);
}

Iter_rep_stringl mk_iter_rep_stringl (Rep_stringl x1)  {
Iter_rep_stringl lx;
lx.f_curser = x1;
lx.f_list = x1;
return lx;
}
void next_iter_rep_stringl (Iter_rep_stringl * x1)  {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_stringl");
x1->f_curser = x1->f_curser->f_next;
}

Str sel_iter_rep_stringl (Iter_rep_stringl * x1)  {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_stringl");

return
x1->f_curser->f_info;
}

Iter_str mk_iter_str (Str x1)  {
Iter_str lx1;
check_handle_str(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_str(x1->f_rep);
return lx1;
}
Iter_stringl mk_iter_stringl (Stringl x1)  {
Iter_stringl lx1;
check_handle_stringl(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_stringl(x1->f_rep);
return lx1;
}

static Bool _rr1_is_subset_rep_strings;
static Rep_strings _tt1_is_subset_rep_strings; static Rep_strings _tt2_is_subset_rep_strings;

static void _ff1_is_subset_rep_strings(Str y1)

{_rr1_is_subset_rep_strings = _rr1_is_subset_rep_strings && is_in_rep_strings(y1,_tt2_is_subset_rep_strings);}

Bool is_subset_rep_strings(Rep_strings x1,Rep_strings x2)

{Bool lr1; lr1 = _rr1_is_subset_rep_strings;
{Rep_strings lt1; Rep_strings lt2; lt1 = _tt1_is_subset_rep_strings; lt2 = _tt2_is_subset_rep_strings;
{
{_tt1_is_subset_rep_strings = x1; _tt2_is_subset_rep_strings = x2;

{_rr1_is_subset_rep_strings = (card_rep_strings(_tt1_is_subset_rep_strings) <= card_rep_strings(_tt2_is_subset_rep_strings));
if (_rr1_is_subset_rep_strings) forall_rep_strings(x1,_ff1_is_subset_rep_strings);

_tt1_is_subset_rep_strings = lt1; _tt2_is_subset_rep_strings = lt2;
{Bool lr2; lr2 = _rr1_is_subset_rep_strings; _rr1_is_subset_rep_strings = lr1; return lr2;}
}}}}}

Rep_strings union1_rep_strings(Rep_strings x1, Str x2)

{register Rep_strings lx1 = x1;
while (lx1)
{if (is_eq_str(ref_rep_strings(lx1)->f_info,x2)) return x1;
lx1 = lx1->f_next;
}
lx1 = mk1_rep_strings(x2);
lx1->f_next = x1;
return lx1;
}

Rep_strings mk1_rep_strings(Str x1)

{Rep_strings lx1 = alloc_rep_strings();
lx1->f_next = (Rep_strings)0;
lx1->f_info = x1;
return lx1;
}

Rep_strings union1d_rep_strings(Rep_strings x1, Str x2)

{register Rep_strings lx1 = x1;
while (lx1)
{if (is_eq_str(ref_rep_strings(lx1)->f_info,x2)) {del_str(x2);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_strings(x2);
lx1->f_next = x1;
return lx1;
}

Rep_strings sub1d_rep_strings(Rep_strings x1, Str x2)

{register Rep_strings * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_rep_strings(*lx1))->f_info,x2))
{Rep_strings lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info);
free_rep_strings(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Rep_strings copy_rep_strings (Rep_strings x1)
{Rep_strings x2 = (Rep_strings)0;
register Rep_strings * px2 = & x2;
while (x1)
{*px2 = alloc_rep_strings();
*(*px2) = *(ref_rep_strings(x1));
(*px2)->f_info = copy_str((*px2)->f_info);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

static Rep_stringl _rr1_sort_rep_strings;
static Rep_strings _tt1_sort_rep_strings; static Nat0 _ll1_sort_rep_strings;

static void _ff1_sort_rep_strings(Str y1)

{{ Nat1 i = 1; while ( i <= _ll1_sort_rep_strings && is_gr_str(y1,sel_rep_stringl(_rr1_sort_rep_strings,i)) ) i++; _rr1_sort_rep_strings = insert_rep_stringl(_rr1_sort_rep_strings,i,copy_str(y1)); _ll1_sort_rep_strings++; }}

Rep_stringl sort_rep_strings(Rep_strings x1)

{Rep_stringl lr1; lr1 = _rr1_sort_rep_strings;
{Rep_strings lt1; lt1 = _tt1_sort_rep_strings;
{Nat0 ll1; ll1 = _ll1_sort_rep_strings;
{_tt1_sort_rep_strings = x1;
_ll1_sort_rep_strings = 0;
{_rr1_sort_rep_strings = mk_empty_rep_stringl();
forall_rep_strings(x1,_ff1_sort_rep_strings);

_tt1_sort_rep_strings = lt1; _ll1_sort_rep_strings = ll1;
{Rep_stringl lr2; lr2 = _rr1_sort_rep_strings; _rr1_sort_rep_strings = lr1; return lr2;}
}}}}}

Nat0 card_rep_strings (Rep_strings x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_rep_strings(x1)->f_next;}
return lx1;
}

static Rep_strings _rr1_intersd_rep_strings;
static Rep_strings _tt1_intersd_rep_strings; static Rep_strings _tt2_intersd_rep_strings;

static void _ff1_intersd_rep_strings(Str y1)

{if (is_in_rep_strings(y1,_tt2_intersd_rep_strings)) _rr1_intersd_rep_strings = union1_rep_strings(_rr1_intersd_rep_strings,y1); else del_str(y1);}

Rep_strings intersd_rep_strings(Rep_strings x1,Rep_strings x2)

{Rep_strings lr1; lr1 = _rr1_intersd_rep_strings;
{Rep_strings lt1; Rep_strings lt2; lt1 = _tt1_intersd_rep_strings; lt2 = _tt2_intersd_rep_strings;
{
{_tt1_intersd_rep_strings = x1; _tt2_intersd_rep_strings = x2;

{_rr1_intersd_rep_strings = mk_empty_rep_strings();
forall_rep_strings(x1,_ff1_intersd_rep_strings);
del1_rep_strings(x1);del_rep_strings(x2);
_tt1_intersd_rep_strings = lt1; _tt2_intersd_rep_strings = lt2;
{Rep_strings lr2; lr2 = _rr1_intersd_rep_strings; _rr1_intersd_rep_strings = lr1; return lr2;}
}}}}}

Bool is_in_rep_strings(Str x1, Rep_strings x2)

{while (x2)
{if (is_eq_str(ref_rep_strings(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

static Rep_strings _tt1_del_rep_strings;

static void _ff1_del_rep_strings(Str y1)

{del_str(y1);}

void del_rep_strings(Rep_strings x1)

{
{Rep_strings lt1; lt1 = _tt1_del_rep_strings;
{
{_tt1_del_rep_strings = x1;

{
forall_rep_strings(x1,_ff1_del_rep_strings);
del1_rep_strings(x1);
_tt1_del_rep_strings = lt1;

}}}}}

#ifndef sub1d_rep_strings
extern Rep_strings sub1d_rep_strings ( Rep_strings x1, Str x2 );
#endif

static Rep_strings _rr1_diffd_rep_strings;
static void _rf1_diffd_rep_strings(Str y1)  {_rr1_diffd_rep_strings = sub1d_rep_strings(_rr1_diffd_rep_strings,y1);}

Rep_strings diffd_rep_strings (Rep_strings x1,Rep_strings x2)
{Rep_strings lr1 = _rr1_diffd_rep_strings;
_rr1_diffd_rep_strings = x1;
forall_rep_strings(x2,_rf1_diffd_rep_strings);
{Rep_strings lr2 = _rr1_diffd_rep_strings; _rr1_diffd_rep_strings = lr1; return lr2;}
}

#ifndef union1d_rep_strings
extern Rep_strings union1d_rep_strings ( Rep_strings x1, Str x2 );
#endif

static Rep_strings _rr1_uniond_rep_strings;
static void _rf1_uniond_rep_strings(Str y1)  {_rr1_uniond_rep_strings = union1d_rep_strings(_rr1_uniond_rep_strings,y1);}

Rep_strings uniond_rep_strings (Rep_strings x1,Rep_strings x2)
{Rep_strings lr1 = _rr1_uniond_rep_strings;
_rr1_uniond_rep_strings = x1;
forall_rep_strings(x2,_rf1_uniond_rep_strings);
del1_rep_strings(x2);
{Rep_strings lr2 = _rr1_uniond_rep_strings; _rr1_uniond_rep_strings = lr1; return lr2;}
}

Bool is_eq_rep_strings (Rep_strings x1,Rep_strings x2)
{return (card_rep_strings(x1) == card_rep_strings(x2))
&& is_subset_rep_strings(x1,x2);
}
void cond_clone_strings (Strings * x1)
{
if ((*x1)->f_rc > 1)
{
Strings clone = alloc_strings();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_strings((*x1)->f_rep);
*x1 = clone;
}
}

Bool is_eq_strings (Strings x1,Strings x2)
{
check_handle_strings(x1);
check_handle_strings(x2);
return is_eq_rep_strings (x1->f_rep , x2->f_rep ) ;
}

void del_strings (Strings x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_strings(x1->f_rep);
free_strings(x1);
}
}

Strings mk1_strings (Str x1)
{
Strings l = alloc_strings();
l->f_rc = 1;
x1 = copy_str(x1);
l->f_rep = mk1_rep_strings (x1);
return l;
}

Strings union1_strings (Strings x1,Str x2)
{
check_handle_strings(x1);
cond_clone_strings(&x1);
x2 = copy_str(x2);
x1->f_rep = union1d_rep_strings (x1->f_rep,x2) ;
return x1;
}
Strings inters_strings (Strings x1,Strings x2)
{
check_handle_strings(x1);
check_handle_strings(x2);
{
Rep_strings lrep2 = copy_rep_strings(x2->f_rep);
cond_clone_strings(&x1);
x1->f_rep = intersd_rep_strings(x1->f_rep,lrep2);
}
return x1;
}
Strings diff_strings (Strings x1,Strings x2)
{
check_handle_strings(x1);
check_handle_strings(x2);
{

cond_clone_strings(&x1);
x1->f_rep = diffd_rep_strings(x1->f_rep,x2->f_rep);
}
return x1;
}

Nat0 card_strings (Strings x1)
{
check_handle_strings(x1);
return card_rep_strings (x1->f_rep  ) ;
}

Strings mk_empty_strings (void)
{
Strings l = alloc_strings();
l->f_rc = 1;
l->f_rep = mk_empty_rep_strings ();
return l;
}

Stringl sort_strings (Strings x1)
{
Stringl lx;

check_handle_strings(x1);
lx = alloc_stringl();
lx->f_rc = 1;
lx->f_rep = sort_rep_strings(x1->f_rep
);
return lx;
}

Bool is_empty_strings (Strings x1)
{
check_handle_strings(x1);
return is_empty_rep_strings (x1->f_rep  ) ;
}

Strings sub1_strings (Strings x1,Str x2)
{
check_handle_strings(x1);
cond_clone_strings(&x1);
x1->f_rep = sub1d_rep_strings (x1->f_rep,x2) ;
return x1;
}
Strings union_strings (Strings x1,Strings x2)
{
check_handle_strings(x1);
check_handle_strings(x2);
{
Rep_strings lrep2 = copy_rep_strings(x2->f_rep);
cond_clone_strings(&x1);
x1->f_rep = uniond_rep_strings(x1->f_rep,lrep2);
}
return x1;
}

Bool is_in_strings (Str x1,Strings x2)
{
check_handle_strings(x2);
return is_in_rep_strings (x1 , x2->f_rep ) ;
}

Strings copy_strings (Strings x1)
{
check_handle_strings(x1);
x1->f_rc++;
return x1;
}
Iter_rep_strings mk_iter_rep_strings (Rep_strings x1)  {
Iter_rep_strings lx;
lx.f_curser = x1;
lx.f_list = x1;
return lx;
}
void next_iter_rep_strings (Iter_rep_strings * x1)  {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_strings");
x1->f_curser = x1->f_curser->f_next;
}

Str sel_iter_rep_strings (Iter_rep_strings * x1)  {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_strings");

return
x1->f_curser->f_info;
}

Iter_strings mk_iter_strings (Strings x1)  {
Iter_strings lx1;
check_handle_strings(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_strings(x1->f_rep);
return lx1;
}
Bool is_eq_rep_context (Rep_context x1,Rep_context x2)
{return 1

&& is_eq_strings(s_rep_adttypes_context_rep_context(x1),s_rep_adttypes_context_rep_context(x2))

&& is_eq_strings(s_rep_special_impl_context_rep_context(x1),s_rep_special_impl_context_rep_context(x2))

&& is_eq_strings(s_rep_special_ops_context_rep_context(x1),s_rep_special_ops_context_rep_context(x2))

&& is_eq_strings(s_rep_filter_adts_context_rep_context(x1),s_rep_filter_adts_context_rep_context(x2))

&& is_eq_strings(s_rep_filter_impl_context_rep_context(x1),s_rep_filter_impl_context_rep_context(x2))

&& is_eq_strings(s_rep_filter_oper_context_rep_context(x1),s_rep_filter_oper_context_rep_context(x2))

&& is_eq_strings(s_rep_filter_comp_context_rep_context(x1),s_rep_filter_comp_context_rep_context(x2))

&& is_eq_strings(s_rep_filter_params_context_rep_context(x1),s_rep_filter_params_context_rep_context(x2))

&& is_eq_strings(s_rep_sign_comps_context_rep_context(x1),s_rep_sign_comps_context_rep_context(x2))

&& is_eq_str(s_rep_operationtype_context_rep_context(x1),s_rep_operationtype_context_rep_context(x2))

;}
Rep_context copy1_rep_context (Rep_context x1)
{Rep_context x2 = alloc_rep_context(); *x2 = *x1; return x2; }
Rep_context mk_rep_context(

Strings x1_rep_adttypes_context_rep_context
,
Strings x1_rep_special_impl_context_rep_context
,
Strings x1_rep_special_ops_context_rep_context
,
Strings x1_rep_filter_adts_context_rep_context
,
Strings x1_rep_filter_impl_context_rep_context
,
Strings x1_rep_filter_oper_context_rep_context
,
Strings x1_rep_filter_comp_context_rep_context
,
Strings x1_rep_filter_params_context_rep_context
,
Strings x1_rep_sign_comps_context_rep_context

,
Str x1_rep_operationtype_context_rep_context

)

{Rep_context lx1 = alloc_rep_context();

lx1->f_rep_adttypes_context_rep_context = x1_rep_adttypes_context_rep_context;

lx1->f_rep_special_impl_context_rep_context = x1_rep_special_impl_context_rep_context;

lx1->f_rep_special_ops_context_rep_context = x1_rep_special_ops_context_rep_context;

lx1->f_rep_filter_adts_context_rep_context = x1_rep_filter_adts_context_rep_context;

lx1->f_rep_filter_impl_context_rep_context = x1_rep_filter_impl_context_rep_context;

lx1->f_rep_filter_oper_context_rep_context = x1_rep_filter_oper_context_rep_context;

lx1->f_rep_filter_comp_context_rep_context = x1_rep_filter_comp_context_rep_context;

lx1->f_rep_filter_params_context_rep_context = x1_rep_filter_params_context_rep_context;

lx1->f_rep_sign_comps_context_rep_context = x1_rep_sign_comps_context_rep_context;

lx1->f_rep_operationtype_context_rep_context = x1_rep_operationtype_context_rep_context;

return lx1;
}
Rep_context copy_rep_context (Rep_context x1)
{x1 = copy1_rep_context(x1);

x1->f_rep_adttypes_context_rep_context = copy_strings(ref_rep_context(x1)->f_rep_adttypes_context_rep_context);

x1->f_rep_special_impl_context_rep_context = copy_strings(ref_rep_context(x1)->f_rep_special_impl_context_rep_context);

x1->f_rep_special_ops_context_rep_context = copy_strings(ref_rep_context(x1)->f_rep_special_ops_context_rep_context);

x1->f_rep_filter_adts_context_rep_context = copy_strings(ref_rep_context(x1)->f_rep_filter_adts_context_rep_context);

x1->f_rep_filter_impl_context_rep_context = copy_strings(ref_rep_context(x1)->f_rep_filter_impl_context_rep_context);

x1->f_rep_filter_oper_context_rep_context = copy_strings(ref_rep_context(x1)->f_rep_filter_oper_context_rep_context);

x1->f_rep_filter_comp_context_rep_context = copy_strings(ref_rep_context(x1)->f_rep_filter_comp_context_rep_context);

x1->f_rep_filter_params_context_rep_context = copy_strings(ref_rep_context(x1)->f_rep_filter_params_context_rep_context);

x1->f_rep_sign_comps_context_rep_context = copy_strings(ref_rep_context(x1)->f_rep_sign_comps_context_rep_context);

x1->f_rep_operationtype_context_rep_context = copy_str(ref_rep_context(x1)->f_rep_operationtype_context_rep_context);

return x1;
}

Rep_context chg_rep_adttypes_context_rep_context(Rep_context x1,Strings x2_rep_adttypes_context_rep_context)   {ref_rep_context(x1)->f_rep_adttypes_context_rep_context = x2_rep_adttypes_context_rep_context; return x1;}

Rep_context chg_rep_special_impl_context_rep_context(Rep_context x1,Strings x2_rep_special_impl_context_rep_context)   {ref_rep_context(x1)->f_rep_special_impl_context_rep_context = x2_rep_special_impl_context_rep_context; return x1;}

Rep_context chg_rep_special_ops_context_rep_context(Rep_context x1,Strings x2_rep_special_ops_context_rep_context)   {ref_rep_context(x1)->f_rep_special_ops_context_rep_context = x2_rep_special_ops_context_rep_context; return x1;}

Rep_context chg_rep_filter_adts_context_rep_context(Rep_context x1,Strings x2_rep_filter_adts_context_rep_context)   {ref_rep_context(x1)->f_rep_filter_adts_context_rep_context = x2_rep_filter_adts_context_rep_context; return x1;}

Rep_context chg_rep_filter_impl_context_rep_context(Rep_context x1,Strings x2_rep_filter_impl_context_rep_context)   {ref_rep_context(x1)->f_rep_filter_impl_context_rep_context = x2_rep_filter_impl_context_rep_context; return x1;}

Rep_context chg_rep_filter_oper_context_rep_context(Rep_context x1,Strings x2_rep_filter_oper_context_rep_context)   {ref_rep_context(x1)->f_rep_filter_oper_context_rep_context = x2_rep_filter_oper_context_rep_context; return x1;}

Rep_context chg_rep_filter_comp_context_rep_context(Rep_context x1,Strings x2_rep_filter_comp_context_rep_context)   {ref_rep_context(x1)->f_rep_filter_comp_context_rep_context = x2_rep_filter_comp_context_rep_context; return x1;}

Rep_context chg_rep_filter_params_context_rep_context(Rep_context x1,Strings x2_rep_filter_params_context_rep_context)   {ref_rep_context(x1)->f_rep_filter_params_context_rep_context = x2_rep_filter_params_context_rep_context; return x1;}

Rep_context chg_rep_sign_comps_context_rep_context(Rep_context x1,Strings x2_rep_sign_comps_context_rep_context)   {ref_rep_context(x1)->f_rep_sign_comps_context_rep_context = x2_rep_sign_comps_context_rep_context; return x1;}

Rep_context chg_rep_operationtype_context_rep_context(Rep_context x1,Str x2_rep_operationtype_context_rep_context)   {ref_rep_context(x1)->f_rep_operationtype_context_rep_context = x2_rep_operationtype_context_rep_context; return x1;}

void del_rep_context (Rep_context x1)
{

del_strings(s_rep_adttypes_context_rep_context(x1));

del_strings(s_rep_special_impl_context_rep_context(x1));

del_strings(s_rep_special_ops_context_rep_context(x1));

del_strings(s_rep_filter_adts_context_rep_context(x1));

del_strings(s_rep_filter_impl_context_rep_context(x1));

del_strings(s_rep_filter_oper_context_rep_context(x1));

del_strings(s_rep_filter_comp_context_rep_context(x1));

del_strings(s_rep_filter_params_context_rep_context(x1));

del_strings(s_rep_sign_comps_context_rep_context(x1));

del_str(s_rep_operationtype_context_rep_context(x1));

del1_rep_context(x1);
}

#ifndef cvtotuppair_rep_operation
extern Outbytes cvtotuppair_rep_operation ( Outbytes x1, Compname x2, Component x3 );
#endif

static Outbytes _rr1_cvtotupelems_rep_operation;
static void _rf1_cvtotupelems_rep_operation(Compname y1, Component y2)   {_rr1_cvtotupelems_rep_operation = cvtotuppair_rep_operation(_rr1_cvtotupelems_rep_operation,y1,y2);}

Outbytes cvtotupelems_rep_operation (Outbytes x1,Rep_operation x2)
{Outbytes lr1 = _rr1_cvtotupelems_rep_operation;
_rr1_cvtotupelems_rep_operation = x1;
forall_rep_operation(x2,_rf1_cvtotupelems_rep_operation);
{Outbytes lr2 = _rr1_cvtotupelems_rep_operation; _rr1_cvtotupelems_rep_operation = lr1; return lr2;}
}

Outbytes cvtotuppair_rep_operation (Outbytes x1,Compname x2,Component x3)
{ return cvtotup1_component(cvtotup1_compname(x1,x2),x3); }

Outbytes cvtotup1_rep_operation (Outbytes x1,Rep_operation x2)
{ return cvtotupelems_rep_operation(cvtotup1_nat0(x1,card_rep_operation(x2)),x2); }

static Bool _rr1_is_submap_rep_operation;
static Rep_operation _tt1_is_submap_rep_operation; static Rep_operation _tt2_is_submap_rep_operation;

static void _ff1_is_submap_rep_operation(Compname y1,Component y2)

{{Component z2; _rr1_is_submap_rep_operation = _rr1_is_submap_rep_operation && is_in_dom_rep_operation(y1,_tt2_is_submap_rep_operation,&z2) && is_eq_component(y2,z2);}}

Bool is_submap_rep_operation(Rep_operation x1,Rep_operation x2)

{Bool lr1; lr1 = _rr1_is_submap_rep_operation;
{Rep_operation lt1; Rep_operation lt2; lt1 = _tt1_is_submap_rep_operation; lt2 = _tt2_is_submap_rep_operation;
{
{_tt1_is_submap_rep_operation = x1; _tt2_is_submap_rep_operation = x2;

{_rr1_is_submap_rep_operation = (card_rep_operation(_tt1_is_submap_rep_operation) <= card_rep_operation(_tt2_is_submap_rep_operation));
if (_rr1_is_submap_rep_operation) forall_rep_operation(x1,_ff1_is_submap_rep_operation);

_tt1_is_submap_rep_operation = lt1; _tt2_is_submap_rep_operation = lt2;
{Bool lr2; lr2 = _rr1_is_submap_rep_operation; _rr1_is_submap_rep_operation = lr1; return lr2;}
}}}}}

#ifndef union1d_rep_operation
extern Rep_operation union1d_rep_operation ( Rep_operation x1, Compname x2, Component x3 );
#endif

static Rep_operation _rr1_uniond_rep_operation;
static void _rf1_uniond_rep_operation(Compname y1, Component y2)   {_rr1_uniond_rep_operation = union1d_rep_operation(_rr1_uniond_rep_operation,y1,y2);}

Rep_operation uniond_rep_operation (Rep_operation x1,Rep_operation x2)
{Rep_operation lr1 = _rr1_uniond_rep_operation;
_rr1_uniond_rep_operation = x1;
forall_rep_operation(x2,_rf1_uniond_rep_operation);
del1_rep_operation(x2);
{Rep_operation lr2 = _rr1_uniond_rep_operation; _rr1_uniond_rep_operation = lr1; return lr2;}
}

static Rep_operation _tt1_del_rep_operation;

static void _ff1_del_rep_operation(Compname y1,Component y2)

{del_compname(y1);del_component(y2);}

void del_rep_operation(Rep_operation x1)

{
{Rep_operation lt1; lt1 = _tt1_del_rep_operation;
{
{_tt1_del_rep_operation = x1;

{
forall_rep_operation(x1,_ff1_del_rep_operation);
del1_rep_operation(x1);
_tt1_del_rep_operation = lt1;

}}}}}

Bool is_in_rep_operation(Compname x1, Rep_operation x2)

{while (x2)
{if (is_eq_compname(ref_rep_operation(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Rep_operation union1d_rep_operation(Rep_operation x1, Compname x2, Component x3)

{register Rep_operation lx1 = x1;
while (lx1)
{if (is_eq_compname(ref_rep_operation(lx1)->f_info,x2)) {if (! is_eq_component(ref_rep_operation(lx1)->f_attr,x3)) err_umap_vdmlib("Rep_operation"); del_compname(x2);del_component(x3);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_operation(x2,x3);
lx1->f_next = x1;
return lx1;
}

Component sel_rep_operation (Rep_operation x1,Compname x2)
{while (x1)
{if (is_eq_compname(ref_rep_operation(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Rep_operation");
return x1->f_attr;
}

Rep_operation copy_rep_operation (Rep_operation x1)
{Rep_operation x2 = (Rep_operation)0;
register Rep_operation * px2 = & x2;
while (x1)
{*px2 = alloc_rep_operation();
*(*px2) = *(ref_rep_operation(x1));
(*px2)->f_info = copy_compname((*px2)->f_info); (*px2)->f_attr = copy_component((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Bool is_in_dom_rep_operation(Compname x1, Rep_operation x2, Component * x3)

{while (x2)
{if (is_eq_compname(ref_rep_operation(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Rep_operation ovwrt1d_rep_operation(Rep_operation x1, Compname x2, Component x3)

{register Rep_operation lx1 = x1;
while (lx1)
{if (is_eq_compname(ref_rep_operation(lx1)->f_info,x2)) {del_compname(x2);del_component(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_operation(x2,x3);
lx1->f_next = x1;
return lx1;
}

Rep_operation sub1d_rep_operation(Rep_operation x1, Compname x2)

{register Rep_operation * lx1 = &x1;
while (*lx1)
{if (is_eq_compname((ref_rep_operation(*lx1))->f_info,x2))
{Rep_operation lx2 = *lx1;
*lx1 = lx2->f_next;
del_compname(lx2->f_info); del_component(lx2->f_attr);
free_rep_operation(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Nat0 card_rep_operation (Rep_operation x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_rep_operation(x1)->f_next;}
return lx1;
}

Rep_operation mk1_rep_operation(Compname x1, Component x2)

{Rep_operation lx1 = alloc_rep_operation();
lx1->f_next = (Rep_operation)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

#ifndef mk_empty_rep_strings
extern Rep_strings mk_empty_rep_strings ( void ) ;
#endif

#ifndef uniond_rep_strings
extern Rep_strings uniond_rep_strings ( Rep_strings x1, Rep_strings x2   ) ;
#endif

#ifndef dom_rep_operation_compname_component
extern Rep_strings dom_rep_operation_compname_component ( Compname y1, Component y2    ) ;
#endif

Rep_strings dom_rep_operation(Rep_operation x1     )

{
Rep_strings lx1;
lx1 = mk_empty_rep_strings();
for(;x1 ; x1=ref_rep_operation(x1)->f_next)
{lx1 = uniond_rep_strings(lx1,dom_rep_operation_compname_component(ref_rep_operation(x1)->f_info,x1->f_attr )  );}
return lx1;
}

#ifndef ovwrt1d_rep_operation
extern Rep_operation ovwrt1d_rep_operation ( Rep_operation x1, Compname x2, Component x3 );
#endif

static Rep_operation _rr1_ovwrtd_rep_operation;
static void _rf1_ovwrtd_rep_operation(Compname y1, Component y2)   {_rr1_ovwrtd_rep_operation = ovwrt1d_rep_operation(_rr1_ovwrtd_rep_operation,y1,y2);}

Rep_operation ovwrtd_rep_operation (Rep_operation x1,Rep_operation x2)
{Rep_operation lr1 = _rr1_ovwrtd_rep_operation;
_rr1_ovwrtd_rep_operation = x1;
forall_rep_operation(x2,_rf1_ovwrtd_rep_operation);
del1_rep_operation(x2);
{Rep_operation lr2 = _rr1_ovwrtd_rep_operation; _rr1_ovwrtd_rep_operation = lr1; return lr2;}
}

Bool is_eq_rep_operation (Rep_operation x1,Rep_operation x2)
{return (card_rep_operation(x1) == card_rep_operation(x2))
&& is_submap_rep_operation(x1,x2);
}

Rep_operation cvfromtup1_rep_operation (Inbytes * x1)
{ Nat0 lx1 = cvfromtup1_nat0(x1);
Rep_operation lx2;

lx2 = mk_empty_rep_operation();
for (; lx1 >= 1; lx1--)
{
Compname lx3; Component lx4;
lx3 = cvfromtup1_compname(x1);
lx4 = cvfromtup1_component(x1);
lx2 = union1_rep_operation(lx2,lx3,lx4);
}
return lx2;
}

Rep_operation union1_rep_operation(Rep_operation x1, Compname x2, Component x3)

{register Rep_operation lx1 = x1;
while (lx1)
{if (is_eq_compname(ref_rep_operation(lx1)->f_info,x2)) {if (! is_eq_component(ref_rep_operation(lx1)->f_attr,x3)) err_umap_vdmlib("Rep_operation"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_operation(x2,x3);
lx1->f_next = x1;
return lx1;
}

void cond_clone_context (Context * x1)
{
if ((*x1)->f_rc > 1)
{
Context clone = alloc_context();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_context((*x1)->f_rep);
*x1 = clone;
}
}

Bool is_eq_context (Context x1,Context x2)
{
check_handle_context(x1);
check_handle_context(x2);
return is_eq_rep_context (x1->f_rep , x2->f_rep ) ;
}

Context copy_context (Context x1)
{
check_handle_context(x1);
x1->f_rc++;
return x1;
}

Context chg_adttypes_context(Context x1,Strings x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_strings(x2); del_strings(s_rep_adttypes_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_adttypes_context_rep_context (x1->f_rep,x2); return x1; }

Context chg_special_impl_context(Context x1,Strings x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_strings(x2); del_strings(s_rep_special_impl_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_special_impl_context_rep_context (x1->f_rep,x2); return x1; }

Context chg_special_ops_context(Context x1,Strings x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_strings(x2); del_strings(s_rep_special_ops_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_special_ops_context_rep_context (x1->f_rep,x2); return x1; }

Context chg_filter_adts_context(Context x1,Strings x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_strings(x2); del_strings(s_rep_filter_adts_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_filter_adts_context_rep_context (x1->f_rep,x2); return x1; }

Context chg_filter_impl_context(Context x1,Strings x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_strings(x2); del_strings(s_rep_filter_impl_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_filter_impl_context_rep_context (x1->f_rep,x2); return x1; }

Context chg_filter_oper_context(Context x1,Strings x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_strings(x2); del_strings(s_rep_filter_oper_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_filter_oper_context_rep_context (x1->f_rep,x2); return x1; }

Context chg_filter_comp_context(Context x1,Strings x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_strings(x2); del_strings(s_rep_filter_comp_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_filter_comp_context_rep_context (x1->f_rep,x2); return x1; }

Context chg_filter_params_context(Context x1,Strings x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_strings(x2); del_strings(s_rep_filter_params_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_filter_params_context_rep_context (x1->f_rep,x2); return x1; }

Context chg_sign_comps_context(Context x1,Strings x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_strings(x2); del_strings(s_rep_sign_comps_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_sign_comps_context_rep_context (x1->f_rep,x2); return x1; }

Context chg_operationtype_context(Context x1,Str x2) { check_handle_context(x1); cond_clone_context(&x1); x2 = copy_str(x2); del_str(s_rep_operationtype_context_rep_context(x1->f_rep)); x1->f_rep = chg_rep_operationtype_context_rep_context (x1->f_rep,x2); return x1; }

Context mk_context(

Strings x_adttypes_context
,
Strings x_special_impl_context
,
Strings x_special_ops_context
,
Strings x_filter_adts_context
,
Strings x_filter_impl_context
,
Strings x_filter_oper_context
,
Strings x_filter_comp_context
,
Strings x_filter_params_context
,
Strings x_sign_comps_context

,
Str x_operationtype_context

)
{
Context l = alloc_context();
l->f_rc = 1;

x_adttypes_context = copy_strings( x_adttypes_context );

x_special_impl_context = copy_strings( x_special_impl_context );

x_special_ops_context = copy_strings( x_special_ops_context );

x_filter_adts_context = copy_strings( x_filter_adts_context );

x_filter_impl_context = copy_strings( x_filter_impl_context );

x_filter_oper_context = copy_strings( x_filter_oper_context );

x_filter_comp_context = copy_strings( x_filter_comp_context );

x_filter_params_context = copy_strings( x_filter_params_context );

x_sign_comps_context = copy_strings( x_sign_comps_context );

x_operationtype_context = copy_str( x_operationtype_context );

l->f_rep = mk_rep_context(

x_adttypes_context
,
x_special_impl_context
,
x_special_ops_context
,
x_filter_adts_context
,
x_filter_impl_context
,
x_filter_oper_context
,
x_filter_comp_context
,
x_filter_params_context
,
x_sign_comps_context

,
x_operationtype_context

);
return l;
}

Strings s_adttypes_context(Context x1) { check_handle_context(x1); return copy_strings(s_rep_adttypes_context_rep_context(x1->f_rep)); }

Strings s_special_impl_context(Context x1) { check_handle_context(x1); return copy_strings(s_rep_special_impl_context_rep_context(x1->f_rep)); }

Strings s_special_ops_context(Context x1) { check_handle_context(x1); return copy_strings(s_rep_special_ops_context_rep_context(x1->f_rep)); }

Strings s_filter_adts_context(Context x1) { check_handle_context(x1); return copy_strings(s_rep_filter_adts_context_rep_context(x1->f_rep)); }

Strings s_filter_impl_context(Context x1) { check_handle_context(x1); return copy_strings(s_rep_filter_impl_context_rep_context(x1->f_rep)); }

Strings s_filter_oper_context(Context x1) { check_handle_context(x1); return copy_strings(s_rep_filter_oper_context_rep_context(x1->f_rep)); }

Strings s_filter_comp_context(Context x1) { check_handle_context(x1); return copy_strings(s_rep_filter_comp_context_rep_context(x1->f_rep)); }

Strings s_filter_params_context(Context x1) { check_handle_context(x1); return copy_strings(s_rep_filter_params_context_rep_context(x1->f_rep)); }

Strings s_sign_comps_context(Context x1) { check_handle_context(x1); return copy_strings(s_rep_sign_comps_context_rep_context(x1->f_rep)); }

Str s_operationtype_context(Context x1) { check_handle_context(x1); return copy_str(s_rep_operationtype_context_rep_context(x1->f_rep)); }

void del_context (Context x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_context(x1->f_rep);
free_context(x1);
}
}
void cond_clone_operation (Operation * x1)
{
if ((*x1)->f_rc > 1)
{
Operation clone = alloc_operation();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_operation((*x1)->f_rep);
*x1 = clone;
}
}

Outbytes cvtotup1_operation (Outbytes x1,Operation x2)
{
check_handle_operation(x2);
return cvtotup1_rep_operation(x1, x2->f_rep);
}

Bool is_eq_operation (Operation x1,Operation x2)
{
check_handle_operation(x1);
check_handle_operation(x2);
return is_eq_rep_operation (x1->f_rep , x2->f_rep ) ;
}

void del_operation (Operation x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_operation(x1->f_rep);
free_operation(x1);
}
}

Operation mk1_operation (Compname x1,Component x2)
{
Operation l = alloc_operation();
l->f_rc = 1;
x1 = copy_compname(x1);
x2 = copy_component(x2);
l->f_rep = mk1_rep_operation (x1,x2);
return l;
}

Nat0 card_operation (Operation x1)
{
check_handle_operation(x1);
return card_rep_operation (x1->f_rep  ) ;
}

Operation sub1_operation (Operation x1,Compname x2)
{
check_handle_operation(x1);
cond_clone_operation(&x1);
x1->f_rep = sub1d_rep_operation (x1->f_rep,x2) ;
return x1;
}

Operation ovwrt1_operation (Operation x1,Compname x2,Component x3)
{
check_handle_operation(x1);
cond_clone_operation(&x1);
x2 = copy_compname(x2);
x3 = copy_component(x3);
x1->f_rep = ovwrt1d_rep_operation (x1->f_rep,x2,x3) ;
return x1;
}
Bool is_in_dom_operation (Compname x1,Operation x2,Component * x3)
{
Component lx;
Bool res;
check_handle_operation(x2);
del_component(*x3);
res = is_in_dom_rep_operation(x1,x2->f_rep,&lx);
if (res==TRUE)
*x3 = copy_component(lx);
else
*x3 = 0;
return res;
}

Operation mk_empty_operation (void)
{
Operation l = alloc_operation();
l->f_rc = 1;
l->f_rep = mk_empty_rep_operation ();
return l;
}

Strings dom_operation (Operation x1)
{
Strings lx;

check_handle_operation(x1);
lx = alloc_strings();
lx->f_rc = 1;
lx->f_rep = dom_rep_operation(x1->f_rep
);
return lx;
}

Bool is_empty_operation (Operation x1)
{
check_handle_operation(x1);
return is_empty_rep_operation (x1->f_rep  ) ;
}

Component sel_operation (Operation x1,Compname x2)
{
check_handle_operation(x1);
return copy_component(sel_rep_operation (x1->f_rep,x2));
}
Operation union_operation (Operation x1,Operation x2)
{
check_handle_operation(x1);
check_handle_operation(x2);
{
Rep_operation lrep2 = copy_rep_operation(x2->f_rep);
cond_clone_operation(&x1);
x1->f_rep = uniond_rep_operation(x1->f_rep,lrep2);
}
return x1;
}
Operation ovwrt_operation (Operation x1,Operation x2)
{
check_handle_operation(x1);
check_handle_operation(x2);
{
Rep_operation lrep2 = copy_rep_operation(x2->f_rep);
cond_clone_operation(&x1);
x1->f_rep = ovwrtd_rep_operation(x1->f_rep,lrep2);
}
return x1;
}

Operation union1_operation (Operation x1,Compname x2,Component x3)
{
check_handle_operation(x1);
cond_clone_operation(&x1);
x2 = copy_compname(x2);
x3 = copy_component(x3);
x1->f_rep = union1d_rep_operation (x1->f_rep,x2,x3) ;
return x1;
}

Bool is_in_operation (Compname x1,Operation x2)
{
check_handle_operation(x2);
return is_in_rep_operation (x1 , x2->f_rep ) ;
}

Operation copy_operation (Operation x1)
{
check_handle_operation(x1);
x1->f_rc++;
return x1;
}

Operation cvfromtup1_operation (Inbytes * x1)
{
Operation lx = alloc_operation();
lx->f_rc = 1;
lx->f_rep = cvfromtup1_rep_operation(x1);
return lx;
}

Iter_rep_operation mk_iter_rep_operation (Rep_operation x1)  {
Iter_rep_operation lx;
lx.f_curser = x1;
lx.f_list = x1;
return lx;
}
void next_iter_rep_operation (Iter_rep_operation * x1)  {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_operation");
x1->f_curser = x1->f_curser->f_next;
}

Compname sel_iter_rep_operation (Iter_rep_operation * x1,Component * x2)   {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_operation");
*x2 = x1->f_curser->f_attr;
return
x1->f_curser->f_info;
}

Iter_operation mk_iter_operation (Operation x1)  {
Iter_operation lx1;
check_handle_operation(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_operation(x1->f_rep);
return lx1;
}

#ifndef union1d_rep_contextmap
extern Rep_contextmap union1d_rep_contextmap ( Rep_contextmap x1, Intg x2, Context x3 );
#endif

static Rep_contextmap _rr1_uniond_rep_contextmap;
static void _rf1_uniond_rep_contextmap(Intg y1, Context y2)   {_rr1_uniond_rep_contextmap = union1d_rep_contextmap(_rr1_uniond_rep_contextmap,y1,y2);}

Rep_contextmap uniond_rep_contextmap (Rep_contextmap x1,Rep_contextmap x2)
{Rep_contextmap lr1 = _rr1_uniond_rep_contextmap;
_rr1_uniond_rep_contextmap = x1;
forall_rep_contextmap(x2,_rf1_uniond_rep_contextmap);
del1_rep_contextmap(x2);
{Rep_contextmap lr2 = _rr1_uniond_rep_contextmap; _rr1_uniond_rep_contextmap = lr1; return lr2;}
}

Rep_contextmap mk1_rep_contextmap(Intg x1, Context x2)

{Rep_contextmap lx1 = alloc_rep_contextmap();
lx1->f_next = (Rep_contextmap)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

Nat0 card_rep_contextmap (Rep_contextmap x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_rep_contextmap(x1)->f_next;}
return lx1;
}

Rep_contextmap sub1d_rep_contextmap(Rep_contextmap x1, Intg x2)

{register Rep_contextmap * lx1 = &x1;
while (*lx1)
{if (is_eq_intg((ref_rep_contextmap(*lx1))->f_info,x2))
{Rep_contextmap lx2 = *lx1;
*lx1 = lx2->f_next;
del_intg(lx2->f_info); del_context(lx2->f_attr);
free_rep_contextmap(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Rep_contextmap ovwrt1d_rep_contextmap(Rep_contextmap x1, Intg x2, Context x3)

{register Rep_contextmap lx1 = x1;
while (lx1)
{if (is_eq_intg(ref_rep_contextmap(lx1)->f_info,x2)) {del_intg(x2);del_context(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_contextmap(x2,x3);
lx1->f_next = x1;
return lx1;
}

Bool is_in_dom_rep_contextmap(Intg x1, Rep_contextmap x2, Context * x3)

{while (x2)
{if (is_eq_intg(ref_rep_contextmap(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Rep_contextmap copy_rep_contextmap (Rep_contextmap x1)
{Rep_contextmap x2 = (Rep_contextmap)0;
register Rep_contextmap * px2 = & x2;
while (x1)
{*px2 = alloc_rep_contextmap();
*(*px2) = *(ref_rep_contextmap(x1));
(*px2)->f_info = copy_intg((*px2)->f_info); (*px2)->f_attr = copy_context((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Context sel_rep_contextmap (Rep_contextmap x1,Intg x2)
{while (x1)
{if (is_eq_intg(ref_rep_contextmap(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Rep_contextmap");
return x1->f_attr;
}

Rep_contextmap union1d_rep_contextmap(Rep_contextmap x1, Intg x2, Context x3)

{register Rep_contextmap lx1 = x1;
while (lx1)
{if (is_eq_intg(ref_rep_contextmap(lx1)->f_info,x2)) {if (! is_eq_context(ref_rep_contextmap(lx1)->f_attr,x3)) err_umap_vdmlib("Rep_contextmap"); del_intg(x2);del_context(x3);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_contextmap(x2,x3);
lx1->f_next = x1;
return lx1;
}

Bool is_in_rep_contextmap(Intg x1, Rep_contextmap x2)

{while (x2)
{if (is_eq_intg(ref_rep_contextmap(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

static Rep_contextmap _tt1_del_rep_contextmap;

static void _ff1_del_rep_contextmap(Intg y1,Context y2)

{del_intg(y1);del_context(y2);}

void del_rep_contextmap(Rep_contextmap x1)

{
{Rep_contextmap lt1; lt1 = _tt1_del_rep_contextmap;
{
{_tt1_del_rep_contextmap = x1;

{
forall_rep_contextmap(x1,_ff1_del_rep_contextmap);
del1_rep_contextmap(x1);
_tt1_del_rep_contextmap = lt1;

}}}}}

#ifndef ovwrt1d_rep_contextmap
extern Rep_contextmap ovwrt1d_rep_contextmap ( Rep_contextmap x1, Intg x2, Context x3 );
#endif

static Rep_contextmap _rr1_ovwrtd_rep_contextmap;
static void _rf1_ovwrtd_rep_contextmap(Intg y1, Context y2)   {_rr1_ovwrtd_rep_contextmap = ovwrt1d_rep_contextmap(_rr1_ovwrtd_rep_contextmap,y1,y2);}

Rep_contextmap ovwrtd_rep_contextmap (Rep_contextmap x1,Rep_contextmap x2)
{Rep_contextmap lr1 = _rr1_ovwrtd_rep_contextmap;
_rr1_ovwrtd_rep_contextmap = x1;
forall_rep_contextmap(x2,_rf1_ovwrtd_rep_contextmap);
del1_rep_contextmap(x2);
{Rep_contextmap lr2 = _rr1_ovwrtd_rep_contextmap; _rr1_ovwrtd_rep_contextmap = lr1; return lr2;}
}

static Nat0 len_mfree_context = 0;

static Nat0 cnt_alloc_context = 0;
static Nat0 cnt_free_context = 0;
static Nat0 cnt_mallc_context = 0;
static Nat0 cnt_mfree_context = 0;

void profile_context (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Context");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_context);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_context);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_context);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_context);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_context);
fprintf(stderr,"\n");
}

static VOIDptr freelist_context = (VOIDptr)0;

Context alloc_context (void)
{Context x1;
cnt_alloc_context ++;
if (! freelist_context)
{while (! (x1 = (Context)ALLOCMEM_vdmlib(sizeof(struct Handle_context)))) heap_oflw_vdmlib("Heap_context");
cnt_mallc_context ++;
return x1;
}
freelist_context = *((VOIDptr *)(x1 = (Context) freelist_context));
len_mfree_context --;
return x1;
}

void free_context (Context x1)
{len_mfree_context ++;
cnt_free_context ++;
*((VOIDptr *)x1) = freelist_context;
freelist_context = (VOIDptr)x1;
if (len_mfree_context > 100)
{while (len_mfree_context > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_context);
FREEMEM_vdmlib(freelist_context,sizeof(struct Handle_context));
freelist_context = lx1;
len_mfree_context --;
cnt_mfree_context ++;
}
}
}

#ifndef cvtotuppair_rep_impl
extern Outbytes cvtotuppair_rep_impl ( Outbytes x1, Opname x2, Operation x3 );
#endif

static Outbytes _rr1_cvtotupelems_rep_impl;
static void _rf1_cvtotupelems_rep_impl(Opname y1, Operation y2)   {_rr1_cvtotupelems_rep_impl = cvtotuppair_rep_impl(_rr1_cvtotupelems_rep_impl,y1,y2);}

Outbytes cvtotupelems_rep_impl (Outbytes x1,Rep_impl x2)
{Outbytes lr1 = _rr1_cvtotupelems_rep_impl;
_rr1_cvtotupelems_rep_impl = x1;
forall_rep_impl(x2,_rf1_cvtotupelems_rep_impl);
{Outbytes lr2 = _rr1_cvtotupelems_rep_impl; _rr1_cvtotupelems_rep_impl = lr1; return lr2;}
}

static Bool _rr1_is_submap_rep_impl;
static Rep_impl _tt1_is_submap_rep_impl; static Rep_impl _tt2_is_submap_rep_impl;

static void _ff1_is_submap_rep_impl(Opname y1,Operation y2)

{{Operation z2; _rr1_is_submap_rep_impl = _rr1_is_submap_rep_impl && is_in_dom_rep_impl(y1,_tt2_is_submap_rep_impl,&z2) && is_eq_operation(y2,z2);}}

Bool is_submap_rep_impl(Rep_impl x1,Rep_impl x2)

{Bool lr1; lr1 = _rr1_is_submap_rep_impl;
{Rep_impl lt1; Rep_impl lt2; lt1 = _tt1_is_submap_rep_impl; lt2 = _tt2_is_submap_rep_impl;
{
{_tt1_is_submap_rep_impl = x1; _tt2_is_submap_rep_impl = x2;

{_rr1_is_submap_rep_impl = (card_rep_impl(_tt1_is_submap_rep_impl) <= card_rep_impl(_tt2_is_submap_rep_impl));
if (_rr1_is_submap_rep_impl) forall_rep_impl(x1,_ff1_is_submap_rep_impl);

_tt1_is_submap_rep_impl = lt1; _tt2_is_submap_rep_impl = lt2;
{Bool lr2; lr2 = _rr1_is_submap_rep_impl; _rr1_is_submap_rep_impl = lr1; return lr2;}
}}}}}

Rep_impl cvfromtup1_rep_impl (Inbytes * x1)
{ Nat0 lx1 = cvfromtup1_nat0(x1);
Rep_impl lx2;

lx2 = mk_empty_rep_impl();
for (; lx1 >= 1; lx1--)
{
Opname lx3; Operation lx4;
lx3 = cvfromtup1_opname(x1);
lx4 = cvfromtup1_operation(x1);
lx2 = union1_rep_impl(lx2,lx3,lx4);
}
return lx2;
}

#ifndef union1d_rep_impl
extern Rep_impl union1d_rep_impl ( Rep_impl x1, Opname x2, Operation x3 );
#endif

static Rep_impl _rr1_uniond_rep_impl;
static void _rf1_uniond_rep_impl(Opname y1, Operation y2)   {_rr1_uniond_rep_impl = union1d_rep_impl(_rr1_uniond_rep_impl,y1,y2);}

Rep_impl uniond_rep_impl (Rep_impl x1,Rep_impl x2)
{Rep_impl lr1 = _rr1_uniond_rep_impl;
_rr1_uniond_rep_impl = x1;
forall_rep_impl(x2,_rf1_uniond_rep_impl);
del1_rep_impl(x2);
{Rep_impl lr2 = _rr1_uniond_rep_impl; _rr1_uniond_rep_impl = lr1; return lr2;}
}

static Rep_impl _tt1_del_rep_impl;

static void _ff1_del_rep_impl(Opname y1,Operation y2)

{del_opname(y1);del_operation(y2);}

void del_rep_impl(Rep_impl x1)

{
{Rep_impl lt1; lt1 = _tt1_del_rep_impl;
{
{_tt1_del_rep_impl = x1;

{
forall_rep_impl(x1,_ff1_del_rep_impl);
del1_rep_impl(x1);
_tt1_del_rep_impl = lt1;

}}}}}

Bool is_in_rep_impl(Opname x1, Rep_impl x2)

{while (x2)
{if (is_eq_opname(ref_rep_impl(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Rep_impl union1d_rep_impl(Rep_impl x1, Opname x2, Operation x3)

{register Rep_impl lx1 = x1;
while (lx1)
{if (is_eq_opname(ref_rep_impl(lx1)->f_info,x2)) {if (! is_eq_operation(ref_rep_impl(lx1)->f_attr,x3)) err_umap_vdmlib("Rep_impl"); del_opname(x2);del_operation(x3);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_impl(x2,x3);
lx1->f_next = x1;
return lx1;
}

Operation sel_rep_impl (Rep_impl x1,Opname x2)
{while (x1)
{if (is_eq_opname(ref_rep_impl(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Rep_impl");
return x1->f_attr;
}

Rep_impl copy_rep_impl (Rep_impl x1)
{Rep_impl x2 = (Rep_impl)0;
register Rep_impl * px2 = & x2;
while (x1)
{*px2 = alloc_rep_impl();
*(*px2) = *(ref_rep_impl(x1));
(*px2)->f_info = copy_opname((*px2)->f_info); (*px2)->f_attr = copy_operation((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Bool is_in_dom_rep_impl(Opname x1, Rep_impl x2, Operation * x3)

{while (x2)
{if (is_eq_opname(ref_rep_impl(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Rep_impl ovwrt1d_rep_impl(Rep_impl x1, Opname x2, Operation x3)

{register Rep_impl lx1 = x1;
while (lx1)
{if (is_eq_opname(ref_rep_impl(lx1)->f_info,x2)) {del_opname(x2);del_operation(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_impl(x2,x3);
lx1->f_next = x1;
return lx1;
}

Rep_impl sub1d_rep_impl(Rep_impl x1, Opname x2)

{register Rep_impl * lx1 = &x1;
while (*lx1)
{if (is_eq_opname((ref_rep_impl(*lx1))->f_info,x2))
{Rep_impl lx2 = *lx1;
*lx1 = lx2->f_next;
del_opname(lx2->f_info); del_operation(lx2->f_attr);
free_rep_impl(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Nat0 card_rep_impl (Rep_impl x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_rep_impl(x1)->f_next;}
return lx1;
}

Rep_impl mk1_rep_impl(Opname x1, Operation x2)

{Rep_impl lx1 = alloc_rep_impl();
lx1->f_next = (Rep_impl)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

#ifndef mk_empty_rep_strings
extern Rep_strings mk_empty_rep_strings ( void ) ;
#endif

#ifndef uniond_rep_strings
extern Rep_strings uniond_rep_strings ( Rep_strings x1, Rep_strings x2   ) ;
#endif

#ifndef dom_rep_impl_opname_operation
extern Rep_strings dom_rep_impl_opname_operation ( Opname y1, Operation y2    ) ;
#endif

Rep_strings dom_rep_impl(Rep_impl x1     )

{
Rep_strings lx1;
lx1 = mk_empty_rep_strings();
for(;x1 ; x1=ref_rep_impl(x1)->f_next)
{lx1 = uniond_rep_strings(lx1,dom_rep_impl_opname_operation(ref_rep_impl(x1)->f_info,x1->f_attr )  );}
return lx1;
}

#ifndef ovwrt1d_rep_impl
extern Rep_impl ovwrt1d_rep_impl ( Rep_impl x1, Opname x2, Operation x3 );
#endif

static Rep_impl _rr1_ovwrtd_rep_impl;
static void _rf1_ovwrtd_rep_impl(Opname y1, Operation y2)   {_rr1_ovwrtd_rep_impl = ovwrt1d_rep_impl(_rr1_ovwrtd_rep_impl,y1,y2);}

Rep_impl ovwrtd_rep_impl (Rep_impl x1,Rep_impl x2)
{Rep_impl lr1 = _rr1_ovwrtd_rep_impl;
_rr1_ovwrtd_rep_impl = x1;
forall_rep_impl(x2,_rf1_ovwrtd_rep_impl);
del1_rep_impl(x2);
{Rep_impl lr2 = _rr1_ovwrtd_rep_impl; _rr1_ovwrtd_rep_impl = lr1; return lr2;}
}

Bool is_eq_rep_impl (Rep_impl x1,Rep_impl x2)
{return (card_rep_impl(x1) == card_rep_impl(x2))
&& is_submap_rep_impl(x1,x2);
}

Outbytes cvtotuppair_rep_impl (Outbytes x1,Opname x2,Operation x3)
{ return cvtotup1_operation(cvtotup1_opname(x1,x2),x3); }

Outbytes cvtotup1_rep_impl (Outbytes x1,Rep_impl x2)
{ return cvtotupelems_rep_impl(cvtotup1_nat0(x1,card_rep_impl(x2)),x2); }

Rep_impl union1_rep_impl(Rep_impl x1, Opname x2, Operation x3)

{register Rep_impl lx1 = x1;
while (lx1)
{if (is_eq_opname(ref_rep_impl(lx1)->f_info,x2)) {if (! is_eq_operation(ref_rep_impl(lx1)->f_attr,x3)) err_umap_vdmlib("Rep_impl"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_impl(x2,x3);
lx1->f_next = x1;
return lx1;
}

void cond_clone_contextmap (ContextMap * x1)
{
if ((*x1)->f_rc > 1)
{
ContextMap clone = alloc_contextmap();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_contextmap((*x1)->f_rep);
*x1 = clone;
}
}
void del_contextmap (ContextMap x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_contextmap(x1->f_rep);
free_contextmap(x1);
}
}

ContextMap mk1_contextmap (Intg x1,Context x2)
{
ContextMap l = alloc_contextmap();
l->f_rc = 1;
x1 = copy_intg(x1);
x2 = copy_context(x2);
l->f_rep = mk1_rep_contextmap (x1,x2);
return l;
}

Nat0 card_contextmap (ContextMap x1)
{
check_handle_contextmap(x1);
return card_rep_contextmap (x1->f_rep  ) ;
}

ContextMap sub1_contextmap (ContextMap x1,Intg x2)
{
check_handle_contextmap(x1);
cond_clone_contextmap(&x1);
x1->f_rep = sub1d_rep_contextmap (x1->f_rep,x2) ;
return x1;
}

ContextMap ovwrt1_contextmap (ContextMap x1,Intg x2,Context x3)
{
check_handle_contextmap(x1);
cond_clone_contextmap(&x1);
x2 = copy_intg(x2);
x3 = copy_context(x3);
x1->f_rep = ovwrt1d_rep_contextmap (x1->f_rep,x2,x3) ;
return x1;
}
Bool is_in_dom_contextmap (Intg x1,ContextMap x2,Context * x3)
{
Context lx;
Bool res;
check_handle_contextmap(x2);
del_context(*x3);
res = is_in_dom_rep_contextmap(x1,x2->f_rep,&lx);
if (res==TRUE)
*x3 = copy_context(lx);
else
*x3 = 0;
return res;
}

ContextMap mk_empty_contextmap (void)
{
ContextMap l = alloc_contextmap();
l->f_rc = 1;
l->f_rep = mk_empty_rep_contextmap ();
return l;
}

Bool is_empty_contextmap (ContextMap x1)
{
check_handle_contextmap(x1);
return is_empty_rep_contextmap (x1->f_rep  ) ;
}

Context sel_contextmap (ContextMap x1,Intg x2)
{
check_handle_contextmap(x1);
return copy_context(sel_rep_contextmap (x1->f_rep,x2));
}
ContextMap union_contextmap (ContextMap x1,ContextMap x2)
{
check_handle_contextmap(x1);
check_handle_contextmap(x2);
{
Rep_contextmap lrep2 = copy_rep_contextmap(x2->f_rep);
cond_clone_contextmap(&x1);
x1->f_rep = uniond_rep_contextmap(x1->f_rep,lrep2);
}
return x1;
}
ContextMap ovwrt_contextmap (ContextMap x1,ContextMap x2)
{
check_handle_contextmap(x1);
check_handle_contextmap(x2);
{
Rep_contextmap lrep2 = copy_rep_contextmap(x2->f_rep);
cond_clone_contextmap(&x1);
x1->f_rep = ovwrtd_rep_contextmap(x1->f_rep,lrep2);
}
return x1;
}

ContextMap union1_contextmap (ContextMap x1,Intg x2,Context x3)
{
check_handle_contextmap(x1);
cond_clone_contextmap(&x1);
x2 = copy_intg(x2);
x3 = copy_context(x3);
x1->f_rep = union1d_rep_contextmap (x1->f_rep,x2,x3) ;
return x1;
}

Bool is_in_contextmap (Intg x1,ContextMap x2)
{
check_handle_contextmap(x2);
return is_in_rep_contextmap (x1 , x2->f_rep ) ;
}

void cond_clone_impl (Impl * x1)
{
if ((*x1)->f_rc > 1)
{
Impl clone = alloc_impl();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_impl((*x1)->f_rep);
*x1 = clone;
}
}

Outbytes cvtotup1_impl (Outbytes x1,Impl x2)
{
check_handle_impl(x2);
return cvtotup1_rep_impl(x1, x2->f_rep);
}

Bool is_eq_impl (Impl x1,Impl x2)
{
check_handle_impl(x1);
check_handle_impl(x2);
return is_eq_rep_impl (x1->f_rep , x2->f_rep ) ;
}

void del_impl (Impl x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_impl(x1->f_rep);
free_impl(x1);
}
}

Impl mk1_impl (Opname x1,Operation x2)
{
Impl l = alloc_impl();
l->f_rc = 1;
x1 = copy_opname(x1);
x2 = copy_operation(x2);
l->f_rep = mk1_rep_impl (x1,x2);
return l;
}

Nat0 card_impl (Impl x1)
{
check_handle_impl(x1);
return card_rep_impl (x1->f_rep  ) ;
}

Impl sub1_impl (Impl x1,Opname x2)
{
check_handle_impl(x1);
cond_clone_impl(&x1);
x1->f_rep = sub1d_rep_impl (x1->f_rep,x2) ;
return x1;
}

Impl ovwrt1_impl (Impl x1,Opname x2,Operation x3)
{
check_handle_impl(x1);
cond_clone_impl(&x1);
x2 = copy_opname(x2);
x3 = copy_operation(x3);
x1->f_rep = ovwrt1d_rep_impl (x1->f_rep,x2,x3) ;
return x1;
}
Bool is_in_dom_impl (Opname x1,Impl x2,Operation * x3)
{
Operation lx;
Bool res;
check_handle_impl(x2);
del_operation(*x3);
res = is_in_dom_rep_impl(x1,x2->f_rep,&lx);
if (res==TRUE)
*x3 = copy_operation(lx);
else
*x3 = 0;
return res;
}

Impl mk_empty_impl (void)
{
Impl l = alloc_impl();
l->f_rc = 1;
l->f_rep = mk_empty_rep_impl ();
return l;
}

Strings dom_impl (Impl x1)
{
Strings lx;

check_handle_impl(x1);
lx = alloc_strings();
lx->f_rc = 1;
lx->f_rep = dom_rep_impl(x1->f_rep
);
return lx;
}

Bool is_empty_impl (Impl x1)
{
check_handle_impl(x1);
return is_empty_rep_impl (x1->f_rep  ) ;
}

Operation sel_impl (Impl x1,Opname x2)
{
check_handle_impl(x1);
return copy_operation(sel_rep_impl (x1->f_rep,x2));
}
Impl union_impl (Impl x1,Impl x2)
{
check_handle_impl(x1);
check_handle_impl(x2);
{
Rep_impl lrep2 = copy_rep_impl(x2->f_rep);
cond_clone_impl(&x1);
x1->f_rep = uniond_rep_impl(x1->f_rep,lrep2);
}
return x1;
}
Impl ovwrt_impl (Impl x1,Impl x2)
{
check_handle_impl(x1);
check_handle_impl(x2);
{
Rep_impl lrep2 = copy_rep_impl(x2->f_rep);
cond_clone_impl(&x1);
x1->f_rep = ovwrtd_rep_impl(x1->f_rep,lrep2);
}
return x1;
}

Impl union1_impl (Impl x1,Opname x2,Operation x3)
{
check_handle_impl(x1);
cond_clone_impl(&x1);
x2 = copy_opname(x2);
x3 = copy_operation(x3);
x1->f_rep = union1d_rep_impl (x1->f_rep,x2,x3) ;
return x1;
}

Bool is_in_impl (Opname x1,Impl x2)
{
check_handle_impl(x2);
return is_in_rep_impl (x1 , x2->f_rep ) ;
}

Impl copy_impl (Impl x1)
{
check_handle_impl(x1);
x1->f_rc++;
return x1;
}

Impl cvfromtup1_impl (Inbytes * x1)
{
Impl lx = alloc_impl();
lx->f_rc = 1;
lx->f_rep = cvfromtup1_rep_impl(x1);
return lx;
}

Iter_rep_contextmap mk_iter_rep_contextmap (Rep_contextmap x1)  {
Iter_rep_contextmap lx;
lx.f_curser = x1;
lx.f_list = x1;
return lx;
}
void next_iter_rep_contextmap (Iter_rep_contextmap * x1)  {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_contextmap");
x1->f_curser = x1->f_curser->f_next;
}

Intg sel_iter_rep_contextmap (Iter_rep_contextmap * x1,Context * x2)   {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_contextmap");
*x2 = x1->f_curser->f_attr;
return
x1->f_curser->f_info;
}

Iter_rep_impl mk_iter_rep_impl (Rep_impl x1)  {
Iter_rep_impl lx;
lx.f_curser = x1;
lx.f_list = x1;
return lx;
}
void next_iter_rep_impl (Iter_rep_impl * x1)  {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_impl");
x1->f_curser = x1->f_curser->f_next;
}

Opname sel_iter_rep_impl (Iter_rep_impl * x1,Operation * x2)   {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_impl");
*x2 = x1->f_curser->f_attr;
return
x1->f_curser->f_info;
}

Iter_contextmap mk_iter_contextmap (ContextMap x1)  {
Iter_contextmap lx1;
check_handle_contextmap(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_contextmap(x1->f_rep);
return lx1;
}
Iter_impl mk_iter_impl (Impl x1)  {
Iter_impl lx1;
check_handle_impl(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_impl(x1->f_rep);
return lx1;
}

static Bool _rr1_is_submap_rep_adt;
static Rep_adt _tt1_is_submap_rep_adt; static Rep_adt _tt2_is_submap_rep_adt;

static void _ff1_is_submap_rep_adt(Implname y1,Impl y2)

{{Impl z2; _rr1_is_submap_rep_adt = _rr1_is_submap_rep_adt && is_in_dom_rep_adt(y1,_tt2_is_submap_rep_adt,&z2) && is_eq_impl(y2,z2);}}

Bool is_submap_rep_adt(Rep_adt x1,Rep_adt x2)

{Bool lr1; lr1 = _rr1_is_submap_rep_adt;
{Rep_adt lt1; Rep_adt lt2; lt1 = _tt1_is_submap_rep_adt; lt2 = _tt2_is_submap_rep_adt;
{
{_tt1_is_submap_rep_adt = x1; _tt2_is_submap_rep_adt = x2;

{_rr1_is_submap_rep_adt = (card_rep_adt(_tt1_is_submap_rep_adt) <= card_rep_adt(_tt2_is_submap_rep_adt));
if (_rr1_is_submap_rep_adt) forall_rep_adt(x1,_ff1_is_submap_rep_adt);

_tt1_is_submap_rep_adt = lt1; _tt2_is_submap_rep_adt = lt2;
{Bool lr2; lr2 = _rr1_is_submap_rep_adt; _rr1_is_submap_rep_adt = lr1; return lr2;}
}}}}}

Rep_adt union1_rep_adt(Rep_adt x1, Implname x2, Impl x3)

{register Rep_adt lx1 = x1;
while (lx1)
{if (is_eq_implname(ref_rep_adt(lx1)->f_info,x2)) {if (! is_eq_impl(ref_rep_adt(lx1)->f_attr,x3)) err_umap_vdmlib("Rep_adt"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_adt(x2,x3);
lx1->f_next = x1;
return lx1;
}

#ifndef union1d_rep_adt
extern Rep_adt union1d_rep_adt ( Rep_adt x1, Implname x2, Impl x3 );
#endif

static Rep_adt _rr1_uniond_rep_adt;
static void _rf1_uniond_rep_adt(Implname y1, Impl y2)   {_rr1_uniond_rep_adt = union1d_rep_adt(_rr1_uniond_rep_adt,y1,y2);}

Rep_adt uniond_rep_adt (Rep_adt x1,Rep_adt x2)
{Rep_adt lr1 = _rr1_uniond_rep_adt;
_rr1_uniond_rep_adt = x1;
forall_rep_adt(x2,_rf1_uniond_rep_adt);
del1_rep_adt(x2);
{Rep_adt lr2 = _rr1_uniond_rep_adt; _rr1_uniond_rep_adt = lr1; return lr2;}
}

Outbytes cvtotuppair_rep_adt (Outbytes x1,Implname x2,Impl x3)
{ return cvtotup1_impl(cvtotup1_implname(x1,x2),x3); }

Outbytes cvtotup1_rep_adt (Outbytes x1,Rep_adt x2)
{ return cvtotupelems_rep_adt(cvtotup1_nat0(x1,card_rep_adt(x2)),x2); }

static Rep_adt _tt1_del_rep_adt;

static void _ff1_del_rep_adt(Implname y1,Impl y2)

{del_implname(y1);del_impl(y2);}

void del_rep_adt(Rep_adt x1)

{
{Rep_adt lt1; lt1 = _tt1_del_rep_adt;
{
{_tt1_del_rep_adt = x1;

{
forall_rep_adt(x1,_ff1_del_rep_adt);
del1_rep_adt(x1);
_tt1_del_rep_adt = lt1;

}}}}}

Bool is_in_rep_adt(Implname x1, Rep_adt x2)

{while (x2)
{if (is_eq_implname(ref_rep_adt(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Rep_adt union1d_rep_adt(Rep_adt x1, Implname x2, Impl x3)

{register Rep_adt lx1 = x1;
while (lx1)
{if (is_eq_implname(ref_rep_adt(lx1)->f_info,x2)) {if (! is_eq_impl(ref_rep_adt(lx1)->f_attr,x3)) err_umap_vdmlib("Rep_adt"); del_implname(x2);del_impl(x3);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_adt(x2,x3);
lx1->f_next = x1;
return lx1;
}

Impl sel_rep_adt (Rep_adt x1,Implname x2)
{while (x1)
{if (is_eq_implname(ref_rep_adt(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Rep_adt");
return x1->f_attr;
}

Rep_adt copy_rep_adt (Rep_adt x1)
{Rep_adt x2 = (Rep_adt)0;
register Rep_adt * px2 = & x2;
while (x1)
{*px2 = alloc_rep_adt();
*(*px2) = *(ref_rep_adt(x1));
(*px2)->f_info = copy_implname((*px2)->f_info); (*px2)->f_attr = copy_impl((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Bool is_in_dom_rep_adt(Implname x1, Rep_adt x2, Impl * x3)

{while (x2)
{if (is_eq_implname(ref_rep_adt(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Rep_adt ovwrt1d_rep_adt(Rep_adt x1, Implname x2, Impl x3)

{register Rep_adt lx1 = x1;
while (lx1)
{if (is_eq_implname(ref_rep_adt(lx1)->f_info,x2)) {del_implname(x2);del_impl(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_adt(x2,x3);
lx1->f_next = x1;
return lx1;
}

Rep_adt sub1d_rep_adt(Rep_adt x1, Implname x2)

{register Rep_adt * lx1 = &x1;
while (*lx1)
{if (is_eq_implname((ref_rep_adt(*lx1))->f_info,x2))
{Rep_adt lx2 = *lx1;
*lx1 = lx2->f_next;
del_implname(lx2->f_info); del_impl(lx2->f_attr);
free_rep_adt(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Nat0 card_rep_adt (Rep_adt x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_rep_adt(x1)->f_next;}
return lx1;
}

Rep_adt mk1_rep_adt(Implname x1, Impl x2)

{Rep_adt lx1 = alloc_rep_adt();
lx1->f_next = (Rep_adt)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

#ifndef mk_empty_rep_strings
extern Rep_strings mk_empty_rep_strings ( void ) ;
#endif

#ifndef uniond_rep_strings
extern Rep_strings uniond_rep_strings ( Rep_strings x1, Rep_strings x2   ) ;
#endif

#ifndef dom_rep_adt_implname_impl
extern Rep_strings dom_rep_adt_implname_impl ( Implname y1, Impl y2    ) ;
#endif

Rep_strings dom_rep_adt(Rep_adt x1     )

{
Rep_strings lx1;
lx1 = mk_empty_rep_strings();
for(;x1 ; x1=ref_rep_adt(x1)->f_next)
{lx1 = uniond_rep_strings(lx1,dom_rep_adt_implname_impl(ref_rep_adt(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Rep_adt cvfromtup1_rep_adt (Inbytes * x1)
{ Nat0 lx1 = cvfromtup1_nat0(x1);
Rep_adt lx2;

lx2 = mk_empty_rep_adt();
for (; lx1 >= 1; lx1--)
{
Implname lx3; Impl lx4;
lx3 = cvfromtup1_implname(x1);
lx4 = cvfromtup1_impl(x1);
lx2 = union1_rep_adt(lx2,lx3,lx4);
}
return lx2;
}

#ifndef ovwrt1d_rep_adt
extern Rep_adt ovwrt1d_rep_adt ( Rep_adt x1, Implname x2, Impl x3 );
#endif

static Rep_adt _rr1_ovwrtd_rep_adt;
static void _rf1_ovwrtd_rep_adt(Implname y1, Impl y2)   {_rr1_ovwrtd_rep_adt = ovwrt1d_rep_adt(_rr1_ovwrtd_rep_adt,y1,y2);}

Rep_adt ovwrtd_rep_adt (Rep_adt x1,Rep_adt x2)
{Rep_adt lr1 = _rr1_ovwrtd_rep_adt;
_rr1_ovwrtd_rep_adt = x1;
forall_rep_adt(x2,_rf1_ovwrtd_rep_adt);
del1_rep_adt(x2);
{Rep_adt lr2 = _rr1_ovwrtd_rep_adt; _rr1_ovwrtd_rep_adt = lr1; return lr2;}
}

Bool is_eq_rep_adt (Rep_adt x1,Rep_adt x2)
{return (card_rep_adt(x1) == card_rep_adt(x2))
&& is_submap_rep_adt(x1,x2);
}

#ifndef cvtotuppair_rep_adt
extern Outbytes cvtotuppair_rep_adt ( Outbytes x1, Implname x2, Impl x3 );
#endif

static Outbytes _rr1_cvtotupelems_rep_adt;
static void _rf1_cvtotupelems_rep_adt(Implname y1, Impl y2)   {_rr1_cvtotupelems_rep_adt = cvtotuppair_rep_adt(_rr1_cvtotupelems_rep_adt,y1,y2);}

Outbytes cvtotupelems_rep_adt (Outbytes x1,Rep_adt x2)
{Outbytes lr1 = _rr1_cvtotupelems_rep_adt;
_rr1_cvtotupelems_rep_adt = x1;
forall_rep_adt(x2,_rf1_cvtotupelems_rep_adt);
{Outbytes lr2 = _rr1_cvtotupelems_rep_adt; _rr1_cvtotupelems_rep_adt = lr1; return lr2;}
}

void cond_clone_adt (Adt * x1)
{
if ((*x1)->f_rc > 1)
{
Adt clone = alloc_adt();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_adt((*x1)->f_rep);
*x1 = clone;
}
}

Bool is_eq_adt (Adt x1,Adt x2)
{
check_handle_adt(x1);
check_handle_adt(x2);
return is_eq_rep_adt (x1->f_rep , x2->f_rep ) ;
}

Adt cvfromtup1_adt (Inbytes * x1)
{
Adt lx = alloc_adt();
lx->f_rc = 1;
lx->f_rep = cvfromtup1_rep_adt(x1);
return lx;
}

void del_adt (Adt x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_adt(x1->f_rep);
free_adt(x1);
}
}

Adt mk1_adt (Implname x1,Impl x2)
{
Adt l = alloc_adt();
l->f_rc = 1;
x1 = copy_implname(x1);
x2 = copy_impl(x2);
l->f_rep = mk1_rep_adt (x1,x2);
return l;
}

Nat0 card_adt (Adt x1)
{
check_handle_adt(x1);
return card_rep_adt (x1->f_rep  ) ;
}

Adt sub1_adt (Adt x1,Implname x2)
{
check_handle_adt(x1);
cond_clone_adt(&x1);
x1->f_rep = sub1d_rep_adt (x1->f_rep,x2) ;
return x1;
}

Adt ovwrt1_adt (Adt x1,Implname x2,Impl x3)
{
check_handle_adt(x1);
cond_clone_adt(&x1);
x2 = copy_implname(x2);
x3 = copy_impl(x3);
x1->f_rep = ovwrt1d_rep_adt (x1->f_rep,x2,x3) ;
return x1;
}
Bool is_in_dom_adt (Implname x1,Adt x2,Impl * x3)
{
Impl lx;
Bool res;
check_handle_adt(x2);
del_impl(*x3);
res = is_in_dom_rep_adt(x1,x2->f_rep,&lx);
if (res==TRUE)
*x3 = copy_impl(lx);
else
*x3 = 0;
return res;
}

Adt mk_empty_adt (void)
{
Adt l = alloc_adt();
l->f_rc = 1;
l->f_rep = mk_empty_rep_adt ();
return l;
}

Strings dom_adt (Adt x1)
{
Strings lx;

check_handle_adt(x1);
lx = alloc_strings();
lx->f_rc = 1;
lx->f_rep = dom_rep_adt(x1->f_rep
);
return lx;
}

Bool is_empty_adt (Adt x1)
{
check_handle_adt(x1);
return is_empty_rep_adt (x1->f_rep  ) ;
}

Impl sel_adt (Adt x1,Implname x2)
{
check_handle_adt(x1);
return copy_impl(sel_rep_adt (x1->f_rep,x2));
}
Adt union_adt (Adt x1,Adt x2)
{
check_handle_adt(x1);
check_handle_adt(x2);
{
Rep_adt lrep2 = copy_rep_adt(x2->f_rep);
cond_clone_adt(&x1);
x1->f_rep = uniond_rep_adt(x1->f_rep,lrep2);
}
return x1;
}
Adt ovwrt_adt (Adt x1,Adt x2)
{
check_handle_adt(x1);
check_handle_adt(x2);
{
Rep_adt lrep2 = copy_rep_adt(x2->f_rep);
cond_clone_adt(&x1);
x1->f_rep = ovwrtd_rep_adt(x1->f_rep,lrep2);
}
return x1;
}

Adt union1_adt (Adt x1,Implname x2,Impl x3)
{
check_handle_adt(x1);
cond_clone_adt(&x1);
x2 = copy_implname(x2);
x3 = copy_impl(x3);
x1->f_rep = union1d_rep_adt (x1->f_rep,x2,x3) ;
return x1;
}

Bool is_in_adt (Implname x1,Adt x2)
{
check_handle_adt(x2);
return is_in_rep_adt (x1 , x2->f_rep ) ;
}

Adt copy_adt (Adt x1)
{
check_handle_adt(x1);
x1->f_rc++;
return x1;
}

Outbytes cvtotup1_adt (Outbytes x1,Adt x2)
{
check_handle_adt(x2);
return cvtotup1_rep_adt(x1, x2->f_rep);
}

Iter_rep_adt mk_iter_rep_adt (Rep_adt x1)  {
Iter_rep_adt lx;
lx.f_curser = x1;
lx.f_list = x1;
return lx;
}
void next_iter_rep_adt (Iter_rep_adt * x1)  {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_adt");
x1->f_curser = x1->f_curser->f_next;
}

Implname sel_iter_rep_adt (Iter_rep_adt * x1,Impl * x2)   {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_adt");
*x2 = x1->f_curser->f_attr;
return
x1->f_curser->f_info;
}

Iter_adt mk_iter_adt (Adt x1)  {
Iter_adt lx1;
check_handle_adt(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_adt(x1->f_rep);
return lx1;
}

#ifndef ovwrt1d_rep_vdmdb
extern Rep_vdmdb ovwrt1d_rep_vdmdb ( Rep_vdmdb x1, Adtname x2, Adt x3 );
#endif

static Rep_vdmdb _rr1_ovwrtd_rep_vdmdb;
static void _rf1_ovwrtd_rep_vdmdb(Adtname y1, Adt y2)   {_rr1_ovwrtd_rep_vdmdb = ovwrt1d_rep_vdmdb(_rr1_ovwrtd_rep_vdmdb,y1,y2);}

Rep_vdmdb ovwrtd_rep_vdmdb (Rep_vdmdb x1,Rep_vdmdb x2)
{Rep_vdmdb lr1 = _rr1_ovwrtd_rep_vdmdb;
_rr1_ovwrtd_rep_vdmdb = x1;
forall_rep_vdmdb(x2,_rf1_ovwrtd_rep_vdmdb);
del1_rep_vdmdb(x2);
{Rep_vdmdb lr2 = _rr1_ovwrtd_rep_vdmdb; _rr1_ovwrtd_rep_vdmdb = lr1; return lr2;}
}

Nat0 card_rep_vdmdb (Rep_vdmdb x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_rep_vdmdb(x1)->f_next;}
return lx1;
}

static Rep_vdmdb _tt1_del_rep_vdmdb;

static void _ff1_del_rep_vdmdb(Adtname y1,Adt y2)

{del_adtname(y1);del_adt(y2);}

void del_rep_vdmdb(Rep_vdmdb x1)

{
{Rep_vdmdb lt1; lt1 = _tt1_del_rep_vdmdb;
{
{_tt1_del_rep_vdmdb = x1;

{
forall_rep_vdmdb(x1,_ff1_del_rep_vdmdb);
del1_rep_vdmdb(x1);
_tt1_del_rep_vdmdb = lt1;

}}}}}

Bool is_in_rep_vdmdb(Adtname x1, Rep_vdmdb x2)

{while (x2)
{if (is_eq_adtname(ref_rep_vdmdb(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Rep_vdmdb sub1d_rep_vdmdb(Rep_vdmdb x1, Adtname x2)

{register Rep_vdmdb * lx1 = &x1;
while (*lx1)
{if (is_eq_adtname((ref_rep_vdmdb(*lx1))->f_info,x2))
{Rep_vdmdb lx2 = *lx1;
*lx1 = lx2->f_next;
del_adtname(lx2->f_info); del_adt(lx2->f_attr);
free_rep_vdmdb(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Rep_vdmdb ovwrt1d_rep_vdmdb(Rep_vdmdb x1, Adtname x2, Adt x3)

{register Rep_vdmdb lx1 = x1;
while (lx1)
{if (is_eq_adtname(ref_rep_vdmdb(lx1)->f_info,x2)) {del_adtname(x2);del_adt(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_vdmdb(x2,x3);
lx1->f_next = x1;
return lx1;
}

Bool is_in_dom_rep_vdmdb(Adtname x1, Rep_vdmdb x2, Adt * x3)

{while (x2)
{if (is_eq_adtname(ref_rep_vdmdb(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Outbytes cvtotuppair_rep_vdmdb (Outbytes x1,Adtname x2,Adt x3)
{ return cvtotup1_adt(cvtotup1_adtname(x1,x2),x3); }

Outbytes cvtotup1_rep_vdmdb (Outbytes x1,Rep_vdmdb x2)
{ return cvtotupelems_rep_vdmdb(cvtotup1_nat0(x1,card_rep_vdmdb(x2)),x2); }

Rep_vdmdb cvfromtup1_rep_vdmdb (Inbytes * x1)
{ Nat0 lx1 = cvfromtup1_nat0(x1);
Rep_vdmdb lx2;

lx2 = mk_empty_rep_vdmdb();
for (; lx1 >= 1; lx1--)
{
Adtname lx3; Adt lx4;
lx3 = cvfromtup1_adtname(x1);
lx4 = cvfromtup1_adt(x1);
lx2 = union1_rep_vdmdb(lx2,lx3,lx4);
}
return lx2;
}

Rep_vdmdb copy_rep_vdmdb (Rep_vdmdb x1)
{Rep_vdmdb x2 = (Rep_vdmdb)0;
register Rep_vdmdb * px2 = & x2;
while (x1)
{*px2 = alloc_rep_vdmdb();
*(*px2) = *(ref_rep_vdmdb(x1));
(*px2)->f_info = copy_adtname((*px2)->f_info); (*px2)->f_attr = copy_adt((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Adt sel_rep_vdmdb (Rep_vdmdb x1,Adtname x2)
{while (x1)
{if (is_eq_adtname(ref_rep_vdmdb(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Rep_vdmdb");
return x1->f_attr;
}

Rep_vdmdb union1d_rep_vdmdb(Rep_vdmdb x1, Adtname x2, Adt x3)

{register Rep_vdmdb lx1 = x1;
while (lx1)
{if (is_eq_adtname(ref_rep_vdmdb(lx1)->f_info,x2)) {if (! is_eq_adt(ref_rep_vdmdb(lx1)->f_attr,x3)) err_umap_vdmlib("Rep_vdmdb"); del_adtname(x2);del_adt(x3);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_vdmdb(x2,x3);
lx1->f_next = x1;
return lx1;
}

Rep_vdmdb mk1_rep_vdmdb(Adtname x1, Adt x2)

{Rep_vdmdb lx1 = alloc_rep_vdmdb();
lx1->f_next = (Rep_vdmdb)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

Rep_vdmdb union1_rep_vdmdb(Rep_vdmdb x1, Adtname x2, Adt x3)

{register Rep_vdmdb lx1 = x1;
while (lx1)
{if (is_eq_adtname(ref_rep_vdmdb(lx1)->f_info,x2)) {if (! is_eq_adt(ref_rep_vdmdb(lx1)->f_attr,x3)) err_umap_vdmlib("Rep_vdmdb"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_rep_vdmdb(x2,x3);
lx1->f_next = x1;
return lx1;
}

#ifndef mk_empty_rep_strings
extern Rep_strings mk_empty_rep_strings ( void ) ;
#endif

#ifndef uniond_rep_strings
extern Rep_strings uniond_rep_strings ( Rep_strings x1, Rep_strings x2   ) ;
#endif

#ifndef dom_rep_vdmdb_adtname_adt
extern Rep_strings dom_rep_vdmdb_adtname_adt ( Adtname y1, Adt y2    ) ;
#endif

Rep_strings dom_rep_vdmdb(Rep_vdmdb x1     )

{
Rep_strings lx1;
lx1 = mk_empty_rep_strings();
for(;x1 ; x1=ref_rep_vdmdb(x1)->f_next)
{lx1 = uniond_rep_strings(lx1,dom_rep_vdmdb_adtname_adt(ref_rep_vdmdb(x1)->f_info,x1->f_attr )  );}
return lx1;
}

#ifndef cvtotuppair_rep_vdmdb
extern Outbytes cvtotuppair_rep_vdmdb ( Outbytes x1, Adtname x2, Adt x3 );
#endif

static Outbytes _rr1_cvtotupelems_rep_vdmdb;
static void _rf1_cvtotupelems_rep_vdmdb(Adtname y1, Adt y2)   {_rr1_cvtotupelems_rep_vdmdb = cvtotuppair_rep_vdmdb(_rr1_cvtotupelems_rep_vdmdb,y1,y2);}

Outbytes cvtotupelems_rep_vdmdb (Outbytes x1,Rep_vdmdb x2)
{Outbytes lr1 = _rr1_cvtotupelems_rep_vdmdb;
_rr1_cvtotupelems_rep_vdmdb = x1;
forall_rep_vdmdb(x2,_rf1_cvtotupelems_rep_vdmdb);
{Outbytes lr2 = _rr1_cvtotupelems_rep_vdmdb; _rr1_cvtotupelems_rep_vdmdb = lr1; return lr2;}
}

#ifndef union1d_rep_vdmdb
extern Rep_vdmdb union1d_rep_vdmdb ( Rep_vdmdb x1, Adtname x2, Adt x3 );
#endif

static Rep_vdmdb _rr1_uniond_rep_vdmdb;
static void _rf1_uniond_rep_vdmdb(Adtname y1, Adt y2)   {_rr1_uniond_rep_vdmdb = union1d_rep_vdmdb(_rr1_uniond_rep_vdmdb,y1,y2);}

Rep_vdmdb uniond_rep_vdmdb (Rep_vdmdb x1,Rep_vdmdb x2)
{Rep_vdmdb lr1 = _rr1_uniond_rep_vdmdb;
_rr1_uniond_rep_vdmdb = x1;
forall_rep_vdmdb(x2,_rf1_uniond_rep_vdmdb);
del1_rep_vdmdb(x2);
{Rep_vdmdb lr2 = _rr1_uniond_rep_vdmdb; _rr1_uniond_rep_vdmdb = lr1; return lr2;}
}

void cond_clone_vdmdb (Vdmdb * x1)
{
if ((*x1)->f_rc > 1)
{
Vdmdb clone = alloc_vdmdb();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_vdmdb((*x1)->f_rep);
*x1 = clone;
}
}
void del_vdmdb (Vdmdb x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_vdmdb(x1->f_rep);
free_vdmdb(x1);
}
}

Vdmdb mk1_vdmdb (Adtname x1,Adt x2)
{
Vdmdb l = alloc_vdmdb();
l->f_rc = 1;
x1 = copy_adtname(x1);
x2 = copy_adt(x2);
l->f_rep = mk1_rep_vdmdb (x1,x2);
return l;
}

Nat0 card_vdmdb (Vdmdb x1)
{
check_handle_vdmdb(x1);
return card_rep_vdmdb (x1->f_rep  ) ;
}

Vdmdb sub1_vdmdb (Vdmdb x1,Adtname x2)
{
check_handle_vdmdb(x1);
cond_clone_vdmdb(&x1);
x1->f_rep = sub1d_rep_vdmdb (x1->f_rep,x2) ;
return x1;
}

Vdmdb ovwrt1_vdmdb (Vdmdb x1,Adtname x2,Adt x3)
{
check_handle_vdmdb(x1);
cond_clone_vdmdb(&x1);
x2 = copy_adtname(x2);
x3 = copy_adt(x3);
x1->f_rep = ovwrt1d_rep_vdmdb (x1->f_rep,x2,x3) ;
return x1;
}
Bool is_in_dom_vdmdb (Adtname x1,Vdmdb x2,Adt * x3)
{
Adt lx;
Bool res;
check_handle_vdmdb(x2);
del_adt(*x3);
res = is_in_dom_rep_vdmdb(x1,x2->f_rep,&lx);
if (res==TRUE)
*x3 = copy_adt(lx);
else
*x3 = 0;
return res;
}

Vdmdb mk_empty_vdmdb (void)
{
Vdmdb l = alloc_vdmdb();
l->f_rc = 1;
l->f_rep = mk_empty_rep_vdmdb ();
return l;
}

Outbytes cvtotupl_vdmdb (Vdmdb x1)
{
Outbytes lx;
check_handle_vdmdb(x1);
lx = cvtotup1_rep_vdmdb(mk_empty_outbytes(),x1->f_rep);
return lx;
}

Strings dom_vdmdb (Vdmdb x1)
{
Strings lx;

check_handle_vdmdb(x1);
lx = alloc_strings();
lx->f_rc = 1;
lx->f_rep = dom_rep_vdmdb(x1->f_rep
);
return lx;
}

Vdmdb cvfromtupl_vdmdb (Inbytes x1)
{
Vdmdb lx = alloc_vdmdb();
lx->f_rc = 1;
#ifdef AUTOMEM_inbytes
check_handle_inbytes(x1);
cond_clone_inbytes(&x1);
#endif
lx->f_rep = cvfromtup1_rep_vdmdb(&x1);
del_inbytes(x1);
return lx;
}

Bool is_empty_vdmdb (Vdmdb x1)
{
check_handle_vdmdb(x1);
return is_empty_rep_vdmdb (x1->f_rep  ) ;
}

Adt sel_vdmdb (Vdmdb x1,Adtname x2)
{
check_handle_vdmdb(x1);
return copy_adt(sel_rep_vdmdb (x1->f_rep,x2));
}
Vdmdb union_vdmdb (Vdmdb x1,Vdmdb x2)
{
check_handle_vdmdb(x1);
check_handle_vdmdb(x2);
{
Rep_vdmdb lrep2 = copy_rep_vdmdb(x2->f_rep);
cond_clone_vdmdb(&x1);
x1->f_rep = uniond_rep_vdmdb(x1->f_rep,lrep2);
}
return x1;
}
Vdmdb ovwrt_vdmdb (Vdmdb x1,Vdmdb x2)
{
check_handle_vdmdb(x1);
check_handle_vdmdb(x2);
{
Rep_vdmdb lrep2 = copy_rep_vdmdb(x2->f_rep);
cond_clone_vdmdb(&x1);
x1->f_rep = ovwrtd_rep_vdmdb(x1->f_rep,lrep2);
}
return x1;
}

Vdmdb union1_vdmdb (Vdmdb x1,Adtname x2,Adt x3)
{
check_handle_vdmdb(x1);
cond_clone_vdmdb(&x1);
x2 = copy_adtname(x2);
x3 = copy_adt(x3);
x1->f_rep = union1d_rep_vdmdb (x1->f_rep,x2,x3) ;
return x1;
}

Bool is_in_vdmdb (Adtname x1,Vdmdb x2)
{
check_handle_vdmdb(x2);
return is_in_rep_vdmdb (x1 , x2->f_rep ) ;
}

Iter_rep_vdmdb mk_iter_rep_vdmdb (Rep_vdmdb x1)  {
Iter_rep_vdmdb lx;
lx.f_curser = x1;
lx.f_list = x1;
return lx;
}
void next_iter_rep_vdmdb (Iter_rep_vdmdb * x1)  {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_vdmdb");
x1->f_curser = x1->f_curser->f_next;
}

Adtname sel_iter_rep_vdmdb (Iter_rep_vdmdb * x1,Adt * x2)   {
if (! x1->f_curser)
err_empty_iterator_vdmlib("Iter_rep_vdmdb");
*x2 = x1->f_curser->f_attr;
return
x1->f_curser->f_info;
}

Iter_vdmdb mk_iter_vdmdb (Vdmdb x1)  {
Iter_vdmdb lx1;
check_handle_vdmdb(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_vdmdb(x1->f_rep);
return lx1;
}
