#ifndef VDM_header_dbm
#define VDM_header_dbm


/* ------- PHASE1 ------------------ */
/*
module generated from VDM Class Library
$Revision: 1.100 $
$Date: 1996/09/18 13:13:42 $
*/

#if defined(sun) && ! defined(sparc)
#define __BSD42__
#endif

#ifdef M_XENIX
#define __XENIX__
#define __SYSV__
#endif

#ifdef __TURBOC__
#define __DOS__
#endif

#if defined(__TURBOC__) || defined(__ANSIC__) || defined(__STDC__)
typedef void * VOIDptr;
#else
typedef char * VOIDptr;
#endif

#if defined(__linux__) || defined(_AIX) || defined(MIPSEL) || (defined(sun) && defined(sparc))
#ifndef __POSIX
#define __POSIX
#endif
#endif

#ifdef __cplusplus
#include <stdlib.h>
#else
#if defined(__STDC__) || defined(__POSIX)
#ifndef apollo
#include <stdlib.h>
#endif
#endif
#endif

#ifdef __cplusplus
#include <stdio.h>
#endif

#ifdef __cplusplus
#include <iostream.h>
#else
#include <stdio.h>
#endif

#include <stdio.h>

#include <fcntl.h>

#include <errno.h>

#include <sys/types.h>

#ifdef __BSD42__
#include <strings.h>
#else
#include <string.h>
#endif

#include <sys/stat.h>

#ifdef __POSIX
#include <unistd.h>
#else
#include <sys/unistd.h>
#endif

/* some systems define TRUE and FALSE in system header files */
#ifndef FALSE
#ifndef TRUE

/* Bool as enum requires conversion between enum and int */
#ifdef BoolAsEnum
enum {FALSE,TRUE};
#else
#define FALSE ((unsigned char)0)
#define TRUE ((unsigned char)1)
#endif

#ifdef __cplusplus
#define false BOOL(FALSE)
#define true BOOL(TRUE)
#endif

#endif
#endif

typedef unsigned char Bool;

#define lb_byte 0

#define ub_byte 255

typedef unsigned char Byte;

#define lb_intg -2147483647

#define ub_intg 2147483647

typedef long int Intg;

#define lb_nat1 1

#define ub_nat1 2147483647

typedef unsigned long Nat1;

typedef char Char;
#define lb_char 0

#define ub_char 255

typedef struct Handle_str * Str;
typedef struct Struct_outbytes * Outbytes;
typedef struct Struct_inbytes * Inbytes;
typedef struct Struct_cvtext_vdmlib * Cvtext_vdmlib;
typedef struct Struct_rep_str * Rep_str;

#define lb_nat0 0

#define ub_nat0 2147483647

typedef unsigned long Nat0;

typedef struct Struct_rep_stringl * Rep_stringl;
typedef struct Handle_stringl * Stringl;
typedef struct Struct_rep_strings * Rep_strings;
typedef struct Handle_strings * Strings;
typedef struct Struct_rep_context * Rep_context;
typedef struct Struct_rep_operation * Rep_operation;
typedef struct Handle_context * Context;
typedef struct Handle_operation * Operation;
typedef struct Struct_rep_contextmap * Rep_contextmap;
typedef struct Struct_rep_impl * Rep_impl;
typedef struct Handle_contextmap * ContextMap;
typedef struct Handle_impl * Impl;
typedef struct Struct_rep_adt * Rep_adt;
typedef struct Handle_adt * Adt;
typedef struct Struct_rep_vdmdb * Rep_vdmdb;
typedef struct Handle_vdmdb * Vdmdb;

/* ------- PHASE2 ------------------ */
extern Bool supress_cvlines_vdmlib;
extern Nat0 curr_linelen_vdmlib;
extern char *start_structure_vdmlib;
extern char *end_structure_vdmlib;

extern void adj_linelen_vdmlib ( Nat0 x1 ) ;
extern Str ident_prefix_vdmlib ( Str x1, Nat0 x2 ) ;
extern Cvtext_vdmlib ident_lines_vdmlib ( Cvtext_vdmlib x1, Str x2 ) ;
extern Cvtext_vdmlib close_struct_vdmlib ( Cvtext_vdmlib x1,Str x2, Nat0 x3 ) ;
extern Cvtext_vdmlib append_lastline_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
#ifdef __cplusplus
extern void fprint_lines_vdmlib ( ostream & x1,Cvtext_vdmlib x2 ) ;
#else
extern void fprint_lines_vdmlib ( FILE *x1,Cvtext_vdmlib x2 ) ;
#endif

#ifdef __cplusplus
inline VOIDptr ALLOCMEM_vdmlib(unsigned long int x1)
{ return (VOIDptr)(new char[x1]); }
inline void FREEMEM_vdmlib(VOIDptr x1,unsigned long int)
{ delete (char *)(x1); }
#else
#if ! defined(__STDC__) && ! defined(_AIX) && ! defined(__NOMALLOC__)
extern VOIDptr malloc ( unsigned long x1 ) ;
extern void free ( VOIDptr x1 ) ;
#endif
#define ALLOCMEM_vdmlib(x1) malloc(x1)
#define FREEMEM_vdmlib(x1,x2) free(x1)
#endif

#define VDM_ERR_EMPTYSET 1
#define VDM_ERR_EMPTYMAP 2
#define VDM_ERR_EMPTYHD 3
#define VDM_ERR_ERRMAXLEN 4
#define VDM_ERR_NILPTR 5
#define VDM_ERR_NILOPT 6
#define VDM_ERR_ILLPTR 7
#define VDM_ERR_SELECT 8
#define VDM_ERR_SELMAP 9
#define VDM_ERR_UNIO 10
#define VDM_ERR_EMPTYTL 11
#define VDM_ERR_UNION 12
#define VDM_ERR_NOTIMPL 13
#define VDM_ERR_HEAPOFL 15
#define VDM_ERR_CVLINES 16
#define VDM_ERR_NV_HDL 17
#define VDM_ERR_EMPTYIT 18
#define VDM_ERR_DIV0 19

struct Handle_str {
Rep_str f_rep;
Nat0 f_rc;
};

#define AUTOMEM_str

void cond_clone_str ( Str * ) ;

#define check_handle_str(h) if ((h) == 0) err_nv_hdl_vdmlib("Str");
#define Adtname Str
#define Implname Str
#define Opname Str
#define Compname Str
#define Component Str

struct Struct_outbytes {
Intg f_fdes;
char f_deffn[128];
char f_ioerr;
Intg f_errno;
Nat0 f_buffelems;
Byte f_buff[4096];
};

extern Outbytes write_buffer_outbytes ( Outbytes x1 );

struct Struct_inbytes {

int f_fdes;
Nat0 f_elfile; /* "elems" left in file */
Byte * f_currelem;
Nat0 f_buffelems;
Byte f_buff[4096];
};

extern Inbytes read_buffer_inbytes ( Inbytes x1 );

struct Struct_cvtext_vdmlib {
Nat0 f_max;
Nat0 f_len;
};
struct Struct_rep_str {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_rep_str(x1,x2) cvlines2_vdmlib(x1,x2)

#define mk1_str_char(x1) mk1_str(x1)

struct Struct_rep_stringl {
Rep_stringl f_next;
Str f_info;

};

struct Handle_stringl {
Rep_stringl f_rep;
Nat0 f_rc;
};

#define AUTOMEM_stringl

void cond_clone_stringl ( Stringl * ) ;

#define check_handle_stringl(h) if ((h) == 0) err_nv_hdl_vdmlib("Stringl");
struct Struct_iter_rep_str {
Rep_str f_array;
unsigned f_curser;
};

typedef struct Struct_iter_rep_str Iter_rep_str;
struct Struct_iter_rep_stringl {
Rep_stringl f_list;
Rep_stringl f_curser;
};

typedef struct Struct_iter_rep_stringl Iter_rep_stringl;
struct Struct_iter_str {
Iter_rep_str f_ir;
Str f_vl;
};

typedef struct Struct_iter_str Iter_str;
struct Struct_iter_stringl {
Iter_rep_stringl f_ir;
Stringl f_vl;
};

typedef struct Struct_iter_stringl Iter_stringl;

struct Struct_rep_strings {
Rep_strings f_next;
Str f_info;

};

struct Handle_strings {
Rep_strings f_rep;
Nat0 f_rc;
};

#define AUTOMEM_strings

void cond_clone_strings ( Strings * ) ;

#define check_handle_strings(h) if ((h) == 0) err_nv_hdl_vdmlib("Strings");
struct Struct_iter_rep_strings {
Rep_strings f_list;
Rep_strings f_curser;
};

typedef struct Struct_iter_rep_strings Iter_rep_strings;
struct Struct_iter_strings {
Iter_rep_strings f_ir;
Strings f_vl;
};

typedef struct Struct_iter_strings Iter_strings;
struct Struct_rep_context {

Strings f_rep_adttypes_context_rep_context;

Strings f_rep_special_impl_context_rep_context;

Strings f_rep_special_ops_context_rep_context;

Strings f_rep_filter_adts_context_rep_context;

Strings f_rep_filter_impl_context_rep_context;

Strings f_rep_filter_oper_context_rep_context;

Strings f_rep_filter_comp_context_rep_context;

Strings f_rep_filter_params_context_rep_context;

Strings f_rep_sign_comps_context_rep_context;

Str f_rep_operationtype_context_rep_context;

};

struct Struct_rep_operation {
Rep_operation f_next;
Compname f_info;
Component f_attr;
};

struct Handle_context {
Rep_context f_rep;
Nat0 f_rc;
};

#define AUTOMEM_context

void cond_clone_context ( Context * ) ;

#define check_handle_context(h) if ((h) == 0) err_nv_hdl_vdmlib("Context");

struct Handle_operation {
Rep_operation f_rep;
Nat0 f_rc;
};

#define AUTOMEM_operation

void cond_clone_operation ( Operation * ) ;

#define check_handle_operation(h) if ((h) == 0) err_nv_hdl_vdmlib("Operation");
struct Struct_iter_rep_operation {
Rep_operation f_list;
Rep_operation f_curser;
};

typedef struct Struct_iter_rep_operation Iter_rep_operation;
struct Struct_iter_operation {
Iter_rep_operation f_ir;
Operation f_vl;
};

typedef struct Struct_iter_operation Iter_operation;

struct Struct_rep_contextmap {
Rep_contextmap f_next;
Intg f_info;
Context f_attr;
};

struct Struct_rep_impl {
Rep_impl f_next;
Opname f_info;
Operation f_attr;
};

struct Handle_contextmap {
Rep_contextmap f_rep;
Nat0 f_rc;
};

#define AUTOMEM_contextmap

void cond_clone_contextmap ( ContextMap * ) ;

#define check_handle_contextmap(h) if ((h) == 0) err_nv_hdl_vdmlib("ContextMap");

struct Handle_impl {
Rep_impl f_rep;
Nat0 f_rc;
};

#define AUTOMEM_impl

void cond_clone_impl ( Impl * ) ;

#define check_handle_impl(h) if ((h) == 0) err_nv_hdl_vdmlib("Impl");
struct Struct_iter_rep_contextmap {
Rep_contextmap f_list;
Rep_contextmap f_curser;
};

typedef struct Struct_iter_rep_contextmap Iter_rep_contextmap;
struct Struct_iter_rep_impl {
Rep_impl f_list;
Rep_impl f_curser;
};

typedef struct Struct_iter_rep_impl Iter_rep_impl;
struct Struct_iter_contextmap {
Iter_rep_contextmap f_ir;
ContextMap f_vl;
};

typedef struct Struct_iter_contextmap Iter_contextmap;
struct Struct_iter_impl {
Iter_rep_impl f_ir;
Impl f_vl;
};

typedef struct Struct_iter_impl Iter_impl;

struct Struct_rep_adt {
Rep_adt f_next;
Implname f_info;
Impl f_attr;
};

struct Handle_adt {
Rep_adt f_rep;
Nat0 f_rc;
};

#define AUTOMEM_adt

void cond_clone_adt ( Adt * ) ;

#define check_handle_adt(h) if ((h) == 0) err_nv_hdl_vdmlib("Adt");
struct Struct_iter_rep_adt {
Rep_adt f_list;
Rep_adt f_curser;
};

typedef struct Struct_iter_rep_adt Iter_rep_adt;
struct Struct_iter_adt {
Iter_rep_adt f_ir;
Adt f_vl;
};

typedef struct Struct_iter_adt Iter_adt;

struct Struct_rep_vdmdb {
Rep_vdmdb f_next;
Adtname f_info;
Adt f_attr;
};

struct Handle_vdmdb {
Rep_vdmdb f_rep;
Nat0 f_rc;
};

#define AUTOMEM_vdmdb

void cond_clone_vdmdb ( Vdmdb * ) ;

#define check_handle_vdmdb(h) if ((h) == 0) err_nv_hdl_vdmlib("Vdmdb");
struct Struct_iter_rep_vdmdb {
Rep_vdmdb f_list;
Rep_vdmdb f_curser;
};

typedef struct Struct_iter_rep_vdmdb Iter_rep_vdmdb;
struct Struct_iter_vdmdb {
Iter_rep_vdmdb f_ir;
Vdmdb f_vl;
};

typedef struct Struct_iter_vdmdb Iter_vdmdb;

/* ------- PHASE3 ------------------ */
extern Rep_contextmap alloc_rep_contextmap ( void );
extern void free_rep_contextmap ( Rep_contextmap x1 );

#define ref_rep_contextmap(x1) (x1)

#define profile_rep_contextmap()

extern Rep_context alloc_rep_context ( void );
extern void free_rep_context ( Rep_context x1 );

#define ref_rep_context(x1) (x1)

#define profile_rep_context()

extern Rep_vdmdb alloc_rep_vdmdb ( void );
extern void free_rep_vdmdb ( Rep_vdmdb x1 );

#define ref_rep_vdmdb(x1) (x1)

#define profile_rep_vdmdb()

extern Rep_adt alloc_rep_adt ( void );
extern void free_rep_adt ( Rep_adt x1 );

#define ref_rep_adt(x1) (x1)

#define profile_rep_adt()

extern Rep_impl alloc_rep_impl ( void );
extern void free_rep_impl ( Rep_impl x1 );

#define ref_rep_impl(x1) (x1)

#define profile_rep_impl()

extern Rep_operation alloc_rep_operation ( void );
extern void free_rep_operation ( Rep_operation x1 );

#define ref_rep_operation(x1) (x1)

#define profile_rep_operation()

extern Rep_strings alloc_rep_strings ( void );
extern void free_rep_strings ( Rep_strings x1 );

#define ref_rep_strings(x1) (x1)

#define profile_rep_strings()

extern Rep_stringl alloc_rep_stringl ( void );
extern void free_rep_stringl ( Rep_stringl x1 );

#define ref_rep_stringl(x1) (x1)

#define profile_rep_stringl()

extern Str alloc_str ( void );
extern void free_str ( Str x1 );

#define ref_str(x1) (x1)

extern void profile_str ( void );

extern ContextMap alloc_contextmap ( void );
extern void free_contextmap ( ContextMap x1 );

#define ref_contextmap(x1) (x1)

extern void profile_contextmap ( void );

extern Vdmdb alloc_vdmdb ( void );
extern void free_vdmdb ( Vdmdb x1 );

#define ref_vdmdb(x1) (x1)

extern void profile_vdmdb ( void );

extern Adt alloc_adt ( void );
extern void free_adt ( Adt x1 );

#define ref_adt(x1) (x1)

extern void profile_adt ( void );

extern Impl alloc_impl ( void );
extern void free_impl ( Impl x1 );

#define ref_impl(x1) (x1)

extern void profile_impl ( void );

extern Operation alloc_operation ( void );
extern void free_operation ( Operation x1 );

#define ref_operation(x1) (x1)

extern void profile_operation ( void );

extern Strings alloc_strings ( void );
extern void free_strings ( Strings x1 );

#define ref_strings(x1) (x1)

extern void profile_strings ( void );

extern Stringl alloc_stringl ( void );
extern void free_stringl ( Stringl x1 );

#define ref_stringl(x1) (x1)

extern void profile_stringl ( void );

extern void err_empty_iterator_vdmlib ( char *x1 );
extern void err_smap_vdmlib ( char *x1 );
extern void err_hd_vdmlib ( char *x1 );
extern void err_tl_vdmlib ( char *x1 );
extern void err_nv_hdl_vdmlib ( char *x1 );
extern void abort_vdmlib ( Nat0 x1 );
extern void heap_oflw_vdmlib ( char *x1 );
extern void err_sel_vdmlib ( Nat1 x1 , Nat0 x2 , char *x3 );
extern void err_umap_vdmlib ( char *x1 );
extern Bool not_bool ( Bool x1 );
extern Bool is_gr_bool ( Bool x1 , Bool x2 );
extern Bool xor_bool ( Bool x1 , Bool x2 );
extern Cvtext_vdmlib cvlines_bool ( Bool x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#ifdef __cplusplus
extern void fpr_bool ( ostream & x1 , Bool x2 );
#else
extern void fpr_bool ( FILE *x1 , Bool x2 );
#endif
extern Bool and_bool ( Bool x1 , Bool x2 );
extern Bool is_eq_bool ( Bool x1 , Bool x2 );
extern Bool is_ge_bool ( Bool x1 , Bool x2 );
extern Bool or_bool ( Bool x1 , Bool x2 );
extern Byte pred_byte ( Byte x1 );
extern Bool is_eq_byte ( Byte x1 , Byte x2 );
extern Bool is_lt_byte ( Byte x1 , Byte x2 );
extern Bool is_ge_byte ( Byte x1 , Byte x2 );
extern Byte times_byte ( Byte x1 , Byte x2 );
extern Byte plus_byte ( Byte x1 , Byte x2 );
extern Byte succ_byte ( Byte x1 );

extern Byte mod_byte ( Byte x1 , Byte x2 );

extern Bool is_le_byte ( Byte x1 , Byte x2 );
extern Bool is_gr_byte ( Byte x1 , Byte x2 );
extern Byte div_byte ( Byte x1 , Byte x2 );
extern Byte minus_byte ( Byte x1 , Byte x2 );
extern Intg pred_intg ( Intg x1 );
extern Bool is_eq_intg ( Intg x1 , Intg x2 );
extern Bool is_lt_intg ( Intg x1 , Intg x2 );
extern Bool is_ge_intg ( Intg x1 , Intg x2 );
extern Intg times_intg ( Intg x1 , Intg x2 );
extern Intg plus_intg ( Intg x1 , Intg x2 );
extern void del_intg ( Intg x1 );
extern Str cvstr_intg ( Intg x1 );
extern Intg copy_intg ( Intg x1 );
extern char * printformat_intg;

extern void set_print_format_intg ( char * x1 );
extern Intg succ_intg ( Intg x1 );

extern Intg mod_intg ( Intg x1 , Intg x2 );

extern Bool is_le_intg ( Intg x1 , Intg x2 );
extern Bool is_gr_intg ( Intg x1 , Intg x2 );
extern Intg div_intg ( Intg x1 , Intg x2 );
extern Intg minus_intg ( Intg x1 , Intg x2 );
extern Nat1 pred_nat1 ( Nat1 x1 );
extern Bool is_eq_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_lt_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_ge_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 times_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 plus_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 succ_nat1 ( Nat1 x1 );

extern Nat1 mod_nat1 ( Nat1 x1 , Nat1 x2 );

extern Bool is_le_nat1 ( Nat1 x1 , Nat1 x2 );
extern Bool is_gr_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 div_nat1 ( Nat1 x1 , Nat1 x2 );
extern Nat1 minus_nat1 ( Nat1 x1 , Nat1 x2 );
extern Char pred_char ( Char x1 );
extern Bool is_eq_char ( Char x1 , Char x2 );
extern Bool is_lt_char ( Char x1 , Char x2 );
extern Bool is_ge_char ( Char x1 , Char x2 );
extern Char times_char ( Char x1 , Char x2 );
extern Char plus_char ( Char x1 , Char x2 );
extern Char copy_char ( Char x1 );
extern void del_char ( Char x1 );
extern Char succ_char ( Char x1 );

extern Char mod_char ( Char x1 , Char x2 );

extern Bool is_le_char ( Char x1 , Char x2 );
extern Bool is_gr_char ( Char x1 , Char x2 );
extern Char div_char ( Char x1 , Char x2 );
extern Char minus_char ( Char x1 , Char x2 );
extern Str ovwrt1_str ( Str x1 , Nat1 x2 , Char x3 );

extern Str cvfromtup1_str ( Inbytes *x1 );

extern Bool is_gr_str ( Str x1 , Str x2 );
extern Cvtext_vdmlib cvlines_str ( Str x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Str appr_str ( Str x1 , Char x2 );
extern Str copy1_str ( Str x1 );
extern Char hd_str ( Str x1 );
extern Str mk_empty_str ( void );
extern void cpc_str ( Str x1 , Char *x2 );
extern void del_str ( Str x1 );
extern Nat0 len_str ( Str x1 );

extern Str quote_str ( Str x1 );

extern Str mkdir_str ( Str x1 );

extern Str sub_tup_str ( Str x1 , Nat1 x2 , Nat0 x3 );
extern Nat0 index_list_from_str ( Str x1 , Str x2 , Nat1 x3 );
extern Str fread_str ( Str x1 );
extern Bool fwrite_str ( Str x1 , Str x2 );
extern Nat0 index_list_str ( Str x1 , Str x2 );
extern Str conc_path_str ( Str x1 , Str x2 );
extern Str conc_path_auto_str ( Str x1 , Str x2 );
extern Str mk_sub_tup_str ( Str x1 , Nat1 x2 , Nat0 x3 );
#ifdef __cplusplus
extern void fpr_str ( ostream & x1 , Str x2 );
#else
extern void fpr_str ( FILE *x1 , Str x2 );
#endif
extern Str mkn_str ( Char x1 , Nat0 x2 );
#ifdef __cplusplus
extern void puts_str ( Str x1 , ostream & x2 );
#else
extern void puts_str ( Str x1 , FILE *x2 );
#endif
extern Nat0 index_str ( Str x1 , Char x2 );
extern Str conc_str ( Str x1 , Str x2 );
extern Str conc_auto_str ( Str x1 , Str x2 );

extern Str headline_str ( Str x1 );

extern Stringl split_str ( Str x1, Char x2 );

extern Str copy_str ( Str x1 );
extern Str mkc_str ( Char *x1 );
extern Bool is_empty_str ( Str x1 );
extern Str appl_str ( Char x1 , Str x2 );
extern void del1_str ( Str x1 );
extern Str tl_str ( Str x1 );
extern Str mk1_str ( Char x1 );
extern Char sel_str ( Str x1 , Nat1 x2 );

extern Outbytes cvtotup1_str ( Outbytes x1 , Str x2 );

extern Bool is_eq_str ( Str x1 , Str x2 );
#define is_eq_adtname is_eq_str
#define cvtotup1_adtname cvtotup1_str
#define copy_adtname copy_str
#define default_adtname default_str
#define del_adtname del_str
#define cvfromtup1_adtname cvfromtup1_str
#define cvfromtup1_implname cvfromtup1_str
#define is_eq_implname is_eq_str
#define copy_implname copy_str
#define default_implname default_str
#define del_implname del_str
#define cvtotup1_implname cvtotup1_str
#define cvfromtup1_opname cvfromtup1_str
#define is_eq_opname is_eq_str
#define copy_opname copy_str
#define default_opname default_str
#define del_opname del_str
#define cvtotup1_opname cvtotup1_str
#define cvfromtup1_compname cvfromtup1_str
#define is_eq_compname is_eq_str
#define copy_compname copy_str
#define default_compname default_str
#define del_compname del_str
#define cvtotup1_compname cvtotup1_str
#define cvfromtup1_component cvfromtup1_str
#define is_eq_component is_eq_str
#define copy_component copy_str
#define default_component default_str
#define del_component del_str
#define cvtotup1_component cvtotup1_str
extern Bool fwrite_outbytes ( Outbytes x1 , Str x2 );
extern Outbytes mk_empty_outbytes ( void );
extern void del_inbytes ( Inbytes x1 );
extern void del1_inbytes ( Inbytes x1 );
extern Inbytes fread_inbytes ( Str x1 );
extern Nat0 len_inbytes ( Inbytes x1 );
extern Cvtext_vdmlib alloc_cvtext_vdmlib ( Nat0 x1 );
extern void free_cvtext_vdmlib ( Cvtext_vdmlib x1 );

#define ref_cvtext_vdmlib(x1) (x1)

#define profile_cvtext_vdmlib()

extern Rep_str alloc_rep_str ( Nat0 x1 );
extern void free_rep_str ( Rep_str x1 );

#define ref_rep_str(x1) (x1)

#define profile_rep_str()

typedef void (* T2_forall_cvtext_vdmlib) ( Str y1 ) ;
extern void forall_cvtext_vdmlib ( Cvtext_vdmlib x1, T2_forall_cvtext_vdmlib x2 ) ;
extern Nat0 len_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Bool is_empty_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern void del_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Str hd_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Cvtext_vdmlib ovwrt1_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 , Str x3 );
extern Cvtext_vdmlib mk1_cvtext_vdmlib ( Str x1 );
extern Cvtext_vdmlib appr_cvtext_vdmlib ( Cvtext_vdmlib x1 , Str x2 );
extern Cvtext_vdmlib conc_cvtext_vdmlib ( Cvtext_vdmlib x1 , Cvtext_vdmlib x2 );
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void );
extern Str last_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Str sel_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 );
extern void del1_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Rep_str mkn_empty_rep_str ( Nat0 x1 );
extern Rep_str ovwrt1d_rep_str ( Rep_str x1 , Nat1 x2 , Char x3 );

extern Str cvstr_rep_str ( Rep_str x1 );

extern Rep_str cvfromtup1_rep_str ( Inbytes *x1 );

extern Char sel_rep_str ( Rep_str x1 , Nat1 x2 );
extern void del1_rep_str ( Rep_str x1 );
extern Bool is_gr_rep_str ( Rep_str x1 , Rep_str x2 );
extern Rep_str mk1_rep_str ( Char x1 );
extern Char hd_rep_str ( Rep_str x1 );
extern Rep_str mk_empty_rep_str ( void );
extern Rep_str mk_sub_tup_rep_str ( Rep_str x1 , Nat1 x2 , Nat0 x3 );
extern Bool fwrite_rep_str ( Rep_str x1 , Str x2 );
extern Rep_str fread_rep_str ( Str x1 );
extern Nat0 index_list_from_rep_str ( Rep_str x1 , Rep_str x2 , Nat1 x3 );
extern Rep_str sub_tupd_rep_str ( Rep_str x1 , Nat1 x2 , Nat0 x3 );
extern Nat0 len_rep_str ( Rep_str x1 );
extern Rep_str mkc_rep_str ( Char *x1 );
extern Rep_str copy_rep_str ( Rep_str x1 );
extern void cpc_rep_str ( Rep_str x1 , Char *x2 );
extern void del_rep_str ( Rep_str x1 );
extern Rep_str conc_rep_str ( Rep_str x1 , Rep_str x2 );
extern Nat0 index_rep_str ( Rep_str x1 , Char x2 );
#ifdef __cplusplus
extern void puts_rep_str ( Rep_str x1 , ostream & x2 );
#else
extern void puts_rep_str ( Rep_str x1 , FILE *x2 );
#endif
extern Rep_str mknc_rep_str ( Char x1 , Nat0 x2 );
extern Nat0 index_list_rep_str ( Rep_str x1 , Rep_str x2 );
extern Rep_str conc_path_rep_str ( Rep_str x1 , Rep_str x2 );
extern Bool is_empty_rep_str ( Rep_str x1 );
extern Rep_str appl_rep_str ( Char x1 , Rep_str x2 );
extern Rep_str tld_rep_str ( Rep_str x1 );
extern Cvtext_vdmlib cvlines_rep_str ( Rep_str x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
typedef void (* T2_forindex_rep_str) ( Char y1, Nat1 y2 ) ;
extern void forindex_rep_str ( Rep_str x1, T2_forindex_rep_str x2 ) ;
extern Rep_str appr_rep_str ( Rep_str x1 , Char x2 );

extern Outbytes cvtotup1_rep_str ( Outbytes x1 , Rep_str x2 );

extern Bool is_eq_rep_str ( Rep_str x1 , Rep_str x2 );
typedef void (* T2_forall_rep_str) ( Char y1 ) ;
extern void forall_rep_str ( Rep_str x1, T2_forall_rep_str x2 ) ;

extern Outbytes cvtotupelems_rep_str ( Outbytes x1 , Rep_str x2 );
extern Nat0 pred_nat0 ( Nat0 x1 );
extern Bool is_eq_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_lt_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_ge_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 times_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 plus_nat0 ( Nat0 x1 , Nat0 x2 );

extern Nat0 cvfromtup1_nat0 ( Inbytes *x1 );

extern Outbytes cvtotup1_nat0 ( Outbytes x1 , Nat0 x2 );

extern Nat0 succ_nat0 ( Nat0 x1 );

extern Nat0 mod_nat0 ( Nat0 x1 , Nat0 x2 );

extern Bool is_le_nat0 ( Nat0 x1 , Nat0 x2 );
extern Bool is_gr_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 div_nat0 ( Nat0 x1 , Nat0 x2 );
extern Nat0 minus_nat0 ( Nat0 x1 , Nat0 x2 );
typedef void (* T2_forindex_rep_stringl) ( Str y1, Nat1 y2 ) ;
extern void forindex_rep_stringl ( Rep_stringl x1, T2_forindex_rep_stringl x2 ) ;
extern Rep_stringl sub_tup_rep_stringl ( Rep_stringl x1 , Nat1 x2 , Nat0 x3 );
extern Rep_stringl rmv1d_rep_stringl ( Rep_stringl x1 , Nat1 x2 );
extern Str sel_rep_stringl ( Rep_stringl x1 , Nat1 x2 );
extern Nat0 len_rep_stringl ( Rep_stringl x1 );
extern void del_rep_stringl ( Rep_stringl x1 );
extern Rep_stringl conc_rep_stringl ( Rep_stringl x1 , Rep_stringl x2 );
extern Rep_stringl sub_tupd_rep_stringl ( Rep_stringl x1 , Nat1 x2 , Nat0 x3 );
extern Rep_stringl copy_rep_stringl ( Rep_stringl x1 );
extern Rep_stringl mk1_rep_stringl ( Str x1 );
extern Rep_stringl insert_rep_stringl ( Rep_stringl x1 , Nat1 x2 , Str x3 );
extern Rep_stringl copy1_rep_stringl ( Rep_stringl x1 );
extern Outbytes alloc_outbytes ( void );
extern void free_outbytes ( Outbytes x1 );

#define ref_outbytes(x1) (x1)

#define profile_outbytes()

extern Inbytes alloc_inbytes ( void );
extern void free_inbytes ( Inbytes x1 );

#define ref_inbytes(x1) (x1)

#define profile_inbytes()

extern void del_stringl ( Stringl x1 );
extern Stringl mk1_stringl ( Str x1 );
extern Str sel_stringl ( Stringl x1 , Nat1 x2 );
extern Stringl tl_stringl ( Stringl x1 );
extern void del1_stringl ( Stringl x1 );
extern Stringl conc_stringl ( Stringl x1 , Stringl x2 );
extern Str hd_stringl ( Stringl x1 );
extern Stringl mk_empty_stringl ( void );
extern Stringl sub_tup_stringl ( Stringl x1 , Nat1 x2 , Nat0 x3 );

extern Str concat_stringl ( Stringl x1, Str x2 );

extern Bool is_empty_stringl ( Stringl x1 );
extern Stringl appl_stringl ( Str x1 , Stringl x2 );
extern Stringl copy1_stringl ( Stringl x1 );
extern Stringl appr_stringl ( Stringl x1 , Str x2 );
extern Nat0 len_stringl ( Stringl x1 );

#define FOR_iter_rep_str(x1,x2) { Iter_rep_str x2##_it = mk_iter_rep_str(x1); while (!is_empty_iter_rep_str(& x2##_it)) { Char x2 = sel_iter_rep_str(& x2##_it);
#define ENDFOR_iter_rep_str(x2) next_iter_rep_str(& x2##_it); } del_iter_rep_str(x2##_it); }

extern Iter_rep_str mk_iter_rep_str ( Rep_str x1 );
extern void next_iter_rep_str ( Iter_rep_str * x1 );
extern Char sel_iter_rep_str ( Iter_rep_str * x1 );

#define FOR_iter_rep_stringl(x1,x2) { Iter_rep_stringl x2##_it = mk_iter_rep_stringl(x1); while (!is_empty_iter_rep_stringl(& x2##_it)) { Str x2 = sel_iter_rep_stringl(& x2##_it);
#define ENDFOR_iter_rep_stringl(x2) next_iter_rep_stringl(& x2##_it); } del_iter_rep_stringl(x2##_it); }

extern Iter_rep_stringl mk_iter_rep_stringl ( Rep_stringl x1 );
extern void next_iter_rep_stringl ( Iter_rep_stringl * x1 );
extern Str sel_iter_rep_stringl ( Iter_rep_stringl * x1 );

#define FOR_iter_str(x1,x2) { Iter_str x2##_it = mk_iter_str(x1); while (!is_empty_iter_str(& x2##_it)) { Char x2 = sel_iter_str(& x2##_it);
#define ENDFOR_iter_str(x2) next_iter_str(& x2##_it); } del_iter_str(x2##_it); }

extern Iter_str mk_iter_str ( Str x1 );

#define FOR_iter_stringl(x1,x2) { Iter_stringl x2##_it = mk_iter_stringl(x1); while (!is_empty_iter_stringl(& x2##_it)) { Str x2 = sel_iter_stringl(& x2##_it);
#define ENDFOR_iter_stringl(x2) next_iter_stringl(& x2##_it); } del_iter_stringl(x2##_it); }

extern Iter_stringl mk_iter_stringl ( Stringl x1 );
extern Bool is_subset_rep_strings ( Rep_strings x1 , Rep_strings x2 );
extern Rep_strings union1_rep_strings ( Rep_strings x1 , Str x2 );
extern Rep_strings uniond_rep_strings ( Rep_strings x1 , Rep_strings x2 );
extern Rep_strings mk1_rep_strings ( Str x1 );
extern Rep_strings union1d_rep_strings ( Rep_strings x1 , Str x2 );
extern Rep_strings sub1d_rep_strings ( Rep_strings x1 , Str x2 );
extern Rep_strings copy_rep_strings ( Rep_strings x1 );

extern Rep_stringl sort_rep_strings ( Rep_strings x1 );

extern Nat0 card_rep_strings ( Rep_strings x1 );
extern Rep_strings diffd_rep_strings ( Rep_strings x1 , Rep_strings x2 );
extern Rep_strings intersd_rep_strings ( Rep_strings x1 , Rep_strings x2 );
extern Bool is_in_rep_strings ( Str x1 , Rep_strings x2 );
extern void del_rep_strings ( Rep_strings x1 );
#define mk_one_rep_strings mk1_rep_strings

extern Bool is_eq_rep_strings ( Rep_strings x1 , Rep_strings x2 );
extern Bool is_eq_strings ( Strings x1 , Strings x2 );
extern void del_strings ( Strings x1 );
extern Strings mk1_strings ( Str x1 );
extern Strings union1_strings ( Strings x1 , Str x2 );
extern Strings inters_strings ( Strings x1 , Strings x2 );
extern void del1_strings ( Strings x1 );
extern Strings diff_strings ( Strings x1 , Strings x2 );
extern Nat0 card_strings ( Strings x1 );
extern Strings mk_empty_strings ( void );

extern Stringl sort_strings ( Strings x1 );

extern Bool is_empty_or_is_in_strings ( Strings x1, Str x2 );

extern Bool is_empty_strings ( Strings x1 );
extern Strings sub1_strings ( Strings x1 , Str x2 );
extern Strings copy1_strings ( Strings x1 );
extern Strings union_strings ( Strings x1 , Strings x2 );
extern Bool is_in_strings ( Str x1 , Strings x2 );
extern Strings copy_strings ( Strings x1 );

#define FOR_iter_rep_strings(x1,x2) { Iter_rep_strings x2##_it = mk_iter_rep_strings(x1); while (!is_empty_iter_rep_strings(& x2##_it)) { Str x2 = sel_iter_rep_strings(& x2##_it);
#define ENDFOR_iter_rep_strings(x2) next_iter_rep_strings(& x2##_it); } del_iter_rep_strings(x2##_it); }

extern Iter_rep_strings mk_iter_rep_strings ( Rep_strings x1 );
extern void next_iter_rep_strings ( Iter_rep_strings * x1 );
extern Str sel_iter_rep_strings ( Iter_rep_strings * x1 );

#define FOR_iter_strings(x1,x2) { Iter_strings x2##_it = mk_iter_strings(x1); while (!is_empty_iter_strings(& x2##_it)) { Str x2 = sel_iter_strings(& x2##_it);
#define ENDFOR_iter_strings(x2) next_iter_strings(& x2##_it); } del_iter_strings(x2##_it); }

extern Iter_strings mk_iter_strings ( Strings x1 );
extern Bool is_eq_rep_context ( Rep_context x1 , Rep_context x2 );
extern Rep_context copy1_rep_context ( Rep_context x1 );
extern Rep_context mk_rep_context

(

Strings x1_rep_adttypes_context_rep_context
,
Strings x1_rep_special_impl_context_rep_context
,
Strings x1_rep_special_ops_context_rep_context
,
Strings x1_rep_filter_adts_context_rep_context
,
Strings x1_rep_filter_impl_context_rep_context
,
Strings x1_rep_filter_oper_context_rep_context
,
Strings x1_rep_filter_comp_context_rep_context
,
Strings x1_rep_filter_params_context_rep_context
,
Strings x1_rep_sign_comps_context_rep_context

,
Str x1_rep_operationtype_context_rep_context

)

;
extern Rep_context copy_rep_context ( Rep_context x1 );

extern Rep_context chg_rep_adttypes_context_rep_context ( Rep_context x1 , Strings x2 );

extern Rep_context chg_rep_special_impl_context_rep_context ( Rep_context x1 , Strings x2 );

extern Rep_context chg_rep_special_ops_context_rep_context ( Rep_context x1 , Strings x2 );

extern Rep_context chg_rep_filter_adts_context_rep_context ( Rep_context x1 , Strings x2 );

extern Rep_context chg_rep_filter_impl_context_rep_context ( Rep_context x1 , Strings x2 );

extern Rep_context chg_rep_filter_oper_context_rep_context ( Rep_context x1 , Strings x2 );

extern Rep_context chg_rep_filter_comp_context_rep_context ( Rep_context x1 , Strings x2 );

extern Rep_context chg_rep_filter_params_context_rep_context ( Rep_context x1 , Strings x2 );

extern Rep_context chg_rep_sign_comps_context_rep_context ( Rep_context x1 , Strings x2 );

extern Rep_context chg_rep_operationtype_context_rep_context ( Rep_context x1 , Str x2 );

extern void del_rep_context ( Rep_context x1 );

extern Outbytes cvtotupelems_rep_operation ( Outbytes x1 , Rep_operation x2 );

extern Outbytes cvtotup1_rep_operation ( Outbytes x1 , Rep_operation x2 );

extern Bool is_submap_rep_operation ( Rep_operation x1 , Rep_operation x2 );

extern void del_rep_operation ( Rep_operation x1 );
extern Bool is_in_rep_operation ( Compname x1 , Rep_operation x2 );
extern Rep_operation union1d_rep_operation ( Rep_operation x1 , Compname x2 , Component x3 );
extern Rep_operation ovwrtd_rep_operation ( Rep_operation x1 , Rep_operation x2 );
extern Rep_operation uniond_rep_operation ( Rep_operation x1 , Rep_operation x2 );
extern Component sel_rep_operation ( Rep_operation x1 , Compname x2 );

#define dom_rep_operation_compname_component(x1,x2) mk_one_rep_strings(copy_compname(x1))

extern Rep_strings dom_rep_operation ( Rep_operation x1 );

extern Rep_operation copy_rep_operation ( Rep_operation x1 );
extern Bool is_in_dom_rep_operation ( Compname x1 , Rep_operation x2 , Component *x3 );
extern Rep_operation ovwrt1d_rep_operation ( Rep_operation x1 , Compname x2 , Component x3 );
extern Rep_operation sub1d_rep_operation ( Rep_operation x1 , Compname x2 );
extern Nat0 card_rep_operation ( Rep_operation x1 );
extern Rep_operation mk1_rep_operation ( Compname x1 , Component x2 );

extern Bool is_eq_rep_operation ( Rep_operation x1 , Rep_operation x2 );

extern Rep_operation cvfromtup1_rep_operation ( Inbytes *x1 );

extern Rep_operation union1_rep_operation ( Rep_operation x1 , Compname x2 , Component x3 );
extern Bool is_eq_context ( Context x1 , Context x2 );
extern Context copy_context ( Context x1 );
extern Context copy1_context ( Context x1 );

extern Context chg_adttypes_context ( Context x1 , Strings x2 );

extern Context chg_special_impl_context ( Context x1 , Strings x2 );

extern Context chg_special_ops_context ( Context x1 , Strings x2 );

extern Context chg_filter_adts_context ( Context x1 , Strings x2 );

extern Context chg_filter_impl_context ( Context x1 , Strings x2 );

extern Context chg_filter_oper_context ( Context x1 , Strings x2 );

extern Context chg_filter_comp_context ( Context x1 , Strings x2 );

extern Context chg_filter_params_context ( Context x1 , Strings x2 );

extern Context chg_sign_comps_context ( Context x1 , Strings x2 );

extern Context chg_operationtype_context ( Context x1 , Str x2 );

extern Context mk_context

(

Strings x1_adttypes_context
,
Strings x1_special_impl_context
,
Strings x1_special_ops_context
,
Strings x1_filter_adts_context
,
Strings x1_filter_impl_context
,
Strings x1_filter_oper_context
,
Strings x1_filter_comp_context
,
Strings x1_filter_params_context
,
Strings x1_sign_comps_context

,
Str x1_operationtype_context

)

;
extern void del1_context ( Context x1 );

extern Strings s_adttypes_context ( Context x1 );

extern Strings s_special_impl_context ( Context x1 );

extern Strings s_special_ops_context ( Context x1 );

extern Strings s_filter_adts_context ( Context x1 );

extern Strings s_filter_impl_context ( Context x1 );

extern Strings s_filter_oper_context ( Context x1 );

extern Strings s_filter_comp_context ( Context x1 );

extern Strings s_filter_params_context ( Context x1 );

extern Strings s_sign_comps_context ( Context x1 );

extern Str s_operationtype_context ( Context x1 );

extern void del_context ( Context x1 );

extern Outbytes cvtotup1_operation ( Outbytes x1 , Operation x2 );

extern Bool is_eq_operation ( Operation x1 , Operation x2 );
extern void del_operation ( Operation x1 );
extern Operation mk1_operation ( Compname x1 , Component x2 );
extern Nat0 card_operation ( Operation x1 );
extern Operation sub1_operation ( Operation x1 , Compname x2 );
extern Operation copy1_operation ( Operation x1 );
extern Operation ovwrt1_operation ( Operation x1 , Compname x2 , Component x3 );
extern Bool is_in_dom_operation ( Compname x1 , Operation x2 , Component *x3 );
extern Operation mk_empty_operation ( void );

#define dom_operation_compname_component(x1,x2) mk_one_strings(x1)

extern Strings dom_operation ( Operation x1 );

extern Bool is_empty_operation ( Operation x1 );
extern Component sel_operation ( Operation x1 , Compname x2 );
extern Operation union_operation ( Operation x1 , Operation x2 );
extern void del1_operation ( Operation x1 );
extern Operation ovwrt_operation ( Operation x1 , Operation x2 );
extern Operation union1_operation ( Operation x1 , Compname x2 , Component x3 );
extern Bool is_in_operation ( Compname x1 , Operation x2 );
extern Operation copy_operation ( Operation x1 );

extern Operation cvfromtup1_operation ( Inbytes *x1 );

#define FOR_iter_rep_operation(x1,x2) { Iter_rep_operation x2##_it = mk_iter_rep_operation(x1); while (!is_empty_iter_rep_operation(& x2##_it)) { Component x2##_e; Compname x2 = sel_iter_rep_operation(& x2##_it,&x2##_e);
#define ENDFOR_iter_rep_operation(x2) next_iter_rep_operation(& x2##_it); } del_iter_rep_operation(x2##_it); }

extern Iter_rep_operation mk_iter_rep_operation ( Rep_operation x1 );
extern void next_iter_rep_operation ( Iter_rep_operation * x1 );
extern Compname sel_iter_rep_operation ( Iter_rep_operation * x1 , Component * x2 );

#define FOR_iter_operation(x1,x2) { Iter_operation x2##_it = mk_iter_operation(x1); while (!is_empty_iter_operation(& x2##_it)) { Component x2##_e; Compname x2 = sel_iter_operation(& x2##_it,&x2##_e);
#define ENDFOR_iter_operation(x2) next_iter_operation(& x2##_it); } del_iter_operation(x2##_it); }

extern Iter_operation mk_iter_operation ( Operation x1 );

extern Rep_contextmap mk1_rep_contextmap ( Intg x1 , Context x2 );
extern Nat0 card_rep_contextmap ( Rep_contextmap x1 );
extern Rep_contextmap sub1d_rep_contextmap ( Rep_contextmap x1 , Intg x2 );
extern Rep_contextmap ovwrt1d_rep_contextmap ( Rep_contextmap x1 , Intg x2 , Context x3 );
extern Bool is_in_dom_rep_contextmap ( Intg x1 , Rep_contextmap x2 , Context *x3 );
extern Rep_contextmap copy_rep_contextmap ( Rep_contextmap x1 );
extern Context sel_rep_contextmap ( Rep_contextmap x1 , Intg x2 );
extern Rep_contextmap uniond_rep_contextmap ( Rep_contextmap x1 , Rep_contextmap x2 );
extern Rep_contextmap ovwrtd_rep_contextmap ( Rep_contextmap x1 , Rep_contextmap x2 );
extern Rep_contextmap union1d_rep_contextmap ( Rep_contextmap x1 , Intg x2 , Context x3 );
extern Bool is_in_rep_contextmap ( Intg x1 , Rep_contextmap x2 );
extern void del_rep_contextmap ( Rep_contextmap x1 );

extern Context alloc_context ( void );
extern void free_context ( Context x1 );

#define ref_context(x1) (x1)

extern void profile_context ( void );

extern Outbytes cvtotupelems_rep_impl ( Outbytes x1 , Rep_impl x2 );
extern Bool is_submap_rep_impl ( Rep_impl x1 , Rep_impl x2 );

extern Rep_impl cvfromtup1_rep_impl ( Inbytes *x1 );

extern void del_rep_impl ( Rep_impl x1 );
extern Bool is_in_rep_impl ( Opname x1 , Rep_impl x2 );
extern Rep_impl union1d_rep_impl ( Rep_impl x1 , Opname x2 , Operation x3 );
extern Rep_impl ovwrtd_rep_impl ( Rep_impl x1 , Rep_impl x2 );
extern Rep_impl uniond_rep_impl ( Rep_impl x1 , Rep_impl x2 );
extern Operation sel_rep_impl ( Rep_impl x1 , Opname x2 );

#define dom_rep_impl_opname_operation(x1,x2) mk_one_rep_strings(copy_opname(x1))

extern Rep_strings dom_rep_impl ( Rep_impl x1 );

extern Rep_impl copy_rep_impl ( Rep_impl x1 );
extern Bool is_in_dom_rep_impl ( Opname x1 , Rep_impl x2 , Operation *x3 );
extern Rep_impl ovwrt1d_rep_impl ( Rep_impl x1 , Opname x2 , Operation x3 );
extern Rep_impl sub1d_rep_impl ( Rep_impl x1 , Opname x2 );
extern Nat0 card_rep_impl ( Rep_impl x1 );
extern Rep_impl mk1_rep_impl ( Opname x1 , Operation x2 );

extern Bool is_eq_rep_impl ( Rep_impl x1 , Rep_impl x2 );

extern Outbytes cvtotup1_rep_impl ( Outbytes x1 , Rep_impl x2 );

extern Rep_impl union1_rep_impl ( Rep_impl x1 , Opname x2 , Operation x3 );
extern void del_contextmap ( ContextMap x1 );
extern ContextMap mk1_contextmap ( Intg x1 , Context x2 );
extern Nat0 card_contextmap ( ContextMap x1 );
extern ContextMap sub1_contextmap ( ContextMap x1 , Intg x2 );
extern ContextMap copy1_contextmap ( ContextMap x1 );
extern ContextMap ovwrt1_contextmap ( ContextMap x1 , Intg x2 , Context x3 );
extern Bool is_in_dom_contextmap ( Intg x1 , ContextMap x2 , Context *x3 );
extern ContextMap mk_empty_contextmap ( void );
extern Bool is_empty_contextmap ( ContextMap x1 );
extern Context sel_contextmap ( ContextMap x1 , Intg x2 );
extern ContextMap union_contextmap ( ContextMap x1 , ContextMap x2 );
extern void del1_contextmap ( ContextMap x1 );
extern ContextMap ovwrt_contextmap ( ContextMap x1 , ContextMap x2 );
extern ContextMap union1_contextmap ( ContextMap x1 , Intg x2 , Context x3 );
extern Bool is_in_contextmap ( Intg x1 , ContextMap x2 );

extern Outbytes cvtotup1_impl ( Outbytes x1 , Impl x2 );

extern Bool is_eq_impl ( Impl x1 , Impl x2 );
extern void del_impl ( Impl x1 );
extern Impl mk1_impl ( Opname x1 , Operation x2 );
extern Nat0 card_impl ( Impl x1 );
extern Impl sub1_impl ( Impl x1 , Opname x2 );
extern Impl copy1_impl ( Impl x1 );
extern Impl ovwrt1_impl ( Impl x1 , Opname x2 , Operation x3 );
extern Bool is_in_dom_impl ( Opname x1 , Impl x2 , Operation *x3 );
extern Impl mk_empty_impl ( void );

#define dom_impl_opname_operation(x1,x2) mk_one_strings(x1)

extern Strings dom_impl ( Impl x1 );

extern Bool is_empty_impl ( Impl x1 );
extern Operation sel_impl ( Impl x1 , Opname x2 );
extern Impl union_impl ( Impl x1 , Impl x2 );
extern void del1_impl ( Impl x1 );
extern Impl ovwrt_impl ( Impl x1 , Impl x2 );
extern Impl union1_impl ( Impl x1 , Opname x2 , Operation x3 );
extern Bool is_in_impl ( Opname x1 , Impl x2 );
extern Impl copy_impl ( Impl x1 );

extern Impl cvfromtup1_impl ( Inbytes *x1 );

#define FOR_iter_rep_contextmap(x1,x2) { Iter_rep_contextmap x2##_it = mk_iter_rep_contextmap(x1); while (!is_empty_iter_rep_contextmap(& x2##_it)) { Context x2##_e; Intg x2 = sel_iter_rep_contextmap(& x2##_it,&x2##_e);
#define ENDFOR_iter_rep_contextmap(x2) next_iter_rep_contextmap(& x2##_it); } del_iter_rep_contextmap(x2##_it); }

extern Iter_rep_contextmap mk_iter_rep_contextmap ( Rep_contextmap x1 );
extern void next_iter_rep_contextmap ( Iter_rep_contextmap * x1 );
extern Intg sel_iter_rep_contextmap ( Iter_rep_contextmap * x1 , Context * x2 );

#define FOR_iter_rep_impl(x1,x2) { Iter_rep_impl x2##_it = mk_iter_rep_impl(x1); while (!is_empty_iter_rep_impl(& x2##_it)) { Operation x2##_e; Opname x2 = sel_iter_rep_impl(& x2##_it,&x2##_e);
#define ENDFOR_iter_rep_impl(x2) next_iter_rep_impl(& x2##_it); } del_iter_rep_impl(x2##_it); }

extern Iter_rep_impl mk_iter_rep_impl ( Rep_impl x1 );
extern void next_iter_rep_impl ( Iter_rep_impl * x1 );
extern Opname sel_iter_rep_impl ( Iter_rep_impl * x1 , Operation * x2 );

#define FOR_iter_contextmap(x1,x2) { Iter_contextmap x2##_it = mk_iter_contextmap(x1); while (!is_empty_iter_contextmap(& x2##_it)) { Context x2##_e; Intg x2 = sel_iter_contextmap(& x2##_it,&x2##_e);
#define ENDFOR_iter_contextmap(x2) next_iter_contextmap(& x2##_it); } del_iter_contextmap(x2##_it); }

extern Iter_contextmap mk_iter_contextmap ( ContextMap x1 );

#define FOR_iter_impl(x1,x2) { Iter_impl x2##_it = mk_iter_impl(x1); while (!is_empty_iter_impl(& x2##_it)) { Operation x2##_e; Opname x2 = sel_iter_impl(& x2##_it,&x2##_e);
#define ENDFOR_iter_impl(x2) next_iter_impl(& x2##_it); } del_iter_impl(x2##_it); }

extern Iter_impl mk_iter_impl ( Impl x1 );
extern Bool is_submap_rep_adt ( Rep_adt x1 , Rep_adt x2 );
extern Rep_adt union1_rep_adt ( Rep_adt x1 , Implname x2 , Impl x3 );

extern Outbytes cvtotup1_rep_adt ( Outbytes x1 , Rep_adt x2 );

extern void del_rep_adt ( Rep_adt x1 );
extern Bool is_in_rep_adt ( Implname x1 , Rep_adt x2 );
extern Rep_adt union1d_rep_adt ( Rep_adt x1 , Implname x2 , Impl x3 );
extern Rep_adt ovwrtd_rep_adt ( Rep_adt x1 , Rep_adt x2 );
extern Rep_adt uniond_rep_adt ( Rep_adt x1 , Rep_adt x2 );
extern Impl sel_rep_adt ( Rep_adt x1 , Implname x2 );

#define dom_rep_adt_implname_impl(x1,x2) mk_one_rep_strings(copy_implname(x1))

extern Rep_strings dom_rep_adt ( Rep_adt x1 );

extern Rep_adt copy_rep_adt ( Rep_adt x1 );
extern Bool is_in_dom_rep_adt ( Implname x1 , Rep_adt x2 , Impl *x3 );
extern Rep_adt ovwrt1d_rep_adt ( Rep_adt x1 , Implname x2 , Impl x3 );
extern Rep_adt sub1d_rep_adt ( Rep_adt x1 , Implname x2 );
extern Nat0 card_rep_adt ( Rep_adt x1 );
extern Rep_adt mk1_rep_adt ( Implname x1 , Impl x2 );

extern Rep_adt cvfromtup1_rep_adt ( Inbytes *x1 );

extern Bool is_eq_rep_adt ( Rep_adt x1 , Rep_adt x2 );

extern Outbytes cvtotupelems_rep_adt ( Outbytes x1 , Rep_adt x2 );
extern Bool is_eq_adt ( Adt x1 , Adt x2 );

extern Adt cvfromtup1_adt ( Inbytes *x1 );

extern void del_adt ( Adt x1 );
extern Adt mk1_adt ( Implname x1 , Impl x2 );
extern Nat0 card_adt ( Adt x1 );
extern Adt sub1_adt ( Adt x1 , Implname x2 );
extern Adt copy1_adt ( Adt x1 );
extern Adt ovwrt1_adt ( Adt x1 , Implname x2 , Impl x3 );
extern Bool is_in_dom_adt ( Implname x1 , Adt x2 , Impl *x3 );
extern Adt mk_empty_adt ( void );

#define dom_adt_implname_impl(x1,x2) mk_one_strings(x1)

extern Strings dom_adt ( Adt x1 );

extern Bool is_empty_adt ( Adt x1 );
extern Impl sel_adt ( Adt x1 , Implname x2 );
extern Adt union_adt ( Adt x1 , Adt x2 );
extern void del1_adt ( Adt x1 );
extern Adt ovwrt_adt ( Adt x1 , Adt x2 );
extern Adt union1_adt ( Adt x1 , Implname x2 , Impl x3 );
extern Bool is_in_adt ( Implname x1 , Adt x2 );
extern Adt copy_adt ( Adt x1 );

extern Outbytes cvtotup1_adt ( Outbytes x1 , Adt x2 );

#define FOR_iter_rep_adt(x1,x2) { Iter_rep_adt x2##_it = mk_iter_rep_adt(x1); while (!is_empty_iter_rep_adt(& x2##_it)) { Impl x2##_e; Implname x2 = sel_iter_rep_adt(& x2##_it,&x2##_e);
#define ENDFOR_iter_rep_adt(x2) next_iter_rep_adt(& x2##_it); } del_iter_rep_adt(x2##_it); }

extern Iter_rep_adt mk_iter_rep_adt ( Rep_adt x1 );
extern void next_iter_rep_adt ( Iter_rep_adt * x1 );
extern Implname sel_iter_rep_adt ( Iter_rep_adt * x1 , Impl * x2 );

#define FOR_iter_adt(x1,x2) { Iter_adt x2##_it = mk_iter_adt(x1); while (!is_empty_iter_adt(& x2##_it)) { Impl x2##_e; Implname x2 = sel_iter_adt(& x2##_it,&x2##_e);
#define ENDFOR_iter_adt(x2) next_iter_adt(& x2##_it); } del_iter_adt(x2##_it); }

extern Iter_adt mk_iter_adt ( Adt x1 );

extern Nat0 card_rep_vdmdb ( Rep_vdmdb x1 );
extern void del_rep_vdmdb ( Rep_vdmdb x1 );
extern Bool is_in_rep_vdmdb ( Adtname x1 , Rep_vdmdb x2 );
extern Rep_vdmdb sub1d_rep_vdmdb ( Rep_vdmdb x1 , Adtname x2 );
extern Rep_vdmdb ovwrt1d_rep_vdmdb ( Rep_vdmdb x1 , Adtname x2 , Adt x3 );
extern Bool is_in_dom_rep_vdmdb ( Adtname x1 , Rep_vdmdb x2 , Adt *x3 );

extern Outbytes cvtotup1_rep_vdmdb ( Outbytes x1 , Rep_vdmdb x2 );

extern Rep_vdmdb cvfromtup1_rep_vdmdb ( Inbytes *x1 );

extern Rep_vdmdb copy_rep_vdmdb ( Rep_vdmdb x1 );

#define dom_rep_vdmdb_adtname_adt(x1,x2) mk_one_rep_strings(copy_adtname(x1))

extern Rep_strings dom_rep_vdmdb ( Rep_vdmdb x1 );

extern Adt sel_rep_vdmdb ( Rep_vdmdb x1 , Adtname x2 );
extern Rep_vdmdb uniond_rep_vdmdb ( Rep_vdmdb x1 , Rep_vdmdb x2 );
extern Rep_vdmdb ovwrtd_rep_vdmdb ( Rep_vdmdb x1 , Rep_vdmdb x2 );
extern Rep_vdmdb union1d_rep_vdmdb ( Rep_vdmdb x1 , Adtname x2 , Adt x3 );
extern Rep_vdmdb mk1_rep_vdmdb ( Adtname x1 , Adt x2 );
extern Rep_vdmdb union1_rep_vdmdb ( Rep_vdmdb x1 , Adtname x2 , Adt x3 );

extern Outbytes cvtotupelems_rep_vdmdb ( Outbytes x1 , Rep_vdmdb x2 );

extern void del_vdmdb ( Vdmdb x1 );
extern Vdmdb mk1_vdmdb ( Adtname x1 , Adt x2 );
extern Nat0 card_vdmdb ( Vdmdb x1 );
extern Vdmdb sub1_vdmdb ( Vdmdb x1 , Adtname x2 );
extern Vdmdb copy1_vdmdb ( Vdmdb x1 );
extern Vdmdb ovwrt1_vdmdb ( Vdmdb x1 , Adtname x2 , Adt x3 );
extern Bool is_in_dom_vdmdb ( Adtname x1 , Vdmdb x2 , Adt *x3 );
extern Vdmdb mk_empty_vdmdb ( void );

extern Bool exist_impl_vdmdb ( Vdmdb x1, Adtname x2, Implname x3 );

extern Bool exist_component_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4, Compname x5, Compname x6 );

extern Bool search_operation_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4 );

extern Component search_component_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4, Compname x5, Compname x6 );

extern Component compute_sign_component_vdmdb ( Vdmdb x1, Adtname x2, Opname x3, Compname x4 );

extern Component search_docu_components_vdmdb ( Vdmdb x1, Adtname x2, Opname x3, Compname x4, Strings x5, Strings x6 );

extern Str sel_adttype_vdmdb ( Vdmdb x1, Adtname x2 );

extern Strings sel_adts_vdmdb ( Vdmdb x1 );

extern Strings sel_oper_vdmdb ( Vdmdb x1, Adtname x2, Implname x3 );

extern Strings sel_opr1_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Str x4 );

extern Strings sel_impl_params_vdmdb ( Vdmdb x1, Adtname x2, Implname x3 );

extern Vdmdb sel_db_vdmdb ( Vdmdb x1, Strings x2, Strings x3, Strings x4, Strings x5, Strings x6 );

extern Str solve_include_vdmdb ( Vdmdb x1, Str x2 );

extern Bool new_adt_vdmdb ( Vdmdb x1, Adtname x2 );

extern Bool new_operation_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4 );

extern Bool import_vdmdb ( Vdmdb x1, Str x2 );

extern Bool rm_impl_vdmdb ( Vdmdb x1, Adtname x2, Implname x3 );

extern Bool rm_component_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4, Compname x5, Compname x6 );

extern Outbytes cvtotupl_vdmdb ( Vdmdb x1 );

#define dom_vdmdb_adtname_adt(x1,x2) mk_one_strings(x1)

extern Strings dom_vdmdb ( Vdmdb x1 );

extern Vdmdb cvfromtupl_vdmdb ( Inbytes x1 );

extern Bool rm_operation_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4 );

extern Bool rm_adt_vdmdb ( Vdmdb x1, Adtname x2 );

extern Bool new_component_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4, Compname x5, Compname x6, Component x7 );

extern Bool new_impl_vdmdb ( Vdmdb x1, Adtname x2, Implname x3 );

extern Str insert_include_vdmdb ( Vdmdb x1, Str x2 );

extern Str export_vdmdb ( Vdmdb x1 );

extern Strings sel_oper_params_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4 );

extern Strings sel_comp_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4 );

extern Strings sel_op_vdmdb ( Vdmdb x1, Adtname x2, Implname x3 );

extern Strings sel_impl_vdmdb ( Vdmdb x1, Adtname x2 );

extern Str classify_op_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4 );

extern Str setup_docu_vdmdb ( Vdmdb x1 );

extern Component search_sign_component_vdmdb ( Vdmdb x1, Adtname x2, Opname x3, Compname x4 );

extern Component sel_component_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4, Compname x5, Compname x6 );

extern Component compute_component_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4, Compname x5, Compname x6 );

extern Bool comp_is_in_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4, Compname x5, Compname x6, Component * r2 );

extern Bool exist_operation_vdmdb ( Vdmdb x1, Adtname x2, Implname x3, Opname x4 );

extern Bool exist_adt_vdmdb ( Vdmdb x1, Adtname x2 );

extern Bool is_empty_vdmdb ( Vdmdb x1 );
extern Adt sel_vdmdb ( Vdmdb x1 , Adtname x2 );
extern Vdmdb union_vdmdb ( Vdmdb x1 , Vdmdb x2 );
extern void del1_vdmdb ( Vdmdb x1 );
extern Vdmdb ovwrt_vdmdb ( Vdmdb x1 , Vdmdb x2 );
extern Vdmdb union1_vdmdb ( Vdmdb x1 , Adtname x2 , Adt x3 );
extern Bool is_in_vdmdb ( Adtname x1 , Vdmdb x2 );

#define FOR_iter_rep_vdmdb(x1,x2) { Iter_rep_vdmdb x2##_it = mk_iter_rep_vdmdb(x1); while (!is_empty_iter_rep_vdmdb(& x2##_it)) { Adt x2##_e; Adtname x2 = sel_iter_rep_vdmdb(& x2##_it,&x2##_e);
#define ENDFOR_iter_rep_vdmdb(x2) next_iter_rep_vdmdb(& x2##_it); } del_iter_rep_vdmdb(x2##_it); }

extern Iter_rep_vdmdb mk_iter_rep_vdmdb ( Rep_vdmdb x1 );
extern void next_iter_rep_vdmdb ( Iter_rep_vdmdb * x1 );
extern Adtname sel_iter_rep_vdmdb ( Iter_rep_vdmdb * x1 , Adt * x2 );

#define FOR_iter_vdmdb(x1,x2) { Iter_vdmdb x2##_it = mk_iter_vdmdb(x1); while (!is_empty_iter_vdmdb(& x2##_it)) { Adt x2##_e; Adtname x2 = sel_iter_vdmdb(& x2##_it,&x2##_e);
#define ENDFOR_iter_vdmdb(x2) next_iter_vdmdb(& x2##_it); } del_iter_vdmdb(x2##_it); }

extern Iter_vdmdb mk_iter_vdmdb ( Vdmdb x1 );

/* ------- PHASE4 ------------------ */
#define tld_inbytes(x1) (ref_inbytes(x1)->f_currelem++, (--((x1)->f_buffelems) == 0) ? read_buffer_inbytes(x1) : x1)

#define is_empty_inbytes(x1) (len_inbytes(x1) == 0)
#define hd_inbytes(x1) *ref_inbytes(x1)->f_currelem

#define tl_inbytes(x1) (ref_inbytes(x1)->f_currelem++, (--((x1)->f_buffelems) == 0) ? read_buffer_inbytes(x1) : x1)

#define del1_outbytes(x1) free_outbytes(ref_outbytes(x1))

#define appr_outbytes(x1,x2) (ref_outbytes(x1)->f_buff[ref_outbytes(x1)->f_buffelems] = x2, (++(x1->f_buffelems) == 4096) ? write_buffer_outbytes(x1) : x1)

#define forall_rep_stringl(x1,x2){Rep_stringl _x1=x1;for(;_x1!=(Rep_stringl)0;_x1=_x1->f_next) x2(ref_rep_stringl(_x1)->f_info);}
#define tld_rep_stringl(x1) rmv1d_rep_stringl(x1,1)
#define hd_rep_stringl(x1) sel_rep_stringl(x1,(Nat1)1)
#define is_empty_rep_stringl(x1) (! (x1))
#define appl_rep_stringl(x1,x2) conc_rep_stringl(mk1_rep_stringl(x1),x2)
#define del1_rep_stringl(x1) {Rep_stringl _y1=x1;while (_y1!=(Rep_stringl)0) {Rep_stringl _x1=_y1;_y1=ref_rep_stringl(_y1)->f_next;free_rep_stringl(_x1);}}
#define appr_rep_stringl(x1,x2) conc_rep_stringl(x1,mk1_rep_stringl(x2))
#define mk_empty_rep_stringl() ((Rep_stringl)0)
#define del1_rep_strings(x1) {Rep_strings _y1=x1;while (_y1!=(Rep_strings)0) {Rep_strings _x1=_y1;_y1=ref_rep_strings(_y1)->f_next;free_rep_strings(_x1);}}
#define mk_empty_rep_strings() ((Rep_strings)0)

#define forall_rep_strings(x1,x2){Rep_strings _x1=x1;for(;_x1!=(Rep_strings)0;_x1=_x1->f_next) x2(ref_rep_strings(_x1)->f_info);}
#define is_empty_rep_strings(x1) (! (x1))

#define forall_rep_operation(x1,x2){Rep_operation _x1=x1;for(;_x1!=(Rep_operation)0;_x1=_x1->f_next) x2(ref_rep_operation(_x1)->f_info,_x1->f_attr);}
#define is_empty_rep_operation(x1) (! (x1))
#define mk_empty_rep_operation() ((Rep_operation)0)
#define del1_rep_operation(x1) {Rep_operation _y1=x1;while (_y1!=(Rep_operation)0) {Rep_operation _x1=_y1;_y1=ref_rep_operation(_y1)->f_next;free_rep_operation(_x1);}}

#define forall_rep_impl(x1,x2){Rep_impl _x1=x1;for(;_x1!=(Rep_impl)0;_x1=_x1->f_next) x2(ref_rep_impl(_x1)->f_info,_x1->f_attr);}
#define is_empty_rep_impl(x1) (! (x1))
#define mk_empty_rep_impl() ((Rep_impl)0)
#define del1_rep_impl(x1) {Rep_impl _y1=x1;while (_y1!=(Rep_impl)0) {Rep_impl _x1=_y1;_y1=ref_rep_impl(_y1)->f_next;free_rep_impl(_x1);}}

#define forall_rep_adt(x1,x2){Rep_adt _x1=x1;for(;_x1!=(Rep_adt)0;_x1=_x1->f_next) x2(ref_rep_adt(_x1)->f_info,_x1->f_attr);}
#define is_empty_rep_adt(x1) (! (x1))
#define mk_empty_rep_adt() ((Rep_adt)0)
#define del1_rep_adt(x1) {Rep_adt _y1=x1;while (_y1!=(Rep_adt)0) {Rep_adt _x1=_y1;_y1=ref_rep_adt(_y1)->f_next;free_rep_adt(_x1);}}

#define forall_rep_vdmdb(x1,x2){Rep_vdmdb _x1=x1;for(;_x1!=(Rep_vdmdb)0;_x1=_x1->f_next) x2(ref_rep_vdmdb(_x1)->f_info,_x1->f_attr);}
#define del1_rep_vdmdb(x1) {Rep_vdmdb _y1=x1;while (_y1!=(Rep_vdmdb)0) {Rep_vdmdb _x1=_y1;_y1=ref_rep_vdmdb(_y1)->f_next;free_rep_vdmdb(_x1);}}
#define mk_empty_rep_vdmdb() ((Rep_vdmdb)0)
#define is_empty_rep_vdmdb(x1) (! (x1))

#define s_rep_adttypes_context_rep_context(x) (ref_rep_context(x)->f_rep_adttypes_context_rep_context)

#define s_rep_special_impl_context_rep_context(x) (ref_rep_context(x)->f_rep_special_impl_context_rep_context)

#define s_rep_special_ops_context_rep_context(x) (ref_rep_context(x)->f_rep_special_ops_context_rep_context)

#define s_rep_filter_adts_context_rep_context(x) (ref_rep_context(x)->f_rep_filter_adts_context_rep_context)

#define s_rep_filter_impl_context_rep_context(x) (ref_rep_context(x)->f_rep_filter_impl_context_rep_context)

#define s_rep_filter_oper_context_rep_context(x) (ref_rep_context(x)->f_rep_filter_oper_context_rep_context)

#define s_rep_filter_comp_context_rep_context(x) (ref_rep_context(x)->f_rep_filter_comp_context_rep_context)

#define s_rep_filter_params_context_rep_context(x) (ref_rep_context(x)->f_rep_filter_params_context_rep_context)

#define s_rep_sign_comps_context_rep_context(x) (ref_rep_context(x)->f_rep_sign_comps_context_rep_context)

#define s_rep_operationtype_context_rep_context(x) (ref_rep_context(x)->f_rep_operationtype_context_rep_context)

#define del1_rep_context(z1) free_rep_context(z1)

#define forall_rep_contextmap(x1,x2){Rep_contextmap _x1=x1;for(;_x1!=(Rep_contextmap)0;_x1=_x1->f_next) x2(ref_rep_contextmap(_x1)->f_info,_x1->f_attr);}
#define mk_empty_rep_contextmap() ((Rep_contextmap)0)
#define is_empty_rep_contextmap(x1) (! (x1))
#define del1_rep_contextmap(x1) {Rep_contextmap _y1=x1;while (_y1!=(Rep_contextmap)0) {Rep_contextmap _x1=_y1;_y1=ref_rep_contextmap(_y1)->f_next;free_rep_contextmap(_x1);}}
#define is_empty_iter_stringl(x1) is_empty_iter_rep_stringl(&((x1)->f_ir))
#define del_iter_stringl(x1) del_stringl((x1).f_vl)
#define sel_iter_stringl(x1) copy_str(sel_iter_rep_stringl(&((x1)->f_ir)))
#define next_iter_stringl(x1) next_iter_rep_stringl(&((x1)->f_ir))
#define is_empty_iter_strings(x1) is_empty_iter_rep_strings(&((x1)->f_ir))
#define del_iter_strings(x1) del_strings((x1).f_vl)
#define sel_iter_strings(x1) copy_str(sel_iter_rep_strings(&((x1)->f_ir)))
#define next_iter_strings(x1) next_iter_rep_strings(&((x1)->f_ir))
#define is_empty_iter_operation(x1) is_empty_iter_rep_operation(&((x1)->f_ir))
#define del_iter_operation(x1) del_operation((x1).f_vl)
#define sel_iter_operation(x1,x2) copy_compname(sel_iter_rep_operation(&((x1)->f_ir),x2))
#define next_iter_operation(x1) next_iter_rep_operation(&((x1)->f_ir))
#define is_empty_iter_impl(x1) is_empty_iter_rep_impl(&((x1)->f_ir))
#define del_iter_impl(x1) del_impl((x1).f_vl)
#define sel_iter_impl(x1,x2) copy_opname(sel_iter_rep_impl(&((x1)->f_ir),x2))
#define next_iter_impl(x1) next_iter_rep_impl(&((x1)->f_ir))
#define is_empty_iter_adt(x1) is_empty_iter_rep_adt(&((x1)->f_ir))
#define del_iter_adt(x1) del_adt((x1).f_vl)
#define sel_iter_adt(x1,x2) copy_implname(sel_iter_rep_adt(&((x1)->f_ir),x2))
#define next_iter_adt(x1) next_iter_rep_adt(&((x1)->f_ir))
#define is_empty_iter_vdmdb(x1) is_empty_iter_rep_vdmdb(&((x1)->f_ir))
#define del_iter_vdmdb(x1) del_vdmdb((x1).f_vl)
#define sel_iter_vdmdb(x1,x2) copy_adtname(sel_iter_rep_vdmdb(&((x1)->f_ir),x2))
#define next_iter_vdmdb(x1) next_iter_rep_vdmdb(&((x1)->f_ir))
#define is_empty_iter_contextmap(x1) is_empty_iter_rep_contextmap(&((x1)->f_ir))
#define del_iter_contextmap(x1) del_contextmap((x1).f_vl)
#define sel_iter_contextmap(x1,x2) copy_intg(sel_iter_rep_contextmap(&((x1)->f_ir),x2))
#define next_iter_contextmap(x1) next_iter_rep_contextmap(&((x1)->f_ir))
#define is_empty_iter_str(x1) is_empty_iter_rep_str(&((x1)->f_ir))
#define del_iter_str(x1) del_str((x1).f_vl)
#define sel_iter_str(x1) copy_char(sel_iter_rep_str(&((x1)->f_ir)))
#define next_iter_str(x1) next_iter_rep_str(&((x1)->f_ir))
#define del_iter_rep_stringl(x1)
#define is_empty_iter_rep_stringl(x1) (! (x1)->f_curser)
#define del_iter_rep_strings(x1)
#define is_empty_iter_rep_strings(x1) (! (x1)->f_curser)
#define del_iter_rep_operation(x1)
#define is_empty_iter_rep_operation(x1) (! (x1)->f_curser)
#define del_iter_rep_impl(x1)
#define is_empty_iter_rep_impl(x1) (! (x1)->f_curser)
#define del_iter_rep_adt(x1)
#define is_empty_iter_rep_adt(x1) (! (x1)->f_curser)
#define del_iter_rep_vdmdb(x1)
#define is_empty_iter_rep_vdmdb(x1) (! (x1)->f_curser)
#define del_iter_rep_contextmap(x1)
#define is_empty_iter_rep_contextmap(x1) (! (x1)->f_curser)
#define del_iter_rep_str(x1)
#define is_empty_iter_rep_str(x1) ((x1)->f_curser == (x1)->f_array->f_len)

#endif
