# $Id: array.tcl,v 1.1 1996/09/05 07:03:38 vdm Exp $

proc array_show arr {
    upvar $arr x
    foreach y [array names x] { puts "$y=$x($y)" }
}

proc array_copy {arrSrc arrDst} {
    catch {uplevel unset $arrDst}
    foreach x [uplevel array names $arrSrc] { 
	uplevel set $arrDst\($x) $$arrSrc\($x)
    }
    return
}

proc array_move {arrSrc arrDst} {
    uplevel array_copy $arrSrc $arrDst
    catch {uplevel unset $arrSrc}
    return
}
 
proc array_reverse {arrSrc {arrDst ""}} { 
    upvar $arrSrc src
    if {$arrDst!={}} { upvar $arrDst dst }
    foreach x [array names src] { set dst($src($x)) $x }
    if {$arrDst=={}} { array_move dst src }
    return
}

