# $Id: getdocu.tcl,v 1.2 1996/09/18 18:44:46 vdm Exp $
# functions for accessing docu and signature components

proc getVsigDocu {adt impl op} {
    set vdocu [searchsign $adt $op vsig]
    set cdocu [searchcomp $adt $impl $op docu]
    if {[string length $cdocu]==0} {
	set cdocu [searchcomp $adt com $op docu]
    }
    set docu "$vdocu\n$cdocu"

    if [string length $docu]==1 {
	return ""
    }
    return "[searchsign stdlib setup docu]$docu"
}

proc getCsigDocu {adt op} {
    set docu [searchsign $adt $op csig]
    if [string length $docu]==0 {
	return $docu
    }
    return "[searchsign stdlib setup docu]$docu"
}

proc getCppDocu {adt op} {
    set docu [searchsign $adt $op cpp]
    if [string length $docu]==0 {
	return $docu
    }
    return "[searchsign stdlib setup docu][searchsign stdlib setup defcpp]$docu"
}

