
# $Id: commdbm.tcl,v 1.1 1994/07/14 16:31:53 vdm Exp $
# communicate with database manager

proc callDbm {cmd {call callServer}} {
    global VdmFd
    supervise  "$call $VdmFd \"$cmd\"" "" CommunicationError
}

proc callDbmToFile {cmd file} {
    global VdmFd
    supervise "callServerToFile $VdmFd \"$cmd\" $file" "" CommunicationError
}

proc sendDbm cmd {callDbm $cmd sendCmd}

proc openDbm { } {
    global VdmDbManager VdmFd
    set VdmFd [openServer $VdmDbManager]
}

proc closeDbm { } {
    global VdmFd
    closeServer $VdmFd
}


