# $Id: createlabel.tcl,v 1.1 1994/08/23 20:08:24 vdm Exp $
# createLabel command for creating a label with options given via the args
# argument, or with the program global options list
# by using the seopt command
#
# currently -borderwidth and -labelrelief (relief form) are supported

# -------------------------------------------------------------------------------

proc createLabel {label text args} {
	setopt borderwidth 1
	setopt labelrelief flat

	label $label -text $text -borderwidth $borderwidth -relief $labelrelief
}

# -------------------------------------------------------------------------------
