# $Id: disablemenubutton.tcl,v 1.1 1995/09/24 14:43:11 vdm Exp $

# disable or enable a menue button
#
# parameters
# button   : the menue widget
# index    : the index of the menuebutton in the menue (counting from 1)
# variable : the variable to be testet, if it is empty the menue entry is disabled,
#            else it is enabled
# args     : arguments supported by the trace command, not needed here
#
# usage 
#            trace variable <var> w "disableMenueButton <widget> <index> <var>"   

proc disableMenueButton {button index variable args} {
    global $variable

    if {[set $variable] == ""} {
	$button entryconfigure $index -state disabled
    } else {
	$button entryconfigure $index -state normal
    }
}

