
# preprocess.tcl,v 1.3 1994/11/13 14:41:11 vdm Exp
# preprocess text for documentation

set baseimpl U
set cplus U

proc operationtype1 lang {
    global baseimpl cplus

    operationtype $lang
    if {"$lang"=="C"}   {set cplus U   } else {set cplus D   }
    if {"$lang"=="A++"} {set baseimpl D} else {set baseimpl U}
    return
}

proc preprocessDocu text {
    global Vdmpp baseimpl cplus

    set docu ""
    if [string length $text]!=0 {
        catch {
            set docu [exec $Vdmpp -E0 -L -R \
                      -DGEN_DOCU -DGEN_C -DGEN_ANSIC \
                      -${cplus}GEN_CPP -${baseimpl}BASEIMPL << $text]
        }
    }
    return $docu
}

# preprocess the result of a command

proc preprocessResult args {
    preprocessDocu [eval $args]
}
