# $Id: vdmhelptext.tcl,v 1.5 1996/09/05 07:03:46 vdm Exp $

proc vdmhelptext { } {
    showdocu vdmhelpText vdmhelpTitle
}

proc vdmhelpTitle w {
    insertBigBlue $w "VDM Class Library Browser "
    insertBigRed  $w "Usage"
    insertNewline $w
}

proc vdmhelpText w {
    insertText $w "
The left list titled \"ADTs\" shows the names of the abstract datatypes
available in the database. Select one of the entries by a left button
double click of the mouse. The currently selected ADT is shown at the top
of the list.

The list in the middle titled \"Implementations\" will then show the
implementations available for the selected ADT. Select one of these
implementations by a left button double click of the mouse. The currently
selected implementation is shown at the top of the list.

The right list titled \"Operations\" shows the operations available for the
selected implementation. When selecting one of them by a left button double
click, a text window will appear with information about the operation.

In the text window all detailed information about ADTs, implementations 
and operation is collected. To see previous information, the scroll bar 
can be used to position the text.

To leave the browser, select the \"Quit\" button in the \"Database\" menue."
}

proc vdmhelptextmenu { } {
    showdocu vdmhelpmenuText vdmhelpmenuTitle
}

proc vdmhelpmenuTitle w {
    insertBigBlue $w "VDM Class Library Browser "
    insertBigRed  $w "Menues"
    insertNewline $w
}

proc vdmhelpmenuText w {
    insertText $w "
The \"Database\" menue has the entries \"Name\" for showing the currently
loaded database, a \"Reload\" button and a \"Quit\" button to leave the program.

The \"Adts\" menue has the entry \"Predefined\" for showing the predefined
datatypes. The \"General\" entry is used to show documentation about the
currently selected ADT.

The \"Implementations\" menue has the entry \"Features\" for showing
documentation about the implementation strategie, time and space constraints
and implementation parameters for the currently selected implementation.

The \"Options\" menue has three radio buttons for selecting the language
variant for the documentation. Selecting the \"ANSI C Prototypes\" button 
shows all operations available for the C interface of the library, the
C prototype will be shown in the docu window.
Selectin the \"C++ member functions\" shows all operations for C++ and their
calling convetions.

Selecting the \"C++ automem member functions\" shows all operations for C++
with automatic memory management for the generated classes. This interface
is simpler and more comfortable and reliable than the pure C++ interface.
It is highly recomended to use this option with C++.

The option status can be saved with the \"Save option\" menu entry, the
state is written into the file \"~/.vdmhelprc\""
}
