# $Id: vdminfohelp.tcl,v 1.3 1996/09/05 07:03:46 vdm Exp $
# help routine for dbm program

proc vdminfohelp args {
  global argv0 defaultdatabase

  puts "Usage: $argv0 <option>... \[<constr> \[<impl> \[<opr>\]\]\]
Options:
 -i		: runs $argv0 in interactive mode ( exec \"help\" to get command info)
 -l		: runs $argv0 in command line mode (one command per call)
 -e		: give predefined elementary domains
 -a		: list internal ADTs also
 -d		: detailed documentation
 -c		: additional ANSI-C prototypes
 -c++   	: additional C++ member function declarations
 -B<vdmdb>	: selects vdm database (default: $defaultdatabase )"

  return ""
}

proc usage { } {vdminfohelp}

proc vdminfohelpi { } {
    global argv0
    puts "$argv0: commands:
predef				# list predefined domains
adt				# list available adts
impl		adt		# list available implementations for an adt
oper		adt impl	# list available operations for an adt and impl
adtdescr			# detailed info for adts
impldescr	adt		# detailed info for implementations of an adt
alloperdescr	adt impl	# detailed info for all operations of and adt and impl
operdescr	adt impl op	# detailed info for op of adt and impl
currdb				# current database
help				# this text
exit				# leave program"
}
