#ifndef NODE_H
#define NODE_H

#include <stdarg.h>
#include "nodesba.hpp"
#include "parse.hpp"
//#include "typcheck.hpp"
//#include ".hpp"

extern void make_layer(void);
extern void kill_layer(void);

#define nodeseq Basicarray_node
typedef long int parse_typ;
typedef nat0 (*rulept)(const nodeseq &, node *, const parse_typ &);

class node
{
public:
 rulept rule;
 nodeseq terms;
 parse_typ typ;
 node * prec;
 bool new_lay;
 nat0 linenr;

 node();
 node(const node & n);
 node(rulept r, const nodeseq & ns, const parse_typ & t, node * p = (node*)0);
 node(rulept r, const parse_typ & t,
      node * elem, ...); // variable Argumentliste und ihr Name
 ~node();
 void parse(bool newtypes = bool(0));
 node & operator = (const node & n);
 bool operator == (const node & n);
 bool operator != (const node & n);
};

#endif
