#ifndef PARSE_H
#define PARSE_H
#include <stdio.h>
#include "types.hpp"
#include "stringba.hpp"

typedef long int check; // Typ von Checks
// Werte von check fr Typnamen-Suche:
const TAGFIELD = -1,
      NOTFOUND = 0;

typedef nat0 t_typ;

extern nat0 yylino;

#define UNKNOWN 1
#define T_BASIC 2
#define T_BOOL 8
#define T_NAT 4
#define T_NAT1 3
#define T_INT 5
#define T_RAT 6
#define T_REAL 7
#define T_CHAR 9
#define T_TOKEN 10
#define T_NIL 11
#define DONTCARE 12
#define NOPAT 13
#define T_UNDEFINED 14
#define T_EMPTYSET 15
#define T_EMPTYSEQ 16
#define T_EMPTYMAP 17
#define T_PROD 18
#define T_SET 19
#define T_QUOTE 20
#define T_TAG 21
#define T_COMP 22
#define T_ID 23
#define T_FIELD 24
#define T_UNION 25
#define T_SEQ 26
#define T_SEQ1 27
#define T_MAP 28
#define T_INMAP 29
#define T_PFUNC 30
#define T_TFUNC 31
#define T_VAR 32
#define T_POLY 33
#define VAR 34
#define VALUE 35
#define PAT_LIST 36
#define T_PARAMS 37
#define MULTI_PAT 38
#define T_FUNC 39
#define T_VARSET 40
#define T_VARSEQ 41

#define KNOWN 2
#define CONST 3
#define CONST_NUM 4

#define OWN_TYPES 18

// Durchlauf-Steuerung
#define FIRST 0
#define SECOND 1
#define NEW_LAYER -1
#define NEW_LAYER_ACT -2

extern Basicarray_String LEXEMS;

#endif


