// String1 Klassse fuer Strings
// die sich wie unstrukturiete Werte
// verhalten
#ifndef STRING_H
 #define STRING_H

 #include <stdlib.h>
 #include <string.h>
 #include <strstream.h>
 #include "types.hpp"
 #include "basicstr.hpp"
 #ifdef WITHDOSIO
  #include <conio.h>
  #include <editor.hpp>
  #include <window.hpp>
  #include <basicstr.hpp>
 #endif

 // Stringstream - Konstanten
 const MAXFILESTRING = 200;  // Puffergre frs Lesen von Strings,
			     // Puffer wird dyn. um diesen Wert vergrert
 typedef char * string;
 typedef unsigned int zahl;

 class String : public Basicstring{

  public:
   String() : Basicstring(){}

   String(string const x) : Basicstring(x){}

   String(const String & x) : Basicstring(x){}

   operator string() const{
    return s;
   }

   friend String operator + (const String & x,const String & y);

   friend String operator + (const String & x, const string y);

   friend String operator + (string const x,const String & y);

   String substr(nat0 apos, nat0 epos) const
   {
    return /*String(*/Basicstring::substr(apos, epos)/*)*/;
   }

   void show(ostrstream & os){
    os << s;
   }

   #ifdef WITHDOSIO
   void show() const{
    cout << s;
   }

   char input(int withshow = 1, const Basicstring & str = Basicstring("Stringeingabe")) {
    Window win(WERTWIN, withshow, str);
    if (withshow)
    {
     win.aktivate();
     gotoxy(2, 2);
     cout << "String: ";
    }
    Editor edit;
    edit.setadjust(LEFT);
    char taste;
    taste = edit.input(*this);
    return taste;
   }

   #endif

   String & load (FILE * fp)
   {
    operator = ("");
    char * buffer;
    buffer = new char[MAXFILESTRING + 1];
    assert(buffer > (char*)NULL, 100);
    long i = 0;
    char c;
    int ok;
    ok = fread(&c, sizeof(char), 1, fp);
    assert(ok > 0, 77);
    while (c != 0)
    {
     if (i < MAXFILESTRING) buffer[i] = c;
     else
     {
      buffer[MAXFILESTRING] = 0;
      operator + (*this, buffer);
      i = 0;
      buffer[i] = c;
     }
     i++;
     ok = fread(&c, sizeof(char), 1, fp);
     assert(ok > 0, 77);
    }
    buffer[i] = 0;
    *this = *this + buffer;
    delete buffer;
    return *this;
   }

   void save(FILE * fp)
   {
    char c = 0;
    int ok;
    ok = fputs(*this, fp);
    assert(ok != EOF, 78);
    ok = fwrite(&c, sizeof(char), 1, fp);
    assert(ok > 0, 78);
   }

 };
extern String operator + (const String & x,const String & y);
extern String operator + (const String & x, const string y);
extern String operator + (string const x,const String & y);

#endif