#ifndef TYPESREC_H
#define TYPESREC_H

#include "parse.hpp"
#include "nat0ba.hpp"
#include "typesba.hpp"
#include "node.hpp"

#define stack Basicarray_nat0
#define typeseq Basicarray_types

extern node * NULL_NODE;

class types : public typeseq
{
public:
// typeseq tp;
 stack ts;
public:
 types(){}
 types(const types & t);
// nat0 add(char * id);   // fuer Lex-Symbole
 nat0 add(const nat0seq & ns, const t_typ & t = UNKNOWN,
	  const nat0 & s = UNKNOWN, node * adr = NULL_NODE,
	  const short & st = KNOWN);
 nat0 add(const typerec & tr)
 { return typeseq::add(tr);}
 nat0 put(const nat0 & i, const nat0seq & ns,
	  const t_typ & t = UNKNOWN, const nat0 & s = UNKNOWN,
	  node * adr = NULL_NODE, const short & st = KNOWN);
 t_typ seek(const String & s);
 t_typ seektag(const String & s);
 t_typ seekid(const String & s);
 t_typ layer_seek(const String & s);

 nat0 push()
 {
  return ts.add(len());
 }

 nat0 pop(bool nur_id = 1);
 types & operator = (const types & t);
 bool operator == (const types & t);
 bool operator != (const types & t);
};


#endif

