
/* einfacher make Prototyp */
/* Hauptprogramm           */

#include "make.hpp"

REGELN example_input(void) {
  REGELN r = empty;
  r = r.plus1("tinymake"
             ,RECHTESEITE(QUELLEN(FILENAME("main.o"))
                          | "make.o"
                          | "filesys.o"
                         ,KOMMANDO("g++ -o tinymake main.o make.o filesys.o")));
  r = r.plus1("main.o"
             ,RECHTESEITE(QUELLEN(FILENAME("main.c"))
                          | "make.hpp"
                          | "make.h"
                         ,KOMMANDO("g++ -c main.c")));
  r = r.plus1("filesys.o"
             ,RECHTESEITE(QUELLEN(FILENAME("filesys.c"))
                          | "make.hpp"
                          | "make.h"
                         ,KOMMANDO("g++ -c filesys.c")));
  r = r.plus1("make.o"
             ,RECHTESEITE(QUELLEN(FILENAME("make.c"))
                          | "make.h"
                         ,KOMMANDO("g++ -c make.c")));
  r = r.plus1("make.c"
             ,RECHTESEITE(QUELLEN(FILENAME("make.vdm"))
                         ,KOMMANDO("VDM -C++ make.vdm")));
  r = r.plus1("make.h"
             ,RECHTESEITE(QUELLEN(FILENAME("make.vdm"))
                         ,KOMMANDO("VDM -C++ make.vdm")));
  r = r.plus1("make.hpp"
             ,RECHTESEITE(QUELLEN(FILENAME("make.vdm"))
                         ,KOMMANDO("VDM -C++ make.vdm")));
  return r;
}

extern BOOL minus_n;

main(int argc, char * argv[]) {
  REGELN r = example_input();
  ZIEL   z = ZIEL("tinymake");
  FILESYSTEM fs;

    minus_n = ( (argc > 1 ? STR(argv[1]) : STR("")) == STR("-n") ); 
    fs.make(z,r);

    return 0;
}
