
/* einfacher make Prototyp */
/* Hauptprogramm           */

#include "make.hpp"

extern BOOL minus_n;
extern BOOL minus_t;


REGELN example_input(void) {
  REGELN	r  = empty;
  r |= PAIR_REGELN("tinymake"
             ,RECHTESEITE(QUELLEN(FILENAME("main.o"))
                          | "make.o"
                          | "filesys.o"
                         ,KOMMANDO("g++ -o tinymake main.o make.o filesys.o")));
  r |= PAIR_REGELN("main.o"
             ,RECHTESEITE(QUELLEN(FILENAME("main.cc"))
                          | "make.hpp"
                          | "make.h"
                         ,KOMMANDO("g++ -c main.cc")));
  r |= PAIR_REGELN("filesys.o"
             ,RECHTESEITE(QUELLEN(FILENAME("filesys.cc"))
                          | "make.hpp"
                          | "make.h"
                         ,KOMMANDO("g++ -c filesys.cc")));
  r |= PAIR_REGELN("make.o"
             ,RECHTESEITE(QUELLEN(FILENAME("make.cc"))
                          | "make.h"
                         ,KOMMANDO("g++ -c make.cc")));
  r |= PAIR_REGELN("make.cc"
             ,RECHTESEITE(QUELLEN(FILENAME("make.vdm"))
                         ,KOMMANDO("VDM -A++ make.vdm;mv make.c make.cc")));
  r |= PAIR_REGELN("make.h"
             ,RECHTESEITE(QUELLEN(FILENAME("make.vdm"))
                         ,KOMMANDO("VDM -A++ make.vdm")));
  r |= PAIR_REGELN("make.hpp"
             ,RECHTESEITE(QUELLEN(FILENAME("make.vdm"))
                         ,KOMMANDO("VDM -A++ make.vdm")));
  r |= PAIR_REGELN("clean"
             ,RECHTESEITE(QUELLEN(empty)
                         ,KOMMANDO("/bin/rm -f main.o make.o filesys.o")));

  if ( minus_t ) 
    cerr << "example_input: r =  " << endl
         << r;

  return r;
}

ZIEL ziel;

void options(int argc, char * argv[]) {		// -n ist default (filesys.cc)
   for (int i = 1; i<argc; i++) {
       STR o = STR(argv[i]);

       if ( o == "-n" ) minus_n = TRUE;
       else
       if ( o == "+n" ) minus_n = FALSE;
       else
       if ( o == "-t" ) minus_t = TRUE;
       else
         ziel=o;
   }
}

main(int argc, char * argv[]) {
  REGELN regeln = example_input();
  FILESYSTEM fs;

    ziel=ZIEL("tinymake");
    options(argc,argv);
    fs.make(ziel,regeln);

    return 0;
}
