/* $Id: main.c,v 1.1 1994/02/10 14:36:26 vdm Exp $ */
/* the example main program */

#include "example.h"

void maptest() {
  Map m = mk_empty_map();
  Map m2;

      printf("\nan empty map\n");
      printf("m = ");pr_map(m);

      m = union1_map(m,1,"a 1. string");
      m = union1_map(m,2,"a 2. string");
      m = union1_map(m,3,"a 3. string");

      printf("\na map with 3 elements\n");
      printf("m = ");pr_map(m);

      m2 = copy_map(m);			/* "deep" copy with copying all substructures */
					/* calls copy_strptr */

      printf("\na copy of the map\n");
      printf("m2= ");pr_map(m2);

      m = ovwrt1_map(m,2,"a new 2. string");
      m = ovwrt1_map(m,4,"a new 4. string");

      printf("\n1 element changed and 1 new element\n");
      printf("m = ");pr_map(m);

      m = sub1_map(m,3);
      m = sub1_map(m,4);

      printf("\n2 elements deleted\n");
      printf("m = ");pr_map(m);

      del1_map(m);			/* free value without substructures */

      del_map(m2);			/* free value with all substructures */
					/* calls del_strptr */
					/* corresponds to copy_map */
      printf("\ntest finished\n");
}

int main(int argc, char* argv[]) {
   maptest();

   return 0;
}
