// $Id: main.cc,v 1.1 1996/09/19 15:46:53 vdm Exp $

#include "stueckliste.hpp"

extern STUECKLISTE beispielStueckListe();

extern STUECKLISTE beispielKonsistenteStueckListe();

int
main()
{

  // eine inkonsistente Stckliste
  {
    STUECKLISTE sl = beispielStueckListe();

    cout << "eine inkonsistente Stckliste" << endl << sl << endl;

    if ( ! sl.inv() ) {
      cout << "Stckliste sl ist nicht konsistent" << endl;
    }
  }

  // eine konsistente Stckliste
  {
    STUECKLISTE sl = beispielKonsistenteStueckListe();

    cout << endl
	 <<"eine konsistente Stckliste" << endl
	 << sl << endl;

    if ( ! sl.inv() ) {
      cout << "Stckliste sl ist nicht konsistent" << endl;
    }

    cout << "Alle Produkte: " << endl
	 << sl.alleProdukte() << endl;
    cout << "Alle Teile: " << endl
	 << sl.alleTeile() << endl;
    cout << "Alle EinzelTeile: " << endl
	 << sl.alleEinfachenTeile() << endl;
    cout << "Die Einzelteile fr ein Fahrrad: " << endl
	 << sl.aufloesen("fahrrad") << endl;
  }

  return 0;
}
