/*----------------------------------------------------------------------*/

/* Modul:                  @(#)dbs.h */
/* Version:                2.1 */
/* Ersteller:              Gerrit Petrich, WI 8215, WS 93 */
/* Datum der letzten */
/* Aenderung:              93/03/29 */

/*----------------------------------------------------------------------*/

/* Aufgabe:   "dbs.h" ist der Header der Funktionen fuer den VDM- */
/*            Generator. */

/*----------------------------------------------------------------------*/

#ifndef DBS
#define DBS

#include "gen.h"
#include "proto.h"

extern Bool run_as_client;
extern char * host;
extern char * port;

extern unsigned char gptrace;

extern void init_vdmdm H0();
extern void finish_vdmdm H0();
                                       /* global names */
extern Str dmADTTYPE   ;
extern Str dmAUX       ;
extern Str dmAUXILIARY ;
extern Str dmBASIC     ;
extern Str dmCOM       ;
extern Str dmDOCU      ;
extern Str dmINTERNAL  ;
extern Str dmPOST      ;
extern Str dmREAL      ;
extern Str dmSIGN      ;
extern Str dmSTDLIB    ;
extern Str dmVDMLIB    ;

Vdmdbs def_Vdmdbs H1(Dbs);
void undef_Vdmdbs H0();

Bool exist_vdmdbs H1(Vdmdbs);
Bool exists_Vdmdbs H1(Vdmdbs);

Bool exists_Adt H2(Vdmdbs,Adtname);
Bool exists_Implementation H3(Vdmdbs,Adtname,Implname);
Bool exists_Operation H4(Vdmdbs,Adtname,Implname,Opname);
Bool exists_Component H5(Vdmdbs,Adtname,Implname,Opname,Compname);
Bool exists_SignComponent H4(Vdmdbs,Adtname,Opname,Compname);

Bool exists_Signature H5(Vdmdbs,
                         Adtname,Opname,
                         Adtname *,Operation *);

Component gets_Component H5(Vdmdbs,Adtname,Implname,Opname,Compname);
Component getsx_Component H5(Vdmdbs,Adtname,Implname,Opname,Compname);

Component gets_SignComponent H4(Vdmdbs,Adtname,Opname,Compname);
Component getsx_SignComponent H4(Vdmdbs,Adtname,Opname,Compname);

Bool exist_Adt H2(Vdmdb,Adtname);
Bool exist_Implementation H3(Vdmdb,Adtname,Implname);
Bool exist_Operation H4(Vdmdb,Adtname,Implname,Opname);
Bool exist_Signature H5(Vdmdb,
                        Adtname,Opname,
                        Adtname *,Operation *);
Bool exist_Component H8(Vdmdb,
                        Adtname,Implname,Opname,Compname,
                        Adtname *,Implname *,Component *);

Component get_Component H5(Vdmdb,Adtname,Implname,Opname,Compname);

#endif

