#if __cplusplus
#include "gen1.hpp"
#else
#include "gen1.h"
#endif

/*LINTLIBRARY*/

#define C_implementation_file

/*
module generated from VDM Class Library
$Revision: 1.100 $
$Date: 1996/09/18 13:13:42 $
*/

Strset alloc_strset (void)
{Strset x1; x1 = (Strset)0;
while (! (x1 = (Strset)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_strset");
;
;
return x1;
}

void free_strset (Strset x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Operation alloc_operation (void)
{Operation x1; x1 = (Operation)0;
while (! (x1 = (Operation)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_operation");
;
;
return x1;
}

void free_operation (Operation x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Impl alloc_impl (void)
{Impl x1; x1 = (Impl)0;
while (! (x1 = (Impl)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_impl");
;
;
return x1;
}

void free_impl (Impl x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Vdmdb alloc_vdmdb (void)
{Vdmdb x1; x1 = (Vdmdb)0;
while (! (x1 = (Vdmdb)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_vdmdb");
;
;
return x1;
}

void free_vdmdb (Vdmdb x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Vdmdbs alloc_vdmdbs (void)
{Vdmdbs x1; x1 = (Vdmdbs)0;
while (! (x1 = (Vdmdbs)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_vdmdbs");
;
;
return x1;
}

void free_vdmdbs (Vdmdbs x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Dbs alloc_dbs (void)
{Dbs x1; x1 = (Dbs)0;
while (! (x1 = (Dbs)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_dbs");
;
;
return x1;
}

void free_dbs (Dbs x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Adt alloc_adt (void)
{Adt x1; x1 = (Adt)0;
while (! (x1 = (Adt)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_adt");
;
;
return x1;
}

void free_adt (Adt x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

#ifdef __cplusplus
#define outerrstr_vdmlib(x1) cerr << x1
#define outerrint_vdmlib(x1) cerr << x1
#define outerrme1_vdmlib(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << " "
#define outerrmes_vdmlib(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << "\n"
#else
#define outerrstr_vdmlib(x1) fprintf(stderr,"%s",x1)
#define outerrint_vdmlib(x1) fprintf(stderr,"%ld",x1)
#define outerrme1_vdmlib(x1,x2) fprintf(stderr,"\n\n%s : %s ",x2,x1)
#define outerrmes_vdmlib(x1,x2) fprintf(stderr,"\n\n%s : %s\n",x2,x1)
#endif
void err_hd_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to take 'hd' of an empty tuple",x1);
abort_vdmlib(VDM_ERR_EMPTYHD);
}
void err_tl_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to take 'tl' of an empty tuple",x1);
abort_vdmlib(VDM_ERR_EMPTYTL);
}
void err_sel_vdmlib (Nat1 x1,Nat0 x2,char * x3)
{
outerrme1_vdmlib("attempt to select element",x3);
outerrint_vdmlib((long)x1);
outerrstr_vdmlib(" of tuple with length ");
outerrint_vdmlib((long)x2);
outerrstr_vdmlib("\n");
abort_vdmlib(VDM_ERR_SELECT);
}
void err_smap_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to select an element that is not in the domain of a map",x1);
abort_vdmlib(VDM_ERR_SELMAP);
}
void heap_oflw_vdmlib (char * x1)
{
outerrmes_vdmlib("no more heap space available",x1);
abort_vdmlib(VDM_ERR_HEAPOFL);
}
void err_elem_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to select an element from an empty set",x1);
abort_vdmlib(VDM_ERR_EMPTYSET);
}
void err_umap_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to union elements [d :-> r1] and [d :->r2] of a map",x1);
abort_vdmlib(VDM_ERR_UNION);
}

Bool supress_cvlines_vdmlib = TRUE;
Nat0 curr_linelen_vdmlib;
char *start_structure_vdmlib;
char *end_structure_vdmlib;

void adj_linelen_vdmlib (Nat0 x1)
{ curr_linelen_vdmlib = (curr_linelen_vdmlib > x1) ? (curr_linelen_vdmlib - x1) : 0;}

Str ident_prefix_vdmlib (Str x1,Nat0 x2)
{ return conc_str(mkn_str(' ',x2 - len_str(x1)), x1); }

Cvtext_vdmlib ident_lines_vdmlib (Cvtext_vdmlib x1,Str x2)
{ Str lx1;Nat1 lx2;

lx1 = mkn_str(' ',len_str(x2));
x1 = ovwrt1_cvtext_vdmlib( x1
, (Nat1)1
, conc_str(x2,sel_cvtext_vdmlib(x1,(Nat1)1)));
for(lx2 = 2;lx2 <= len_cvtext_vdmlib(x1); lx2++)
x1 = ovwrt1_cvtext_vdmlib( x1
, lx2
, conc_str( copy_str(lx1)
, sel_cvtext_vdmlib(x1,lx2)));
del_str(lx1);
return x1;
}

Cvtext_vdmlib close_struct_vdmlib (Cvtext_vdmlib x1,Str x2,Nat0 x3)
{ Nat0 lx1 = len_cvtext_vdmlib(x1);
Str lx2 = sel_cvtext_vdmlib(x1,(Nat1)lx1);
Nat0 lx3 = 1;

if (lx1 <= 2)
return ovwrt1_cvtext_vdmlib(x1,(Nat1)lx1,conc_str(lx2,x2));

while(sel_str(lx2,lx3) == ' ') lx3++;
if ( len_str(x2) == 1
&& sel_str(lx2,lx3) == hd_str(x2)
)
{ return ovwrt1_cvtext_vdmlib(x1
,(Nat1)lx1
,ovwrt1_str(lx2,x3,hd_str(x2)));
}

return appr_cvtext_vdmlib(x1,ident_prefix_vdmlib(x2,x3));
}

Cvtext_vdmlib append_lastline_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{ if (len_cvtext_vdmlib(x2) != 1)
{
outerrstr_vdmlib("error in 2nd parameter of 'append_lastline'");
abort_vdmlib(VDM_ERR_CVLINES);
}
{ Nat0 lx1 = len_cvtext_vdmlib(x1);

x1 = ovwrt1_cvtext_vdmlib( x1
, (Nat1)lx1
, conc_str( sel_cvtext_vdmlib(x1,(Nat1)lx1)
, conc_str( mkc_str(",")
, hd_cvtext_vdmlib(x2))));
del1_cvtext_vdmlib(x2);
return x1;
}
}

static Bool last_was_simple_vdmlib (Cvtext_vdmlib x1,Nat0 x2)
{ return ( len_cvtext_vdmlib(x1) == 1
|| index_str(last_cvtext_vdmlib(x1),',') == x2
);
}

Cvtext_vdmlib cvlines2_cvtext_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{ if (is_empty_cvtext_vdmlib(x1))
return ident_lines_vdmlib(x2,mkc_str(start_structure_vdmlib));
else
{ if ( len_cvtext_vdmlib(x2) == 1
&& len_str(hd_cvtext_vdmlib(x2))
+ len_str(last_cvtext_vdmlib(x1))
< curr_linelen_vdmlib
&& last_was_simple_vdmlib(x1,(Nat0)strlen(start_structure_vdmlib))
)
return append_lastline_vdmlib(x1,x2);
else
return conc_cvtext_vdmlib
(x1,ident_lines_vdmlib
(x2,ident_prefix_vdmlib( mkc_str(",")
, (Nat0)strlen(start_structure_vdmlib))));
}
}

#ifdef __cplusplus
void fprint_lines_vdmlib (ostream & x1,Cvtext_vdmlib x2)
#else
void fprint_lines_vdmlib (FILE * x1,Cvtext_vdmlib x2)
#endif
{ Nat1 lx1;

for (lx1 = 1;lx1 <= len_cvtext_vdmlib(x2); lx1++)
{ Nat1 lx3;
Str lx4;

lx4 = sel_cvtext_vdmlib(x2,lx1);
for (lx3 = 1; lx3 <= len_str(lx4); lx3++)
#ifdef __cplusplus
{x1 << (char)(sel_str(lx4,lx3));}
x1 << "\n";
#else
{fprintf(x1,"%c",sel_str(lx4,lx3));}
fprintf(x1,"\n");
#endif
}
}

void abort_vdmlib (Nat0 x1)
{
exit(1);
}
#if __cplusplus
niletc empty, nil, new_val;
#endif

Str alloc_str (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_str) + (x1 + 0) * sizeof(Char);
Nat0 len2 = 4;
Str lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Str) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Str");
lx1->f_max = ((len2 - sizeof(struct Struct_str))/sizeof(Char));
lx1->f_len = x1;
;
;
return lx1;
}

void free_str (Str x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_str) + x1->f_max*sizeof(Char));
}

Outbytes write_buffer_outbytes (Outbytes x1)
{
if (x1->f_ioerr == 0)
{ Intg lx1 = write((int)(x1->f_fdes),
(char *)(x1->f_buff),
(x1->f_buffelems) * sizeof(Char));

if (lx1 != (Intg)(x1->f_buffelems * sizeof(Char)))
{
x1->f_ioerr = 1;
x1->f_errno = errno;
}
}

x1->f_buffelems = 0;
return x1;
}

static void get_deffn_outbytes (char * x1,Nat0 x2)   { sprintf(x1,"tmp_%lu_outbytes!",x2); }

Outbytes mk_empty_outbytes (void)
{ static Nat0 f_opencnt = 0;
Outbytes lx1 = alloc_outbytes();

get_deffn_outbytes(lx1->f_deffn,f_opencnt++);
lx1->f_fdes = open(lx1->f_deffn,O_WRONLY | O_CREAT,0x01A4);

if (lx1->f_fdes == -1)
{ lx1->f_ioerr = 1; lx1->f_errno = errno;
}
else
{ lx1->f_ioerr = 0; lx1->f_errno = 0; }

lx1->f_buffelems = 0;
return lx1;
}

Bool fwrite_outbytes (Outbytes x1,Str x2)
{ Intg lx1;

x1 = write_buffer_outbytes(ref_outbytes(x1));
lx1 = close((int)(x1->f_fdes));

if (x1->f_ioerr) { errno = (int)(x1->f_errno); return 0; }
if (lx1 == -1)
{
return 0;
}

{ char lx2[128];

cpc_str(x2,lx2);
if (strcmp(x1->f_deffn,lx2))
{ if (unlink(lx2) && errno != ENOENT) { return 0; }
if (link(x1->f_deffn,lx2)) { return 0; }
if (unlink(x1->f_deffn)) { return 0; }
}
}

return 1;
}

Inbytes read_buffer_inbytes (Inbytes x1)
{
Nat0 lx1;
Nat0 lx2;
Intg lx3;

lx1 = (x1->f_elfile > 4096) ? 4096 : x1->f_elfile;
lx2 = lx1 * sizeof(Char);
lx3 = read((int)(x1->f_fdes),
(char *)(x1->f_buff),
lx2);

if (lx3 != (Intg)lx2)
{
err_tl_vdmlib("Inbytes");
}

x1->f_currelem = &x1->f_buff[0];
x1->f_buffelems = lx1;
x1->f_elfile -= lx1;

return x1;
}
Nat0 len_inbytes (Inbytes x1)
{ return ref_inbytes(x1)->f_buffelems + ref_inbytes(x1)->f_elfile; }
void del_inbytes (Inbytes x1)
{ if (ref_inbytes(x1)->f_fdes != -1) { close((int)(x1->f_fdes)); }
free_inbytes(ref_inbytes(x1));
}

Inbytes fread_inbytes (Str x1)
{ Inbytes lx1 = alloc_inbytes();

lx1->f_elfile = 0;
lx1->f_buffelems = 0;

{ char *lx2 = (char *)ALLOCMEM_vdmlib(len_str(x1) + 5);

cpc_str(x1,lx2);
lx1->f_fdes = open(lx2,O_RDONLY);
FREEMEM_vdmlib(lx2,len_str(x1) + 5);
}

if (lx1->f_fdes == -1) { return lx1; }

{ struct stat lx2;

if (fstat((int)(lx1->f_fdes),&lx2) == -1) { return lx1; }

lx1->f_elfile = lx2.st_size / sizeof(Char);
}

lx1 = read_buffer_inbytes(lx1);
return lx1;
}

Nat0 cvfromtup1_nat0 (Inbytes * x1)
{ register unsigned long lx1;
register unsigned long int lx2 = 0;

lx1 = hd_inbytes(*x1); *x1 = tld_inbytes(*x1);
if (sizeof(Nat0) == 1 || lx1 < 128)
{ return (Nat0)lx1; }
else if ((unsigned char)lx1 == 192)
{ lx2 = ((unsigned long)hd_inbytes(*x1) & 255);
*x1 = tld_inbytes(*x1);
lx2 |= ((unsigned long)hd_inbytes(*x1) & 255) << 8;
*x1 = tld_inbytes(*x1);
return (Nat0)lx2;
}
else
{ for (lx1 = 0; lx1 < sizeof(Nat0); lx1++)
{ lx2 |= (((unsigned long)hd_inbytes(*x1)) & 255) << (lx1*8);
*x1 = tld_inbytes(*x1);
}
return (Nat0)lx2;
}
}

Str cvstr_nat0 (Nat0 x1)
{char ft[20];
sprintf(ft,printformat_nat0,(unsigned long)x1);
return mkc_str(ft);
}

char * printformat_nat0 = "%lu";

void set_print_format_nat0 (char * x1)
{ printformat_nat0 = (x1) ? x1 : "%lu"; }

Outbytes cvtotup1_nat0 (Outbytes x1,Nat0 x2)
{
if ( sizeof(x2) == 1 || (unsigned long)x2 < 128 )
{
return appr_outbytes(x1, (unsigned char)x2);
}

if ( (unsigned long)x2 < 32768 )
{
x1 = appr_outbytes(x1,192);
x1 = appr_outbytes(x1,((unsigned int)x2) & 255);
x1 = appr_outbytes(x1,(((unsigned int)x2) >> 8) & 255);
return x1;
}

{
register Nat0 i;
x1 = appr_outbytes(x1,128);
for (i = 1; i <= (Nat0)sizeof(Nat0); i++)
{
x1 = appr_outbytes(x1,(((unsigned int) x2) & 255));
x2 = (Nat0)(((unsigned int) x2) >> 8);
}
return x1;
}
}

Str mkn_empty_str (Nat0 x1)  { Str lx1 = alloc_str(x1); lx1->f_len = 0; return lx1;; }
void forall_str (Str x1,T2_forall_str x2)
{Nat0 lx1 = ref_str(x1)->f_len;
Char * px1 = (Char * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

Outbytes cvtotup1_str (Outbytes x1,Str x2)
{ return cvtotupelems_str(cvtotup1_nat0(x1,len_str(x2)),x2); }

#ifdef __cplusplus
void fpr_str (ostream & x1,Str x2)
#else
void fpr_str (FILE * x1,Str x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_str(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Str mkn_str (Char x1,Nat0 x2)
{ Str y1 = alloc_str(x2);
Char* y2 = ((Char *)(y1 + 1));

while(x2--) { *(y2++) = x1; }
return y1;
}

void del1_str (Str x1)  {free_str(x1);}

Str sub_tup_str (Str x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_str(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }

{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Char * px1 = (Char *)(x1+1);
/* start of array */
register Char * px2 = px1 + (x2 - 1);
/* start of substring */
register Char * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

Cvtext_vdmlib cvlines_str (Str x1)
{ return mk1_cvtext_vdmlib( conc_str( mkc_str("\"")
, conc_str( cvstr_str(x1)
, mkc_str("\"")
) ) );
}

Str mk1_str(Char x1)
{Str lx1 = alloc_str((Nat0)1);
*((Char *)(lx1+1)) = x1;
return lx1;
}

#if defined(__DOS__)
#define VDMpathdel '\\'
#else
#define VDMpathdel '/'
#endif

Str conc_path_str (Str x1,Str x2)
{return conc_str(appr_str(x1,VDMpathdel),x2);}

#undef VDMpathdel
Bool is_prefix_str (Str x1,Str x2)
{ Nat0 l1 = len_str(x1);
Nat0 l2 = len_str(x2);
Nat0 i = 1;
while ( i <= l1 && i <= l2 && is_eq_char(sel_str(x1,i),sel_str(x2,i)) )
i++;
return ( i > l1 );
}

Str copy_str (Str x1)
{Nat0 l1 = ref_str(x1)->f_len;
Str x2 = alloc_str(l1);
register Char * px1 = (Char *)(x1+1);
register Char * px2 = (Char *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = *(px1++);
return x2;
}

Bool fapp_str (Str x1,Str x2)
{char path[256];
FILE * fd;
cpc_str(x2,path);
if ((fd = fopen(path,"a")))
{if (fwrite((char *)(x1+1),sizeof(Char),x1->f_len,fd) != x1->f_len) return 0;
fclose(fd);
return 1;
}
else return 0;
}

Str mkc_str (Char * x1)
{register Nat0 li = 0;
register Char * lx1 = (Char *)x1;
while (*(lx1++)) li++;
{Str x2 = alloc_str(li);
register Char * lx2 = (Char *)(x2 + 1);
lx1 = (Char *)x1;
while (li--) *(lx2++) = *(lx1++);
return x2;
}
}

static Nat0 _rr1_index_str;
static Str _tt1_index_str; static Char _tt2_index_str;

static void _ff1_index_str(Char y1,Nat1 y2)

{if ((_rr1_index_str == 0) && is_eq_char(y1,_tt2_index_str)) _rr1_index_str = y2;}

Nat0 index_str(Str x1,Char x2)

{Nat0 lr1; lr1 = _rr1_index_str;
{Str lt1; Char lt2; lt1 = _tt1_index_str; lt2 = _tt2_index_str;
{
{_tt1_index_str = x1; _tt2_index_str = x2;

{_rr1_index_str = 0;
forindex_str(x1,_ff1_index_str);

_tt1_index_str = lt1; _tt2_index_str = lt2;
{Nat0 lr2; lr2 = _rr1_index_str; _rr1_index_str = lr1; return lr2;}
}}}}}

Nat0 rindex_str (Str x1,Char x2)
{ Nat0 lx1;

for (lx1 = len_str(x1); lx1 > 0; lx1--)
{ if (is_eq_char(x2,sel_str(x1,lx1))) { return lx1; }}
return 0;
}

Str ovwrt1_str (Str x1,Nat1 x2,Char x3)
{
if (x2 > ref_str(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Str");
;
*( ((Char *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Bool is_gr_str (Str x1,Str x2)
{Nat0 lx1 = ref_str(x1)->f_len;
Nat0 lx2 = ref_str(x2)->f_len;
register Nat0 i = 0;
register Char * px1 = (Char *)(x1+1);
register Char * px2 = (Char *)(x2+1);
while (1)
{if (i == lx1) return 0;
if (i == lx2) return 1;
{Char le1 = * (px1++);
Char le2 = * (px2++);
if (is_eq_char(le1,le2)) i++;
else return is_ge_char(le1,le2);
}
}
}
Str appr_str (Str x1,Char x2)
{ Nat0 lx1 = ref_str(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Char *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_str(x1,mk1_str(x2)); }
}
#ifdef __cplusplus
void puts_str (Str x1,ostream & x2)
#else
void puts_str (Str x1,FILE * x2)
#endif
{Nat0 li = x1->f_len;
Char * lx1 = (Char *)(x1 + 1);
while (li--)
#ifdef __cplusplus
x2 << (char)(*(lx1++));
#else
fputc((char)(*(lx1++)),x2);
#endif
}
Bool is_eq_str (Str x1,Str x2)
{register Nat0 lx1 = ref_str(x1)->f_len;
if (lx1 != ref_str(x2)->f_len) return 0;
{Nat0 i = 0;
register Char * px1 = (Char *)(x1+1);
register Char * px2 = (Char *)(x2+1);
while (i != lx1)
{if (! is_eq_char(*(px1++),*(px2++))) return 0;
i++;
}
return 1;
}
}
Str insert_str (Str x1,Nat1 x2,Char x3)
{ Nat0 lx1 = len_str(x1);
Str lx2 = copy1_str(x1);

if (x2 > lx1 + 1) err_sel_vdmlib(x2,lx1,"Str");
return conc_str(appr_str(sub_tup_str(lx2,1,x2-1)
,x3)
,sub_tup_str(x1,x2,lx1));
}

Str sub_tupd_str (Str x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_str(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }

{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Char * px1 = (Char *)(x1+1);
/* start of array */
register Char * px2 = px1 + (x2 - 1);
/* start of substring */
register Char * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

Str fread_str (Str x1)
{char path[256];
FILE * fd;
cpc_str(x1,path);
if ( (fd = fopen(path,"r")) != 0)
{Str t1;
t1 = mk_empty_str();
{int space; int cnt; while (space = (int)(t1->f_max - t1->f_len), (cnt = fread((char *)(((Char *)(t1 + 1)) + t1->f_len), sizeof(Char), (size_t)space,fd)) == space) {Str t2; t2 = alloc_str((Nat0)((t1->f_max)*2 + 1)); t2->f_len = t1->f_max; {register Nat0 i = t1->f_max; register Char * px3 = (Char *)(t2 + 1); register Char * px1 = (Char *)(t1 + 1); while (i--) *(px3++) = *(px1++); } del1_str(t1); t1 = t2; } t1->f_len += cnt; }
fclose(fd);
return t1;
}
else return mk_empty_str();
}

Str conc_str (Str x1,Str x2)
{Nat0 ll1 = ref_str(x1)->f_len;
Nat0 ll = ll1 + ref_str(x2)->f_len;
if (ll > x1->f_max)
{Str lx3 = alloc_str(ll);
register Nat0 i = ll1;
register Char * px3 = (Char *)(lx3 + 1);
register Char * px1 = (Char *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_str(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Char * px1 = ((Char *)( x1 + 1)) + ll1;
register Char * px2 = (Char *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_str(x2);
}
return x1;
}

void cpc_str (Str x1,Char * x2)
{register Nat0 li = ref_str(x1)->f_len;
register Char * px1 = (Char *)(x1 + 1);
register Char * px2 = (Char *)x2;
while (li--) *(px2++) = *(px1++);
*(px2) = 0;
}

Str mknc_str (Char x1,Nat0 x2)
{ Str y1 = alloc_str(x2);
Char* y2 = ((Char *)(y1 + 1));

while(x2--) { *(y2++) = copy_char(x1); }
return y1;
}

Bool fwrite_str (Str x1,Str x2)
{char path[256];
FILE * fd;
cpc_str(x2,path);
if ((fd = fopen(path,"w")))
{if (fwrite((char *)(x1+1) ,sizeof(Char) ,(size_t)(x1->f_len) ,fd ) != x1->f_len) return 0;
fclose(fd);
return 1;
}
else return 0;
}

void del_str (Str x1)  {del1_str(x1);}

Str copy1_str (Str x1)
{Nat0 l1 = ref_str(x1)->f_len;
Str x2 = alloc_str(l1);
register Char * px1 = (Char *)(x1+1);
register Char * px2 = (Char *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = *(px1++);
return x2;
}

Str mk_sub_tup_str (Str x1,Nat1 x2,Nat0 x3)
{ Str lx1;
Nat0 len1;
if (x3 > ref_str(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
len1 = x3 - x2 + 1;
lx1 = alloc_str(len1);
lx1->f_len = len1;
{ register Char * plx1 = (Char *)(lx1+1);
register Char * px1 =((Char *)( x1+1)) + (x2 - 1);
register Char * pend = plx1 + len1;
while (plx1 != pend) { *(plx1++) = *(px1++); }
}
return lx1;
}

Char sel_str (Str x1,Nat1 x2)
{

if (x2 > ref_str(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Str");
return *( ((Char *)(x1 + 1)) + x2 -1);
}

static Str _tt1_forindex_str; static T2_forindex_str _tt2_forindex_str; static Nat1 _ll1_forindex_str;

static void _ff1_forindex_str(Char y1)

{(*_tt2_forindex_str)(y1,_ll1_forindex_str++);}

void forindex_str(Str x1,T2_forindex_str x2)

{
{Str lt1; T2_forindex_str lt2; lt1 = _tt1_forindex_str; lt2 = _tt2_forindex_str;
{Nat1 ll1; ll1 = _ll1_forindex_str;
{_tt1_forindex_str = x1; _tt2_forindex_str = x2;
_ll1_forindex_str = 1;
{
forall_str(x1,_ff1_forindex_str);

_tt1_forindex_str = lt1; _tt2_forindex_str = lt2; _ll1_forindex_str = ll1;

}}}}}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef mk1_str_char
extern Str mk1_str_char ( Char y1    ) ;
#endif

static Str _rr1_cvstr_str;
static void _rf1_cvstr_str(Char y1 )

{_rr1_cvstr_str = conc_str(_rr1_cvstr_str,mk1_str_char(y1 )  );}

Str cvstr_str(Str x1     )

{Str lr1;
lr1 = _rr1_cvstr_str;
_rr1_cvstr_str = mk_empty_str();
forall_str(x1,_rf1_cvstr_str);
{Str lr2 = _rr1_cvstr_str; _rr1_cvstr_str = lr1; return lr2;}
}

Str cvfromtup1_str (Inbytes * x1)
{ register Nat0 lx1 = cvfromtup1_nat0(x1);
register Str lx2;

lx2 = mkn_empty_str(lx1);
for (; lx1 >= 1; lx1--) {
*( ((Char *)(lx2 + 1)) + lx2->f_len++) = hd_inbytes(*x1);
*x1 = tld_inbytes(*x1);
}
return lx2;
}

#ifndef appr_outbytes
extern Outbytes appr_outbytes ( Outbytes x1, Char x2 );
#endif

static Outbytes _rr1_cvtotupelems_str;
static void _rf1_cvtotupelems_str(Char y1)  {_rr1_cvtotupelems_str = appr_outbytes(_rr1_cvtotupelems_str,y1);}

Outbytes cvtotupelems_str (Outbytes x1,Str x2)
{Outbytes lr1 = _rr1_cvtotupelems_str;
_rr1_cvtotupelems_str = x1;
forall_str(x2,_rf1_cvtotupelems_str);
{Outbytes lr2 = _rr1_cvtotupelems_str; _rr1_cvtotupelems_str = lr1; return lr2;}
}

Str sel_cvtext_vdmlib (Cvtext_vdmlib x1,Nat1 x2)
{

if (x2 > ref_cvtext_vdmlib(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Cvtext_vdmlib");
return *( ((Str *)(x1 + 1)) + x2 -1);
}
void forall_cvtext_vdmlib (Cvtext_vdmlib x1,T2_forall_cvtext_vdmlib x2)
{Nat0 lx1 = ref_cvtext_vdmlib(x1)->f_len;
Str * px1 = (Str * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

Cvtext_vdmlib mk1_cvtext_vdmlib(Str x1)
{Cvtext_vdmlib lx1 = alloc_cvtext_vdmlib((Nat0)1);
*((Str *)(lx1+1)) = x1;
return lx1;
}

static Cvtext_vdmlib _tt1_del_cvtext_vdmlib;

static void _ff1_del_cvtext_vdmlib(Str y1)

{del_str(y1);}

void del_cvtext_vdmlib(Cvtext_vdmlib x1)

{
{Cvtext_vdmlib lt1; lt1 = _tt1_del_cvtext_vdmlib;
{
{_tt1_del_cvtext_vdmlib = x1;

{
forall_cvtext_vdmlib(x1,_ff1_del_cvtext_vdmlib);
del1_cvtext_vdmlib(x1);
_tt1_del_cvtext_vdmlib = lt1;

}}}}}

Cvtext_vdmlib ovwrt1_cvtext_vdmlib (Cvtext_vdmlib x1,Nat1 x2,Str x3)
{
if (x2 > ref_cvtext_vdmlib(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Cvtext_vdmlib");
;
*( ((Str *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Cvtext_vdmlib appr_cvtext_vdmlib (Cvtext_vdmlib x1,Str x2)
{ Nat0 lx1 = ref_cvtext_vdmlib(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Str *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_cvtext_vdmlib(x1,mk1_cvtext_vdmlib(x2)); }
}

Cvtext_vdmlib conc_cvtext_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{Nat0 ll1 = ref_cvtext_vdmlib(x1)->f_len;
Nat0 ll = ll1 + ref_cvtext_vdmlib(x2)->f_len;
if (ll > x1->f_max)
{Cvtext_vdmlib lx3 = alloc_cvtext_vdmlib(ll);
register Nat0 i = ll1;
register Str * px3 = (Str *)(lx3 + 1);
register Str * px1 = (Str *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_cvtext_vdmlib(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Str * px1 = ((Str *)( x1 + 1)) + ll1;
register Str * px2 = (Str *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_cvtext_vdmlib(x2);
}
return x1;
}

void del1_cvtext_vdmlib (Cvtext_vdmlib x1)  {free_cvtext_vdmlib(x1);}

Cvtext_vdmlib alloc_cvtext_vdmlib (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_cvtext_vdmlib) + (x1 + 0) * sizeof(Str);
Nat0 len2 = 4;
Cvtext_vdmlib lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Cvtext_vdmlib) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Cvtext_vdmlib");
lx1->f_max = ((len2 - sizeof(struct Struct_cvtext_vdmlib))/sizeof(Str));
lx1->f_len = x1;
;
;
return lx1;
}

void free_cvtext_vdmlib (Cvtext_vdmlib x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_cvtext_vdmlib) + x1->f_max*sizeof(Str));
}

Outbytes alloc_outbytes (void)
{Outbytes x1; x1 = (Outbytes)0;
while (! (x1 = (Outbytes)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_outbytes");
;
;
return x1;
}

void free_outbytes (Outbytes x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Inbytes alloc_inbytes (void)
{Inbytes x1; x1 = (Inbytes)0;
while (! (x1 = (Inbytes)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_inbytes");
;
;
return x1;
}

void free_inbytes (Inbytes x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_str
extern Cvtext_vdmlib cvlines_str ( Str y1    ) ;
#endif

Cvtext_vdmlib cvlines1_strset(Strset x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_strset(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines_str(ref_strset(x1)->f_info )  );}
return lx1;
}

Strset union1d_strset(Strset x1, Str x2)

{register Strset lx1 = x1;
while (lx1)
{if (is_eq_str(ref_strset(lx1)->f_info,x2)) {del_str(x2);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_strset(x2);
lx1->f_next = x1;
return lx1;
}

#ifndef sub1_strset
extern Strset sub1_strset ( Strset x1, Str x2 );
#endif

static Strset _rr1_diff_strset;
static void _rf1_diff_strset(Str y1)  {_rr1_diff_strset = sub1_strset(_rr1_diff_strset,y1);}

Strset diff_strset (Strset x1,Strset x2)
{Strset lr1 = _rr1_diff_strset;
_rr1_diff_strset = x1;
forall_strset(x2,_rf1_diff_strset);
{Strset lr2 = _rr1_diff_strset; _rr1_diff_strset = lr1; return lr2;}
}

#ifdef __cplusplus
void fpr_strset (ostream & x1,Strset x2)
#else
void fpr_strset (FILE * x1,Strset x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_strset(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Bool is_in_strset(Str x1, Strset x2)

{while (x2)
{if (is_eq_str(ref_strset(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

static Strset _tt1_del_strset;

static void _ff1_del_strset(Str y1)

{del_str(y1);}

void del_strset(Strset x1)

{
{Strset lt1; lt1 = _tt1_del_strset;
{
{_tt1_del_strset = x1;

{
forall_strset(x1,_ff1_del_strset);
del1_strset(x1);
_tt1_del_strset = lt1;

}}}}}

Strset sub1d_strset(Strset x1, Str x2)

{register Strset * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_strset(*lx1))->f_info,x2))
{Strset lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info);
free_strset(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Str sel_strset (Strset x1)
{if ( !x1 )
err_elem_vdmlib("Strset");
return ref_strset(x1)->f_info;
}

Strset union1_strset(Strset x1, Str x2)

{register Strset lx1 = x1;
while (lx1)
{if (is_eq_str(ref_strset(lx1)->f_info,x2)) return x1;
lx1 = lx1->f_next;
}
lx1 = mk1_strset(x2);
lx1->f_next = x1;
return lx1;
}

Strset copy_strset (Strset x1)
{Strset x2 = (Strset)0;
register Strset * px2 = & x2;
while (x1)
{*px2 = alloc_strset();
*(*px2) = *(ref_strset(x1));
(*px2)->f_info = copy_str((*px2)->f_info);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Strset mk1_strset(Str x1)

{Strset lx1 = alloc_strset();
lx1->f_next = (Strset)0;
lx1->f_info = x1;
return lx1;
}

Strset sub1_strset(Strset x1, Str x2)

{register Strset * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_strset(*lx1))->f_info,x2))
{Strset lx2 = *lx1;
*lx1 = lx2->f_next;

free_strset(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

#ifndef union1d_strset
extern Strset union1d_strset ( Strset x1, Str x2 );
#endif

static Strset _rr1_uniond_strset;
static void _rf1_uniond_strset(Str y1)  {_rr1_uniond_strset = union1d_strset(_rr1_uniond_strset,y1);}

Strset uniond_strset (Strset x1,Strset x2)
{Strset lr1 = _rr1_uniond_strset;
_rr1_uniond_strset = x1;
forall_strset(x2,_rf1_uniond_strset);
del1_strset(x2);
{Strset lr2 = _rr1_uniond_strset; _rr1_uniond_strset = lr1; return lr2;}
}

#ifndef sub1d_strset
extern Strset sub1d_strset ( Strset x1, Str x2 );
#endif

static Strset _rr1_diffd_strset;
static void _rf1_diffd_strset(Str y1)  {_rr1_diffd_strset = sub1d_strset(_rr1_diffd_strset,y1);}

Strset diffd_strset (Strset x1,Strset x2)
{Strset lr1 = _rr1_diffd_strset;
_rr1_diffd_strset = x1;
forall_strset(x2,_rf1_diffd_strset);
{Strset lr2 = _rr1_diffd_strset; _rr1_diffd_strset = lr1; return lr2;}
}

#ifndef union1_strset
extern Strset union1_strset ( Strset x1, Str x2 );
#endif

static Strset _rr1_union_strset;
static void _rf1_union_strset(Str y1)  {_rr1_union_strset = union1_strset(_rr1_union_strset,y1);}

Strset union_strset (Strset x1,Strset x2)
{Strset lr1 = _rr1_union_strset;
_rr1_union_strset = x1;
forall_strset(x2,_rf1_union_strset);
del1_strset(x2);
{Strset lr2 = _rr1_union_strset; _rr1_union_strset = lr1; return lr2;}
}

Cvtext_vdmlib cvlines_strset (Strset x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "{";
end_structure_vdmlib = "}";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_strset(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_strset(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

#ifndef cvtotuppair_operation
extern Outbytes cvtotuppair_operation ( Outbytes x1, Str x2, Str x3 );
#endif

static Outbytes _rr1_cvtotupelems_operation;
static void _rf1_cvtotupelems_operation(Str y1, Str y2)   {_rr1_cvtotupelems_operation = cvtotuppair_operation(_rr1_cvtotupelems_operation,y1,y2);}

Outbytes cvtotupelems_operation (Outbytes x1,Operation x2)
{Outbytes lr1 = _rr1_cvtotupelems_operation;
_rr1_cvtotupelems_operation = x1;
forall_operation(x2,_rf1_cvtotupelems_operation);
{Outbytes lr2 = _rr1_cvtotupelems_operation; _rr1_cvtotupelems_operation = lr1; return lr2;}
}

Outbytes cvtotuppair_operation (Outbytes x1,Str x2,Str x3)
{ return cvtotup1_str(cvtotup1_str(x1,x2),x3); }

Outbytes cvtotup1_operation (Outbytes x1,Operation x2)
{ return cvtotupelems_operation(cvtotup1_nat0(x1,card_operation(x2)),x2); }

static Bool _rr1_is_submap_operation;
static Operation _tt1_is_submap_operation; static Operation _tt2_is_submap_operation;

static void _ff1_is_submap_operation(Str y1,Str y2)

{{Str z2; _rr1_is_submap_operation = _rr1_is_submap_operation && is_in_dom_operation(y1,_tt2_is_submap_operation,&z2) && is_eq_str(y2,z2);}}

Bool is_submap_operation(Operation x1,Operation x2)

{Bool lr1; lr1 = _rr1_is_submap_operation;
{Operation lt1; Operation lt2; lt1 = _tt1_is_submap_operation; lt2 = _tt2_is_submap_operation;
{
{_tt1_is_submap_operation = x1; _tt2_is_submap_operation = x2;

{_rr1_is_submap_operation = (card_operation(_tt1_is_submap_operation) <= card_operation(_tt2_is_submap_operation));
if (_rr1_is_submap_operation) forall_operation(x1,_ff1_is_submap_operation);

_tt1_is_submap_operation = lt1; _tt2_is_submap_operation = lt2;
{Bool lr2; lr2 = _rr1_is_submap_operation; _rr1_is_submap_operation = lr1; return lr2;}
}}}}}

Bool is_eq_operation (Operation x1,Operation x2)
{return (card_operation(x1) == card_operation(x2))
&& is_submap_operation(x1,x2);
}
Str sel_operation (Operation x1,Str x2)
{while (x1)
{if (is_eq_str(ref_operation(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Operation");
return x1->f_attr;
}

Operation ovwrt1d_operation(Operation x1, Str x2, Str x3)

{register Operation lx1 = x1;
while (lx1)
{if (is_eq_str(ref_operation(lx1)->f_info,x2)) {del_str(x2);del_str(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_operation(x2,x3);
lx1->f_next = x1;
return lx1;
}

Operation mk1_operation(Str x1, Str x2)

{Operation lx1 = alloc_operation();
lx1->f_next = (Operation)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

static Operation _tt1_del_operation;

static void _ff1_del_operation(Str y1,Str y2)

{del_str(y1);del_str(y2);}

void del_operation(Operation x1)

{
{Operation lt1; lt1 = _tt1_del_operation;
{
{_tt1_del_operation = x1;

{
forall_operation(x1,_ff1_del_operation);
del1_operation(x1);
_tt1_del_operation = lt1;

}}}}}

Bool is_in_dom_operation(Str x1, Operation x2, Str * x3)

{while (x2)
{if (is_eq_str(ref_operation(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Operation sub1d_operation(Operation x1, Str x2)

{register Operation * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_operation(*lx1))->f_info,x2))
{Operation lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info); del_str(lx2->f_attr);
free_operation(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

#ifndef mk_empty_strset
extern Strset mk_empty_strset ( void ) ;
#endif

#ifndef union_strset
extern Strset union_strset ( Strset x1, Strset x2   ) ;
#endif

#ifndef convert_to_str_str
extern Strset convert_to_str_str ( Str y1, Str y2    ) ;
#endif

Strset dom_operation(Operation x1     )

{
Strset lx1;
lx1 = mk_empty_strset();
for(;x1 ; x1=ref_operation(x1)->f_next)
{lx1 = union_strset(lx1,convert_to_str_str(ref_operation(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Operation copy_operation (Operation x1)
{Operation x2 = (Operation)0;
register Operation * px2 = & x2;
while (x1)
{*px2 = alloc_operation();
*(*px2) = *(ref_operation(x1));
(*px2)->f_info = copy_str((*px2)->f_info); (*px2)->f_attr = copy_str((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Operation union1_operation(Operation x1, Str x2, Str x3)

{register Operation lx1 = x1;
while (lx1)
{if (is_eq_str(ref_operation(lx1)->f_info,x2)) {if (! is_eq_str(ref_operation(lx1)->f_attr,x3)) err_umap_vdmlib("Operation"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_operation(x2,x3);
lx1->f_next = x1;
return lx1;
}

Bool is_in_operation(Str x1, Operation x2)

{while (x2)
{if (is_eq_str(ref_operation(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

#ifdef __cplusplus
void fpr_operation (ostream & x1,Operation x2)
#else
void fpr_operation (FILE * x1,Operation x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_operation(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Nat0 card_operation (Operation x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_operation(x1)->f_next;}
return lx1;
}
Cvtext_vdmlib cvlines3_operation_str_str (Str x1,Str x2)
{ Cvtext_vdmlib lx1;
Cvtext_vdmlib lx2;

lx1 = cvlines_str(x1);
lx2 = cvlines_str(x2);
if ( len_cvtext_vdmlib(lx1) == 1
&& len_cvtext_vdmlib(lx2) == 1
&& len_str(hd_cvtext_vdmlib(lx1)) + len_str(hd_cvtext_vdmlib(lx2))
<= curr_linelen_vdmlib - 5
)
{ Str lx3;

lx3 = conc_str( hd_cvtext_vdmlib(lx1)
, conc_str(mkc_str(" :-> "),hd_cvtext_vdmlib(lx2))
);
del1_cvtext_vdmlib(lx1);
del1_cvtext_vdmlib(lx2);
return mk1_cvtext_vdmlib(lx3);
}
else
{ return conc_cvtext_vdmlib(lx1, ident_lines_vdmlib(lx2,mkc_str(" :-> ")));}
}

Cvtext_vdmlib cvlines_operation (Operation x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "[";
end_structure_vdmlib = "]";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_operation(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_operation(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines3_operation_str_str
extern Cvtext_vdmlib cvlines3_operation_str_str ( Str y1, Str y2    ) ;
#endif

Cvtext_vdmlib cvlines1_operation(Operation x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_operation(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines3_operation_str_str(ref_operation(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Operation cvfromtup1_operation (Inbytes * x1)
{ Nat0 lx1 = cvfromtup1_nat0(x1);
Operation lx2;

lx2 = mk_empty_operation();
for (; lx1 >= 1; lx1--)
{
Str lx3; Str lx4;
lx3 = cvfromtup1_str(x1);
lx4 = cvfromtup1_str(x1);
lx2 = union1_operation(lx2,lx3,lx4);
}
return lx2;
}

#ifndef cvtotuppair_impl
extern Outbytes cvtotuppair_impl ( Outbytes x1, Str x2, Operation x3 );
#endif

static Outbytes _rr1_cvtotupelems_impl;
static void _rf1_cvtotupelems_impl(Str y1, Operation y2)   {_rr1_cvtotupelems_impl = cvtotuppair_impl(_rr1_cvtotupelems_impl,y1,y2);}

Outbytes cvtotupelems_impl (Outbytes x1,Impl x2)
{Outbytes lr1 = _rr1_cvtotupelems_impl;
_rr1_cvtotupelems_impl = x1;
forall_impl(x2,_rf1_cvtotupelems_impl);
{Outbytes lr2 = _rr1_cvtotupelems_impl; _rr1_cvtotupelems_impl = lr1; return lr2;}
}

Outbytes cvtotuppair_impl (Outbytes x1,Str x2,Operation x3)
{ return cvtotup1_operation(cvtotup1_str(x1,x2),x3); }

Outbytes cvtotup1_impl (Outbytes x1,Impl x2)
{ return cvtotupelems_impl(cvtotup1_nat0(x1,card_impl(x2)),x2); }

static Bool _rr1_is_submap_impl;
static Impl _tt1_is_submap_impl; static Impl _tt2_is_submap_impl;

static void _ff1_is_submap_impl(Str y1,Operation y2)

{{Operation z2; _rr1_is_submap_impl = _rr1_is_submap_impl && is_in_dom_impl(y1,_tt2_is_submap_impl,&z2) && is_eq_operation(y2,z2);}}

Bool is_submap_impl(Impl x1,Impl x2)

{Bool lr1; lr1 = _rr1_is_submap_impl;
{Impl lt1; Impl lt2; lt1 = _tt1_is_submap_impl; lt2 = _tt2_is_submap_impl;
{
{_tt1_is_submap_impl = x1; _tt2_is_submap_impl = x2;

{_rr1_is_submap_impl = (card_impl(_tt1_is_submap_impl) <= card_impl(_tt2_is_submap_impl));
if (_rr1_is_submap_impl) forall_impl(x1,_ff1_is_submap_impl);

_tt1_is_submap_impl = lt1; _tt2_is_submap_impl = lt2;
{Bool lr2; lr2 = _rr1_is_submap_impl; _rr1_is_submap_impl = lr1; return lr2;}
}}}}}

Bool is_eq_impl (Impl x1,Impl x2)
{return (card_impl(x1) == card_impl(x2))
&& is_submap_impl(x1,x2);
}

Impl union1_impl(Impl x1, Str x2, Operation x3)

{register Impl lx1 = x1;
while (lx1)
{if (is_eq_str(ref_impl(lx1)->f_info,x2)) {if (! is_eq_operation(ref_impl(lx1)->f_attr,x3)) err_umap_vdmlib("Impl"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_impl(x2,x3);
lx1->f_next = x1;
return lx1;
}

Bool is_in_impl(Str x1, Impl x2)

{while (x2)
{if (is_eq_str(ref_impl(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

static Impl _tt1_del_impl;

static void _ff1_del_impl(Str y1,Operation y2)

{del_str(y1);del_operation(y2);}

void del_impl(Impl x1)

{
{Impl lt1; lt1 = _tt1_del_impl;
{
{_tt1_del_impl = x1;

{
forall_impl(x1,_ff1_del_impl);
del1_impl(x1);
_tt1_del_impl = lt1;

}}}}}

Impl copy_impl (Impl x1)
{Impl x2 = (Impl)0;
register Impl * px2 = & x2;
while (x1)
{*px2 = alloc_impl();
*(*px2) = *(ref_impl(x1));
(*px2)->f_info = copy_str((*px2)->f_info); (*px2)->f_attr = copy_operation((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Impl sub1d_impl(Impl x1, Str x2)

{register Impl * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_impl(*lx1))->f_info,x2))
{Impl lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info); del_operation(lx2->f_attr);
free_impl(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Bool is_in_dom_impl(Str x1, Impl x2, Operation * x3)

{while (x2)
{if (is_eq_str(ref_impl(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

#ifndef mk_empty_strset
extern Strset mk_empty_strset ( void ) ;
#endif

#ifndef union_strset
extern Strset union_strset ( Strset x1, Strset x2   ) ;
#endif

#ifndef convert_to_str_operation
extern Strset convert_to_str_operation ( Str y1, Operation y2    ) ;
#endif

Strset dom_impl(Impl x1     )

{
Strset lx1;
lx1 = mk_empty_strset();
for(;x1 ; x1=ref_impl(x1)->f_next)
{lx1 = union_strset(lx1,convert_to_str_operation(ref_impl(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Impl mk1_impl(Str x1, Operation x2)

{Impl lx1 = alloc_impl();
lx1->f_next = (Impl)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

Impl ovwrt1d_impl(Impl x1, Str x2, Operation x3)

{register Impl lx1 = x1;
while (lx1)
{if (is_eq_str(ref_impl(lx1)->f_info,x2)) {del_str(x2);del_operation(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_impl(x2,x3);
lx1->f_next = x1;
return lx1;
}

Operation sel_impl (Impl x1,Str x2)
{while (x1)
{if (is_eq_str(ref_impl(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Impl");
return x1->f_attr;
}

#ifdef __cplusplus
void fpr_impl (ostream & x1,Impl x2)
#else
void fpr_impl (FILE * x1,Impl x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_impl(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Nat0 card_impl (Impl x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_impl(x1)->f_next;}
return lx1;
}
Cvtext_vdmlib cvlines3_impl_str_operation (Str x1,Operation x2)
{ Cvtext_vdmlib lx1;
Cvtext_vdmlib lx2;

lx1 = cvlines_str(x1);
lx2 = cvlines_operation(x2);
if ( len_cvtext_vdmlib(lx1) == 1
&& len_cvtext_vdmlib(lx2) == 1
&& len_str(hd_cvtext_vdmlib(lx1)) + len_str(hd_cvtext_vdmlib(lx2))
<= curr_linelen_vdmlib - 5
)
{ Str lx3;

lx3 = conc_str( hd_cvtext_vdmlib(lx1)
, conc_str(mkc_str(" :-> "),hd_cvtext_vdmlib(lx2))
);
del1_cvtext_vdmlib(lx1);
del1_cvtext_vdmlib(lx2);
return mk1_cvtext_vdmlib(lx3);
}
else
{ return conc_cvtext_vdmlib(lx1, ident_lines_vdmlib(lx2,mkc_str(" :-> ")));}
}

Cvtext_vdmlib cvlines_impl (Impl x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "[";
end_structure_vdmlib = "]";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_impl(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_impl(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Impl cvfromtup1_impl (Inbytes * x1)
{ Nat0 lx1 = cvfromtup1_nat0(x1);
Impl lx2;

lx2 = mk_empty_impl();
for (; lx1 >= 1; lx1--)
{
Str lx3; Operation lx4;
lx3 = cvfromtup1_str(x1);
lx4 = cvfromtup1_operation(x1);
lx2 = union1_impl(lx2,lx3,lx4);
}
return lx2;
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines3_impl_str_operation
extern Cvtext_vdmlib cvlines3_impl_str_operation ( Str y1, Operation y2    ) ;
#endif

Cvtext_vdmlib cvlines1_impl(Impl x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_impl(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines3_impl_str_operation(ref_impl(x1)->f_info,x1->f_attr )  );}
return lx1;
}

static Bool _rr1_is_submap_adt;
static Adt _tt1_is_submap_adt; static Adt _tt2_is_submap_adt;

static void _ff1_is_submap_adt(Str y1,Impl y2)

{{Impl z2; _rr1_is_submap_adt = _rr1_is_submap_adt && is_in_dom_adt(y1,_tt2_is_submap_adt,&z2) && is_eq_impl(y2,z2);}}

Bool is_submap_adt(Adt x1,Adt x2)

{Bool lr1; lr1 = _rr1_is_submap_adt;
{Adt lt1; Adt lt2; lt1 = _tt1_is_submap_adt; lt2 = _tt2_is_submap_adt;
{
{_tt1_is_submap_adt = x1; _tt2_is_submap_adt = x2;

{_rr1_is_submap_adt = (card_adt(_tt1_is_submap_adt) <= card_adt(_tt2_is_submap_adt));
if (_rr1_is_submap_adt) forall_adt(x1,_ff1_is_submap_adt);

_tt1_is_submap_adt = lt1; _tt2_is_submap_adt = lt2;
{Bool lr2; lr2 = _rr1_is_submap_adt; _rr1_is_submap_adt = lr1; return lr2;}
}}}}}

#ifndef cvtotuppair_adt
extern Outbytes cvtotuppair_adt ( Outbytes x1, Str x2, Impl x3 );
#endif

static Outbytes _rr1_cvtotupelems_adt;
static void _rf1_cvtotupelems_adt(Str y1, Impl y2)   {_rr1_cvtotupelems_adt = cvtotuppair_adt(_rr1_cvtotupelems_adt,y1,y2);}

Outbytes cvtotupelems_adt (Outbytes x1,Adt x2)
{Outbytes lr1 = _rr1_cvtotupelems_adt;
_rr1_cvtotupelems_adt = x1;
forall_adt(x2,_rf1_cvtotupelems_adt);
{Outbytes lr2 = _rr1_cvtotupelems_adt; _rr1_cvtotupelems_adt = lr1; return lr2;}
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines3_adt_str_impl
extern Cvtext_vdmlib cvlines3_adt_str_impl ( Str y1, Impl y2    ) ;
#endif

Cvtext_vdmlib cvlines1_adt(Adt x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_adt(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines3_adt_str_impl(ref_adt(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Adt cvfromtup1_adt (Inbytes * x1)
{ Nat0 lx1 = cvfromtup1_nat0(x1);
Adt lx2;

lx2 = mk_empty_adt();
for (; lx1 >= 1; lx1--)
{
Str lx3; Impl lx4;
lx3 = cvfromtup1_str(x1);
lx4 = cvfromtup1_impl(x1);
lx2 = union1_adt(lx2,lx3,lx4);
}
return lx2;
}

Cvtext_vdmlib cvlines3_adt_str_impl (Str x1,Impl x2)
{ Cvtext_vdmlib lx1;
Cvtext_vdmlib lx2;

lx1 = cvlines_str(x1);
lx2 = cvlines_impl(x2);
if ( len_cvtext_vdmlib(lx1) == 1
&& len_cvtext_vdmlib(lx2) == 1
&& len_str(hd_cvtext_vdmlib(lx1)) + len_str(hd_cvtext_vdmlib(lx2))
<= curr_linelen_vdmlib - 5
)
{ Str lx3;

lx3 = conc_str( hd_cvtext_vdmlib(lx1)
, conc_str(mkc_str(" :-> "),hd_cvtext_vdmlib(lx2))
);
del1_cvtext_vdmlib(lx1);
del1_cvtext_vdmlib(lx2);
return mk1_cvtext_vdmlib(lx3);
}
else
{ return conc_cvtext_vdmlib(lx1, ident_lines_vdmlib(lx2,mkc_str(" :-> ")));}
}

Cvtext_vdmlib cvlines_adt (Adt x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "[";
end_structure_vdmlib = "]";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_adt(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_adt(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

#ifdef __cplusplus
void fpr_adt (ostream & x1,Adt x2)
#else
void fpr_adt (FILE * x1,Adt x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_adt(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Adt sub1d_adt(Adt x1, Str x2)

{register Adt * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_adt(*lx1))->f_info,x2))
{Adt lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info); del_impl(lx2->f_attr);
free_adt(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

#ifndef mk_empty_strset
extern Strset mk_empty_strset ( void ) ;
#endif

#ifndef union_strset
extern Strset union_strset ( Strset x1, Strset x2   ) ;
#endif

#ifndef convert_to_str_impl
extern Strset convert_to_str_impl ( Str y1, Impl y2    ) ;
#endif

Strset dom_adt(Adt x1     )

{
Strset lx1;
lx1 = mk_empty_strset();
for(;x1 ; x1=ref_adt(x1)->f_next)
{lx1 = union_strset(lx1,convert_to_str_impl(ref_adt(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Adt copy_adt (Adt x1)
{Adt x2 = (Adt)0;
register Adt * px2 = & x2;
while (x1)
{*px2 = alloc_adt();
*(*px2) = *(ref_adt(x1));
(*px2)->f_info = copy_str((*px2)->f_info); (*px2)->f_attr = copy_impl((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Adt union1_adt(Adt x1, Str x2, Impl x3)

{register Adt lx1 = x1;
while (lx1)
{if (is_eq_str(ref_adt(lx1)->f_info,x2)) {if (! is_eq_impl(ref_adt(lx1)->f_attr,x3)) err_umap_vdmlib("Adt"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_adt(x2,x3);
lx1->f_next = x1;
return lx1;
}

Impl sel_adt (Adt x1,Str x2)
{while (x1)
{if (is_eq_str(ref_adt(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Adt");
return x1->f_attr;
}

Bool is_in_dom_adt(Str x1, Adt x2, Impl * x3)

{while (x2)
{if (is_eq_str(ref_adt(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Adt ovwrt1d_adt(Adt x1, Str x2, Impl x3)

{register Adt lx1 = x1;
while (lx1)
{if (is_eq_str(ref_adt(lx1)->f_info,x2)) {del_str(x2);del_impl(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_adt(x2,x3);
lx1->f_next = x1;
return lx1;
}

Adt mk1_adt(Str x1, Impl x2)

{Adt lx1 = alloc_adt();
lx1->f_next = (Adt)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

static Adt _tt1_del_adt;

static void _ff1_del_adt(Str y1,Impl y2)

{del_str(y1);del_impl(y2);}

void del_adt(Adt x1)

{
{Adt lt1; lt1 = _tt1_del_adt;
{
{_tt1_del_adt = x1;

{
forall_adt(x1,_ff1_del_adt);
del1_adt(x1);
_tt1_del_adt = lt1;

}}}}}

Bool is_in_adt(Str x1, Adt x2)

{while (x2)
{if (is_eq_str(ref_adt(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Outbytes cvtotuppair_adt (Outbytes x1,Str x2,Impl x3)
{ return cvtotup1_impl(cvtotup1_str(x1,x2),x3); }

Outbytes cvtotup1_adt (Outbytes x1,Adt x2)
{ return cvtotupelems_adt(cvtotup1_nat0(x1,card_adt(x2)),x2); }

Nat0 card_adt (Adt x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_adt(x1)->f_next;}
return lx1;
}
Bool is_eq_adt (Adt x1,Adt x2)
{return (card_adt(x1) == card_adt(x2))
&& is_submap_adt(x1,x2);
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines3_vdmdb_str_adt
extern Cvtext_vdmlib cvlines3_vdmdb_str_adt ( Str y1, Adt y2    ) ;
#endif

Cvtext_vdmlib cvlines1_vdmdb(Vdmdb x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_vdmdb(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines3_vdmdb_str_adt(ref_vdmdb(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Cvtext_vdmlib cvlines3_vdmdb_str_adt (Str x1,Adt x2)
{ Cvtext_vdmlib lx1;
Cvtext_vdmlib lx2;

lx1 = cvlines_str(x1);
lx2 = cvlines_adt(x2);
if ( len_cvtext_vdmlib(lx1) == 1
&& len_cvtext_vdmlib(lx2) == 1
&& len_str(hd_cvtext_vdmlib(lx1)) + len_str(hd_cvtext_vdmlib(lx2))
<= curr_linelen_vdmlib - 5
)
{ Str lx3;

lx3 = conc_str( hd_cvtext_vdmlib(lx1)
, conc_str(mkc_str(" :-> "),hd_cvtext_vdmlib(lx2))
);
del1_cvtext_vdmlib(lx1);
del1_cvtext_vdmlib(lx2);
return mk1_cvtext_vdmlib(lx3);
}
else
{ return conc_cvtext_vdmlib(lx1, ident_lines_vdmlib(lx2,mkc_str(" :-> ")));}
}

Cvtext_vdmlib cvlines_vdmdb (Vdmdb x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "[";
end_structure_vdmlib = "]";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_vdmdb(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_vdmdb(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Nat0 card_vdmdb (Vdmdb x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_vdmdb(x1)->f_next;}
return lx1;
}

Vdmdb cvfromtup1_vdmdb (Inbytes * x1)
{ Nat0 lx1 = cvfromtup1_nat0(x1);
Vdmdb lx2;

lx2 = mk_empty_vdmdb();
for (; lx1 >= 1; lx1--)
{
Str lx3; Adt lx4;
lx3 = cvfromtup1_str(x1);
lx4 = cvfromtup1_adt(x1);
lx2 = union1_vdmdb(lx2,lx3,lx4);
}
return lx2;
}

#ifdef __cplusplus
void fpr_vdmdb (ostream & x1,Vdmdb x2)
#else
void fpr_vdmdb (FILE * x1,Vdmdb x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_vdmdb(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}
Adt sel_vdmdb (Vdmdb x1,Str x2)
{while (x1)
{if (is_eq_str(ref_vdmdb(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Vdmdb");
return x1->f_attr;
}

static Vdmdb _tt1_del_vdmdb;

static void _ff1_del_vdmdb(Str y1,Adt y2)

{del_str(y1);del_adt(y2);}

void del_vdmdb(Vdmdb x1)

{
{Vdmdb lt1; lt1 = _tt1_del_vdmdb;
{
{_tt1_del_vdmdb = x1;

{
forall_vdmdb(x1,_ff1_del_vdmdb);
del1_vdmdb(x1);
_tt1_del_vdmdb = lt1;

}}}}}

#ifndef mk_empty_strset
extern Strset mk_empty_strset ( void ) ;
#endif

#ifndef union_strset
extern Strset union_strset ( Strset x1, Strset x2   ) ;
#endif

#ifndef convert_to_str_adt
extern Strset convert_to_str_adt ( Str y1, Adt y2    ) ;
#endif

Strset dom_vdmdb(Vdmdb x1     )

{
Strset lx1;
lx1 = mk_empty_strset();
for(;x1 ; x1=ref_vdmdb(x1)->f_next)
{lx1 = union_strset(lx1,convert_to_str_adt(ref_vdmdb(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Vdmdb sub1d_vdmdb(Vdmdb x1, Str x2)

{register Vdmdb * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_vdmdb(*lx1))->f_info,x2))
{Vdmdb lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info); del_adt(lx2->f_attr);
free_vdmdb(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Vdmdb copy_vdmdb (Vdmdb x1)
{Vdmdb x2 = (Vdmdb)0;
register Vdmdb * px2 = & x2;
while (x1)
{*px2 = alloc_vdmdb();
*(*px2) = *(ref_vdmdb(x1));
(*px2)->f_info = copy_str((*px2)->f_info); (*px2)->f_attr = copy_adt((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Bool is_in_dom_vdmdb(Str x1, Vdmdb x2, Adt * x3)

{while (x2)
{if (is_eq_str(ref_vdmdb(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Outbytes cvtotupl_vdmdb (Vdmdb x1)
{ Outbytes lx1;
lx1 = cvtotup1_vdmdb(mk_empty_outbytes(),x1);
del_vdmdb(x1);
return lx1;
}

Vdmdb copy1_vdmdb (Vdmdb x1)
{Vdmdb x2 = (Vdmdb)0;
register Vdmdb * px2 = & x2;
while (x1)
{*px2 = alloc_vdmdb();
*(*px2) = *(ref_vdmdb(x1));

px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Vdmdb ovwrt1d_vdmdb(Vdmdb x1, Str x2, Adt x3)

{register Vdmdb lx1 = x1;
while (lx1)
{if (is_eq_str(ref_vdmdb(lx1)->f_info,x2)) {del_str(x2);del_adt(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_vdmdb(x2,x3);
lx1->f_next = x1;
return lx1;
}

Vdmdb mk1_vdmdb(Str x1, Adt x2)

{Vdmdb lx1 = alloc_vdmdb();
lx1->f_next = (Vdmdb)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

Bool is_in_vdmdb(Str x1, Vdmdb x2)

{while (x2)
{if (is_eq_str(ref_vdmdb(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Outbytes cvtotuppair_vdmdb (Outbytes x1,Str x2,Adt x3)
{ return cvtotup1_adt(cvtotup1_str(x1,x2),x3); }

Outbytes cvtotup1_vdmdb (Outbytes x1,Vdmdb x2)
{ return cvtotupelems_vdmdb(cvtotup1_nat0(x1,card_vdmdb(x2)),x2); }

#ifndef cvtotuppair_vdmdb
extern Outbytes cvtotuppair_vdmdb ( Outbytes x1, Str x2, Adt x3 );
#endif

static Outbytes _rr1_cvtotupelems_vdmdb;
static void _rf1_cvtotupelems_vdmdb(Str y1, Adt y2)   {_rr1_cvtotupelems_vdmdb = cvtotuppair_vdmdb(_rr1_cvtotupelems_vdmdb,y1,y2);}

Outbytes cvtotupelems_vdmdb (Outbytes x1,Vdmdb x2)
{Outbytes lr1 = _rr1_cvtotupelems_vdmdb;
_rr1_cvtotupelems_vdmdb = x1;
forall_vdmdb(x2,_rf1_cvtotupelems_vdmdb);
{Outbytes lr2 = _rr1_cvtotupelems_vdmdb; _rr1_cvtotupelems_vdmdb = lr1; return lr2;}
}

Vdmdb union1_vdmdb(Vdmdb x1, Str x2, Adt x3)

{register Vdmdb lx1 = x1;
while (lx1)
{if (is_eq_str(ref_vdmdb(lx1)->f_info,x2)) {if (! is_eq_adt(ref_vdmdb(lx1)->f_attr,x3)) err_umap_vdmlib("Vdmdb"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_vdmdb(x2,x3);
lx1->f_next = x1;
return lx1;
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_vdmdb
extern Cvtext_vdmlib cvlines_vdmdb ( Vdmdb y1    ) ;
#endif

Cvtext_vdmlib cvlines1_vdmdbs(Vdmdbs x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_vdmdbs(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines_vdmdb(ref_vdmdbs(x1)->f_info )  );}
return lx1;
}

static Vdmdbs _tt1_forindex_vdmdbs; static T2_forindex_vdmdbs _tt2_forindex_vdmdbs; static Nat1 _ll1_forindex_vdmdbs;

static void _ff1_forindex_vdmdbs(Vdmdb y1)

{(*_tt2_forindex_vdmdbs)(y1,_ll1_forindex_vdmdbs++);}

void forindex_vdmdbs(Vdmdbs x1,T2_forindex_vdmdbs x2)

{
{Vdmdbs lt1; T2_forindex_vdmdbs lt2; lt1 = _tt1_forindex_vdmdbs; lt2 = _tt2_forindex_vdmdbs;
{Nat1 ll1; ll1 = _ll1_forindex_vdmdbs;
{_tt1_forindex_vdmdbs = x1; _tt2_forindex_vdmdbs = x2;
_ll1_forindex_vdmdbs = 1;
{
forall_vdmdbs(x1,_ff1_forindex_vdmdbs);

_tt1_forindex_vdmdbs = lt1; _tt2_forindex_vdmdbs = lt2; _ll1_forindex_vdmdbs = ll1;

}}}}}

Vdmdbs conc_vdmdbs (Vdmdbs x1,Vdmdbs x2)
{Vdmdbs * px1 = & x1;
while (*px1)
{ Vdmdbs lx1 = ref_vdmdbs(*px1);
px1 = &(lx1->f_next);
}
*px1 = x2;
return x1;
}

Nat0 len_vdmdbs (Vdmdbs x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_vdmdbs(x1)->f_next;}
return lx1;
}

Vdmdbs copy_vdmdbs (Vdmdbs x1)
{Vdmdbs x2 = (Vdmdbs)0;
register Vdmdbs * px2 = & x2;
while (x1)
{*px2 = alloc_vdmdbs();
*(*px2) = *(ref_vdmdbs(x1));
(*px2)->f_info = copy_vdmdb((*px2)->f_info);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

static Vdmdbs _tt1_del_vdmdbs;

static void _ff1_del_vdmdbs(Vdmdb y1)

{del_vdmdb(y1);}

void del_vdmdbs(Vdmdbs x1)

{
{Vdmdbs lt1; lt1 = _tt1_del_vdmdbs;
{
{_tt1_del_vdmdbs = x1;

{
forall_vdmdbs(x1,_ff1_del_vdmdbs);
del1_vdmdbs(x1);
_tt1_del_vdmdbs = lt1;

}}}}}

Vdmdb sel_vdmdbs (Vdmdbs x1,Nat1 x2)
{
Nat0 len = 0;

while (x1)
{
if (++len == x2)
return ref_vdmdbs(x1)->f_info;

x1=x1->f_next;
}

err_sel_vdmlib(x2,len,"Vdmdbs");

return x1->f_info;
}

Vdmdbs mk1_vdmdbs(Vdmdb x1)

{Vdmdbs lx1 = alloc_vdmdbs();
lx1->f_next = (Vdmdbs)0;
lx1->f_info = x1;
return lx1;
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef exist_vdmdb
extern Bool exist_vdmdb ( Vdmdb y1    ) ;
#endif

Bool fold_exists_vdmdbs(Vdmdbs x1     )

{
Bool lx1;
lx1 = true_bool();
for(;x1 ; x1=ref_vdmdbs(x1)->f_next)
{lx1 = and_bool(lx1,exist_vdmdb(ref_vdmdbs(x1)->f_info )  );}
return lx1;
}

Vdmdbs copy1_vdmdbs (Vdmdbs x1)
{Vdmdbs x2 = (Vdmdbs)0;
register Vdmdbs * px2 = & x2;
while (x1)
{*px2 = alloc_vdmdbs();
*(*px2) = *(ref_vdmdbs(x1));

px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

#ifdef __cplusplus
void fpr_vdmdbs (ostream & x1,Vdmdbs x2)
#else
void fpr_vdmdbs (FILE * x1,Vdmdbs x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_vdmdbs(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

static Vdmdbs _rr1_rmv1_vdmdbs;
static Vdmdbs _tt1_rmv1_vdmdbs; static Nat1 _tt2_rmv1_vdmdbs;

static void _ff1_rmv1_vdmdbs(Vdmdb y1,Nat1 y2)

{if (y2 != _tt2_rmv1_vdmdbs) _rr1_rmv1_vdmdbs = appr_vdmdbs(_rr1_rmv1_vdmdbs,y1);}

Vdmdbs rmv1_vdmdbs(Vdmdbs x1,Nat1 x2)

{Vdmdbs lr1; lr1 = _rr1_rmv1_vdmdbs;
{Vdmdbs lt1; Nat1 lt2; lt1 = _tt1_rmv1_vdmdbs; lt2 = _tt2_rmv1_vdmdbs;
{
{_tt1_rmv1_vdmdbs = x1; _tt2_rmv1_vdmdbs = x2;

{_rr1_rmv1_vdmdbs = mk_empty_vdmdbs();
forindex_vdmdbs(x1,_ff1_rmv1_vdmdbs);
del1_vdmdbs(x1);
_tt1_rmv1_vdmdbs = lt1; _tt2_rmv1_vdmdbs = lt2;
{Vdmdbs lr2; lr2 = _rr1_rmv1_vdmdbs; _rr1_rmv1_vdmdbs = lr1; return lr2;}
}}}}}

static Vdmdbs _rr1_rmv1d_vdmdbs;
static Vdmdbs _tt1_rmv1d_vdmdbs; static Nat1 _tt2_rmv1d_vdmdbs;

static void _ff1_rmv1d_vdmdbs(Vdmdb y1,Nat1 y2)

{if (y2 == _tt2_rmv1d_vdmdbs) del_vdmdb(y1); else _rr1_rmv1d_vdmdbs = appr_vdmdbs(_rr1_rmv1d_vdmdbs,y1);}

Vdmdbs rmv1d_vdmdbs(Vdmdbs x1,Nat1 x2)

{Vdmdbs lr1; lr1 = _rr1_rmv1d_vdmdbs;
{Vdmdbs lt1; Nat1 lt2; lt1 = _tt1_rmv1d_vdmdbs; lt2 = _tt2_rmv1d_vdmdbs;
{
{_tt1_rmv1d_vdmdbs = x1; _tt2_rmv1d_vdmdbs = x2;

{_rr1_rmv1d_vdmdbs = mk_empty_vdmdbs();
forindex_vdmdbs(x1,_ff1_rmv1d_vdmdbs);
del1_vdmdbs(x1);
_tt1_rmv1d_vdmdbs = lt1; _tt2_rmv1d_vdmdbs = lt2;
{Vdmdbs lr2; lr2 = _rr1_rmv1d_vdmdbs; _rr1_rmv1d_vdmdbs = lr1; return lr2;}
}}}}}

Cvtext_vdmlib cvlines_vdmdbs (Vdmdbs x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_vdmdbs(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_vdmdbs(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_str
extern Cvtext_vdmlib cvlines_str ( Str y1    ) ;
#endif

Cvtext_vdmlib cvlines1_dbs(Dbs x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_dbs(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines_str(ref_dbs(x1)->f_info )  );}
return lx1;
}

static Dbs _tt1_forindex_dbs; static T2_forindex_dbs _tt2_forindex_dbs; static Nat1 _ll1_forindex_dbs;

static void _ff1_forindex_dbs(Str y1)

{(*_tt2_forindex_dbs)(y1,_ll1_forindex_dbs++);}

void forindex_dbs(Dbs x1,T2_forindex_dbs x2)

{
{Dbs lt1; T2_forindex_dbs lt2; lt1 = _tt1_forindex_dbs; lt2 = _tt2_forindex_dbs;
{Nat1 ll1; ll1 = _ll1_forindex_dbs;
{_tt1_forindex_dbs = x1; _tt2_forindex_dbs = x2;
_ll1_forindex_dbs = 1;
{
forall_dbs(x1,_ff1_forindex_dbs);

_tt1_forindex_dbs = lt1; _tt2_forindex_dbs = lt2; _ll1_forindex_dbs = ll1;

}}}}}

Dbs conc_dbs (Dbs x1,Dbs x2)
{Dbs * px1 = & x1;
while (*px1)
{ Dbs lx1 = ref_dbs(*px1);
px1 = &(lx1->f_next);
}
*px1 = x2;
return x1;
}

#ifdef __cplusplus
void fpr_dbs (ostream & x1,Dbs x2)
#else
void fpr_dbs (FILE * x1,Dbs x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_dbs(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

static Dbs _rr1_rmv1d_dbs;
static Dbs _tt1_rmv1d_dbs; static Nat1 _tt2_rmv1d_dbs;

static void _ff1_rmv1d_dbs(Str y1,Nat1 y2)

{if (y2 == _tt2_rmv1d_dbs) del_str(y1); else _rr1_rmv1d_dbs = appr_dbs(_rr1_rmv1d_dbs,y1);}

Dbs rmv1d_dbs(Dbs x1,Nat1 x2)

{Dbs lr1; lr1 = _rr1_rmv1d_dbs;
{Dbs lt1; Nat1 lt2; lt1 = _tt1_rmv1d_dbs; lt2 = _tt2_rmv1d_dbs;
{
{_tt1_rmv1d_dbs = x1; _tt2_rmv1d_dbs = x2;

{_rr1_rmv1d_dbs = mk_empty_dbs();
forindex_dbs(x1,_ff1_rmv1d_dbs);
del1_dbs(x1);
_tt1_rmv1d_dbs = lt1; _tt2_rmv1d_dbs = lt2;
{Dbs lr2; lr2 = _rr1_rmv1d_dbs; _rr1_rmv1d_dbs = lr1; return lr2;}
}}}}}

Dbs mk1_dbs(Str x1)

{Dbs lx1 = alloc_dbs();
lx1->f_next = (Dbs)0;
lx1->f_info = x1;
return lx1;
}

#ifndef mk_empty_vdmdbs
extern Vdmdbs mk_empty_vdmdbs ( void ) ;
#endif

#ifndef conc_vdmdbs
extern Vdmdbs conc_vdmdbs ( Vdmdbs x1, Vdmdbs x2   ) ;
#endif

#ifndef mk_vdmdbs_from_str
extern Vdmdbs mk_vdmdbs_from_str ( Str y1    ) ;
#endif

Vdmdbs mk_tuple_dbs(Dbs x1     )

{
Vdmdbs lx1;
lx1 = mk_empty_vdmdbs();
for(;x1 ; x1=ref_dbs(x1)->f_next)
{lx1 = conc_vdmdbs(lx1,mk_vdmdbs_from_str(ref_dbs(x1)->f_info )  );}
return lx1;
}

Nat0 len_dbs (Dbs x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_dbs(x1)->f_next;}
return lx1;
}

static Dbs _tt1_del_dbs;

static void _ff1_del_dbs(Str y1)

{del_str(y1);}

void del_dbs(Dbs x1)

{
{Dbs lt1; lt1 = _tt1_del_dbs;
{
{_tt1_del_dbs = x1;

{
forall_dbs(x1,_ff1_del_dbs);
del1_dbs(x1);
_tt1_del_dbs = lt1;

}}}}}

static Dbs _rr1_rmv1_dbs;
static Dbs _tt1_rmv1_dbs; static Nat1 _tt2_rmv1_dbs;

static void _ff1_rmv1_dbs(Str y1,Nat1 y2)

{if (y2 != _tt2_rmv1_dbs) _rr1_rmv1_dbs = appr_dbs(_rr1_rmv1_dbs,y1);}

Dbs rmv1_dbs(Dbs x1,Nat1 x2)

{Dbs lr1; lr1 = _rr1_rmv1_dbs;
{Dbs lt1; Nat1 lt2; lt1 = _tt1_rmv1_dbs; lt2 = _tt2_rmv1_dbs;
{
{_tt1_rmv1_dbs = x1; _tt2_rmv1_dbs = x2;

{_rr1_rmv1_dbs = mk_empty_dbs();
forindex_dbs(x1,_ff1_rmv1_dbs);
del1_dbs(x1);
_tt1_rmv1_dbs = lt1; _tt2_rmv1_dbs = lt2;
{Dbs lr2; lr2 = _rr1_rmv1_dbs; _rr1_rmv1_dbs = lr1; return lr2;}
}}}}}

Str sel_dbs (Dbs x1,Nat1 x2)
{
Nat0 len = 0;

while (x1)
{
if (++len == x2)
return ref_dbs(x1)->f_info;

x1=x1->f_next;
}

err_sel_vdmlib(x2,len,"Dbs");

return x1->f_info;
}

Cvtext_vdmlib cvlines_dbs (Dbs x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_dbs(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_dbs(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}
