#ifndef VDM_header_gen1
#define VDM_header_gen1


/* ------- PHASE1 ------------------ */
/*
module generated from VDM Class Library
$Revision: 1.100 $
$Date: 1996/09/18 13:13:42 $
*/

#if defined(sun) && ! defined(sparc)
#define __BSD42__
#endif

#ifdef M_XENIX
#define __XENIX__
#define __SYSV__
#endif

#ifdef __TURBOC__
#define __DOS__
#endif

#if defined(__TURBOC__) || defined(__ANSIC__) || defined(__STDC__)
typedef void * VOIDptr;
#else
typedef char * VOIDptr;
#endif

#if defined(__linux__) || defined(_AIX) || defined(MIPSEL) || (defined(sun) && defined(sparc))
#ifndef __POSIX
#define __POSIX
#endif
#endif

#ifdef __cplusplus
#include <stdlib.h>
#else
#if defined(__STDC__) || defined(__POSIX)
#ifndef apollo
#include <stdlib.h>
#endif
#endif
#endif

#ifdef __cplusplus
#include <stdio.h>
#endif

#ifdef __cplusplus
#include <iostream.h>
#else
#include <stdio.h>
#endif

#include <stdio.h>

#include <fcntl.h>

#include <errno.h>

#include <sys/types.h>

#ifdef __BSD42__
#include <strings.h>
#else
#include <string.h>
#endif

#include <sys/stat.h>

#ifdef __POSIX
#include <unistd.h>
#else
#include <sys/unistd.h>
#endif

/* some systems define TRUE and FALSE in system header files */
#ifndef FALSE
#ifndef TRUE

/* Bool as enum requires conversion between enum and int */
#ifdef BoolAsEnum
enum {FALSE,TRUE};
#else
#define FALSE ((unsigned char)0)
#define TRUE ((unsigned char)1)
#endif

#ifdef __cplusplus
#define false BOOL(FALSE)
#define true BOOL(TRUE)
#endif

#endif
#endif

typedef unsigned char Bool;

typedef char Char;
#define lb_char 0

#define ub_char 255

#define lb_intg -2147483647

#define ub_intg 2147483647

typedef long int Intg;

#define lb_nat1 1

#define ub_nat1 2147483647

typedef unsigned long Nat1;

typedef struct Struct_outbytes * Outbytes;
typedef struct Struct_inbytes * Inbytes;

#define lb_nat0 0

#define ub_nat0 2147483647

typedef unsigned long Nat0;

typedef struct Struct_str * Str;
typedef struct Struct_cvtext_vdmlib * Cvtext_vdmlib;
typedef struct Struct_strset * Strset;
typedef struct Struct_operation * Operation;
typedef struct Struct_impl * Impl;
typedef struct Struct_adt * Adt;
typedef struct Struct_vdmdb * Vdmdb;
typedef struct Struct_vdmdbs * Vdmdbs;
typedef struct Struct_dbs * Dbs;

/* ------- PHASE2 ------------------ */
#ifdef __cplusplus
inline VOIDptr ALLOCMEM_vdmlib(unsigned long int x1)
{ return (VOIDptr)(new char[x1]); }
inline void FREEMEM_vdmlib(VOIDptr x1,unsigned long int)
{ delete (char *)(x1); }
#else
#if ! defined(__STDC__) && ! defined(_AIX) && ! defined(__NOMALLOC__)
extern VOIDptr malloc ( unsigned long x1 ) ;
extern void free ( VOIDptr x1 ) ;
#endif
#define ALLOCMEM_vdmlib(x1) malloc(x1)
#define FREEMEM_vdmlib(x1,x2) free(x1)
#endif

extern Bool supress_cvlines_vdmlib;
extern Nat0 curr_linelen_vdmlib;
extern char *start_structure_vdmlib;
extern char *end_structure_vdmlib;

extern void adj_linelen_vdmlib ( Nat0 x1 ) ;
extern Str ident_prefix_vdmlib ( Str x1, Nat0 x2 ) ;
extern Cvtext_vdmlib ident_lines_vdmlib ( Cvtext_vdmlib x1, Str x2 ) ;
extern Cvtext_vdmlib close_struct_vdmlib ( Cvtext_vdmlib x1,Str x2, Nat0 x3 ) ;
extern Cvtext_vdmlib append_lastline_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
#ifdef __cplusplus
extern void fprint_lines_vdmlib ( ostream & x1,Cvtext_vdmlib x2 ) ;
#else
extern void fprint_lines_vdmlib ( FILE *x1,Cvtext_vdmlib x2 ) ;
#endif

#define VDM_ERR_EMPTYSET 1
#define VDM_ERR_EMPTYMAP 2
#define VDM_ERR_EMPTYHD 3
#define VDM_ERR_ERRMAXLEN 4
#define VDM_ERR_NILPTR 5
#define VDM_ERR_NILOPT 6
#define VDM_ERR_ILLPTR 7
#define VDM_ERR_SELECT 8
#define VDM_ERR_SELMAP 9
#define VDM_ERR_UNIO 10
#define VDM_ERR_EMPTYTL 11
#define VDM_ERR_UNION 12
#define VDM_ERR_NOTIMPL 13
#define VDM_ERR_HEAPOFL 15
#define VDM_ERR_CVLINES 16
#define VDM_ERR_NV_HDL 17
#define VDM_ERR_EMPTYIT 18
#define VDM_ERR_DIV0 19

struct Struct_outbytes {
Intg f_fdes;
char f_deffn[128];
char f_ioerr;
Intg f_errno;
Nat0 f_buffelems;
Char f_buff[4096];
};

extern Outbytes write_buffer_outbytes ( Outbytes x1 );

struct Struct_inbytes {

int f_fdes;
Nat0 f_elfile; /* "elems" left in file */
Char * f_currelem;
Nat0 f_buffelems;
Char f_buff[4096];
};

extern Inbytes read_buffer_inbytes ( Inbytes x1 );

struct Struct_str {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_str(x1,x2) cvlines2_vdmlib(x1,x2)

#define mk1_str_char(x1) mk1_str(x1)

struct Struct_cvtext_vdmlib {
Nat0 f_max;
Nat0 f_len;
};

struct Struct_strset {
Strset f_next;
Str f_info;

};

#define cvlines2_strset(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_operation {
Operation f_next;
Str f_info;
Str f_attr;
};

extern Cvtext_vdmlib cvlines3_operation_str_str ( Str x1, Str x2 ) ;

struct Struct_impl {
Impl f_next;
Str f_info;
Operation f_attr;
};

extern Cvtext_vdmlib cvlines3_impl_str_operation ( Str x1, Operation x2 ) ;

struct Struct_adt {
Adt f_next;
Str f_info;
Impl f_attr;
};

extern Cvtext_vdmlib cvlines3_adt_str_impl ( Str x1, Impl x2 ) ;

struct Struct_vdmdb {
Vdmdb f_next;
Str f_info;
Adt f_attr;
};

extern Cvtext_vdmlib cvlines3_vdmdb_str_adt ( Str x1, Adt x2 ) ;

struct Struct_vdmdbs {
Vdmdbs f_next;
Vdmdb f_info;

};

#define cvlines2_vdmdbs(x1,x2) cvlines2_vdmlib(x1,x2)

struct Struct_dbs {
Dbs f_next;
Str f_info;

};

#define cvlines2_dbs(x1,x2) cvlines2_vdmlib(x1,x2)

/* ------- PHASE3 ------------------ */
extern Strset alloc_strset ( void );
extern void free_strset ( Strset x1 );

#define ref_strset(x1) (x1)

#define profile_strset()

extern Operation alloc_operation ( void );
extern void free_operation ( Operation x1 );

#define ref_operation(x1) (x1)

#define profile_operation()

extern Impl alloc_impl ( void );
extern void free_impl ( Impl x1 );

#define ref_impl(x1) (x1)

#define profile_impl()

extern Vdmdb alloc_vdmdb ( void );
extern void free_vdmdb ( Vdmdb x1 );

#define ref_vdmdb(x1) (x1)

#define profile_vdmdb()

extern Vdmdbs alloc_vdmdbs ( void );
extern void free_vdmdbs ( Vdmdbs x1 );

#define ref_vdmdbs(x1) (x1)

#define profile_vdmdbs()

extern Dbs alloc_dbs ( void );
extern void free_dbs ( Dbs x1 );

#define ref_dbs(x1) (x1)

#define profile_dbs()

extern Adt alloc_adt ( void );
extern void free_adt ( Adt x1 );

#define ref_adt(x1) (x1)

#define profile_adt()

extern void err_hd_vdmlib ( char *x1 );
extern void err_tl_vdmlib ( char *x1 );
extern void err_sel_vdmlib ( Nat1 x1 , Nat0 x2 , char *x3 );
extern void err_smap_vdmlib ( char *x1 );
extern void heap_oflw_vdmlib ( char *x1 );
extern void err_elem_vdmlib ( char *x1 );
extern void err_umap_vdmlib ( char *x1 );
extern void abort_vdmlib ( Nat0 x1 );
extern Str alloc_str ( Nat0 x1 );
extern void free_str ( Str x1 );

#define ref_str(x1) (x1)

#define profile_str()

extern Outbytes mk_empty_outbytes ( void );
extern Bool fwrite_outbytes ( Outbytes x1 , Str x2 );
extern Nat0 len_inbytes ( Inbytes x1 );
extern void del_inbytes ( Inbytes x1 );
extern Inbytes fread_inbytes ( Str x1 );

extern Nat0 cvfromtup1_nat0 ( Inbytes *x1 );

extern Str cvstr_nat0 ( Nat0 x1 );
extern char * printformat_nat0;

extern void set_print_format_nat0 ( char * x1 );

extern Outbytes cvtotup1_nat0 ( Outbytes x1 , Nat0 x2 );

extern Str mkn_empty_str ( Nat0 x1 );
typedef void (* T2_forall_str) ( Char y1 ) ;
extern void forall_str ( Str x1, T2_forall_str x2 ) ;

extern Outbytes cvtotup1_str ( Outbytes x1 , Str x2 );

#ifdef __cplusplus
extern void fpr_str ( ostream & x1 , Str x2 );
#else
extern void fpr_str ( FILE *x1 , Str x2 );
#endif
extern Str mkn_str ( Char x1 , Nat0 x2 );
extern void del1_str ( Str x1 );
extern Str sub_tup_str ( Str x1 , Nat1 x2 , Nat0 x3 );
extern Cvtext_vdmlib cvlines_str ( Str x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Str mk1_str ( Char x1 );
extern Str conc_path_str ( Str x1 , Str x2 );
extern Bool is_prefix_str ( Str x1 , Str x2 );
extern Str copy_str ( Str x1 );
extern Bool fapp_str ( Str x1 , Str x2 );
extern Str mkc_str ( Char *x1 );
extern Nat0 index_str ( Str x1 , Char x2 );
extern Nat0 rindex_str ( Str x1 , Char x2 );
extern Str ovwrt1_str ( Str x1 , Nat1 x2 , Char x3 );
extern Bool is_gr_str ( Str x1 , Str x2 );
extern Str appr_str ( Str x1 , Char x2 );
#ifdef __cplusplus
extern void puts_str ( Str x1 , ostream & x2 );
#else
extern void puts_str ( Str x1 , FILE *x2 );
#endif
extern Bool is_eq_str ( Str x1 , Str x2 );
extern Str insert_str ( Str x1 , Nat1 x2 , Char x3 );
extern Str sub_tupd_str ( Str x1 , Nat1 x2 , Nat0 x3 );
extern Str fread_str ( Str x1 );
extern Str conc_str ( Str x1 , Str x2 );
extern void cpc_str ( Str x1 , Char *x2 );
extern Str mknc_str ( Char x1 , Nat0 x2 );
extern Bool fwrite_str ( Str x1 , Str x2 );
extern void del_str ( Str x1 );
extern Str copy1_str ( Str x1 );
extern Str mk_sub_tup_str ( Str x1 , Nat1 x2 , Nat0 x3 );
typedef void (* T2_forindex_str) ( Char y1, Nat1 y2 ) ;
extern void forindex_str ( Str x1, T2_forindex_str x2 ) ;

extern Str cvstr_str ( Str x1 );

extern Str cvfromtup1_str ( Inbytes *x1 );

extern Outbytes cvtotupelems_str ( Outbytes x1 , Str x2 );
typedef void (* T2_forall_cvtext_vdmlib) ( Str y1 ) ;
extern void forall_cvtext_vdmlib ( Cvtext_vdmlib x1, T2_forall_cvtext_vdmlib x2 ) ;
extern Cvtext_vdmlib mk1_cvtext_vdmlib ( Str x1 );
extern void del_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Cvtext_vdmlib ovwrt1_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 , Str x3 );
extern Cvtext_vdmlib appr_cvtext_vdmlib ( Cvtext_vdmlib x1 , Str x2 );
extern Cvtext_vdmlib conc_cvtext_vdmlib ( Cvtext_vdmlib x1 , Cvtext_vdmlib x2 );
extern void del1_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Cvtext_vdmlib alloc_cvtext_vdmlib ( Nat0 x1 );
extern void free_cvtext_vdmlib ( Cvtext_vdmlib x1 );

#define ref_cvtext_vdmlib(x1) (x1)

#define profile_cvtext_vdmlib()

extern Outbytes alloc_outbytes ( void );
extern void free_outbytes ( Outbytes x1 );

#define ref_outbytes(x1) (x1)

#define profile_outbytes()

extern Inbytes alloc_inbytes ( void );
extern void free_inbytes ( Inbytes x1 );

#define ref_inbytes(x1) (x1)

#define profile_inbytes()

extern Cvtext_vdmlib cvlines1_strset ( Strset x1 );

extern Strset union1d_strset ( Strset x1 , Str x2 );

#ifdef __cplusplus
extern void fpr_strset ( ostream & x1 , Strset x2 );
#else
extern void fpr_strset ( FILE *x1 , Strset x2 );
#endif
extern Bool is_in_strset ( Str x1 , Strset x2 );
extern void del_strset ( Strset x1 );
extern Strset sub1d_strset ( Strset x1 , Str x2 );
extern Str sel_strset ( Strset x1 );
extern Strset union1_strset ( Strset x1 , Str x2 );
extern Strset copy_strset ( Strset x1 );
extern Strset uniond_strset ( Strset x1 , Strset x2 );
extern Strset diffd_strset ( Strset x1 , Strset x2 );
extern Strset diff_strset ( Strset x1 , Strset x2 );
extern Strset mk1_strset ( Str x1 );
extern Strset sub1_strset ( Strset x1 , Str x2 );
extern Strset union_strset ( Strset x1 , Strset x2 );

extern Cvtext_vdmlib cvlines_strset ( Strset x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Outbytes cvtotupelems_operation ( Outbytes x1 , Operation x2 );

extern Outbytes cvtotup1_operation ( Outbytes x1 , Operation x2 );

extern Bool is_submap_operation ( Operation x1 , Operation x2 );
extern Bool is_eq_operation ( Operation x1 , Operation x2 );
extern Str sel_operation ( Operation x1 , Str x2 );
extern Operation ovwrt1d_operation ( Operation x1 , Str x2 , Str x3 );
extern Operation mk1_operation ( Str x1 , Str x2 );
extern void del_operation ( Operation x1 );
extern Bool is_in_dom_operation ( Str x1 , Operation x2 , Str *x3 );
extern Operation sub1d_operation ( Operation x1 , Str x2 );

extern Strset dom_operation ( Operation x1 );

extern Operation copy_operation ( Operation x1 );
extern Operation union1_operation ( Operation x1 , Str x2 , Str x3 );
extern Bool is_in_operation ( Str x1 , Operation x2 );
#ifdef __cplusplus
extern void fpr_operation ( ostream & x1 , Operation x2 );
#else
extern void fpr_operation ( FILE *x1 , Operation x2 );
#endif
extern Nat0 card_operation ( Operation x1 );
extern Cvtext_vdmlib cvlines_operation ( Operation x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Cvtext_vdmlib cvlines1_operation ( Operation x1 );

extern Operation cvfromtup1_operation ( Inbytes *x1 );

extern Outbytes cvtotupelems_impl ( Outbytes x1 , Impl x2 );

extern Outbytes cvtotup1_impl ( Outbytes x1 , Impl x2 );

extern Bool is_submap_impl ( Impl x1 , Impl x2 );
extern Bool is_eq_impl ( Impl x1 , Impl x2 );
extern Impl union1_impl ( Impl x1 , Str x2 , Operation x3 );
extern Bool is_in_impl ( Str x1 , Impl x2 );
extern void del_impl ( Impl x1 );
extern Impl copy_impl ( Impl x1 );
extern Impl sub1d_impl ( Impl x1 , Str x2 );
extern Bool is_in_dom_impl ( Str x1 , Impl x2 , Operation *x3 );

extern Strset dom_impl ( Impl x1 );

extern Impl mk1_impl ( Str x1 , Operation x2 );
extern Impl ovwrt1d_impl ( Impl x1 , Str x2 , Operation x3 );
extern Operation sel_impl ( Impl x1 , Str x2 );
#ifdef __cplusplus
extern void fpr_impl ( ostream & x1 , Impl x2 );
#else
extern void fpr_impl ( FILE *x1 , Impl x2 );
#endif
extern Nat0 card_impl ( Impl x1 );
extern Cvtext_vdmlib cvlines_impl ( Impl x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Impl cvfromtup1_impl ( Inbytes *x1 );

extern Cvtext_vdmlib cvlines1_impl ( Impl x1 );

extern Bool is_submap_adt ( Adt x1 , Adt x2 );

extern Outbytes cvtotupelems_adt ( Outbytes x1 , Adt x2 );

extern Cvtext_vdmlib cvlines1_adt ( Adt x1 );

extern Adt cvfromtup1_adt ( Inbytes *x1 );

extern Cvtext_vdmlib cvlines_adt ( Adt x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#ifdef __cplusplus
extern void fpr_adt ( ostream & x1 , Adt x2 );
#else
extern void fpr_adt ( FILE *x1 , Adt x2 );
#endif
extern Adt sub1d_adt ( Adt x1 , Str x2 );

extern Strset dom_adt ( Adt x1 );

extern Adt copy_adt ( Adt x1 );
extern Adt union1_adt ( Adt x1 , Str x2 , Impl x3 );
extern Impl sel_adt ( Adt x1 , Str x2 );
extern Bool is_in_dom_adt ( Str x1 , Adt x2 , Impl *x3 );
extern Adt ovwrt1d_adt ( Adt x1 , Str x2 , Impl x3 );
extern Adt mk1_adt ( Str x1 , Impl x2 );
extern void del_adt ( Adt x1 );
extern Bool is_in_adt ( Str x1 , Adt x2 );

extern Outbytes cvtotup1_adt ( Outbytes x1 , Adt x2 );

extern Nat0 card_adt ( Adt x1 );
extern Bool is_eq_adt ( Adt x1 , Adt x2 );

extern Cvtext_vdmlib cvlines1_vdmdb ( Vdmdb x1 );

extern Cvtext_vdmlib cvlines_vdmdb ( Vdmdb x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Nat0 card_vdmdb ( Vdmdb x1 );

extern Vdmdb cvfromtup1_vdmdb ( Inbytes *x1 );

#ifdef __cplusplus
extern void fpr_vdmdb ( ostream & x1 , Vdmdb x2 );
#else
extern void fpr_vdmdb ( FILE *x1 , Vdmdb x2 );
#endif
extern Adt sel_vdmdb ( Vdmdb x1 , Str x2 );
extern void del_vdmdb ( Vdmdb x1 );

extern Strset dom_vdmdb ( Vdmdb x1 );

extern Vdmdb sub1d_vdmdb ( Vdmdb x1 , Str x2 );
extern Vdmdb copy_vdmdb ( Vdmdb x1 );
extern Bool is_in_dom_vdmdb ( Str x1 , Vdmdb x2 , Adt *x3 );

extern Outbytes cvtotupl_vdmdb ( Vdmdb x1 );

extern Vdmdb copy1_vdmdb ( Vdmdb x1 );
extern Vdmdb ovwrt1d_vdmdb ( Vdmdb x1 , Str x2 , Adt x3 );
extern Vdmdb mk1_vdmdb ( Str x1 , Adt x2 );
extern Bool is_in_vdmdb ( Str x1 , Vdmdb x2 );

extern Outbytes cvtotup1_vdmdb ( Outbytes x1 , Vdmdb x2 );

extern Outbytes cvtotupelems_vdmdb ( Outbytes x1 , Vdmdb x2 );
extern Vdmdb union1_vdmdb ( Vdmdb x1 , Str x2 , Adt x3 );

extern Cvtext_vdmlib cvlines1_vdmdbs ( Vdmdbs x1 );

typedef void (* T2_forindex_vdmdbs) ( Vdmdb y1, Nat1 y2 ) ;
extern void forindex_vdmdbs ( Vdmdbs x1, T2_forindex_vdmdbs x2 ) ;
extern Vdmdbs conc_vdmdbs ( Vdmdbs x1 , Vdmdbs x2 );
extern Nat0 len_vdmdbs ( Vdmdbs x1 );
extern Vdmdbs copy_vdmdbs ( Vdmdbs x1 );
extern void del_vdmdbs ( Vdmdbs x1 );
extern Vdmdb sel_vdmdbs ( Vdmdbs x1 , Nat1 x2 );
extern Vdmdbs mk1_vdmdbs ( Vdmdb x1 );

extern Bool fold_exists_vdmdbs ( Vdmdbs x1 );

extern Vdmdbs copy1_vdmdbs ( Vdmdbs x1 );
#ifdef __cplusplus
extern void fpr_vdmdbs ( ostream & x1 , Vdmdbs x2 );
#else
extern void fpr_vdmdbs ( FILE *x1 , Vdmdbs x2 );
#endif
extern Vdmdbs rmv1_vdmdbs ( Vdmdbs x1 , Nat1 x2 );
extern Vdmdbs rmv1d_vdmdbs ( Vdmdbs x1 , Nat1 x2 );
extern Cvtext_vdmlib cvlines_vdmdbs ( Vdmdbs x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

extern Cvtext_vdmlib cvlines1_dbs ( Dbs x1 );

typedef void (* T2_forindex_dbs) ( Str y1, Nat1 y2 ) ;
extern void forindex_dbs ( Dbs x1, T2_forindex_dbs x2 ) ;
extern Dbs conc_dbs ( Dbs x1 , Dbs x2 );
#ifdef __cplusplus
extern void fpr_dbs ( ostream & x1 , Dbs x2 );
#else
extern void fpr_dbs ( FILE *x1 , Dbs x2 );
#endif
extern Dbs rmv1d_dbs ( Dbs x1 , Nat1 x2 );
extern Dbs mk1_dbs ( Str x1 );

extern Vdmdbs mk_tuple_dbs ( Dbs x1 );

extern Nat0 len_dbs ( Dbs x1 );
extern void del_dbs ( Dbs x1 );
extern Dbs rmv1_dbs ( Dbs x1 , Nat1 x2 );
extern Str sel_dbs ( Dbs x1 , Nat1 x2 );
extern Cvtext_vdmlib cvlines_dbs ( Dbs x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */

/* ------- PHASE4 ------------------ */
#define forall_adt(x1,x2){Adt _x1=x1;for(;_x1!=(Adt)0;_x1=_x1->f_next) x2(ref_adt(_x1)->f_info,_x1->f_attr);}
#ifdef __cplusplus
#define pr_adt(x1) fpr_adt(cout,x1)
#else
#define pr_adt(x1) fpr_adt(stdout,x1)
#endif
#define mk_empty_adt() ((Adt)0)
#define del1_adt(x1) {Adt _y1=x1;while (_y1!=(Adt)0) {Adt _x1=_y1;_y1=ref_adt(_y1)->f_next;free_adt(_x1);}}
#define is_empty_adt(x1) (! (x1))

#define len_cvtext_vdmlib(x1) (ref_cvtext_vdmlib((x1))->f_len)
#define is_empty_cvtext_vdmlib(x1) (! (ref_cvtext_vdmlib((x1))->f_len) )
#define hd_cvtext_vdmlib(x1) sel_cvtext_vdmlib(x1,(Nat1)1)
#define mk_empty_cvtext_vdmlib() alloc_cvtext_vdmlib((Nat0)0)
#define last_cvtext_vdmlib(x1) sel_cvtext_vdmlib(x1,(Nat1)(len_cvtext_vdmlib(x1)))
extern Str sel_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 );
#define copy_char(x1) x1
#define is_ge_char(x1,x2) ((x1) >= (x2))
#define is_eq_char(x1,x2) ((x1) == (x2))
#define false_bool() ((Bool)0)
#define true_bool() ((Bool)1)
#define and_bool(x1,x2) ((x1) & (x2))
#define or_bool(x1,x2) ((x1) | (x2))
#define is_eq_bool(x1,x2) ((x1) == (x2))
#define conc4_str(x1,x2,x3,x4) (conc_str(conc_str(conc_str(x1,x2),x3),x4))
#define conc5_str(x1,x2,x3,x4,x5) (conc_str(conc4_str(x1,x2,x3,x4),x5))
#define hd_str(x1) sel_str(x1,(Nat1)1)
#define mk_empty_str() alloc_str((Nat0)0)
#ifdef __cplusplus
#define pr_str(x1) fpr_str(cout,x1)
#else
#define pr_str(x1) fpr_str(stdout,x1)
#endif
extern Char sel_str ( Str x1 , Nat1 x2 );
#define appl_str(x1,x2) conc_str(mk1_str(x1),x2)
#define is_empty_str(x1) (! (ref_str((x1))->f_len) )
#define conc3_str(x1,x2,x3) (conc_str(conc_str(x1,x2),x3))
#define conc6_str(x1,x2,x3,x4,x5,x6) (conc_str(conc_str(conc4_str(x1,x2,x3,x4),x5),x6))

#define len_str(x1) (ref_str((x1))->f_len)
#define is_eq_nat0(x1,x2) ((x1) == (x2))
#define del_nat0(x1)
#define hd_inbytes(x1) *ref_inbytes(x1)->f_currelem

#define tld_inbytes(x1) (ref_inbytes(x1)->f_currelem++, (--((x1)->f_buffelems) == 0) ? read_buffer_inbytes(x1) : x1)

#define is_empty_inbytes(x1) (len_inbytes(x1) == 0)

#define appr_outbytes(x1,x2) (ref_outbytes(x1)->f_buff[ref_outbytes(x1)->f_buffelems] = x2, (++(x1->f_buffelems) == 4096) ? write_buffer_outbytes(x1) : x1)
#define del1_dbs(x1) {Dbs _y1=x1;while (_y1!=(Dbs)0) {Dbs _x1=_y1;_y1=ref_dbs(_y1)->f_next;free_dbs(_x1);}}
#define hd_dbs(x1) sel_dbs(x1,(Nat1)1)
#define tl_dbs(x1) rmv1_dbs(x1,1)
#define tld_dbs(x1) rmv1d_dbs(x1,1)
#define is_empty_dbs(x1) (! (x1))
#ifdef __cplusplus
#define pr_dbs(x1) fpr_dbs(cout,x1)
#else
#define pr_dbs(x1) fpr_dbs(stdout,x1)
#endif
#define appr_dbs(x1,x2) conc_dbs(x1,mk1_dbs(x2))
#define mk_empty_dbs() ((Dbs)0)

#define forall_dbs(x1,x2){Dbs _x1=x1;for(;_x1!=(Dbs)0;_x1=_x1->f_next) x2(ref_dbs(_x1)->f_info);}

#define forall_vdmdbs(x1,x2){Vdmdbs _x1=x1;for(;_x1!=(Vdmdbs)0;_x1=_x1->f_next) x2(ref_vdmdbs(_x1)->f_info);}
#define is_empty_vdmdbs(x1) (! (x1))
#define appl_vdmdbs(x1,x2) conc_vdmdbs(mk1_vdmdbs(x1),x2)
#define hd_vdmdbs(x1) sel_vdmdbs(x1,(Nat1)1)
#define mk_empty_vdmdbs() ((Vdmdbs)0)
#ifdef __cplusplus
#define pr_vdmdbs(x1) fpr_vdmdbs(cout,x1)
#else
#define pr_vdmdbs(x1) fpr_vdmdbs(stdout,x1)
#endif
#define del1_vdmdbs(x1) {Vdmdbs _y1=x1;while (_y1!=(Vdmdbs)0) {Vdmdbs _x1=_y1;_y1=ref_vdmdbs(_y1)->f_next;free_vdmdbs(_x1);}}
#define tl_vdmdbs(x1) rmv1_vdmdbs(x1,1)
#define tld_vdmdbs(x1) rmv1d_vdmdbs(x1,1)
#define appr_vdmdbs(x1,x2) conc_vdmdbs(x1,mk1_vdmdbs(x2))

#define forall_vdmdb(x1,x2){Vdmdb _x1=x1;for(;_x1!=(Vdmdb)0;_x1=_x1->f_next) x2(ref_vdmdb(_x1)->f_info,_x1->f_attr);}

#define cvfromtupl_vdmdb(x1) cvfromtup1_vdmdb(&x1)

#define is_empty_vdmdb(x1) (! (x1))
#ifdef __cplusplus
#define pr_vdmdb(x1) fpr_vdmdb(cout,x1)
#else
#define pr_vdmdb(x1) fpr_vdmdb(stdout,x1)
#endif
#define mk_empty_vdmdb() ((Vdmdb)0)
#define del1_vdmdb(x1) {Vdmdb _y1=x1;while (_y1!=(Vdmdb)0) {Vdmdb _x1=_y1;_y1=ref_vdmdb(_y1)->f_next;free_vdmdb(_x1);}}
#define is_empty_impl(x1) (! (x1))

#define forall_impl(x1,x2){Impl _x1=x1;for(;_x1!=(Impl)0;_x1=_x1->f_next) x2(ref_impl(_x1)->f_info,_x1->f_attr);}
#ifdef __cplusplus
#define pr_impl(x1) fpr_impl(cout,x1)
#else
#define pr_impl(x1) fpr_impl(stdout,x1)
#endif
#define mk_empty_impl() ((Impl)0)
#define del1_impl(x1) {Impl _y1=x1;while (_y1!=(Impl)0) {Impl _x1=_y1;_y1=ref_impl(_y1)->f_next;free_impl(_x1);}}
#define is_empty_operation(x1) (! (x1))

#define forall_operation(x1,x2){Operation _x1=x1;for(;_x1!=(Operation)0;_x1=_x1->f_next) x2(ref_operation(_x1)->f_info,_x1->f_attr);}
#define mk_empty_operation() ((Operation)0)
#ifdef __cplusplus
#define pr_operation(x1) fpr_operation(cout,x1)
#else
#define pr_operation(x1) fpr_operation(stdout,x1)
#endif
#define del1_operation(x1) {Operation _y1=x1;while (_y1!=(Operation)0) {Operation _x1=_y1;_y1=ref_operation(_y1)->f_next;free_operation(_x1);}}
#define del1_strset(x1) {Strset _y1=x1;while (_y1!=(Strset)0) {Strset _x1=_y1;_y1=ref_strset(_y1)->f_next;free_strset(_x1);}}
#define mk_empty_strset() ((Strset)0)

#define forall_strset(x1,x2){Strset _x1=x1;for(;_x1!=(Strset)0;_x1=_x1->f_next) x2(ref_strset(_x1)->f_info);}
#ifdef __cplusplus
#define pr_strset(x1) fpr_strset(cout,x1)
#else
#define pr_strset(x1) fpr_strset(stdout,x1)
#endif
#define is_empty_strset(x1) (! (x1))

#endif
