/*----------------------------------------------------------------------*/

/* Modul:                  $Id: genext.c,v 1.4 1996/09/07 14:12:10 vdm Exp $ */
/* Ersteller:              Gerrit Petrich, WI 8215, WS 93 */

/*----------------------------------------------------------------------*/

/* Aufgabe:   "genext.c" stellt die fuer die Fold-Funktionen aus */
/*            "gen.vdm" benoetigten Funktionen zur Verfuegung */

/*----------------------------------------------------------------------*/

#include "header.h"
#include "genext.h"          /* eigenes Headerfile */

/*----------------------------------------------------------------------*/

Adtnameset convert_to_str_adt F2(Adtname,adt_name,Adt,adt)
{
    return mk1_strset(copy_str(adt_name));
}

/*----------------------------------------------------------------------*/

Implnameset convert_to_str_impl F2(Implname,impl_name,Impl,impl)
{
    return mk1_strset(copy_str(impl_name));
}

/*----------------------------------------------------------------------*/

Opnameset convert_to_str_operation F2(Opname,op_name,Operation,op)
{
    return mk1_strset(copy_str(op_name));
}

/*----------------------------------------------------------------------*/

Compnameset convert_to_str_str F2(Compname,comp_name,Component,comp)
{
    return mk1_strset(copy_str(comp_name));
}

/*----------------------------------------------------------------------*/

Vdmdbs mk_vdmdbs_from_str F1(Vdmdbname,vdmdb_name)
{
    return mk1_vdmdbs(mk_vdmdb_from_str(vdmdb_name));
}

Vdmdb mk_vdmdb_from_str F1(Vdmdbname,vdmdb_name)
#ifdef FLAT
{
    Inbytes ib;
    Vdmdbname vn;
    Vdmdb vdb;

    vn = conc_str(copy_str(vdmdb_name),mkc_str( DEFAULT_FLAT_EXTENSION ));
    ib = fread_inbytes(vn);
    vdb = IF is_empty_inbytes(ib) THEN mk_empty_vdmdb() ELSE cvfromtupl_vdmdb(ib);

    del_str(vn);
    return vdb;
}
#else
{
    return fread_vdmdb(vdmdb_name);
}
#endif

/*----------------------------------------------------------------------*/

Bool exist_vdmdb F1(Vdmdb,vdmdb)
{
    return !is_empty_vdmdb(vdmdb);
}

/*----------------------------------------------------------------------*/
