#if __cplusplus
#include "domadt.hpp"
#else
#include "domadt.h"
#endif

/*LINTLIBRARY*/

#define C_implementation_file

/*
module generated from VDM Class Library
$Revision: 1.100 $
$Date: 1996/09/18 13:13:42 $
*/

Crossref alloc_crossref (void)
{Crossref x1; x1 = (Crossref)0;
while (! (x1 = (Crossref)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_crossref");
;
;
return x1;
}

void free_crossref (Crossref x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Rootvals alloc_rootvals (void)
{Rootvals x1; x1 = (Rootvals)0;
while (! (x1 = (Rootvals)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_rootvals");
;
;
return x1;
}

void free_rootvals (Rootvals x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Operations alloc_operations (void)
{Operations x1; x1 = (Operations)0;
while (! (x1 = (Operations)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_operations");
;
;
return x1;
}

void free_operations (Operations x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Params alloc_params (void)
{Params x1; x1 = (Params)0;
while (! (x1 = (Params)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_params");
;
;
return x1;
}

void free_params (Params x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Dependgraph alloc_dependgraph (void)
{Dependgraph x1; x1 = (Dependgraph)0;
while (! (x1 = (Dependgraph)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_dependgraph");
;
;
return x1;
}

void free_dependgraph (Dependgraph x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Depend alloc_depend (void)
{Depend x1; x1 = (Depend)0;
while (! (x1 = (Depend)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_depend");
;
;
return x1;
}

void free_depend (Depend x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Elems alloc_elems (void)
{Elems x1; x1 = (Elems)0;
while (! (x1 = (Elems)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_elems");
;
;
return x1;
}

void free_elems (Elems x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Dominfo alloc_dominfo (void)
{Dominfo x1; x1 = (Dominfo)0;
while (! (x1 = (Dominfo)ALLOCMEM_vdmlib(sizeof(*x1)))) heap_oflw_vdmlib("Heap_dominfo");
;
;
return x1;
}

void free_dominfo (Dominfo x1)
{
FREEMEM_vdmlib((VOIDptr)x1,sizeof(*x1));
;
}

Bool is_eq_info (Info x1,Info x2)
{return 1

&& is_eq_str(s_defined(x1),s_defined(x2))

&& is_eq_nat0(s_line(x1),s_line(x2))

;}
Info mk_info(

Str x1_defined
,
Nat0 x1_line

)

{Info lx1;

lx1.f_defined = x1_defined;

lx1.f_line = x1_line;

return lx1;
}

Bool is_in_dom_crossref(Str x1, Crossref x2, Info * x3)

{while (x2)
{if (is_eq_str(ref_crossref(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Crossref union1_crossref(Crossref x1, Str x2, Info x3)

{register Crossref lx1 = x1;
while (lx1)
{if (is_eq_str(ref_crossref(lx1)->f_info,x2)) {if (! is_eq_info(ref_crossref(lx1)->f_attr,x3)) err_umap_vdmlib("Crossref"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_crossref(x2,x3);
lx1->f_next = x1;
return lx1;
}

Bool is_in_crossref(Str x1, Crossref x2)

{while (x2)
{if (is_eq_str(ref_crossref(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Crossref mk1_crossref(Str x1, Info x2)

{Crossref lx1 = alloc_crossref();
lx1->f_next = (Crossref)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

Fileval mk_fileval(

Str x1_fdomain
,
Str x1_fconstr
,
Str x1_fimplid
,
Str x1_foperationid
,
Nat0 x1_lines
,
Nat0 x1_linenr

)

{Fileval lx1;

lx1.f_fdomain = x1_fdomain;

lx1.f_fconstr = x1_fconstr;

lx1.f_fimplid = x1_fimplid;

lx1.f_foperationid = x1_foperationid;

lx1.f_lines = x1_lines;

lx1.f_linenr = x1_linenr;

return lx1;
}
void del_fileval (Fileval x1)
{

del_str(s_fdomain(x1));

del_str(s_fconstr(x1));

del_str(s_fimplid(x1));

del_str(s_foperationid(x1));

del_nat0(s_lines(x1));

del_nat0(s_linenr(x1));

del1_fileval(x1);
}

Rootvals conc_rootvals (Rootvals x1,Rootvals x2)
{Rootvals * px1 = & x1;
while (*px1)
{ Rootvals lx1 = ref_rootvals(*px1);
px1 = &(lx1->f_next);
}
*px1 = x2;
return x1;
}

Nat0 len_rootvals (Rootvals x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_rootvals(x1)->f_next;}
return lx1;
}
Fileval sel_rootvals (Rootvals x1,Nat1 x2)
{
Nat0 len = 0;

while (x1)
{
if (++len == x2)
return ref_rootvals(x1)->f_info;

x1=x1->f_next;
}

err_sel_vdmlib(x2,len,"Rootvals");

return x1->f_info;
}

Rootvals mk1_rootvals(Fileval x1)

{Rootvals lx1 = alloc_rootvals();
lx1->f_next = (Rootvals)0;
lx1->f_info = x1;
return lx1;
}

static Rootvals _tt1_del_rootvals;

static void _ff1_del_rootvals(Fileval y1)

{del_fileval(y1);}

void del_rootvals(Rootvals x1)

{
{Rootvals lt1; lt1 = _tt1_del_rootvals;
{
{_tt1_del_rootvals = x1;

{
forall_rootvals(x1,_ff1_del_rootvals);
del1_rootvals(x1);
_tt1_del_rootvals = lt1;

}}}}}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines3_params_str_str
extern Cvtext_vdmlib cvlines3_params_str_str ( Str y1, Str y2    ) ;
#endif

Cvtext_vdmlib cvlines1_params(Params x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_params(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines3_params_str_str(ref_params(x1)->f_info,x1->f_attr )  );}
return lx1;
}

static Bool _rr1_is_submap_params;
static Params _tt1_is_submap_params; static Params _tt2_is_submap_params;

static void _ff1_is_submap_params(Str y1,Str y2)

{{Str z2; _rr1_is_submap_params = _rr1_is_submap_params && is_in_dom_params(y1,_tt2_is_submap_params,&z2) && is_eq_str(y2,z2);}}

Bool is_submap_params(Params x1,Params x2)

{Bool lr1; lr1 = _rr1_is_submap_params;
{Params lt1; Params lt2; lt1 = _tt1_is_submap_params; lt2 = _tt2_is_submap_params;
{
{_tt1_is_submap_params = x1; _tt2_is_submap_params = x2;

{_rr1_is_submap_params = (card_params(_tt1_is_submap_params) <= card_params(_tt2_is_submap_params));
if (_rr1_is_submap_params) forall_params(x1,_ff1_is_submap_params);

_tt1_is_submap_params = lt1; _tt2_is_submap_params = lt2;
{Bool lr2; lr2 = _rr1_is_submap_params; _rr1_is_submap_params = lr1; return lr2;}
}}}}}

Params ovwrt1d_params(Params x1, Str x2, Str x3)

{register Params lx1 = x1;
while (lx1)
{if (is_eq_str(ref_params(lx1)->f_info,x2)) {del_str(x2);del_str(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_params(x2,x3);
lx1->f_next = x1;
return lx1;
}

#ifndef ovwrt1d_params
extern Params ovwrt1d_params ( Params x1, Str x2, Str x3 );
#endif

static Params _rr1_ovwrtd_params;
static void _rf1_ovwrtd_params(Str y1, Str y2)   {_rr1_ovwrtd_params = ovwrt1d_params(_rr1_ovwrtd_params,y1,y2);}

Params ovwrtd_params (Params x1,Params x2)
{Params lr1 = _rr1_ovwrtd_params;
_rr1_ovwrtd_params = x1;
forall_params(x2,_rf1_ovwrtd_params);
del1_params(x2);
{Params lr2 = _rr1_ovwrtd_params; _rr1_ovwrtd_params = lr1; return lr2;}
}

#ifndef ovwrt1_params
extern Params ovwrt1_params ( Params x1, Str x2, Str x3 );
#endif

static Params _rr1_ovwrt_params;
static void _rf1_ovwrt_params(Str y1, Str y2)   {_rr1_ovwrt_params = ovwrt1_params(_rr1_ovwrt_params,y1,y2);}

Params ovwrt_params (Params x1,Params x2)
{Params lr1 = _rr1_ovwrt_params;
_rr1_ovwrt_params = x1;
forall_params(x2,_rf1_ovwrt_params);
del1_params(x2);
{Params lr2 = _rr1_ovwrt_params; _rr1_ovwrt_params = lr1; return lr2;}
}

Params copy_params (Params x1)
{Params x2 = (Params)0;
register Params * px2 = & x2;
while (x1)
{*px2 = alloc_params();
*(*px2) = *(ref_params(x1));
(*px2)->f_info = copy_str((*px2)->f_info); (*px2)->f_attr = copy_str((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Params sub1d_params(Params x1, Str x2)

{register Params * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_params(*lx1))->f_info,x2))
{Params lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info); del_str(lx2->f_attr);
free_params(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Params union1d_params(Params x1, Str x2, Str x3)

{register Params lx1 = x1;
while (lx1)
{if (is_eq_str(ref_params(lx1)->f_info,x2)) {if (! is_eq_str(ref_params(lx1)->f_attr,x3)) err_umap_vdmlib("Params"); del_str(x2);del_str(x3);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_params(x2,x3);
lx1->f_next = x1;
return lx1;
}

#ifndef merge1_params
extern Params merge1_params ( Params x1, Str x2, Str x3 );
#endif

static Params _rr1_merge_params;
static void _rf1_merge_params(Str y1, Str y2)   {_rr1_merge_params = merge1_params(_rr1_merge_params,y1,y2);}

Params merge_params (Params x1,Params x2)
{Params lr1 = _rr1_merge_params;
_rr1_merge_params = x1;
forall_params(x2,_rf1_merge_params);
del1_params(x2);
{Params lr2 = _rr1_merge_params; _rr1_merge_params = lr1; return lr2;}
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef is_domsubmap1_str_str
extern Bool is_domsubmap1_str_str ( Str y1, Str y2  ,Params px1  ) ;
#endif

Bool is_domsubmap_params(Params x1   ,Params px1  )

{
Bool lx1;
lx1 = true_bool();
for(;x1 ; x1=ref_params(x1)->f_next)
{lx1 = and_bool(lx1,is_domsubmap1_str_str(ref_params(x1)->f_info,x1->f_attr ,px1 )  );}
return lx1;
}

Params ovwrt1_params(Params x1, Str x2, Str x3)

{register Params lx1 = x1;
while (lx1)
{if (is_eq_str(ref_params(lx1)->f_info,x2)) {ref_params(lx1)->f_attr=x3; return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_params(x2,x3);
lx1->f_next = x1;
return lx1;
}

Str sel_params (Params x1,Str x2)
{while (x1)
{if (is_eq_str(ref_params(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Params");
return x1->f_attr;
}

Params mk1_params(Str x1, Str x2)

{Params lx1 = alloc_params();
lx1->f_next = (Params)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

Params sub1_params(Params x1, Str x2)

{register Params * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_params(*lx1))->f_info,x2))
{Params lx2 = *lx1;
*lx1 = lx2->f_next;

free_params(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Params union1_params(Params x1, Str x2, Str x3)

{register Params lx1 = x1;
while (lx1)
{if (is_eq_str(ref_params(lx1)->f_info,x2)) {if (! is_eq_str(ref_params(lx1)->f_attr,x3)) err_umap_vdmlib("Params"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_params(x2,x3);
lx1->f_next = x1;
return lx1;
}

Bool is_in_params(Str x1, Params x2)

{while (x2)
{if (is_eq_str(ref_params(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Bool is_in_dom_params(Str x1, Params x2, Str * x3)

{while (x2)
{if (is_eq_str(ref_params(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_params_str_str
extern Str gen_params_str_str ( Str y1, Str y2    ) ;
#endif

Str gen_params(Params x1     )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_params(x1)->f_next)
{lx1 = conc_str(lx1,gen_params_str_str(ref_params(x1)->f_info,x1->f_attr )  );}
return lx1;
}

static Params _tt1_del_params;

static void _ff1_del_params(Str y1,Str y2)

{del_str(y1);del_str(y2);}

void del_params(Params x1)

{
{Params lt1; lt1 = _tt1_del_params;
{
{_tt1_del_params = x1;

{
forall_params(x1,_ff1_del_params);
del1_params(x1);
_tt1_del_params = lt1;

}}}}}

#ifndef union1_params
extern Params union1_params ( Params x1, Str x2, Str x3 );
#endif

static Params _rr1_union_params;
static void _rf1_union_params(Str y1, Str y2)   {_rr1_union_params = union1_params(_rr1_union_params,y1,y2);}

Params union_params (Params x1,Params x2)
{Params lr1 = _rr1_union_params;
_rr1_union_params = x1;
forall_params(x2,_rf1_union_params);
del1_params(x2);
{Params lr2 = _rr1_union_params; _rr1_union_params = lr1; return lr2;}
}

#ifndef union1d_params
extern Params union1d_params ( Params x1, Str x2, Str x3 );
#endif

static Params _rr1_uniond_params;
static void _rf1_uniond_params(Str y1, Str y2)   {_rr1_uniond_params = union1d_params(_rr1_uniond_params,y1,y2);}

Params uniond_params (Params x1,Params x2)
{Params lr1 = _rr1_uniond_params;
_rr1_uniond_params = x1;
forall_params(x2,_rf1_uniond_params);
del1_params(x2);
{Params lr2 = _rr1_uniond_params; _rr1_uniond_params = lr1; return lr2;}
}

Bool is_eq_params (Params x1,Params x2)
{return (card_params(x1) == card_params(x2))
&& is_submap_params(x1,x2);
}

Nat0 card_params (Params x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_params(x1)->f_next;}
return lx1;
}
Cvtext_vdmlib cvlines3_params_str_str (Str x1,Str x2)
{ Cvtext_vdmlib lx1;
Cvtext_vdmlib lx2;

lx1 = cvlines_str(x1);
lx2 = cvlines_str(x2);
if ( len_cvtext_vdmlib(lx1) == 1
&& len_cvtext_vdmlib(lx2) == 1
&& len_str(hd_cvtext_vdmlib(lx1)) + len_str(hd_cvtext_vdmlib(lx2))
<= curr_linelen_vdmlib - 5
)
{ Str lx3;

lx3 = conc_str( hd_cvtext_vdmlib(lx1)
, conc_str(mkc_str(" :-> "),hd_cvtext_vdmlib(lx2))
);
del1_cvtext_vdmlib(lx1);
del1_cvtext_vdmlib(lx2);
return mk1_cvtext_vdmlib(lx3);
}
else
{ return conc_cvtext_vdmlib(lx1, ident_lines_vdmlib(lx2,mkc_str(" :-> ")));}
}

Cvtext_vdmlib cvlines_params (Params x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "[";
end_structure_vdmlib = "]";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_params(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_params(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Cvtext_vdmlib cvlines_implid (Implid x1)
{ Str x2;
if (is_opt_implid(x1,&x2))
{ return close_struct_vdmlib(ident_lines_vdmlib( cvlines_str(x2)
,mkc_str("mk_implid("))
,mkc_str(")")
,strlen("mk_implid("));
}
return mk1_cvtext_vdmlib(mkc_str("NIL"));
}
Bool is_opt_implid (Implid x1,Str * x2)
{if (x1) {*x2 = x1; return 1;}
return 0;
}
Bool is_eq_implid (Implid x1,Implid x2)
{return is_nil_implid(x1)
? is_nil_implid(x2)
: (! is_nil_implid(x2)
&& is_eq_str(s_str_implid(x1),s_str_implid(x2))
);
}
void del_implid (Implid x1)
{Str x2;
if (is_opt_implid(x1,&x2)) del_str(x2);
del1_implid(x1);
}
Implid copy_implid (Implid x1)
{Str x2;
if (is_opt_implid(x1,&x2)) return mk_opt_implid(copy_str(x2));
else return mk_nil_implid();
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_str
extern Cvtext_vdmlib cvlines_str ( Str y1    ) ;
#endif

Cvtext_vdmlib cvlines1_depend(Depend x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines_str(ref_depend(x1)->f_info )  );}
return lx1;
}

Cvtext_vdmlib cvlines_depend (Depend x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "{";
end_structure_vdmlib = "}";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_depend(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_depend(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Depend copy_depend (Depend x1)
{Depend x2 = (Depend)0;
register Depend * px2 = & x2;
while (x1)
{*px2 = alloc_depend();
*(*px2) = *(ref_depend(x1));
(*px2)->f_info = copy_str((*px2)->f_info);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

static Depend _tt1_del_depend;

static void _ff1_del_depend(Str y1)

{del_str(y1);}

void del_depend(Depend x1)

{
{Depend lt1; lt1 = _tt1_del_depend;
{
{_tt1_del_depend = x1;

{
forall_depend(x1,_ff1_del_depend);
del1_depend(x1);
_tt1_del_depend = lt1;

}}}}}

Bool is_in_depend(Str x1, Depend x2)

{while (x2)
{if (is_eq_str(ref_depend(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Depend union1_depend(Depend x1, Str x2)

{register Depend lx1 = x1;
while (lx1)
{if (is_eq_str(ref_depend(lx1)->f_info,x2)) return x1;
lx1 = lx1->f_next;
}
lx1 = mk1_depend(x2);
lx1->f_next = x1;
return lx1;
}

#ifndef sub1_depend
extern Depend sub1_depend ( Depend x1, Str x2 );
#endif

static Depend _rr1_diff_depend;
static void _rf1_diff_depend(Str y1)  {_rr1_diff_depend = sub1_depend(_rr1_diff_depend,y1);}

Depend diff_depend (Depend x1,Depend x2)
{Depend lr1 = _rr1_diff_depend;
_rr1_diff_depend = x1;
forall_depend(x2,_rf1_diff_depend);
{Depend lr2 = _rr1_diff_depend; _rr1_diff_depend = lr1; return lr2;}
}

Nat0 card_depend (Depend x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_depend(x1)->f_next;}
return lx1;
}

#ifndef sub1d_depend
extern Depend sub1d_depend ( Depend x1, Str x2 );
#endif

static Depend _rr1_diffd_depend;
static void _rf1_diffd_depend(Str y1)  {_rr1_diffd_depend = sub1d_depend(_rr1_diffd_depend,y1);}

Depend diffd_depend (Depend x1,Depend x2)
{Depend lr1 = _rr1_diffd_depend;
_rr1_diffd_depend = x1;
forall_depend(x2,_rf1_diffd_depend);
{Depend lr2 = _rr1_diffd_depend; _rr1_diffd_depend = lr1; return lr2;}
}

static Depend _rr1_intersd_depend;
static Depend _tt1_intersd_depend; static Depend _tt2_intersd_depend;

static void _ff1_intersd_depend(Str y1)

{if (is_in_depend(y1,_tt2_intersd_depend)) _rr1_intersd_depend = union1_depend(_rr1_intersd_depend,y1); else del_str(y1);}

Depend intersd_depend(Depend x1,Depend x2)

{Depend lr1; lr1 = _rr1_intersd_depend;
{Depend lt1; Depend lt2; lt1 = _tt1_intersd_depend; lt2 = _tt2_intersd_depend;
{
{_tt1_intersd_depend = x1; _tt2_intersd_depend = x2;

{_rr1_intersd_depend = mk_empty_depend();
forall_depend(x1,_ff1_intersd_depend);
del1_depend(x1);del_depend(x2);
_tt1_intersd_depend = lt1; _tt2_intersd_depend = lt2;
{Depend lr2; lr2 = _rr1_intersd_depend; _rr1_intersd_depend = lr1; return lr2;}
}}}}}

Str sel_depend (Depend x1)
{if ( !x1 )
err_elem_vdmlib("Depend");
return ref_depend(x1)->f_info;
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef is_domsub1_str
extern Bool is_domsub1_str ( Str y1    ) ;
#endif

Bool is_domsub_depend(Depend x1     )

{
Bool lx1;
lx1 = true_bool();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = and_bool(lx1,is_domsub1_str(ref_depend(x1)->f_info )  );}
return lx1;
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef is_indomforward1_str
extern Bool is_indomforward1_str ( Str y1  ,Depend px1, Dominfo px2  ) ;
#endif

Bool is_indomforward_depend(Depend x1   ,Depend px1, Dominfo px2  )

{
Bool lx1;
lx1 = true_bool();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = and_bool(lx1,is_indomforward1_str(ref_depend(x1)->f_info ,px1,px2 )  );}
return lx1;
}

#ifndef mk_empty_depend
extern Depend mk_empty_depend ( void ) ;
#endif

#ifndef union_depend
extern Depend union_depend ( Depend x1, Depend x2   ) ;
#endif

#ifndef gen_deps_str
extern Depend gen_deps_str ( Str y1  ,Dominfo px1  ) ;
#endif

Depend gen_deps_depend(Depend x1   ,Dominfo px1  )

{
Depend lx1;
lx1 = mk_empty_depend();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = union_depend(lx1,gen_deps_str(ref_depend(x1)->f_info ,px1 )  );}
return lx1;
}

#ifndef false_bool
extern Bool false_bool ( void ) ;
#endif

#ifndef or_bool
extern Bool or_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef cyclic_dep1_str
extern Bool cyclic_dep1_str ( Str y1  ,Dominfo px1  ) ;
#endif

Bool cyclic_dep_depend(Depend x1   ,Dominfo px1  )

{
Bool lx1;
lx1 = false_bool();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = or_bool(lx1,cyclic_dep1_str(ref_depend(x1)->f_info ,px1 )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

Str coll_depends_depend(Depend x1  , _T2cv_coll_depends_depend Pvcvfct   )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = conc_str(lx1,(*Pvcvfct)(ref_depend(x1)->f_info )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_depend_str
extern Str gen_depend_str ( Str y1  ,Str px1  ) ;
#endif

Str gen_depend(Depend x1   ,Str px1  )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = conc_str(lx1,gen_depend_str(ref_depend(x1)->f_info ,px1 )  );}
return lx1;
}

static Bool _rr1_is_subset_depend;
static Depend _tt1_is_subset_depend; static Depend _tt2_is_subset_depend;

static void _ff1_is_subset_depend(Str y1)

{_rr1_is_subset_depend = _rr1_is_subset_depend && is_in_depend(y1,_tt2_is_subset_depend);}

Bool is_subset_depend(Depend x1,Depend x2)

{Bool lr1; lr1 = _rr1_is_subset_depend;
{Depend lt1; Depend lt2; lt1 = _tt1_is_subset_depend; lt2 = _tt2_is_subset_depend;
{
{_tt1_is_subset_depend = x1; _tt2_is_subset_depend = x2;

{_rr1_is_subset_depend = (card_depend(_tt1_is_subset_depend) <= card_depend(_tt2_is_subset_depend));
if (_rr1_is_subset_depend) forall_depend(x1,_ff1_is_subset_depend);

_tt1_is_subset_depend = lt1; _tt2_is_subset_depend = lt2;
{Bool lr2; lr2 = _rr1_is_subset_depend; _rr1_is_subset_depend = lr1; return lr2;}
}}}}}

Depend mk1_depend(Str x1)

{Depend lx1 = alloc_depend();
lx1->f_next = (Depend)0;
lx1->f_info = x1;
return lx1;
}

Depend sub1_depend(Depend x1, Str x2)

{register Depend * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_depend(*lx1))->f_info,x2))
{Depend lx2 = *lx1;
*lx1 = lx2->f_next;

free_depend(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef make_print_depend1_str
extern Str make_print_depend1_str ( Str y1    ) ;
#endif

Str make_print_depend(Depend x1     )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = conc_str(lx1,make_print_depend1_str(ref_depend(x1)->f_info )  );}
return lx1;
}

#ifndef false_bool
extern Bool false_bool ( void ) ;
#endif

#ifndef or_bool
extern Bool or_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef gen_order1_str
extern Bool gen_order1_str ( Str y1  ,Dominfo px1  ) ;
#endif

Bool gen_order1_depend(Depend x1   ,Dominfo px1  )

{
Bool lx1;
lx1 = false_bool();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = or_bool(lx1,gen_order1_str(ref_depend(x1)->f_info ,px1 )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef tofile_str
extern Str tofile_str ( Str y1    ) ;
#endif

Str tofile_depend(Depend x1     )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = conc_str(lx1,tofile_str(ref_depend(x1)->f_info )  );}
return lx1;
}

#ifndef false_bool
extern Bool false_bool ( void ) ;
#endif

#ifndef or_bool
extern Bool or_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef gen_order2_str
extern Bool gen_order2_str ( Str y1  ,Dominfo px1  ) ;
#endif

Bool gen_order2_depend(Depend x1   ,Dominfo px1  )

{
Bool lx1;
lx1 = false_bool();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = or_bool(lx1,gen_order2_str(ref_depend(x1)->f_info ,px1 )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef coll_includes_str
extern Str coll_includes_str ( Str y1  ,Str px1  ) ;
#endif

Str coll_includes_depend(Depend x1   ,Str px1  )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_depend(x1)->f_next)
{lx1 = conc_str(lx1,coll_includes_str(ref_depend(x1)->f_info ,px1 )  );}
return lx1;
}

static Elems _rr1_sort_depend;
static Depend _tt1_sort_depend; static Nat0 _ll1_sort_depend;

static void _ff1_sort_depend(Str y1)

{{ Nat1 i = 1; while ( i <= _ll1_sort_depend && is_gr_str(y1,sel_elems(_rr1_sort_depend,i)) ) i++; _rr1_sort_depend = insert_elems(_rr1_sort_depend,i,copy_str(y1)); _ll1_sort_depend++; }}

Elems sort_depend(Depend x1)

{Elems lr1; lr1 = _rr1_sort_depend;
{Depend lt1; lt1 = _tt1_sort_depend;
{Nat0 ll1; ll1 = _ll1_sort_depend;
{_tt1_sort_depend = x1;
_ll1_sort_depend = 0;
{_rr1_sort_depend = mk_empty_elems();
forall_depend(x1,_ff1_sort_depend);

_tt1_sort_depend = lt1; _ll1_sort_depend = ll1;
{Elems lr2; lr2 = _rr1_sort_depend; _rr1_sort_depend = lr1; return lr2;}
}}}}}

Depend copy1_depend (Depend x1)
{Depend x2 = (Depend)0;
register Depend * px2 = & x2;
while (x1)
{*px2 = alloc_depend();
*(*px2) = *(ref_depend(x1));

px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

#ifndef union1_depend
extern Depend union1_depend ( Depend x1, Str x2 );
#endif

static Depend _rr1_union_depend;
static void _rf1_union_depend(Str y1)  {_rr1_union_depend = union1_depend(_rr1_union_depend,y1);}

Depend union_depend (Depend x1,Depend x2)
{Depend lr1 = _rr1_union_depend;
_rr1_union_depend = x1;
forall_depend(x2,_rf1_union_depend);
del1_depend(x2);
{Depend lr2 = _rr1_union_depend; _rr1_union_depend = lr1; return lr2;}
}

#ifdef __cplusplus
void fpr_depend (ostream & x1,Depend x2)
#else
void fpr_depend (FILE * x1,Depend x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_depend(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

#ifndef union1d_depend
extern Depend union1d_depend ( Depend x1, Str x2 );
#endif

static Depend _rr1_uniond_depend;
static void _rf1_uniond_depend(Str y1)  {_rr1_uniond_depend = union1d_depend(_rr1_uniond_depend,y1);}

Depend uniond_depend (Depend x1,Depend x2)
{Depend lr1 = _rr1_uniond_depend;
_rr1_uniond_depend = x1;
forall_depend(x2,_rf1_uniond_depend);
del1_depend(x2);
{Depend lr2 = _rr1_uniond_depend; _rr1_uniond_depend = lr1; return lr2;}
}

Bool is_eq_depend (Depend x1,Depend x2)
{return (card_depend(x1) == card_depend(x2))
&& is_subset_depend(x1,x2);
}

Depend sub1d_depend(Depend x1, Str x2)

{register Depend * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_depend(*lx1))->f_info,x2))
{Depend lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info);
free_depend(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Depend union1d_depend(Depend x1, Str x2)

{register Depend lx1 = x1;
while (lx1)
{if (is_eq_str(ref_depend(lx1)->f_info,x2)) {del_str(x2);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_depend(x2);
lx1->f_next = x1;
return lx1;
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_str
extern Cvtext_vdmlib cvlines_str ( Str y1    ) ;
#endif

Cvtext_vdmlib cvlines1_elems(Elems x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines_str(ref_elems(x1)->f_info )  );}
return lx1;
}

static Bool _rr1_is_eq_elems;
static Elems _tt1_is_eq_elems; static Elems _tt2_is_eq_elems; static Nat1 _ll1_is_eq_elems;

static void _ff1_is_eq_elems(Str y1)

{if (_rr1_is_eq_elems) _rr1_is_eq_elems = is_eq_str(y1,sel_elems(_tt2_is_eq_elems,(Nat1)(_ll1_is_eq_elems++)));}

Bool is_eq_elems(Elems x1,Elems x2)

{Bool lr1; lr1 = _rr1_is_eq_elems;
{Elems lt1; Elems lt2; lt1 = _tt1_is_eq_elems; lt2 = _tt2_is_eq_elems;
{Nat1 ll1; ll1 = _ll1_is_eq_elems;
{_tt1_is_eq_elems = x1; _tt2_is_eq_elems = x2;
_ll1_is_eq_elems = 1;
{_rr1_is_eq_elems = (Bool)(len_elems(x1) == len_elems(x2));
if (_rr1_is_eq_elems) forall_elems(x1,_ff1_is_eq_elems);

_tt1_is_eq_elems = lt1; _tt2_is_eq_elems = lt2; _ll1_is_eq_elems = ll1;
{Bool lr2; lr2 = _rr1_is_eq_elems; _rr1_is_eq_elems = lr1; return lr2;}
}}}}}

Elems copy1_elems (Elems x1)
{Elems x2 = (Elems)0;
register Elems * px2 = & x2;
while (x1)
{*px2 = alloc_elems();
*(*px2) = *(ref_elems(x1));

px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Elems insert_elems (Elems x1,Nat1 x2,Str x3)
{ Nat0 lx1 = len_elems(x1);
Elems lx2 = copy1_elems(x1);

if (x2 > lx1 + 1) err_sel_vdmlib(x2,lx1,"Elems");
return conc_elems(appr_elems(sub_tup_elems(lx2,1,x2-1)
,x3)
,sub_tup_elems(x1,x2,lx1));
}

static Elems _rr1_rmv1d_elems;
static Elems _tt1_rmv1d_elems; static Nat1 _tt2_rmv1d_elems;

static void _ff1_rmv1d_elems(Str y1,Nat1 y2)

{if (y2 == _tt2_rmv1d_elems) del_str(y1); else _rr1_rmv1d_elems = appr_elems(_rr1_rmv1d_elems,y1);}

Elems rmv1d_elems(Elems x1,Nat1 x2)

{Elems lr1; lr1 = _rr1_rmv1d_elems;
{Elems lt1; Nat1 lt2; lt1 = _tt1_rmv1d_elems; lt2 = _tt2_rmv1d_elems;
{
{_tt1_rmv1d_elems = x1; _tt2_rmv1d_elems = x2;

{_rr1_rmv1d_elems = mk_empty_elems();
forindex_elems(x1,_ff1_rmv1d_elems);
del1_elems(x1);
_tt1_rmv1d_elems = lt1; _tt2_rmv1d_elems = lt2;
{Elems lr2; lr2 = _rr1_rmv1d_elems; _rr1_rmv1d_elems = lr1; return lr2;}
}}}}}

#ifndef mk_empty_depend
extern Depend mk_empty_depend ( void ) ;
#endif

#ifndef uniond_depend
extern Depend uniond_depend ( Depend x1, Depend x2   ) ;
#endif

#ifndef elems_elems_str
extern Depend elems_elems_str ( Str y1    ) ;
#endif

Depend elems_elems(Elems x1     )

{
Depend lx1;
lx1 = mk_empty_depend();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = uniond_depend(lx1,elems_elems_str(ref_elems(x1)->f_info )  );}
return lx1;
}

Elems copy_elems (Elems x1)
{Elems x2 = (Elems)0;
register Elems * px2 = & x2;
while (x1)
{*px2 = alloc_elems();
*(*px2) = *(ref_elems(x1));
(*px2)->f_info = copy_str((*px2)->f_info);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

static Nat0 _rr1_index_elems;
static Elems _tt1_index_elems; static Str _tt2_index_elems;

static void _ff1_index_elems(Str y1,Nat1 y2)

{if ((_rr1_index_elems == 0) && is_eq_str(y1,_tt2_index_elems)) _rr1_index_elems = y2;}

Nat0 index_elems(Elems x1,Str x2)

{Nat0 lr1; lr1 = _rr1_index_elems;
{Elems lt1; Str lt2; lt1 = _tt1_index_elems; lt2 = _tt2_index_elems;
{
{_tt1_index_elems = x1; _tt2_index_elems = x2;

{_rr1_index_elems = 0;
forindex_elems(x1,_ff1_index_elems);

_tt1_index_elems = lt1; _tt2_index_elems = lt2;
{Nat0 lr2; lr2 = _rr1_index_elems; _rr1_index_elems = lr1; return lr2;}
}}}}}

#ifndef mk_empty_params
extern Params mk_empty_params ( void ) ;
#endif

#ifndef union_params
extern Params union_params ( Params x1, Params x2   ) ;
#endif

#ifndef get_tree_str
extern Params get_tree_str ( Str y1 ,Nat0 yi ,Str px1  ) ;
#endif

Params get_tree_elems(Elems x1   ,Str px1  )

{ Nat0 yi = 1;
Params lx1;
lx1 = mk_empty_params();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = union_params(lx1,get_tree_str(ref_elems(x1)->f_info ,yi++ ,px1 )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_tree_str
extern Str gen_tree_str ( Str y1 ,Nat0 yi ,Str px1  ) ;
#endif

Str gen_tree_elems(Elems x1   ,Str px1  )

{ Nat0 yi = 1;
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = conc_str(lx1,gen_tree_str(ref_elems(x1)->f_info ,yi++ ,px1 )  );}
return lx1;
}

#ifndef mk_empty_depend
extern Depend mk_empty_depend ( void ) ;
#endif

#ifndef union_depend
extern Depend union_depend ( Depend x1, Depend x2   ) ;
#endif

#ifndef get_unique_elems1_str
extern Depend get_unique_elems1_str ( Str y1 ,Nat0 yi ,Str px1  ) ;
#endif

Depend get_unique_elems(Elems x1   ,Str px1  )

{ Nat0 yi = 1;
Depend lx1;
lx1 = mk_empty_depend();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = union_depend(lx1,get_unique_elems1_str(ref_elems(x1)->f_info ,yi++ ,px1 )  );}
return lx1;
}

#ifndef mk_empty_dominfo
extern Dominfo mk_empty_dominfo ( void ) ;
#endif

#ifndef merge_dominfo
extern Dominfo merge_dominfo ( Dominfo x1, Dominfo x2   ) ;
#endif

#ifndef mk_sig_dominfo_str
extern Dominfo mk_sig_dominfo_str ( Str y1  ,Elems px1, Elems px2, Str px3  ) ;
#endif

Dominfo mk_sig_dominfo_elems(Elems x1   ,Elems px1, Elems px2, Str px3  )

{
Dominfo lx1;
lx1 = mk_empty_dominfo();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = merge_dominfo(lx1,mk_sig_dominfo_str(ref_elems(x1)->f_info ,px1,px2,px3 )  );}
return lx1;
}

#ifndef mk_empty_depend
extern Depend mk_empty_depend ( void ) ;
#endif

#ifndef union_depend
extern Depend union_depend ( Depend x1, Depend x2   ) ;
#endif

#ifndef get_elems1_str
extern Depend get_elems1_str ( Str y1 ,Nat0 yi ,Str px1  ) ;
#endif

Depend get_elems(Elems x1   ,Str px1  )

{ Nat0 yi = 1;
Depend lx1;
lx1 = mk_empty_depend();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = union_depend(lx1,get_elems1_str(ref_elems(x1)->f_info ,yi++ ,px1 )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_fct_str
extern Str gen_fct_str ( Str y1 ,Nat0 yi ,Nat0 px1  ) ;
#endif

Str gen_fct_elems(Elems x1   ,Nat0 px1  )

{ Nat0 yi = 1;
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = conc_str(lx1,gen_fct_str(ref_elems(x1)->f_info ,yi++ ,px1 )  );}
return lx1;
}

#ifndef mk_empty_params
extern Params mk_empty_params ( void ) ;
#endif

#ifndef union_params
extern Params union_params ( Params x1, Params x2   ) ;
#endif

#ifndef get_fct_str
extern Params get_fct_str ( Str y1 ,Nat0 yi ,Nat1 px1  ) ;
#endif

Params get_fct_elems(Elems x1   ,Nat1 px1  )

{ Nat0 yi = 1;
Params lx1;
lx1 = mk_empty_params();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = union_params(lx1,get_fct_str(ref_elems(x1)->f_info ,yi++ ,px1 )  );}
return lx1;
}

Elems sub_tupd_elems (Elems x1,Nat1 x2,Nat0 x3)
{Elems lx1 = mk_empty_elems();
Nat0 lx2 = len_elems(x1);
Nat0 lx3 = x2;
if (lx2 < x3)
x3 = lx2;
while (lx3 <= x3)
lx1 = appr_elems(lx1,sel_elems(x1,lx3++));
{ Nat0 i=1; while (i != x2 ) del_str(sel_elems(x1,(i++))); } { Nat0 i=x3; while (i != lx2) del_str(sel_elems(x1,(++i))); }
del1_elems(x1);
return lx1;
}

Elems mk1_elems(Str x1)

{Elems lx1 = alloc_elems();
lx1->f_next = (Elems)0;
lx1->f_info = x1;
return lx1;
}

Elems conc_elems (Elems x1,Elems x2)
{Elems * px1 = & x1;
while (*px1)
{ Elems lx1 = ref_elems(*px1);
px1 = &(lx1->f_next);
}
*px1 = x2;
return x1;
}

static Elems _tt1_del_elems;

static void _ff1_del_elems(Str y1)

{del_str(y1);}

void del_elems(Elems x1)

{
{Elems lt1; lt1 = _tt1_del_elems;
{
{_tt1_del_elems = x1;

{
forall_elems(x1,_ff1_del_elems);
del1_elems(x1);
_tt1_del_elems = lt1;

}}}}}

Str sel_elems (Elems x1,Nat1 x2)
{
Nat0 len = 0;

while (x1)
{
if (++len == x2)
return ref_elems(x1)->f_info;

x1=x1->f_next;
}

err_sel_vdmlib(x2,len,"Elems");

return x1->f_info;
}

#ifndef mk_empty_params
extern Params mk_empty_params ( void ) ;
#endif

#ifndef union_params
extern Params union_params ( Params x1, Params x2   ) ;
#endif

#ifndef get_union_str
extern Params get_union_str ( Str y1 ,Nat0 yi   ) ;
#endif

Params get_union_elems(Elems x1     )

{ Nat0 yi = 1;
Params lx1;
lx1 = mk_empty_params();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = union_params(lx1,get_union_str(ref_elems(x1)->f_info ,yi++ )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_union_str
extern Str gen_union_str ( Str y1 ,Nat0 yi ,Str px1  ) ;
#endif

Str gen_union_elems(Elems x1   ,Str px1  )

{ Nat0 yi = 1;
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = conc_str(lx1,gen_union_str(ref_elems(x1)->f_info ,yi++ ,px1 )  );}
return lx1;
}

#ifndef mk_empty_depend
extern Depend mk_empty_depend ( void ) ;
#endif

#ifndef union_depend
extern Depend union_depend ( Depend x1, Depend x2   ) ;
#endif

#ifndef make1_str
extern Depend make1_str ( Str y1    ) ;
#endif

Depend make_elems(Elems x1     )

{
Depend lx1;
lx1 = mk_empty_depend();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = union_depend(lx1,make1_str(ref_elems(x1)->f_info )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef make_cyc_str
extern Str make_cyc_str ( Str y1    ) ;
#endif

Str make_cyc_elems(Elems x1     )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = conc_str(lx1,make_cyc_str(ref_elems(x1)->f_info )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_tokuni_str
extern Str gen_tokuni_str ( Str y1 ,Nat0 yi ,Nat0 px1  ) ;
#endif

Str gen_tokuni_elems(Elems x1   ,Nat0 px1  )

{ Nat0 yi = 1;
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = conc_str(lx1,gen_tokuni_str(ref_elems(x1)->f_info ,yi++ ,px1 )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef get_tokuni_str
extern Str get_tokuni_str ( Str y1 ,Nat0 yi ,Nat1 px1  ) ;
#endif

Str get_tokuni_elems(Elems x1   ,Nat1 px1  )

{ Nat0 yi = 1;
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_elems(x1)->f_next)
{lx1 = conc_str(lx1,get_tokuni_str(ref_elems(x1)->f_info ,yi++ ,px1 )  );}
return lx1;
}

Nat0 len_elems (Elems x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_elems(x1)->f_next;}
return lx1;
}

#ifdef __cplusplus
void fpr_elems (ostream & x1,Elems x2)
#else
void fpr_elems (FILE * x1,Elems x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_elems(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

static Elems _tt1_forindex_elems; static T2_forindex_elems _tt2_forindex_elems; static Nat1 _ll1_forindex_elems;

static void _ff1_forindex_elems(Str y1)

{(*_tt2_forindex_elems)(y1,_ll1_forindex_elems++);}

void forindex_elems(Elems x1,T2_forindex_elems x2)

{
{Elems lt1; T2_forindex_elems lt2; lt1 = _tt1_forindex_elems; lt2 = _tt2_forindex_elems;
{Nat1 ll1; ll1 = _ll1_forindex_elems;
{_tt1_forindex_elems = x1; _tt2_forindex_elems = x2;
_ll1_forindex_elems = 1;
{
forall_elems(x1,_ff1_forindex_elems);

_tt1_forindex_elems = lt1; _tt2_forindex_elems = lt2; _ll1_forindex_elems = ll1;

}}}}}

Cvtext_vdmlib cvlines_elems (Elems x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_elems(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_elems(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Elems sub_tup_elems (Elems x1,Nat1 x2,Nat0 x3)
{Elems lx1 = mk_empty_elems();
Nat0 lx2 = len_elems(x1);
Nat0 lx3 = x2;
if (lx2 < x3)
x3 = lx2;
while (lx3 <= x3)
lx1 = appr_elems(lx1,sel_elems(x1,lx3++));

del1_elems(x1);
return lx1;
}

#ifndef cvlines_str
extern Cvtext_vdmlib cvlines_str ( Str x1   );
#endif
#ifndef cvlines_elems
extern Cvtext_vdmlib cvlines_elems ( Elems x1   );
#endif
#ifndef cvlines_depend
extern Cvtext_vdmlib cvlines_depend ( Depend x1   );
#endif

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

Cvtext_vdmlib cvlines1_domain(Domain x1   )

{Cvtext_vdmlib lr1 = mk_empty_cvtext_vdmlib();

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_str(s_constr(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_elems(s_elems(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_depend(s_depend(x1)  )  );

return lr1;
}

Bool is_eq_domain (Domain x1,Domain x2)
{return 1

&& is_eq_str(s_constr(x1),s_constr(x2))

&& is_eq_elems(s_elems(x1),s_elems(x2))

&& is_eq_depend(s_depend(x1),s_depend(x2))

;}
Domain mk_domain(

Str x1_constr
,
Elems x1_elems
,
Depend x1_depend

)

{Domain lx1;

lx1.f_constr = x1_constr;

lx1.f_elems = x1_elems;

lx1.f_depend = x1_depend;

return lx1;
}
void smk_domain(
Domain x1,

Str * x1_constr
,
Elems * x1_elems
,
Depend * x1_depend

)

{

(* x1_constr) = s_constr(x1);

(* x1_elems) = s_elems(x1);

(* x1_depend) = s_depend(x1);

}
void del_domain (Domain x1)
{

del_str(s_constr(x1));

del_elems(s_elems(x1));

del_depend(s_depend(x1));

del1_domain(x1);
}
Domain copy_domain (Domain x1)
{

x1.f_constr = copy_str(x1.f_constr);

x1.f_elems = copy_elems(x1.f_elems);

x1.f_depend = copy_depend(x1.f_depend);

return x1;
}

Cvtext_vdmlib cvlines_domain (Domain x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "mk_domain(";
end_structure_vdmlib = ")";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (0)
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_domain(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines3_operations_str_params
extern Cvtext_vdmlib cvlines3_operations_str_params ( Str y1, Params y2    ) ;
#endif

Cvtext_vdmlib cvlines1_operations(Operations x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_operations(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines3_operations_str_params(ref_operations(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Operations copy_operations (Operations x1)
{Operations x2 = (Operations)0;
register Operations * px2 = & x2;
while (x1)
{*px2 = alloc_operations();
*(*px2) = *(ref_operations(x1));
(*px2)->f_info = copy_str((*px2)->f_info); (*px2)->f_attr = copy_params((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

static Operations _tt1_del_operations;

static void _ff1_del_operations(Str y1,Params y2)

{del_str(y1);del_params(y2);}

void del_operations(Operations x1)

{
{Operations lt1; lt1 = _tt1_del_operations;
{
{_tt1_del_operations = x1;

{
forall_operations(x1,_ff1_del_operations);
del1_operations(x1);
_tt1_del_operations = lt1;

}}}}}

Operations sub1_operations(Operations x1, Str x2)

{register Operations * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_operations(*lx1))->f_info,x2))
{Operations lx2 = *lx1;
*lx1 = lx2->f_next;

free_operations(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Bool is_in_dom_operations(Str x1, Operations x2, Params * x3)

{while (x2)
{if (is_eq_str(ref_operations(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Operations sub1d_operations(Operations x1, Str x2)

{register Operations * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_operations(*lx1))->f_info,x2))
{Operations lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info); del_params(lx2->f_attr);
free_operations(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Operations union1d_operations(Operations x1, Str x2, Params x3)

{register Operations lx1 = x1;
while (lx1)
{if (is_eq_str(ref_operations(lx1)->f_info,x2)) {if (! is_eq_params(ref_operations(lx1)->f_attr,x3)) err_umap_vdmlib("Operations"); del_str(x2);del_params(x3);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_operations(x2,x3);
lx1->f_next = x1;
return lx1;
}

Params sel_operations (Operations x1,Str x2)
{while (x1)
{if (is_eq_str(ref_operations(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Operations");
return x1->f_attr;
}

#ifndef update_alias1_operations
extern Operations update_alias1_operations ( Operations x1, Str x2, Params x3 );
#endif

static Operations _rr1_update_alias_operations;
static void _rf1_update_alias_operations(Str y1, Params y2)   {_rr1_update_alias_operations = update_alias1_operations(_rr1_update_alias_operations,y1,y2);}

Operations update_alias_operations (Operations x1,Operations x2)
{Operations lr1 = _rr1_update_alias_operations;
_rr1_update_alias_operations = x1;
forall_operations(x2,_rf1_update_alias_operations);
del1_operations(x2);
{Operations lr2 = _rr1_update_alias_operations; _rr1_update_alias_operations = lr1; return lr2;}
}

#ifndef select_constructor1_operations
extern Operations select_constructor1_operations ( Operations x1, Str x2, Params x3 );
#endif

static Operations _rr1_select_constructors_operations;
static void _rf1_select_constructors_operations(Str y1, Params y2)   {_rr1_select_constructors_operations = select_constructor1_operations(_rr1_select_constructors_operations,y1,y2);}

Operations select_constructors_operations (Operations x1,Operations x2)
{Operations lr1 = _rr1_select_constructors_operations;
_rr1_select_constructors_operations = x1;
forall_operations(x2,_rf1_select_constructors_operations);
{Operations lr2 = _rr1_select_constructors_operations; _rr1_select_constructors_operations = lr1; return lr2;}
}

Operations ovwrt1d_operations(Operations x1, Str x2, Params x3)

{register Operations lx1 = x1;
while (lx1)
{if (is_eq_str(ref_operations(lx1)->f_info,x2)) {del_str(x2);del_params(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_operations(x2,x3);
lx1->f_next = x1;
return lx1;
}

Operations mk1_operations(Str x1, Params x2)

{Operations lx1 = alloc_operations();
lx1->f_next = (Operations)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

Operations copy1_operations (Operations x1)
{Operations x2 = (Operations)0;
register Operations * px2 = & x2;
while (x1)
{*px2 = alloc_operations();
*(*px2) = *(ref_operations(x1));

px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

static Operations _rr1_subd_operations;
static Operations _tt1_subd_operations; static Operations _tt2_subd_operations;

static void _ff1_subd_operations(Str y1,Params y2)

{_rr1_subd_operations = sub1d_operations(_rr1_subd_operations,y1);}

Operations subd_operations(Operations x1,Operations x2)

{Operations lr1; lr1 = _rr1_subd_operations;
{Operations lt1; Operations lt2; lt1 = _tt1_subd_operations; lt2 = _tt2_subd_operations;
{
{_tt1_subd_operations = x1; _tt2_subd_operations = x2;

{_rr1_subd_operations = x1;
forall_operations(x2,_ff1_subd_operations);

_tt1_subd_operations = lt1; _tt2_subd_operations = lt2;
{Operations lr2; lr2 = _rr1_subd_operations; _rr1_subd_operations = lr1; return lr2;}
}}}}}

#ifndef merge1_operations
extern Operations merge1_operations ( Operations x1, Str x2, Params x3 );
#endif

static Operations _rr1_merge_operations;
static void _rf1_merge_operations(Str y1, Params y2)   {_rr1_merge_operations = merge1_operations(_rr1_merge_operations,y1,y2);}

Operations merge_operations (Operations x1,Operations x2)
{Operations lr1 = _rr1_merge_operations;
_rr1_merge_operations = x1;
forall_operations(x2,_rf1_merge_operations);
del1_operations(x2);
{Operations lr2 = _rr1_merge_operations; _rr1_merge_operations = lr1; return lr2;}
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_operations_str_params
extern Str gen_operations_str_params ( Str y1, Params y2    ) ;
#endif

Str gen_operations(Operations x1     )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_operations(x1)->f_next)
{lx1 = conc_str(lx1,gen_operations_str_params(ref_operations(x1)->f_info,x1->f_attr )  );}
return lx1;
}

static Bool _rr1_is_submap_operations;
static Operations _tt1_is_submap_operations; static Operations _tt2_is_submap_operations;

static void _ff1_is_submap_operations(Str y1,Params y2)

{{Params z2; _rr1_is_submap_operations = _rr1_is_submap_operations && is_in_dom_operations(y1,_tt2_is_submap_operations,&z2) && is_eq_params(y2,z2);}}

Bool is_submap_operations(Operations x1,Operations x2)

{Bool lr1; lr1 = _rr1_is_submap_operations;
{Operations lt1; Operations lt2; lt1 = _tt1_is_submap_operations; lt2 = _tt2_is_submap_operations;
{
{_tt1_is_submap_operations = x1; _tt2_is_submap_operations = x2;

{_rr1_is_submap_operations = (card_operations(_tt1_is_submap_operations) <= card_operations(_tt2_is_submap_operations));
if (_rr1_is_submap_operations) forall_operations(x1,_ff1_is_submap_operations);

_tt1_is_submap_operations = lt1; _tt2_is_submap_operations = lt2;
{Bool lr2; lr2 = _rr1_is_submap_operations; _rr1_is_submap_operations = lr1; return lr2;}
}}}}}

static Operations _rr1_sub_operations;
static Operations _tt1_sub_operations; static Operations _tt2_sub_operations;

static void _ff1_sub_operations(Str y1,Params y2)

{_rr1_sub_operations = sub1_operations(_rr1_sub_operations,y1);}

Operations sub_operations(Operations x1,Operations x2)

{Operations lr1; lr1 = _rr1_sub_operations;
{Operations lt1; Operations lt2; lt1 = _tt1_sub_operations; lt2 = _tt2_sub_operations;
{
{_tt1_sub_operations = x1; _tt2_sub_operations = x2;

{_rr1_sub_operations = x1;
forall_operations(x2,_ff1_sub_operations);

_tt1_sub_operations = lt1; _tt2_sub_operations = lt2;
{Operations lr2; lr2 = _rr1_sub_operations; _rr1_sub_operations = lr1; return lr2;}
}}}}}

Nat0 card_operations (Operations x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_operations(x1)->f_next;}
return lx1;
}
Bool is_eq_operations (Operations x1,Operations x2)
{return (card_operations(x1) == card_operations(x2))
&& is_submap_operations(x1,x2);
}
Cvtext_vdmlib cvlines3_operations_str_params (Str x1,Params x2)
{ Cvtext_vdmlib lx1;
Cvtext_vdmlib lx2;

lx1 = cvlines_str(x1);
lx2 = cvlines_params(x2);
if ( len_cvtext_vdmlib(lx1) == 1
&& len_cvtext_vdmlib(lx2) == 1
&& len_str(hd_cvtext_vdmlib(lx1)) + len_str(hd_cvtext_vdmlib(lx2))
<= curr_linelen_vdmlib - 5
)
{ Str lx3;

lx3 = conc_str( hd_cvtext_vdmlib(lx1)
, conc_str(mkc_str(" :-> "),hd_cvtext_vdmlib(lx2))
);
del1_cvtext_vdmlib(lx1);
del1_cvtext_vdmlib(lx2);
return mk1_cvtext_vdmlib(lx3);
}
else
{ return conc_cvtext_vdmlib(lx1, ident_lines_vdmlib(lx2,mkc_str(" :-> ")));}
}

Cvtext_vdmlib cvlines_operations (Operations x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "[";
end_structure_vdmlib = "]";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_operations(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_operations(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

#ifndef cvlines_implid
extern Cvtext_vdmlib cvlines_implid ( Implid x1   );
#endif
#ifndef cvlines_params
extern Cvtext_vdmlib cvlines_params ( Params x1   );
#endif
#ifndef cvlines_operations
extern Cvtext_vdmlib cvlines_operations ( Operations x1   );
#endif

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

Cvtext_vdmlib cvlines1_implementation(Implementation x1   )

{Cvtext_vdmlib lr1 = mk_empty_cvtext_vdmlib();

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_implid(s_implid(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_params(s_iparams(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_operations(s_operations(x1)  )  );

return lr1;
}

Bool is_eq_implementation (Implementation x1,Implementation x2)
{return 1

&& is_eq_implid(s_implid(x1),s_implid(x2))

&& is_eq_params(s_iparams(x1),s_iparams(x2))

&& is_eq_operations(s_operations(x1),s_operations(x2))

;}
Implementation mk_implementation(

Implid x1_implid
,
Params x1_iparams
,
Operations x1_operations

)

{Implementation lx1;

lx1.f_implid = x1_implid;

lx1.f_iparams = x1_iparams;

lx1.f_operations = x1_operations;

return lx1;
}
void smk_implementation(
Implementation x1,

Implid * x1_implid
,
Params * x1_iparams
,
Operations * x1_operations

)

{

(* x1_implid) = s_implid(x1);

(* x1_iparams) = s_iparams(x1);

(* x1_operations) = s_operations(x1);

}
void del_implementation (Implementation x1)
{

del_implid(s_implid(x1));

del_params(s_iparams(x1));

del_operations(s_operations(x1));

del1_implementation(x1);
}
Implementation copy_implementation (Implementation x1)
{

x1.f_implid = copy_implid(x1.f_implid);

x1.f_iparams = copy_params(x1.f_iparams);

x1.f_operations = copy_operations(x1.f_operations);

return x1;
}

Cvtext_vdmlib cvlines_implementation (Implementation x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "mk_implementation(";
end_structure_vdmlib = ")";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (0)
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_implementation(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines3_dependgraph_str_depend
extern Cvtext_vdmlib cvlines3_dependgraph_str_depend ( Str y1, Depend y2    ) ;
#endif

Cvtext_vdmlib cvlines1_dependgraph(Dependgraph x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_dependgraph(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines3_dependgraph_str_depend(ref_dependgraph(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Cvtext_vdmlib cvlines3_dependgraph_str_depend (Str x1,Depend x2)
{ Cvtext_vdmlib lx1;
Cvtext_vdmlib lx2;

lx1 = cvlines_str(x1);
lx2 = cvlines_depend(x2);
if ( len_cvtext_vdmlib(lx1) == 1
&& len_cvtext_vdmlib(lx2) == 1
&& len_str(hd_cvtext_vdmlib(lx1)) + len_str(hd_cvtext_vdmlib(lx2))
<= curr_linelen_vdmlib - 5
)
{ Str lx3;

lx3 = conc_str( hd_cvtext_vdmlib(lx1)
, conc_str(mkc_str(" :-> "),hd_cvtext_vdmlib(lx2))
);
del1_cvtext_vdmlib(lx1);
del1_cvtext_vdmlib(lx2);
return mk1_cvtext_vdmlib(lx3);
}
else
{ return conc_cvtext_vdmlib(lx1, ident_lines_vdmlib(lx2,mkc_str(" :-> ")));}
}

Cvtext_vdmlib cvlines_dependgraph (Dependgraph x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "[";
end_structure_vdmlib = "]";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_dependgraph(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_dependgraph(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

#ifdef __cplusplus
void fpr_dependgraph (ostream & x1,Dependgraph x2)
#else
void fpr_dependgraph (FILE * x1,Dependgraph x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_dependgraph(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Dependgraph copy_dependgraph (Dependgraph x1)
{Dependgraph x2 = (Dependgraph)0;
register Dependgraph * px2 = & x2;
while (x1)
{*px2 = alloc_dependgraph();
*(*px2) = *(ref_dependgraph(x1));
(*px2)->f_info = copy_str((*px2)->f_info); (*px2)->f_attr = copy_depend((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Dependgraph union1_dependgraph(Dependgraph x1, Str x2, Depend x3)

{register Dependgraph lx1 = x1;
while (lx1)
{if (is_eq_str(ref_dependgraph(lx1)->f_info,x2)) {if (! is_eq_depend(ref_dependgraph(lx1)->f_attr,x3)) err_umap_vdmlib("Dependgraph"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_dependgraph(x2,x3);
lx1->f_next = x1;
return lx1;
}

Dependgraph ovwrt1d_dependgraph(Dependgraph x1, Str x2, Depend x3)

{register Dependgraph lx1 = x1;
while (lx1)
{if (is_eq_str(ref_dependgraph(lx1)->f_info,x2)) {del_str(x2);del_depend(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_dependgraph(x2,x3);
lx1->f_next = x1;
return lx1;
}

Depend sel_dependgraph (Dependgraph x1,Str x2)
{while (x1)
{if (is_eq_str(ref_dependgraph(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Dependgraph");
return x1->f_attr;
}

Dependgraph sub1d_dependgraph(Dependgraph x1, Str x2)

{register Dependgraph * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_dependgraph(*lx1))->f_info,x2))
{Dependgraph lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info); del_depend(lx2->f_attr);
free_dependgraph(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Dependgraph ovwrt1_dependgraph(Dependgraph x1, Str x2, Depend x3)

{register Dependgraph lx1 = x1;
while (lx1)
{if (is_eq_str(ref_dependgraph(lx1)->f_info,x2)) {ref_dependgraph(lx1)->f_attr=x3; return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_dependgraph(x2,x3);
lx1->f_next = x1;
return lx1;
}

static Dependgraph _tt1_del_dependgraph;

static void _ff1_del_dependgraph(Str y1,Depend y2)

{del_str(y1);del_depend(y2);}

void del_dependgraph(Dependgraph x1)

{
{Dependgraph lt1; lt1 = _tt1_del_dependgraph;
{
{_tt1_del_dependgraph = x1;

{
forall_dependgraph(x1,_ff1_del_dependgraph);
del1_dependgraph(x1);
_tt1_del_dependgraph = lt1;

}}}}}

Dependgraph mk1_dependgraph(Str x1, Depend x2)

{Dependgraph lx1 = alloc_dependgraph();
lx1->f_next = (Dependgraph)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

Dependgraph union1d_dependgraph(Dependgraph x1, Str x2, Depend x3)

{register Dependgraph lx1 = x1;
while (lx1)
{if (is_eq_str(ref_dependgraph(lx1)->f_info,x2)) {if (! is_eq_depend(ref_dependgraph(lx1)->f_attr,x3)) err_umap_vdmlib("Dependgraph"); del_str(x2);del_depend(x3);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_dependgraph(x2,x3);
lx1->f_next = x1;
return lx1;
}

Bool is_in_dom_dependgraph(Str x1, Dependgraph x2, Depend * x3)

{while (x2)
{if (is_eq_str(ref_dependgraph(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Bool is_in_dependgraph(Str x1, Dependgraph x2)

{while (x2)
{if (is_eq_str(ref_dependgraph(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

Dependgraph sub1_dependgraph(Dependgraph x1, Str x2)

{register Dependgraph * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_dependgraph(*lx1))->f_info,x2))
{Dependgraph lx2 = *lx1;
*lx1 = lx2->f_next;

free_dependgraph(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Dependgraph copy1_dependgraph (Dependgraph x1)
{Dependgraph x2 = (Dependgraph)0;
register Dependgraph * px2 = & x2;
while (x1)
{*px2 = alloc_dependgraph();
*(*px2) = *(ref_dependgraph(x1));

px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

#ifndef mk_empty_depend
extern Depend mk_empty_depend ( void ) ;
#endif

#ifndef union_depend
extern Depend union_depend ( Depend x1, Depend x2   ) ;
#endif

#ifndef dom_dependgraph_str_depend
extern Depend dom_dependgraph_str_depend ( Str y1, Depend y2    ) ;
#endif

Depend dom_dependgraph(Dependgraph x1     )

{
Depend lx1;
lx1 = mk_empty_depend();
for(;x1 ; x1=ref_dependgraph(x1)->f_next)
{lx1 = union_depend(lx1,dom_dependgraph_str_depend(ref_dependgraph(x1)->f_info,x1->f_attr )  );}
return lx1;
}

#ifndef cvlines_domain
extern Cvtext_vdmlib cvlines_domain ( Domain x1   );
#endif
#ifndef cvlines_implementation
extern Cvtext_vdmlib cvlines_implementation ( Implementation x1   );
#endif

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

Cvtext_vdmlib cvlines1_description(Description x1   )

{Cvtext_vdmlib lr1 = mk_empty_cvtext_vdmlib();

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_domain(s_domain(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_implementation(s_implem(x1)  )  );

return lr1;
}

Bool is_eq_description (Description x1,Description x2)
{return 1

&& is_eq_domain(s_domain(x1),s_domain(x2))

&& is_eq_implementation(s_implem(x1),s_implem(x2))

;}
void del_description (Description x1)
{

del_domain(s_domain(x1));

del_implementation(s_implem(x1));

del1_description(x1);
}
Description mk_description(

Domain x1_domain
,
Implementation x1_implem

)

{Description lx1;

lx1.f_domain = x1_domain;

lx1.f_implem = x1_implem;

return lx1;
}
Description copy_description (Description x1)
{

x1.f_domain = copy_domain(x1.f_domain);

x1.f_implem = copy_implementation(x1.f_implem);

return x1;
}

Cvtext_vdmlib cvlines_description (Description x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "mk_description(";
end_structure_vdmlib = ")";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (0)
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_description(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines3_dominfo_str_description
extern Cvtext_vdmlib cvlines3_dominfo_str_description ( Str y1, Description y2    ) ;
#endif

Cvtext_vdmlib cvlines1_dominfo(Dominfo x1     )

{
Cvtext_vdmlib lx1;
lx1 = mk_empty_cvtext_vdmlib();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = cvlines2_cvtext_vdmlib(lx1,cvlines3_dominfo_str_description(ref_dominfo(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Dominfo ovwrt1_dominfo(Dominfo x1, Str x2, Description x3)

{register Dominfo lx1 = x1;
while (lx1)
{if (is_eq_str(ref_dominfo(lx1)->f_info,x2)) {ref_dominfo(lx1)->f_attr=x3; return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_dominfo(x2,x3);
lx1->f_next = x1;
return lx1;
}

Nat0 card_dominfo (Dominfo x1)
{Nat0 lx1 = 0;
while (x1) {lx1++; x1=ref_dominfo(x1)->f_next;}
return lx1;
}

#ifndef mk_empty_depend
extern Depend mk_empty_depend ( void ) ;
#endif

#ifndef union_depend
extern Depend union_depend ( Depend x1, Depend x2   ) ;
#endif

#ifndef dom_dominfo_str_description
extern Depend dom_dominfo_str_description ( Str y1, Description y2    ) ;
#endif

Depend dom_dominfo(Dominfo x1     )

{
Depend lx1;
lx1 = mk_empty_depend();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = union_depend(lx1,dom_dominfo_str_description(ref_dominfo(x1)->f_info,x1->f_attr )  );}
return lx1;
}

Dominfo union1_dominfo(Dominfo x1, Str x2, Description x3)

{register Dominfo lx1 = x1;
while (lx1)
{if (is_eq_str(ref_dominfo(lx1)->f_info,x2)) {if (! is_eq_description(ref_dominfo(lx1)->f_attr,x3)) err_umap_vdmlib("Dominfo"); return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_dominfo(x2,x3);
lx1->f_next = x1;
return lx1;
}

#ifndef ovwrt1_dominfo
extern Dominfo ovwrt1_dominfo ( Dominfo x1, Str x2, Description x3 );
#endif

static Dominfo _rr1_ovwrt_dominfo;
static void _rf1_ovwrt_dominfo(Str y1, Description y2)   {_rr1_ovwrt_dominfo = ovwrt1_dominfo(_rr1_ovwrt_dominfo,y1,y2);}

Dominfo ovwrt_dominfo (Dominfo x1,Dominfo x2)
{Dominfo lr1 = _rr1_ovwrt_dominfo;
_rr1_ovwrt_dominfo = x1;
forall_dominfo(x2,_rf1_ovwrt_dominfo);
del1_dominfo(x2);
{Dominfo lr2 = _rr1_ovwrt_dominfo; _rr1_ovwrt_dominfo = lr1; return lr2;}
}

Dominfo copy_dominfo (Dominfo x1)
{Dominfo x2 = (Dominfo)0;
register Dominfo * px2 = & x2;
while (x1)
{*px2 = alloc_dominfo();
*(*px2) = *(ref_dominfo(x1));
(*px2)->f_info = copy_str((*px2)->f_info); (*px2)->f_attr = copy_description((*px2)->f_attr);
px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

Bool is_in_dom_dominfo(Str x1, Dominfo x2, Description * x3)

{while (x2)
{if (is_eq_str(ref_dominfo(x2)->f_info,x1)) {*x3 = x2->f_attr; return 1;}
x2 = x2->f_next;
}
return 0;
}

Bool is_in_dominfo(Str x1, Dominfo x2)

{while (x2)
{if (is_eq_str(ref_dominfo(x2)->f_info,x1)) return 1;
x2 = x2->f_next;
}
return 0;
}

#ifndef del_predef1_dominfo
extern Dominfo del_predef1_dominfo ( Dominfo x1, Str x2, Description x3 );
#endif

static Dominfo _rr1_del_predef_dominfo;
static void _rf1_del_predef_dominfo(Str y1, Description y2)   {_rr1_del_predef_dominfo = del_predef1_dominfo(_rr1_del_predef_dominfo,y1,y2);}

Dominfo del_predef_dominfo (Dominfo x1,Dominfo x2)
{Dominfo lr1 = _rr1_del_predef_dominfo;
_rr1_del_predef_dominfo = x1;
forall_dominfo(x2,_rf1_del_predef_dominfo);
del1_dominfo(x2);
{Dominfo lr2 = _rr1_del_predef_dominfo; _rr1_del_predef_dominfo = lr1; return lr2;}
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_domain_str_description
extern Str gen_domain_str_description ( Str y1, Description y2  ,Str px1  ) ;
#endif

Str gen_domain_dominfo(Dominfo x1   ,Str px1  )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = conc_str(lx1,gen_domain_str_description(ref_dominfo(x1)->f_info,x1->f_attr ,px1 )  );}
return lx1;
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef complete_depends1_str_description
extern Bool complete_depends1_str_description ( Str y1, Description y2    ) ;
#endif

Bool complete_depends_dominfo(Dominfo x1     )

{
Bool lx1;
lx1 = true_bool();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = and_bool(lx1,complete_depends1_str_description(ref_dominfo(x1)->f_info,x1->f_attr )  );}
return lx1;
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef is_enriched_by_str_description
extern Bool is_enriched_by_str_description ( Str y1, Description y2  ,Dominfo px1  ) ;
#endif

Bool is_enriched_by_dominfo(Dominfo x1   ,Dominfo px1  )

{
Bool lx1;
lx1 = true_bool();
for(;x1 && !is_eq_bool(FALSE,lx1); x1=ref_dominfo(x1)->f_next)
{lx1 = and_bool(lx1,is_enriched_by_str_description(ref_dominfo(x1)->f_info,x1->f_attr ,px1 )  );}
return lx1;
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef domain_check1_str_description
extern Bool domain_check1_str_description ( Str y1, Description y2    ) ;
#endif

Bool domain_check_dominfo(Dominfo x1     )

{
Bool lx1;
lx1 = true_bool();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = and_bool(lx1,domain_check1_str_description(ref_dominfo(x1)->f_info,x1->f_attr )  );}
return lx1;
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_includes_str_description
extern Str gen_includes_str_description ( Str y1, Description y2  ,Str px1  ) ;
#endif

Str gen_includes_dominfo(Dominfo x1   ,Str px1  )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = conc_str(lx1,gen_includes_str_description(ref_dominfo(x1)->f_info,x1->f_attr ,px1 )  );}
return lx1;
}

#ifndef diff1_dominfo
extern Dominfo diff1_dominfo ( Dominfo x1, Str x2, Description x3 );
#endif

static Dominfo _rr1_diff_dominfo;
static void _rf1_diff_dominfo(Str y1, Description y2)   {_rr1_diff_dominfo = diff1_dominfo(_rr1_diff_dominfo,y1,y2);}

Dominfo diff_dominfo (Dominfo x1,Dominfo x2)
{Dominfo lr1 = _rr1_diff_dominfo;
_rr1_diff_dominfo = x1;
forall_dominfo(x2,_rf1_diff_dominfo);
del1_dominfo(x2);
{Dominfo lr2 = _rr1_diff_dominfo; _rr1_diff_dominfo = lr1; return lr2;}
}

Dominfo union1d_dominfo(Dominfo x1, Str x2, Description x3)

{register Dominfo lx1 = x1;
while (lx1)
{if (is_eq_str(ref_dominfo(lx1)->f_info,x2)) {if (! is_eq_description(ref_dominfo(lx1)->f_attr,x3)) err_umap_vdmlib("Dominfo"); del_str(x2);del_description(x3);return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_dominfo(x2,x3);
lx1->f_next = x1;
return lx1;
}

static Dominfo _rr1_intersd_dominfo;
static Dominfo _tt1_intersd_dominfo; static Dominfo _tt2_intersd_dominfo;

static void _ff1_intersd_dominfo(Str y1,Description y2)

{{Description z2; if (is_in_dom_dominfo(y1,_tt2_intersd_dominfo,&z2) && is_eq_description(y2,z2)) _rr1_intersd_dominfo = union1_dominfo(_rr1_intersd_dominfo,y1,y2);else {del_str(y1);del_description(y2);}}}

Dominfo intersd_dominfo(Dominfo x1,Dominfo x2)

{Dominfo lr1; lr1 = _rr1_intersd_dominfo;
{Dominfo lt1; Dominfo lt2; lt1 = _tt1_intersd_dominfo; lt2 = _tt2_intersd_dominfo;
{
{_tt1_intersd_dominfo = x1; _tt2_intersd_dominfo = x2;

{_rr1_intersd_dominfo = mk_empty_dominfo();
forall_dominfo(x1,_ff1_intersd_dominfo);
del1_dominfo(x1);del_dominfo(x2);
_tt1_intersd_dominfo = lt1; _tt2_intersd_dominfo = lt2;
{Dominfo lr2; lr2 = _rr1_intersd_dominfo; _rr1_intersd_dominfo = lr1; return lr2;}
}}}}}

Dominfo sub1_dominfo(Dominfo x1, Str x2)

{register Dominfo * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_dominfo(*lx1))->f_info,x2))
{Dominfo lx2 = *lx1;
*lx1 = lx2->f_next;

free_dominfo(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Dominfo mk1_dominfo(Str x1, Description x2)

{Dominfo lx1 = alloc_dominfo();
lx1->f_next = (Dominfo)0;
lx1->f_info = x1; lx1->f_attr = x2;
return lx1;
}

Description sel_dominfo (Dominfo x1,Str x2)
{while (x1)
{if (is_eq_str(ref_dominfo(x1)->f_info,x2)) return x1->f_attr;
x1 = x1->f_next;
}
err_smap_vdmlib("Dominfo");
return x1->f_attr;
}

Dominfo ovwrt1d_dominfo(Dominfo x1, Str x2, Description x3)

{register Dominfo lx1 = x1;
while (lx1)
{if (is_eq_str(ref_dominfo(lx1)->f_info,x2)) {del_str(x2);del_description(lx1->f_attr);lx1->f_attr=x3;return x1;}
lx1 = lx1->f_next;
}
lx1 = mk1_dominfo(x2,x3);
lx1->f_next = x1;
return lx1;
}

#ifndef update_alias1_dominfo
extern Dominfo update_alias1_dominfo ( Dominfo x1, Str x2, Description x3 );
#endif

static Dominfo _rr1_update_alias_dominfo;
static void _rf1_update_alias_dominfo(Str y1, Description y2)   {_rr1_update_alias_dominfo = update_alias1_dominfo(_rr1_update_alias_dominfo,y1,y2);}

Dominfo update_alias_dominfo (Dominfo x1,Dominfo x2)
{Dominfo lr1 = _rr1_update_alias_dominfo;
_rr1_update_alias_dominfo = x1;
forall_dominfo(x2,_rf1_update_alias_dominfo);
del1_dominfo(x2);
{Dominfo lr2 = _rr1_update_alias_dominfo; _rr1_update_alias_dominfo = lr1; return lr2;}
}

#ifndef mk_empty_str
extern Str mk_empty_str ( void ) ;
#endif

#ifndef conc_str
extern Str conc_str ( Str x1, Str x2   ) ;
#endif

#ifndef gen_implementation_str_description
extern Str gen_implementation_str_description ( Str y1, Description y2  ,Str px1  ) ;
#endif

Str gen_implementation_dominfo(Dominfo x1   ,Str px1  )

{
Str lx1;
lx1 = mk_empty_str();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = conc_str(lx1,gen_implementation_str_description(ref_dominfo(x1)->f_info,x1->f_attr ,px1 )  );}
return lx1;
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef nounique_elems1_str_description
extern Bool nounique_elems1_str_description ( Str y1, Description y2  ,Dominfo px1  ) ;
#endif

Bool nounique_elems_dominfo(Dominfo x1   ,Dominfo px1  )

{
Bool lx1;
lx1 = true_bool();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = and_bool(lx1,nounique_elems1_str_description(ref_dominfo(x1)->f_info,x1->f_attr ,px1 )  );}
return lx1;
}

#ifndef mk_empty_depend
extern Depend mk_empty_depend ( void ) ;
#endif

#ifndef union_depend
extern Depend union_depend ( Depend x1, Depend x2   ) ;
#endif

#ifndef unique_elems1_str_description
extern Depend unique_elems1_str_description ( Str y1, Description y2    ) ;
#endif

Depend unique_elems_dominfo(Dominfo x1     )

{
Depend lx1;
lx1 = mk_empty_depend();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = union_depend(lx1,unique_elems1_str_description(ref_dominfo(x1)->f_info,x1->f_attr )  );}
return lx1;
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

#ifndef casesen_domid_str_description
extern Bool casesen_domid_str_description ( Str y1, Description y2  ,Dominfo px1  ) ;
#endif

Bool casesen_domid_dominfo(Dominfo x1   ,Dominfo px1  )

{
Bool lx1;
lx1 = true_bool();
for(;x1 ; x1=ref_dominfo(x1)->f_next)
{lx1 = and_bool(lx1,casesen_domid_str_description(ref_dominfo(x1)->f_info,x1->f_attr ,px1 )  );}
return lx1;
}

#ifndef add_constructor1_for_isa_dominfo
extern Dominfo add_constructor1_for_isa_dominfo ( Dominfo x1, Str x2, Description x3 );
#endif

static Dominfo _rr1_add_constructors_for_isa_dominfo;
static void _rf1_add_constructors_for_isa_dominfo(Str y1, Description y2)   {_rr1_add_constructors_for_isa_dominfo = add_constructor1_for_isa_dominfo(_rr1_add_constructors_for_isa_dominfo,y1,y2);}

Dominfo add_constructors_for_isa_dominfo (Dominfo x1,Dominfo x2)
{Dominfo lr1 = _rr1_add_constructors_for_isa_dominfo;
_rr1_add_constructors_for_isa_dominfo = x1;
forall_dominfo(x2,_rf1_add_constructors_for_isa_dominfo);
del1_dominfo(x2);
{Dominfo lr2 = _rr1_add_constructors_for_isa_dominfo; _rr1_add_constructors_for_isa_dominfo = lr1; return lr2;}
}

#ifndef merge1_dominfo
extern Dominfo merge1_dominfo ( Dominfo x1, Str x2, Description x3 );
#endif

static Dominfo _rr1_merge_dominfo;
static void _rf1_merge_dominfo(Str y1, Description y2)   {_rr1_merge_dominfo = merge1_dominfo(_rr1_merge_dominfo,y1,y2);}

Dominfo merge_dominfo (Dominfo x1,Dominfo x2)
{Dominfo lr1 = _rr1_merge_dominfo;
_rr1_merge_dominfo = x1;
forall_dominfo(x2,_rf1_merge_dominfo);
del1_dominfo(x2);
{Dominfo lr2 = _rr1_merge_dominfo; _rr1_merge_dominfo = lr1; return lr2;}
}

Dominfo sub1d_dominfo(Dominfo x1, Str x2)

{register Dominfo * lx1 = &x1;
while (*lx1)
{if (is_eq_str((ref_dominfo(*lx1))->f_info,x2))
{Dominfo lx2 = *lx1;
*lx1 = lx2->f_next;
del_str(lx2->f_info); del_description(lx2->f_attr);
free_dominfo(lx2);
break;
}
lx1 = &((*lx1)->f_next);
}
return x1;
}

Bool is_eq_dominfo (Dominfo x1,Dominfo x2)
{return (card_dominfo(x1) == card_dominfo(x2))
&& is_submap_dominfo(x1,x2);
}

static Dominfo _tt1_del_dominfo;

static void _ff1_del_dominfo(Str y1,Description y2)

{del_str(y1);del_description(y2);}

void del_dominfo(Dominfo x1)

{
{Dominfo lt1; lt1 = _tt1_del_dominfo;
{
{_tt1_del_dominfo = x1;

{
forall_dominfo(x1,_ff1_del_dominfo);
del1_dominfo(x1);
_tt1_del_dominfo = lt1;

}}}}}

Dominfo copy1_dominfo (Dominfo x1)
{Dominfo x2 = (Dominfo)0;
register Dominfo * px2 = & x2;
while (x1)
{*px2 = alloc_dominfo();
*(*px2) = *(ref_dominfo(x1));

px2 = &((*px2)->f_next);
x1=x1->f_next;
}
return x2;
}

#ifdef __cplusplus
void fpr_dominfo (ostream & x1,Dominfo x2)
#else
void fpr_dominfo (FILE * x1,Dominfo x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_dominfo(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

#ifndef false_bool
extern Bool false_bool ( void ) ;
#endif

#ifndef or_bool
extern Bool or_bool ( Bool x1, Bool x2   ) ;
#endif

Bool exist_dominfo(Dominfo x1  , _T2cv_exist_dominfo Pvcvfct   )

{
Bool lx1;
lx1 = false_bool();
for(;x1 && !is_eq_bool(TRUE,lx1); x1=ref_dominfo(x1)->f_next)
{lx1 = or_bool(lx1,(*Pvcvfct)(ref_dominfo(x1)->f_info,x1->f_attr )  );}
return lx1;
}

#ifndef true_bool
extern Bool true_bool ( void ) ;
#endif

#ifndef and_bool
extern Bool and_bool ( Bool x1, Bool x2   ) ;
#endif

Bool all_dominfo(Dominfo x1  , _T2cv_all_dominfo Pvcvfct   )

{
Bool lx1;
lx1 = true_bool();
for(;x1 && !is_eq_bool(FALSE,lx1); x1=ref_dominfo(x1)->f_next)
{lx1 = and_bool(lx1,(*Pvcvfct)(ref_dominfo(x1)->f_info,x1->f_attr )  );}
return lx1;
}

static Bool _rr1_is_submap_dominfo;
static Dominfo _tt1_is_submap_dominfo; static Dominfo _tt2_is_submap_dominfo;

static void _ff1_is_submap_dominfo(Str y1,Description y2)

{{Description z2; _rr1_is_submap_dominfo = _rr1_is_submap_dominfo && is_in_dom_dominfo(y1,_tt2_is_submap_dominfo,&z2) && is_eq_description(y2,z2);}}

Bool is_submap_dominfo(Dominfo x1,Dominfo x2)

{Bool lr1; lr1 = _rr1_is_submap_dominfo;
{Dominfo lt1; Dominfo lt2; lt1 = _tt1_is_submap_dominfo; lt2 = _tt2_is_submap_dominfo;
{
{_tt1_is_submap_dominfo = x1; _tt2_is_submap_dominfo = x2;

{_rr1_is_submap_dominfo = (card_dominfo(_tt1_is_submap_dominfo) <= card_dominfo(_tt2_is_submap_dominfo));
if (_rr1_is_submap_dominfo) forall_dominfo(x1,_ff1_is_submap_dominfo);

_tt1_is_submap_dominfo = lt1; _tt2_is_submap_dominfo = lt2;
{Bool lr2; lr2 = _rr1_is_submap_dominfo; _rr1_is_submap_dominfo = lr1; return lr2;}
}}}}}

#ifndef union1_dominfo
extern Dominfo union1_dominfo ( Dominfo x1, Str x2, Description x3 );
#endif

static Dominfo _rr1_union_dominfo;
static void _rf1_union_dominfo(Str y1, Description y2)   {_rr1_union_dominfo = union1_dominfo(_rr1_union_dominfo,y1,y2);}

Dominfo union_dominfo (Dominfo x1,Dominfo x2)
{Dominfo lr1 = _rr1_union_dominfo;
_rr1_union_dominfo = x1;
forall_dominfo(x2,_rf1_union_dominfo);
del1_dominfo(x2);
{Dominfo lr2 = _rr1_union_dominfo; _rr1_union_dominfo = lr1; return lr2;}
}

Cvtext_vdmlib cvlines3_dominfo_str_description (Str x1,Description x2)
{ Cvtext_vdmlib lx1;
Cvtext_vdmlib lx2;

lx1 = cvlines_str(x1);
lx2 = cvlines_description(x2);
if ( len_cvtext_vdmlib(lx1) == 1
&& len_cvtext_vdmlib(lx2) == 1
&& len_str(hd_cvtext_vdmlib(lx1)) + len_str(hd_cvtext_vdmlib(lx2))
<= curr_linelen_vdmlib - 5
)
{ Str lx3;

lx3 = conc_str( hd_cvtext_vdmlib(lx1)
, conc_str(mkc_str(" :-> "),hd_cvtext_vdmlib(lx2))
);
del1_cvtext_vdmlib(lx1);
del1_cvtext_vdmlib(lx2);
return mk1_cvtext_vdmlib(lx3);
}
else
{ return conc_cvtext_vdmlib(lx1, ident_lines_vdmlib(lx2,mkc_str(" :-> ")));}
}

Cvtext_vdmlib cvlines_dominfo (Dominfo x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "[";
end_structure_vdmlib = "]";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_dominfo(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_dominfo(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}
