// $Id: cmd.hpp,v 1.1 1994/03/17 23:21:58 vdm Exp $

#ifndef CMD_HPP
#define CMD_HPP

#include <iostream.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>

//--------------------------------------------------------------------

const int not_found = -1;
const int exit_executed  = -2;

const maxline   = 256;
const maxargs   = 128;

typedef int (*cmdfct)(int argc, char * argv[]);
typedef struct { char * cn; char * params; cmdfct cf; } cmdassoc;

int interpreterloop(void);

int exitcmd(int argc, char * argv[]);
int noopcmd(int argc, char * argv[]);
int helpcmd(int argc, char * argv[]);

extern const cmdassoc commands[];

extern char * prompt;
#endif
