#include "compat.h"
#include "support.h"

#ifdef TCL_CHANNEL_SUPPORT

int Tcl_EnterFile (Tcl_Interp *interp, FILE *file, int permissions)
{
  Tcl_Channel channel;
  
  channel=Tcl_MakeFileChannel((ClientData)fileno(file),(ClientData)fileno(file),
  		permissions);  
  if (channel==NULL) return TCL_ERROR;
  Tcl_RegisterChannel(interp,channel);
  sprintf(interp->result,"%s",Tcl_GetChannelName(channel));
  return TCL_OK;
}

#endif /* TCL_CHANNEL_SUPPORT */
