#ifndef _TCL_COMPAT_H
#define _TCL_COMPAT_H

#include "support.h"

#ifdef TCL_CHANNEL_SUPPORT

#include <tcl.h>

/* Backward support for TCL less than 7.5. Meanwhile Tcl_EnterFile 
   is obsolete because of channel handling. */

#define TCL_FILE_READABLE TCL_READABLE
#define TCL_FILE_WRITABLE TCL_WRITABLE

int Tcl_EnterFile (Tcl_Interp *interp, FILE *file, int permissions);

#endif /* TCL_CHANNEL_SUPPORT */

#endif /* _TCL_COMPAT_H */
