/* Figure out the type of system 
 * 
 * Try to determine the environment automatically from the C compiler's
 * predefined symbols.
 * The following can be determined automatically:
 * BSD VAX, Phyramid, Xenix, AT&T 3b1, AT&T 80386, Celerity and MS-DOS.
 * If this doesn't work on some new system, ifdef this out, and set it 
 * by hand.
 *
 * This file ist stolen from Richard Stevens and changed by mt for 
 * political correctness here.
 */
 
#ifndef _SYSTYPE_H
#define _SYSTYPE_H

#ifdef linux
#ifndef LINUX
#define LINUX
#endif 
#endif /* LINUX */

#ifdef	unix		
#ifndef UNIX
#define UNIX		1 
#endif

#ifdef  vax
#ifndef VAX
#define VAX		1
#endif

#ifndef BSD
#define BSD		1
#endif
	
#else
#ifdef	pyr

#ifndef PYRAMID
#define PYRAMID		1
#endif

#ifndef BSD
#define	BSD		1
#endif
	
#else
#ifdef	mc68k
	
#ifndef UNIXPC
#define	UNIXPC		1	
#endif

#ifndef SYS5
#define SYS5		1
#endif
#else
#ifdef	i386

#ifndef UNIXPC
#define UNIXPC		1
#endif

#ifndef SYS5
#define SYS5		1
#endif
#else
#ifdef	accel

#ifndef CELERITY
#define CELERITY	1
#endif
	
#ifndef BSD
#define BSD		1
#endif
#else

#endif	/* accel */
#endif	/* i386 */
#endif	/* mc68k */
#endif	/* pyr */
#endif	/* vax */

#endif	/* unix */

#ifdef	M_XENIX		
#ifndef UNIX
#define UNIX		1
#endif
#ifndef XENIX
#define XENIX		1
#endif
#ifndef SYS5
#define SYS5		1
#endif
#ifndef IBMPC
#define IBMPC		1
#endif
#endif	/* M_XENIX */

#ifdef	MSDOS		
#ifndef IBMPC
#define IBMPC		1
#endif
#ifndef MICROSOFT
#define MICROSOFT	1
#endif
#endif /* MSDOS */

#if defined(SYS5) && !defined(LINUX)
#ifndef rindex
#define	rindex	strrchr
#endif
#ifndef index
#define index	strchr
#endif

#ifndef u_char
#define u_char	unchar
#endif 
#ifndef u_short
#define u_short	ushort
#endif
#ifndef u_int
#define u_int	uint
#endif
#ifndef u_long
#define u_long	ulong
#endif
#endif	/* SYS 5 */

#ifdef MICROSOFT
#ifndef rindex
#define rindex	strrchr
#endif
#ifndef index
#define index	strchr
#endif
#ifndef u_char
#define u_char	uchar
#endif
#ifndef u_short
#define u_short ushort
#endif
#ifndef u_int
#define u_int	uint
#endif
#ifndef u_long
#define u_long	ulong
#endif
#endif /* MICROSOFT */


#endif /* _SYSTYPE_H */
