#include <sys/types.h>
#include <sys/wait.h> 
#include <stdlib.h>
#include <tcl.h>
#include "proto.h"

int Tcl_waitpidCmd(ClientData clientData,Tcl_Interp *interp,int argc,char *argv[])
{
    int status;
    pid_t pid;
		
    if (argc != 2) {
	interp->result = "waitpid pid";
	return TCL_ERROR;
    }
	
    pid=waitpid(atoi(argv[1]),&status,WUNTRACED); 
    sprintf(interp->result, "%d", pid);  
    return TCL_OK;
}

