#ifndef CPP_header_dbm
#define CPP_header_dbm
/* ------- PHASE1 ------------------ */

#include "dbm.h"

/*
module generated from VDM Class Library
$Revision: 1.100 $
$Date: 1996/09/18 13:13:42 $
*/
class NILETC;
class STDLIB;
class VDMLIB;
class BOOL;
class BYTE;
class INTG;
class NAT1;
class CHAR;
class STR;

#define ADTNAME STR

#define IMPLNAME STR

#define OPNAME STR

#define COMPNAME STR

#define COMPONENT STR

class OUTBYTES;
class INBYTES;
class NAT0;
class STRINGL;
class ITER_STR;
class ITER_STRINGL;
class STRINGS;
class ITER_STRINGS;
class CONTEXT;
class OPERATION;
class PAIR_OPERATION;
class ITER_OPERATION;
class CONTEXTMAP;
class PAIR_CONTEXTMAP;
class IMPL;
class PAIR_IMPL;
class ITER_CONTEXTMAP;
class ITER_IMPL;
class ADT;
class PAIR_ADT;
class ITER_ADT;
class VDMDB;
class PAIR_VDMDB;
class ITER_VDMDB;

/* ------- PHASE2 ------------------ */
class NILETC {
};

#ifndef STDLIB_CL
#define STDLIB_CL
class STDLIB {

};
#endif
class VDMLIB {
};
class BOOL {
public:
Bool data;
BOOL() {}
BOOL (int x1) { data = (Bool)x1; }
BOOL & operator=(int x1) { data = (Bool)x1; return *this; }
BOOL (const BOOL & x1) { data = x1.data; }
BOOL & operator=(const BOOL & x1) { data = x1.data; return *this; }

operator int() const { return (int)data; }

Bool cv_bool() const { return data; }

inline BOOL not () const
;

inline BOOL operator ! () const
;

inline BOOL is_gr (const BOOL & x2) const
;

inline BOOL operator > (const BOOL & x2) const
;

inline BOOL xor (const BOOL & x2)
;

inline BOOL & operator ^= (const BOOL & x2)
;

inline BOOL operator ^ (const BOOL & x2)
;

inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const BOOL & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline BOOL and (const BOOL & x2)
;

inline BOOL & operator &= (const BOOL & x2)
;

inline BOOL operator & (const BOOL & x2)
;

inline BOOL is_eq (const BOOL & x2) const
;

inline BOOL operator == (const BOOL & x2) const
;

inline BOOL operator != (const BOOL & x2) const
;

inline BOOL is_ge (const BOOL & x2) const
;

inline BOOL operator >= (const BOOL & x2) const
;

inline BOOL or (const BOOL & x2)
;

inline BOOL & operator |= (const BOOL & x2)
;

inline BOOL operator | (const BOOL & x2)
;

};
class BYTE {
public:
Byte data;
BYTE () {}
BYTE (Byte x1) { data = x1; }
BYTE & operator=(Byte x1) { data = x1; return *this; }
BYTE (const BYTE & x1) { data = x1.data; }
BYTE & operator=(const BYTE & x1) { data = x1.data; return *this; }

Byte cv_byte() const { return data; }

BYTE (const NAT0 & x1);

operator NAT0 () const;

inline BYTE pred ()
;

inline BYTE & operator -- ()
;

inline BYTE operator -- (int)
;

inline BOOL is_eq (const BYTE & x2) const
;

inline BOOL operator == (const BYTE & x2) const
;

inline BOOL operator != (const BYTE & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const BYTE & x2) const
;

inline BOOL operator < (const BYTE & x2) const
;

inline BOOL is_ge (const BYTE & x2) const
;

inline BOOL operator >= (const BYTE & x2) const
;

inline BYTE times (const BYTE & x2) const
;

inline BYTE & operator *= (const BYTE & x2)
;

inline BYTE operator * (const BYTE & x2) const
;

inline BYTE plus (const BYTE & x2) const
;

inline BYTE & operator += (const BYTE & x2)
;

inline BYTE operator + (const BYTE & x2) const
;

inline BYTE succ ()
;

inline BYTE & operator ++ ()
;

inline BYTE operator ++ (int)
;

inline BYTE mod (const BYTE & x2) const
;

inline BYTE & operator %= (const BYTE & x2)
;

inline BYTE operator % (const BYTE & x2) const
;

inline BOOL is_le (const BYTE & x2) const
;

inline BOOL operator <= (const BYTE & x2) const
;

inline BOOL is_gr (const BYTE & x2) const
;

inline BOOL operator > (const BYTE & x2) const
;

inline BYTE div (const BYTE & x2) const
;

inline BYTE & operator /= (const BYTE & x2)
;

inline BYTE operator / (const BYTE & x2) const
;

inline BYTE minus (const BYTE & x2) const
;

inline BYTE & operator -= (const BYTE & x2)
;

inline BYTE operator - (const BYTE & x2) const
;

};
class INTG {
public:
Intg data;
INTG () {}
INTG (Intg x1) { data = x1; }
INTG & operator=(Intg x1) { data = x1; return *this; }
INTG (const INTG & x1) { data = x1.data; }
INTG & operator=(const INTG & x1) { data = x1.data; return *this; }

Intg cv_intg() const { return data; }

INTG (const NAT0 & x1);

inline INTG pred ()
;

inline INTG & operator -- ()
;

inline INTG operator -- (int)
;

inline BOOL is_eq (const INTG & x2) const
;

inline BOOL operator == (const INTG & x2) const
;

inline BOOL operator != (const INTG & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const INTG & x2) const
;

inline BOOL operator < (const INTG & x2) const
;

inline BOOL is_ge (const INTG & x2) const
;

inline BOOL operator >= (const INTG & x2) const
;

inline INTG times (const INTG & x2) const
;

inline INTG & operator *= (const INTG & x2)
;

inline INTG operator * (const INTG & x2) const
;

inline INTG plus (const INTG & x2) const
;

inline INTG & operator += (const INTG & x2)
;

inline INTG operator + (const INTG & x2) const
;

inline void del ()
;

inline STR cvstr ()
;
inline INTG copy () const
;
inline void set_print_format (char * x1) const
;

inline void set_print_format () const
;

inline INTG succ ()
;

inline INTG & operator ++ ()
;

inline INTG operator ++ (int)
;

inline INTG mod (const INTG & x2) const
;

inline INTG & operator %= (const INTG & x2)
;

inline INTG operator % (const INTG & x2) const
;

inline BOOL is_le (const INTG & x2) const
;

inline BOOL operator <= (const INTG & x2) const
;

inline BOOL is_gr (const INTG & x2) const
;

inline BOOL operator > (const INTG & x2) const
;

inline INTG div (const INTG & x2) const
;

inline INTG & operator /= (const INTG & x2)
;

inline INTG operator / (const INTG & x2) const
;

inline INTG minus (const INTG & x2) const
;

inline INTG & operator -= (const INTG & x2)
;

inline INTG operator - (const INTG & x2) const
;

};
class NAT1 {
public:
Nat1 data;
NAT1 () {}
NAT1 (Nat1 x1) { data = x1; }
NAT1 & operator=(Nat1 x1) { data = x1; return *this; }
NAT1 (const NAT1 & x1) { data = x1.data; }
NAT1 & operator=(const NAT1 & x1) { data = x1.data; return *this; }

Nat1 cv_nat1() const { return data; }

NAT1 (const NAT0 & x1);

operator NAT0 () const;

inline NAT1 pred ()
;

inline NAT1 & operator -- ()
;

inline NAT1 operator -- (int)
;

inline BOOL is_eq (const NAT1 & x2) const
;

inline BOOL operator == (const NAT1 & x2) const
;

inline BOOL operator != (const NAT1 & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const NAT1 & x2) const
;

inline BOOL operator < (const NAT1 & x2) const
;

inline BOOL is_ge (const NAT1 & x2) const
;

inline BOOL operator >= (const NAT1 & x2) const
;

inline NAT1 times (const NAT1 & x2) const
;

inline NAT1 & operator *= (const NAT1 & x2)
;

inline NAT1 operator * (const NAT1 & x2) const
;

inline NAT1 plus (const NAT1 & x2) const
;

inline NAT1 & operator += (const NAT1 & x2)
;

inline NAT1 operator + (const NAT1 & x2) const
;

inline NAT1 succ ()
;

inline NAT1 & operator ++ ()
;

inline NAT1 operator ++ (int)
;

inline NAT1 mod (const NAT1 & x2) const
;

inline NAT1 & operator %= (const NAT1 & x2)
;

inline NAT1 operator % (const NAT1 & x2) const
;

inline BOOL is_le (const NAT1 & x2) const
;

inline BOOL operator <= (const NAT1 & x2) const
;

inline BOOL is_gr (const NAT1 & x2) const
;

inline BOOL operator > (const NAT1 & x2) const
;

inline NAT1 div (const NAT1 & x2) const
;

inline NAT1 & operator /= (const NAT1 & x2)
;

inline NAT1 operator / (const NAT1 & x2) const
;

inline NAT1 minus (const NAT1 & x2) const
;

inline NAT1 & operator -= (const NAT1 & x2)
;

inline NAT1 operator - (const NAT1 & x2) const
;

};
class CHAR {
public:
Char data;
CHAR () {}
CHAR (Char x1) { data = x1; }
CHAR & operator=(Char x1) { data = x1; return *this; }
CHAR (const CHAR & x1) { data = x1.data; }
CHAR & operator=(const CHAR & x1) { data = x1.data; return *this; }

Char cv_char() const { return data; }

CHAR (const NAT0 & x1);

operator NAT0 () const;

inline CHAR pred ()
;

inline CHAR & operator -- ()
;

inline CHAR operator -- (int)
;

inline BOOL is_eq (const CHAR & x2) const
;

inline BOOL operator == (const CHAR & x2) const
;

inline BOOL operator != (const CHAR & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const CHAR & x2) const
;

inline BOOL operator < (const CHAR & x2) const
;

inline BOOL is_ge (const CHAR & x2) const
;

inline BOOL operator >= (const CHAR & x2) const
;

inline CHAR times (const CHAR & x2) const
;

inline CHAR & operator *= (const CHAR & x2)
;

inline CHAR operator * (const CHAR & x2) const
;

inline CHAR plus (const CHAR & x2) const
;

inline CHAR & operator += (const CHAR & x2)
;

inline CHAR operator + (const CHAR & x2) const
;

inline CHAR copy () const
;

inline void del ()
;

inline CHAR succ ()
;

inline CHAR & operator ++ ()
;

inline CHAR operator ++ (int)
;

inline CHAR mod (const CHAR & x2) const
;

inline CHAR & operator %= (const CHAR & x2)
;

inline CHAR operator % (const CHAR & x2) const
;

inline BOOL is_le (const CHAR & x2) const
;

inline BOOL operator <= (const CHAR & x2) const
;

inline BOOL is_gr (const CHAR & x2) const
;

inline BOOL operator > (const CHAR & x2) const
;

inline CHAR div (const CHAR & x2) const
;

inline CHAR & operator /= (const CHAR & x2)
;

inline CHAR operator / (const CHAR & x2) const
;

inline CHAR minus (const CHAR & x2) const
;

inline CHAR & operator -= (const CHAR & x2)
;

inline CHAR operator - (const CHAR & x2) const
;

};
class STR {
public:
Str data;

STR()
{
data = 0;
/* == non valid handle */
}

~STR() { del_str(data); }

STR(const STR & x1)
{
check_handle_str(x1.data);
data = x1.data;
data->f_rc++;
}

STR(const Str &x1)
{
check_handle_str(x1);
data = x1;

}

STR & operator=(const STR & x1)
{
check_handle_str(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_str(data);
data = x1.data;
return *this;
}

Str cv_str() const
{
check_handle_str(data);
data->f_rc++;
return data;
}

inline STR & ovwrt1 (const NAT1 & x2, const CHAR & x3)
;

inline BOOL is_gr (const STR & x2) const
;

inline BOOL operator > (const STR & x2) const
;

inline STR & appr (const CHAR & x2)
;

inline STR & operator += (const CHAR & x2)
;

inline STR operator + (const CHAR & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline CHAR hd () const
;
inline STR (const NILETC & x1)
;
inline void cpc (char * x2) const
;

/* === Member function 'del' not required for automem implementations === */

inline NAT0 len () const
;

STR quote () const ;

STR mkdir () const ;

inline STR & sub_tup (const NAT1 & x2, const NAT0 & x3)
;
inline NAT0 index (const STR & x2, const NAT1 x3) const
;

inline STR & fread (const STR & x1)
;
inline BOOL fwrite (const STR & x2) const
;
inline NAT0 index (const STR & x2) const
;

inline STR & conc_path (const STR & x2)

;

inline STR (const STR & x1, const NAT1 & x2, const NAT0 & x3)
;
inline void fpr (ostream & x1) const
;
inline friend ostream & operator << (ostream & x1, const STR & x2)
;

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline STR (const CHAR & x1, const NAT0 & x2)
;
inline void puts (ostream & x2) const
;

inline NAT0 index (const CHAR & x2) const
;

inline STR & conc (const STR & x2)
;

inline STR & operator += (const STR & x2)
;

inline STR operator + (const STR & x2) const
;

STR headline () const ;

STRINGL split (const CHAR & x2) const ;

/* === Member function 'copy' not required for automem implementations === */
inline STR (char * x1)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline STR & appl (const CHAR & x1)
;
inline friend STR operator + (const CHAR & x1, STR & x2)
;

/* Member function 'del1' not required for automem implementations */

inline STR & tl ()
;
inline STR (const CHAR & x1)
;

inline CHAR sel (const NAT1 & x2) const
;
 CHAR operator [] (const NAT1 & x2) const
;

inline BOOL is_eq (const STR & x2) const
;

inline BOOL operator == (const STR & x2) const
;

inline BOOL operator != (const STR & x2) const
;

};

class OUTBYTES {
public:
Outbytes data;

OUTBYTES () { }
OUTBYTES (const Outbytes & x1) { data = x1; }
OUTBYTES (const OUTBYTES & x1) { data = x1.data; }
OUTBYTES & operator=(const OUTBYTES & x1) { data = x1.data; return *this; }

Outbytes cv_outbytes() const { return data; }

inline void del1 ()
;

inline BOOL fwrite (const STR & x2) const
;

inline OUTBYTES & appr (const BYTE & x2)
;

inline OUTBYTES & operator + (const BYTE & x2)
;

inline OUTBYTES & operator += (const BYTE & x2)
;

inline OUTBYTES (const NILETC & x1)
;
};
class INBYTES {
public:
Inbytes data;

INBYTES () { }
INBYTES (const Inbytes & x1) { data = x1; }
INBYTES (const INBYTES & x1) { data = x1.data; }
INBYTES & operator=(const INBYTES & x1) { data = x1.data; return *this; }

Inbytes cv_inbytes() const { return data; }

inline INBYTES & tld ()
;

inline void del ()
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline void del1 ()
;

inline INBYTES & fread (const STR & x1)
;
inline BYTE hd () const
;
inline INBYTES & tl ()
;
inline NAT0 len () const
;
};
class NAT0 {
public:
Nat0 data;
NAT0 () {}
NAT0 (Nat0 x1) { data = x1; }
NAT0 & operator=(Nat0 x1) { data = x1; return *this; }
NAT0 (const NAT0 & x1) { data = x1.data; }
NAT0 & operator=(const NAT0 & x1) { data = x1.data; return *this; }

Nat0 cv_nat0() const { return data; }

NAT0 (const INTG & x1);

inline NAT0 pred ()
;

inline NAT0 & operator -- ()
;

inline NAT0 operator -- (int)
;

inline BOOL is_eq (const NAT0 & x2) const
;

inline BOOL operator == (const NAT0 & x2) const
;

inline BOOL operator != (const NAT0 & x2) const
;

inline BOOL operator ! () const
;

inline BOOL is_lt (const NAT0 & x2) const
;

inline BOOL operator < (const NAT0 & x2) const
;

inline BOOL is_ge (const NAT0 & x2) const
;

inline BOOL operator >= (const NAT0 & x2) const
;

inline NAT0 times (const NAT0 & x2) const
;

inline NAT0 & operator *= (const NAT0 & x2)
;

inline NAT0 operator * (const NAT0 & x2) const
;

inline NAT0 plus (const NAT0 & x2) const
;

inline NAT0 & operator += (const NAT0 & x2)
;

inline NAT0 operator + (const NAT0 & x2) const
;

inline NAT0 succ ()
;

inline NAT0 & operator ++ ()
;

inline NAT0 operator ++ (int)
;

inline NAT0 mod (const NAT0 & x2) const
;

inline NAT0 & operator %= (const NAT0 & x2)
;

inline NAT0 operator % (const NAT0 & x2) const
;

inline BOOL is_le (const NAT0 & x2) const
;

inline BOOL operator <= (const NAT0 & x2) const
;

inline BOOL is_gr (const NAT0 & x2) const
;

inline BOOL operator > (const NAT0 & x2) const
;

inline NAT0 div (const NAT0 & x2) const
;

inline NAT0 & operator /= (const NAT0 & x2)
;

inline NAT0 operator / (const NAT0 & x2) const
;

inline NAT0 minus (const NAT0 & x2) const
;

inline NAT0 & operator -= (const NAT0 & x2)
;

inline NAT0 operator - (const NAT0 & x2) const
;

};
class STRINGL {
public:
Stringl data;

STRINGL()
{
data = 0;
/* == non valid handle */
}

~STRINGL() { del_stringl(data); }

STRINGL(const STRINGL & x1)
{
check_handle_stringl(x1.data);
data = x1.data;
data->f_rc++;
}

STRINGL(const Stringl &x1)
{
check_handle_stringl(x1);
data = x1;

}

STRINGL & operator=(const STRINGL & x1)
{
check_handle_stringl(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_stringl(data);
data = x1.data;
return *this;
}

Stringl cv_stringl() const
{
check_handle_stringl(data);
data->f_rc++;
return data;
}

/* === Member function 'del' not required for automem implementations === */

inline STRINGL (const STR & x1)
;

inline STR sel (const NAT1 & x2) const
;
 STR operator [] (const NAT1 & x2) const
;
inline STRINGL & tl ()
;

/* Member function 'del1' not required for automem implementations */

inline STRINGL & conc (const STRINGL & x2)
;

inline STRINGL & operator += (const STRINGL & x2)
;

inline STRINGL operator + (const STRINGL & x2) const
;

inline STR hd () const
;
inline STRINGL (const NILETC & x1)
;
inline STRINGL & sub_tup (const NAT1 & x2, const NAT0 & x3)
;

STR concat (const STR & x2) const ;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline STRINGL & appl (const STR & x1)
;
inline friend STRINGL operator + (const STR & x1, STRINGL & x2)
;

/* Member function 'copy1' not required for automem implementations */

inline STRINGL & appr (const STR & x2)
;

inline STRINGL & operator += (const STR & x2)
;

inline STRINGL operator + (const STR & x2) const
;

inline NAT0 len () const
;
};
class ITER_STR {
public:
Iter_str data;
~ITER_STR() { del_iter_str(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_STR (STR x1)
;
inline CHAR sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class ITER_STRINGL {
public:
Iter_stringl data;
~ITER_STRINGL() { del_iter_stringl(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_STRINGL (STRINGL x1)
;
inline STR sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class STRINGS {
public:
Strings data;

STRINGS()
{
data = 0;
/* == non valid handle */
}

~STRINGS()
{
del_strings(data);
}

STRINGS(const STRINGS & x1)
{
check_handle_strings(x1.data);
data = x1.data;
data->f_rc++;
}

STRINGS(const Strings &x1)
{
check_handle_strings(x1);
data = x1;
}

STRINGS & operator = (const STRINGS & x1)
{
check_handle_strings(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_strings(data);
data = x1.data;
return *this;
}

Strings cv_strings() const
{
check_handle_strings(data);
data->f_rc++;
return data;
}

inline BOOL is_eq (const STRINGS & x2) const
;

inline BOOL operator == (const STRINGS & x2) const
;

inline BOOL operator != (const STRINGS & x2) const
;

/* === Member function 'del' not required for automem implementations === */

inline STRINGS (const STR & x1)
;

inline STRINGS & plus1 (const STR & x2)
;

inline STRINGS & operator |= (const STR & x2)
;

inline STRINGS operator | (const STR & x2) const
;

inline STRINGS & inters (const STRINGS & x2)
;

inline STRINGS & operator &= (const STRINGS & x2)
;

inline STRINGS operator & (const STRINGS & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline STRINGS & diff (const STRINGS & x2)
;

inline STRINGS & operator -= (const STRINGS & x2)
;

inline STRINGS operator - (const STRINGS & x2) const
;

inline NAT0 card () const
;

inline STRINGS (const NILETC & x1)
;

inline STRINGL sort () const
;

BOOL is_empty_or_is_in (const STR & x2) const ;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline STRINGS & sub1 (const STR & x2)
;

inline STRINGS & operator -= (const STR & x2)
;

inline STRINGS operator - (const STR & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline STRINGS & plus (const STRINGS & x2)
;

inline STRINGS & operator |= (const STRINGS & x2)
;

inline STRINGS operator | (const STRINGS & x2) const
;

inline BOOL is_in (const STR & x1) const
;
/* === Member function 'copy' not required for automem implementations === */
};
class ITER_STRINGS {
public:
Iter_strings data;
~ITER_STRINGS() { del_iter_strings(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_STRINGS (STRINGS x1)
;
inline STR sel ()
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class CONTEXT {
public:
Context data;

CONTEXT()
{
data = 0;
/* == non valid handle */
}

~CONTEXT()
{
del_context(data);
}

CONTEXT(const CONTEXT & x1)
{
check_handle_context(x1.data);
data = x1.data;
data->f_rc++;
}

CONTEXT(const Context &x1)
{
check_handle_context(x1);
data = x1;
}

CONTEXT & operator = (const CONTEXT & x1)
{
check_handle_context(x1.data);
(x1.data)->f_rc++;
if (data!=0) del_context(data);
data = x1.data;
return *this;
}

Context cv_context() const
{
check_handle_context(data);
data->f_rc++;
return data;
}

inline BOOL is_eq (const CONTEXT & x2) const
;

inline BOOL operator == (const CONTEXT & x2) const
;

inline BOOL operator != (const CONTEXT & x2) const
;

/* === Member function 'copy' not required for automem implementations === */

/* Member function 'copy1' not required for automem implementations */

inline CONTEXT & chg_adttypes (const STRINGS & x2)
;

inline CONTEXT & chg_special_impl (const STRINGS & x2)
;

inline CONTEXT & chg_special_ops (const STRINGS & x2)
;

inline CONTEXT & chg_filter_adts (const STRINGS & x2)
;

inline CONTEXT & chg_filter_impl (const STRINGS & x2)
;

inline CONTEXT & chg_filter_oper (const STRINGS & x2)
;

inline CONTEXT & chg_filter_comp (const STRINGS & x2)
;

inline CONTEXT & chg_filter_params (const STRINGS & x2)
;

inline CONTEXT & chg_sign_comps (const STRINGS & x2)
;

inline CONTEXT & chg_operationtype (const STR & x2)
;

inline CONTEXT
(

const STRINGS & x_adttypes_context
,
const STRINGS & x_special_impl_context
,
const STRINGS & x_special_ops_context
,
const STRINGS & x_filter_adts_context
,
const STRINGS & x_filter_impl_context
,
const STRINGS & x_filter_oper_context
,
const STRINGS & x_filter_comp_context
,
const STRINGS & x_filter_params_context
,
const STRINGS & x_sign_comps_context

,
const STR & x_operationtype_context

)
;

/* Member function 'del1' not required for automem implementations */

inline STRINGS adttypes () const
;

inline STRINGS special_impl () const
;

inline STRINGS special_ops () const
;

inline STRINGS filter_adts () const
;

inline STRINGS filter_impl () const
;

inline STRINGS filter_oper () const
;

inline STRINGS filter_comp () const
;

inline STRINGS filter_params () const
;

inline STRINGS sign_comps () const
;

inline STR operationtype () const
;

/* === Member function 'del' not required for automem implementations === */

};
class OPERATION {
public:
Operation data;

OPERATION()
{
data = 0;
/* == non valid handle */
}

~OPERATION() { del_operation(data); }

OPERATION(const OPERATION & x1)
{
check_handle_operation(x1.data);
data = x1.data;
data->f_rc++;
}

OPERATION(const Operation &x1)
{
check_handle_operation(x1);
data = x1;
data->f_rc++;
}

OPERATION & operator = (const OPERATION & x1)
{
check_handle_operation(x1.data);
if (data != x1.data)
{
if (data!=0) del_operation(data);
data = x1.data;
data->f_rc++;
}
return *this;
}

Operation cv_operation() const
{
check_handle_operation(data);
data->f_rc++;
return data;
}

inline BOOL is_eq (const OPERATION & x2) const
;

inline BOOL operator == (const OPERATION & x2) const
;

inline BOOL operator != (const OPERATION & x2) const
;

/* === Member function 'del' not required for automem implementations === */

inline OPERATION (const COMPNAME & x1, const COMPONENT & x2)
;
inline NAT0 card () const
;

inline OPERATION & sub1 (const COMPNAME & x2)
;

inline OPERATION & operator -= (const COMPNAME & x2)
;

inline OPERATION operator - (const COMPNAME & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline OPERATION & ovwrt1 (const COMPNAME & x2, const COMPONENT & x3)
;

inline OPERATION & operator += (const PAIR_OPERATION & x2)
;

inline BOOL is_in_dom (const COMPNAME & x1, COMPONENT & x3) const
;

inline OPERATION (const NILETC & x1)
;
inline STRINGS dom () const
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline COMPONENT sel (const COMPNAME & x2) const
;

 COMPONENT operator [] (const COMPNAME & x2) const
;

inline OPERATION & plus (const OPERATION & x2)
;

inline OPERATION & operator |= (const OPERATION & x2)
;

inline OPERATION operator | (const OPERATION & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline OPERATION & ovwrt (const OPERATION & x2)
;

inline OPERATION & operator += (const OPERATION & x2)
;

inline OPERATION operator + (const OPERATION & x2) const
;

inline OPERATION & plus1 (const COMPNAME & x2, const COMPONENT & x3)
;

inline OPERATION & operator |= (const PAIR_OPERATION & x2)
;

inline BOOL is_in (const COMPNAME & x1) const
;
/* === Member function 'copy' not required for automem implementations === */
};
class ITER_OPERATION {
public:
Iter_operation data;
~ITER_OPERATION() { del_iter_operation(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_OPERATION (OPERATION x1)
;
inline COMPNAME sel (COMPONENT & x2)
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class CONTEXTMAP {
public:
ContextMap data;

CONTEXTMAP()
{
data = 0;
/* == non valid handle */
}

~CONTEXTMAP() { del_contextmap(data); }

CONTEXTMAP(const CONTEXTMAP & x1)
{
check_handle_contextmap(x1.data);
data = x1.data;
data->f_rc++;
}

CONTEXTMAP(const ContextMap &x1)
{
check_handle_contextmap(x1);
data = x1;
data->f_rc++;
}

CONTEXTMAP & operator = (const CONTEXTMAP & x1)
{
check_handle_contextmap(x1.data);
if (data != x1.data)
{
if (data!=0) del_contextmap(data);
data = x1.data;
data->f_rc++;
}
return *this;
}

ContextMap cv_contextmap() const
{
check_handle_contextmap(data);
data->f_rc++;
return data;
}

/* === Member function 'del' not required for automem implementations === */

inline CONTEXTMAP (const INTG & x1, const CONTEXT & x2)
;
inline NAT0 card () const
;

inline CONTEXTMAP & sub1 (const INTG & x2)
;

inline CONTEXTMAP & operator -= (const INTG & x2)
;

inline CONTEXTMAP operator - (const INTG & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline CONTEXTMAP & ovwrt1 (const INTG & x2, const CONTEXT & x3)
;

inline CONTEXTMAP & operator += (const PAIR_CONTEXTMAP & x2)
;

inline BOOL is_in_dom (const INTG & x1, CONTEXT & x3) const
;

inline CONTEXTMAP (const NILETC & x1)
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline CONTEXT sel (const INTG & x2) const
;

 CONTEXT operator [] (const INTG & x2) const
;

inline CONTEXTMAP & plus (const CONTEXTMAP & x2)
;

inline CONTEXTMAP & operator |= (const CONTEXTMAP & x2)
;

inline CONTEXTMAP operator | (const CONTEXTMAP & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline CONTEXTMAP & ovwrt (const CONTEXTMAP & x2)
;

inline CONTEXTMAP & operator += (const CONTEXTMAP & x2)
;

inline CONTEXTMAP operator + (const CONTEXTMAP & x2) const
;

inline CONTEXTMAP & plus1 (const INTG & x2, const CONTEXT & x3)
;

inline CONTEXTMAP & operator |= (const PAIR_CONTEXTMAP & x2)
;

inline BOOL is_in (const INTG & x1) const
;
};
class IMPL {
public:
Impl data;

IMPL()
{
data = 0;
/* == non valid handle */
}

~IMPL() { del_impl(data); }

IMPL(const IMPL & x1)
{
check_handle_impl(x1.data);
data = x1.data;
data->f_rc++;
}

IMPL(const Impl &x1)
{
check_handle_impl(x1);
data = x1;
data->f_rc++;
}

IMPL & operator = (const IMPL & x1)
{
check_handle_impl(x1.data);
if (data != x1.data)
{
if (data!=0) del_impl(data);
data = x1.data;
data->f_rc++;
}
return *this;
}

Impl cv_impl() const
{
check_handle_impl(data);
data->f_rc++;
return data;
}

inline BOOL is_eq (const IMPL & x2) const
;

inline BOOL operator == (const IMPL & x2) const
;

inline BOOL operator != (const IMPL & x2) const
;

/* === Member function 'del' not required for automem implementations === */

inline IMPL (const OPNAME & x1, const OPERATION & x2)
;
inline NAT0 card () const
;

inline IMPL & sub1 (const OPNAME & x2)
;

inline IMPL & operator -= (const OPNAME & x2)
;

inline IMPL operator - (const OPNAME & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline IMPL & ovwrt1 (const OPNAME & x2, const OPERATION & x3)
;

inline IMPL & operator += (const PAIR_IMPL & x2)
;

inline BOOL is_in_dom (const OPNAME & x1, OPERATION & x3) const
;

inline IMPL (const NILETC & x1)
;
inline STRINGS dom () const
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline OPERATION sel (const OPNAME & x2) const
;

 OPERATION operator [] (const OPNAME & x2) const
;

inline IMPL & plus (const IMPL & x2)
;

inline IMPL & operator |= (const IMPL & x2)
;

inline IMPL operator | (const IMPL & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline IMPL & ovwrt (const IMPL & x2)
;

inline IMPL & operator += (const IMPL & x2)
;

inline IMPL operator + (const IMPL & x2) const
;

inline IMPL & plus1 (const OPNAME & x2, const OPERATION & x3)
;

inline IMPL & operator |= (const PAIR_IMPL & x2)
;

inline BOOL is_in (const OPNAME & x1) const
;
/* === Member function 'copy' not required for automem implementations === */
};
class ITER_CONTEXTMAP {
public:
Iter_contextmap data;
~ITER_CONTEXTMAP() { del_iter_contextmap(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_CONTEXTMAP (CONTEXTMAP x1)
;
inline INTG sel (CONTEXT & x2)
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class ITER_IMPL {
public:
Iter_impl data;
~ITER_IMPL() { del_iter_impl(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_IMPL (IMPL x1)
;
inline OPNAME sel (OPERATION & x2)
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class ADT {
public:
Adt data;

ADT()
{
data = 0;
/* == non valid handle */
}

~ADT() { del_adt(data); }

ADT(const ADT & x1)
{
check_handle_adt(x1.data);
data = x1.data;
data->f_rc++;
}

ADT(const Adt &x1)
{
check_handle_adt(x1);
data = x1;
data->f_rc++;
}

ADT & operator = (const ADT & x1)
{
check_handle_adt(x1.data);
if (data != x1.data)
{
if (data!=0) del_adt(data);
data = x1.data;
data->f_rc++;
}
return *this;
}

Adt cv_adt() const
{
check_handle_adt(data);
data->f_rc++;
return data;
}

inline BOOL is_eq (const ADT & x2) const
;

inline BOOL operator == (const ADT & x2) const
;

inline BOOL operator != (const ADT & x2) const
;

/* === Member function 'del' not required for automem implementations === */

inline ADT (const IMPLNAME & x1, const IMPL & x2)
;
inline NAT0 card () const
;

inline ADT & sub1 (const IMPLNAME & x2)
;

inline ADT & operator -= (const IMPLNAME & x2)
;

inline ADT operator - (const IMPLNAME & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline ADT & ovwrt1 (const IMPLNAME & x2, const IMPL & x3)
;

inline ADT & operator += (const PAIR_ADT & x2)
;

inline BOOL is_in_dom (const IMPLNAME & x1, IMPL & x3) const
;

inline ADT (const NILETC & x1)
;
inline STRINGS dom () const
;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline IMPL sel (const IMPLNAME & x2) const
;

 IMPL operator [] (const IMPLNAME & x2) const
;

inline ADT & plus (const ADT & x2)
;

inline ADT & operator |= (const ADT & x2)
;

inline ADT operator | (const ADT & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline ADT & ovwrt (const ADT & x2)
;

inline ADT & operator += (const ADT & x2)
;

inline ADT operator + (const ADT & x2) const
;

inline ADT & plus1 (const IMPLNAME & x2, const IMPL & x3)
;

inline ADT & operator |= (const PAIR_ADT & x2)
;

inline BOOL is_in (const IMPLNAME & x1) const
;
/* === Member function 'copy' not required for automem implementations === */
};
class ITER_ADT {
public:
Iter_adt data;
~ITER_ADT() { del_iter_adt(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_ADT (ADT x1)
;
inline IMPLNAME sel (IMPL & x2)
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};
class VDMDB {
public:
Vdmdb data;

VDMDB()
{
data = 0;
/* == non valid handle */
}

~VDMDB() { del_vdmdb(data); }

VDMDB(const VDMDB & x1)
{
check_handle_vdmdb(x1.data);
data = x1.data;
data->f_rc++;
}

VDMDB(const Vdmdb &x1)
{
check_handle_vdmdb(x1);
data = x1;
data->f_rc++;
}

VDMDB & operator = (const VDMDB & x1)
{
check_handle_vdmdb(x1.data);
if (data != x1.data)
{
if (data!=0) del_vdmdb(data);
data = x1.data;
data->f_rc++;
}
return *this;
}

Vdmdb cv_vdmdb() const
{
check_handle_vdmdb(data);
data->f_rc++;
return data;
}

/* === Member function 'del' not required for automem implementations === */

inline VDMDB (const ADTNAME & x1, const ADT & x2)
;
inline NAT0 card () const
;

inline VDMDB & sub1 (const ADTNAME & x2)
;

inline VDMDB & operator -= (const ADTNAME & x2)
;

inline VDMDB operator - (const ADTNAME & x2) const
;

/* Member function 'copy1' not required for automem implementations */

inline VDMDB & ovwrt1 (const ADTNAME & x2, const ADT & x3)
;

inline VDMDB & operator += (const PAIR_VDMDB & x2)
;

inline BOOL is_in_dom (const ADTNAME & x1, ADT & x3) const
;

inline VDMDB (const NILETC & x1)
;

BOOL exist_impl (const ADTNAME & x2, const IMPLNAME & x3) const ;

BOOL exist_component (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4, const COMPNAME & x5) const ;

BOOL search_operation (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4) const ;

COMPONENT search_component (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4, const COMPNAME & x5) const ;

COMPONENT compute_sign_component (const ADTNAME & x2, const OPNAME & x3, const COMPNAME & x4) const ;

COMPONENT search_docu_components (const ADTNAME & x2, const OPNAME & x3, const COMPNAME & x4, const STRINGS & x5) const ;

STR sel_adttype (const ADTNAME & x2) const ;

STRINGS sel_adts () const ;

STRINGS sel_oper (const ADTNAME & x2, const IMPLNAME & x3) const ;

STRINGS sel_opr1 (const ADTNAME & x2, const IMPLNAME & x3, const STR & x4) const ;

STRINGS sel_impl_params (const ADTNAME & x2, const IMPLNAME & x3) const ;

VDMDB sel_db (const STRINGS & x2, const STRINGS & x3, const STRINGS & x4, const STRINGS & x5) const ;

STR solve_include (const STR & x2) const ;

BOOL new_adt (const ADTNAME & x2)  ;

BOOL new_operation (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4)  ;

BOOL import (const STR & x2)  ;

BOOL rm_impl (const ADTNAME & x2, const IMPLNAME & x3)  ;

BOOL rm_component (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4, const COMPNAME & x5)  ;

inline OUTBYTES cvtotupl ()
;

inline STRINGS dom () const
;

inline VDMDB & cvfromtupl (INBYTES & x1)
;

BOOL rm_operation (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4)  ;

BOOL rm_adt (const ADTNAME & x2)  ;

BOOL new_component (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4, const COMPNAME & x5, const COMPONENT & x6)  ;

BOOL new_impl (const ADTNAME & x2, const IMPLNAME & x3)  ;

STR insert_include (const STR & x2) const ;

STR export () const ;

STRINGS sel_oper_params (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4) const ;

STRINGS sel_comp (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4) const ;

STRINGS sel_op (const ADTNAME & x2, const IMPLNAME & x3) const ;

STRINGS sel_impl (const ADTNAME & x2) const ;

STR classify_op (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4) const ;

STR setup_docu () const ;

COMPONENT search_sign_component (const ADTNAME & x2, const OPNAME & x3, const COMPNAME & x4) const ;

COMPONENT sel_component (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4, const COMPNAME & x5) const ;

COMPONENT compute_component (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4, const COMPNAME & x5) const ;

BOOL comp_is_in (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4, const COMPNAME & x5 , COMPONENT & r2) const ;

BOOL exist_operation (const ADTNAME & x2, const IMPLNAME & x3, const OPNAME & x4) const ;

BOOL exist_adt (const ADTNAME & x2) const ;

inline BOOL is_empty () const
;

inline BOOL operator ! () const
;

inline ADT sel (const ADTNAME & x2) const
;

 ADT operator [] (const ADTNAME & x2) const
;

inline VDMDB & plus (const VDMDB & x2)
;

inline VDMDB & operator |= (const VDMDB & x2)
;

inline VDMDB operator | (const VDMDB & x2) const
;

/* Member function 'del1' not required for automem implementations */

inline VDMDB & ovwrt (const VDMDB & x2)
;

inline VDMDB & operator += (const VDMDB & x2)
;

inline VDMDB operator + (const VDMDB & x2) const
;

inline VDMDB & plus1 (const ADTNAME & x2, const ADT & x3)
;

inline VDMDB & operator |= (const PAIR_VDMDB & x2)
;

inline BOOL is_in (const ADTNAME & x1) const
;
};
class ITER_VDMDB {
public:
Iter_vdmdb data;
~ITER_VDMDB() { del_iter_vdmdb(data); }
inline BOOL is_empty ()
;

inline BOOL operator ! ()
;

/* === Member function 'del' not required for automem implementations === */

inline ITER_VDMDB (VDMDB x1)
;
inline ADTNAME sel (ADT & x2)
;
inline void next ()
;

inline void operator ++ ()
;

inline void operator ++ (int)
;
};

/* ------- PHASE3 ------------------ */
extern NILETC empty, nil, new_val;
typedef NILETC * mklc;

inline BOOL BOOL :: not () const
{ return BOOL(not_bool (data));}

inline BOOL BOOL :: operator ! () const
{ return BOOL(not_bool (data));}

inline BOOL BOOL :: is_gr (const BOOL & x2) const
{ return BOOL(is_gr_bool (data, x2.data));}

inline BOOL BOOL :: operator > (const BOOL & x2) const
{ return BOOL(is_gr_bool (data, x2.data));}

inline BOOL BOOL :: xor (const BOOL & x2)
{ return BOOL(xor_bool (data, x2.data));}

inline BOOL & BOOL :: operator ^= (const BOOL & x2)
{ data = xor_bool (data, x2.data); return *this;}

inline BOOL BOOL :: operator ^ (const BOOL & x2)
{ return BOOL(xor_bool (data, x2.data));}

inline void BOOL :: fpr (ostream & x1) const
{ fpr_bool (x1, data);}
inline ostream & operator << (ostream & x1, const BOOL & x2)
{ fpr_bool (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline BOOL BOOL :: and (const BOOL & x2)
{ return BOOL(and_bool (data, x2.data));}

inline BOOL & BOOL :: operator &= (const BOOL & x2)
{ data = and_bool (data, x2.data); return *this;}

inline BOOL BOOL :: operator & (const BOOL & x2)
{ return BOOL(and_bool (data, x2.data));}

inline BOOL BOOL :: is_eq (const BOOL & x2) const
{ return BOOL(is_eq_bool (data, x2.data));}

inline BOOL BOOL :: operator == (const BOOL & x2) const
{ return BOOL(is_eq_bool (data, x2.data));}

inline BOOL BOOL :: operator != (const BOOL & x2) const
{ return BOOL((Bool)! is_eq_bool (data, x2.data));}

inline BOOL BOOL :: is_ge (const BOOL & x2) const
{ return BOOL(is_ge_bool (data, x2.data));}

inline BOOL BOOL :: operator >= (const BOOL & x2) const
{ return BOOL(is_ge_bool (data, x2.data));}

inline BOOL BOOL :: or (const BOOL & x2)
{ return BOOL(or_bool (data, x2.data));}

inline BOOL & BOOL :: operator |= (const BOOL & x2)
{ data = or_bool (data, x2.data); return *this;}

inline BOOL BOOL :: operator | (const BOOL & x2)
{ return BOOL(or_bool (data, x2.data));}

inline
BYTE :: BYTE (const NAT0 & x1)
{
data = Byte(x1.data);
}
inline
BYTE :: operator NAT0 () const
{
return NAT0(Nat0(data));
}

inline BYTE BYTE :: pred ()
{ return BYTE(pred_byte (data));}

inline BYTE & BYTE :: operator -- ()
{ data = pred_byte (data); return *this;}

inline BYTE BYTE :: operator -- (int)
{ BYTE tmp=*this; { data = pred_byte (data);}; return tmp; }

inline BOOL BYTE :: is_eq (const BYTE & x2) const
{ return BOOL(is_eq_byte (data, x2.data));}

inline BOOL BYTE :: operator == (const BYTE & x2) const
{ return BOOL(is_eq_byte (data, x2.data));}

inline BOOL BYTE :: operator != (const BYTE & x2) const
{ return BOOL((Bool)! is_eq_byte (data, x2.data));}

inline BOOL BYTE :: operator ! () const
{ return BOOL((Bool)! is_eq_byte (data,((Byte)0)));}

inline BOOL BYTE :: is_lt (const BYTE & x2) const
{ return BOOL(is_lt_byte (data, x2.data));}

inline BOOL BYTE :: operator < (const BYTE & x2) const
{ return BOOL(is_lt_byte (data, x2.data));}

inline BOOL BYTE :: is_ge (const BYTE & x2) const
{ return BOOL(is_ge_byte (data, x2.data));}

inline BOOL BYTE :: operator >= (const BYTE & x2) const
{ return BOOL(is_ge_byte (data, x2.data));}

inline BYTE BYTE :: times (const BYTE & x2) const
{ return BYTE(times_byte (data, x2.data));}

inline BYTE & BYTE :: operator *= (const BYTE & x2)
{ data = times_byte (data, x2.data); return *this;}

inline BYTE BYTE :: operator * (const BYTE & x2) const
{ return BYTE(times_byte (data, x2.data));}

inline BYTE BYTE :: plus (const BYTE & x2) const
{ return BYTE(plus_byte (data, x2.data));}

inline BYTE & BYTE :: operator += (const BYTE & x2)
{ data = plus_byte (data, x2.data); return *this;}

inline BYTE BYTE :: operator + (const BYTE & x2) const
{ return BYTE(plus_byte (data, x2.data));}

inline BYTE BYTE :: succ ()
{ return BYTE(succ_byte (data));}

inline BYTE & BYTE :: operator ++ ()
{ data = succ_byte (data); return *this;}

inline BYTE BYTE :: operator ++ (int)
{ BYTE tmp=*this; { data = succ_byte (data);}; return tmp; }

inline BYTE BYTE :: mod (const BYTE & x2) const
{ return BYTE(mod_byte (data, x2.data));}

inline BYTE & BYTE :: operator %= (const BYTE & x2)
{ data = mod_byte (data, x2.data); return *this;}

inline BYTE BYTE :: operator % (const BYTE & x2) const
{ return BYTE(mod_byte (data, x2.data));}

inline BOOL BYTE :: is_le (const BYTE & x2) const
{ return BOOL(is_le_byte (data, x2.data));}

inline BOOL BYTE :: operator <= (const BYTE & x2) const
{ return BOOL(is_le_byte (data, x2.data));}

inline BOOL BYTE :: is_gr (const BYTE & x2) const
{ return BOOL(is_gr_byte (data, x2.data));}

inline BOOL BYTE :: operator > (const BYTE & x2) const
{ return BOOL(is_gr_byte (data, x2.data));}

inline BYTE BYTE :: div (const BYTE & x2) const
{ return BYTE(div_byte (data, x2.data));}

inline BYTE & BYTE :: operator /= (const BYTE & x2)
{ data = div_byte (data, x2.data); return *this;}

inline BYTE BYTE :: operator / (const BYTE & x2) const
{ return BYTE(div_byte (data, x2.data));}

inline BYTE BYTE :: minus (const BYTE & x2) const
{ return BYTE(minus_byte (data, x2.data));}

inline BYTE & BYTE :: operator -= (const BYTE & x2)
{ data = minus_byte (data, x2.data); return *this;}

inline BYTE BYTE :: operator - (const BYTE & x2) const
{ return BYTE(minus_byte (data, x2.data));}

inline INTG :: INTG (const NAT0 & x1)
{
data = Intg(x1.data);
}

inline INTG INTG :: pred ()
{ return INTG(pred_intg (data));}

inline INTG & INTG :: operator -- ()
{ data = pred_intg (data); return *this;}

inline INTG INTG :: operator -- (int)
{ INTG tmp=*this; { data = pred_intg (data);}; return tmp; }

inline BOOL INTG :: is_eq (const INTG & x2) const
{ return BOOL(is_eq_intg (data, x2.data));}

inline BOOL INTG :: operator == (const INTG & x2) const
{ return BOOL(is_eq_intg (data, x2.data));}

inline BOOL INTG :: operator != (const INTG & x2) const
{ return BOOL((Bool)! is_eq_intg (data, x2.data));}

inline BOOL INTG :: operator ! () const
{ return BOOL((Bool)! is_eq_intg (data,((Intg)0)));}

inline BOOL INTG :: is_lt (const INTG & x2) const
{ return BOOL(is_lt_intg (data, x2.data));}

inline BOOL INTG :: operator < (const INTG & x2) const
{ return BOOL(is_lt_intg (data, x2.data));}

inline BOOL INTG :: is_ge (const INTG & x2) const
{ return BOOL(is_ge_intg (data, x2.data));}

inline BOOL INTG :: operator >= (const INTG & x2) const
{ return BOOL(is_ge_intg (data, x2.data));}

inline INTG INTG :: times (const INTG & x2) const
{ return INTG(times_intg (data, x2.data));}

inline INTG & INTG :: operator *= (const INTG & x2)
{ data = times_intg (data, x2.data); return *this;}

inline INTG INTG :: operator * (const INTG & x2) const
{ return INTG(times_intg (data, x2.data));}

inline INTG INTG :: plus (const INTG & x2) const
{ return INTG(plus_intg (data, x2.data));}

inline INTG & INTG :: operator += (const INTG & x2)
{ data = plus_intg (data, x2.data); return *this;}

inline INTG INTG :: operator + (const INTG & x2) const
{ return INTG(plus_intg (data, x2.data));}

inline void INTG :: del ()
{ del_intg (data);}

inline STR INTG :: cvstr ()
{ return STR(cvstr_intg (data));}
inline INTG INTG :: copy () const
{ return INTG(copy_intg (data));}
inline void INTG :: set_print_format (char * x1) const
{ set_print_format_intg (x1);}

inline void INTG :: set_print_format () const
{ set_print_format_intg ((char *)0);}

inline INTG INTG :: succ ()
{ return INTG(succ_intg (data));}

inline INTG & INTG :: operator ++ ()
{ data = succ_intg (data); return *this;}

inline INTG INTG :: operator ++ (int)
{ INTG tmp=*this; { data = succ_intg (data);}; return tmp; }

inline INTG INTG :: mod (const INTG & x2) const
{ return INTG(mod_intg (data, x2.data));}

inline INTG & INTG :: operator %= (const INTG & x2)
{ data = mod_intg (data, x2.data); return *this;}

inline INTG INTG :: operator % (const INTG & x2) const
{ return INTG(mod_intg (data, x2.data));}

inline BOOL INTG :: is_le (const INTG & x2) const
{ return BOOL(is_le_intg (data, x2.data));}

inline BOOL INTG :: operator <= (const INTG & x2) const
{ return BOOL(is_le_intg (data, x2.data));}

inline BOOL INTG :: is_gr (const INTG & x2) const
{ return BOOL(is_gr_intg (data, x2.data));}

inline BOOL INTG :: operator > (const INTG & x2) const
{ return BOOL(is_gr_intg (data, x2.data));}

inline INTG INTG :: div (const INTG & x2) const
{ return INTG(div_intg (data, x2.data));}

inline INTG & INTG :: operator /= (const INTG & x2)
{ data = div_intg (data, x2.data); return *this;}

inline INTG INTG :: operator / (const INTG & x2) const
{ return INTG(div_intg (data, x2.data));}

inline INTG INTG :: minus (const INTG & x2) const
{ return INTG(minus_intg (data, x2.data));}

inline INTG & INTG :: operator -= (const INTG & x2)
{ data = minus_intg (data, x2.data); return *this;}

inline INTG INTG :: operator - (const INTG & x2) const
{ return INTG(minus_intg (data, x2.data));}

inline
NAT1 :: NAT1 (const NAT0 & x1)
{
data = Nat1(x1.data);
}
inline
NAT1 :: operator NAT0 () const
{
return NAT0(Nat0(data));
}

inline NAT1 NAT1 :: pred ()
{ return NAT1(pred_nat1 (data));}

inline NAT1 & NAT1 :: operator -- ()
{ data = pred_nat1 (data); return *this;}

inline NAT1 NAT1 :: operator -- (int)
{ NAT1 tmp=*this; { data = pred_nat1 (data);}; return tmp; }

inline BOOL NAT1 :: is_eq (const NAT1 & x2) const
{ return BOOL(is_eq_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator == (const NAT1 & x2) const
{ return BOOL(is_eq_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator != (const NAT1 & x2) const
{ return BOOL((Bool)! is_eq_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator ! () const
{ return BOOL((Bool)! is_eq_nat1 (data,((Nat1)0)));}

inline BOOL NAT1 :: is_lt (const NAT1 & x2) const
{ return BOOL(is_lt_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator < (const NAT1 & x2) const
{ return BOOL(is_lt_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_ge (const NAT1 & x2) const
{ return BOOL(is_ge_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator >= (const NAT1 & x2) const
{ return BOOL(is_ge_nat1 (data, x2.data));}

inline NAT1 NAT1 :: times (const NAT1 & x2) const
{ return NAT1(times_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator *= (const NAT1 & x2)
{ data = times_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator * (const NAT1 & x2) const
{ return NAT1(times_nat1 (data, x2.data));}

inline NAT1 NAT1 :: plus (const NAT1 & x2) const
{ return NAT1(plus_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator += (const NAT1 & x2)
{ data = plus_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator + (const NAT1 & x2) const
{ return NAT1(plus_nat1 (data, x2.data));}

inline NAT1 NAT1 :: succ ()
{ return NAT1(succ_nat1 (data));}

inline NAT1 & NAT1 :: operator ++ ()
{ data = succ_nat1 (data); return *this;}

inline NAT1 NAT1 :: operator ++ (int)
{ NAT1 tmp=*this; { data = succ_nat1 (data);}; return tmp; }

inline NAT1 NAT1 :: mod (const NAT1 & x2) const
{ return NAT1(mod_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator %= (const NAT1 & x2)
{ data = mod_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator % (const NAT1 & x2) const
{ return NAT1(mod_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_le (const NAT1 & x2) const
{ return BOOL(is_le_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator <= (const NAT1 & x2) const
{ return BOOL(is_le_nat1 (data, x2.data));}

inline BOOL NAT1 :: is_gr (const NAT1 & x2) const
{ return BOOL(is_gr_nat1 (data, x2.data));}

inline BOOL NAT1 :: operator > (const NAT1 & x2) const
{ return BOOL(is_gr_nat1 (data, x2.data));}

inline NAT1 NAT1 :: div (const NAT1 & x2) const
{ return NAT1(div_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator /= (const NAT1 & x2)
{ data = div_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator / (const NAT1 & x2) const
{ return NAT1(div_nat1 (data, x2.data));}

inline NAT1 NAT1 :: minus (const NAT1 & x2) const
{ return NAT1(minus_nat1 (data, x2.data));}

inline NAT1 & NAT1 :: operator -= (const NAT1 & x2)
{ data = minus_nat1 (data, x2.data); return *this;}

inline NAT1 NAT1 :: operator - (const NAT1 & x2) const
{ return NAT1(minus_nat1 (data, x2.data));}

inline
CHAR :: CHAR (const NAT0 & x1)
{
data = Char(x1.data);
}
inline
CHAR :: operator NAT0 () const
{
return NAT0(Nat0(data));
}

inline CHAR CHAR :: pred ()
{ return CHAR(pred_char (data));}

inline CHAR & CHAR :: operator -- ()
{ data = pred_char (data); return *this;}

inline CHAR CHAR :: operator -- (int)
{ CHAR tmp=*this; { data = pred_char (data);}; return tmp; }

inline BOOL CHAR :: is_eq (const CHAR & x2) const
{ return BOOL(is_eq_char (data, x2.data));}

inline BOOL CHAR :: operator == (const CHAR & x2) const
{ return BOOL(is_eq_char (data, x2.data));}

inline BOOL CHAR :: operator != (const CHAR & x2) const
{ return BOOL((Bool)! is_eq_char (data, x2.data));}

inline BOOL CHAR :: operator ! () const
{ return BOOL((Bool)! is_eq_char (data,((Char)0)));}

inline BOOL CHAR :: is_lt (const CHAR & x2) const
{ return BOOL(is_lt_char (data, x2.data));}

inline BOOL CHAR :: operator < (const CHAR & x2) const
{ return BOOL(is_lt_char (data, x2.data));}

inline BOOL CHAR :: is_ge (const CHAR & x2) const
{ return BOOL(is_ge_char (data, x2.data));}

inline BOOL CHAR :: operator >= (const CHAR & x2) const
{ return BOOL(is_ge_char (data, x2.data));}

inline CHAR CHAR :: times (const CHAR & x2) const
{ return CHAR(times_char (data, x2.data));}

inline CHAR & CHAR :: operator *= (const CHAR & x2)
{ data = times_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator * (const CHAR & x2) const
{ return CHAR(times_char (data, x2.data));}

inline CHAR CHAR :: plus (const CHAR & x2) const
{ return CHAR(plus_char (data, x2.data));}

inline CHAR & CHAR :: operator += (const CHAR & x2)
{ data = plus_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator + (const CHAR & x2) const
{ return CHAR(plus_char (data, x2.data));}

inline CHAR CHAR :: copy () const
{ return CHAR(copy_char (data));}

inline void CHAR :: del ()
{ del_char (data);}

inline CHAR CHAR :: succ ()
{ return CHAR(succ_char (data));}

inline CHAR & CHAR :: operator ++ ()
{ data = succ_char (data); return *this;}

inline CHAR CHAR :: operator ++ (int)
{ CHAR tmp=*this; { data = succ_char (data);}; return tmp; }

inline CHAR CHAR :: mod (const CHAR & x2) const
{ return CHAR(mod_char (data, x2.data));}

inline CHAR & CHAR :: operator %= (const CHAR & x2)
{ data = mod_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator % (const CHAR & x2) const
{ return CHAR(mod_char (data, x2.data));}

inline BOOL CHAR :: is_le (const CHAR & x2) const
{ return BOOL(is_le_char (data, x2.data));}

inline BOOL CHAR :: operator <= (const CHAR & x2) const
{ return BOOL(is_le_char (data, x2.data));}

inline BOOL CHAR :: is_gr (const CHAR & x2) const
{ return BOOL(is_gr_char (data, x2.data));}

inline BOOL CHAR :: operator > (const CHAR & x2) const
{ return BOOL(is_gr_char (data, x2.data));}

inline CHAR CHAR :: div (const CHAR & x2) const
{ return CHAR(div_char (data, x2.data));}

inline CHAR & CHAR :: operator /= (const CHAR & x2)
{ data = div_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator / (const CHAR & x2) const
{ return CHAR(div_char (data, x2.data));}

inline CHAR CHAR :: minus (const CHAR & x2) const
{ return CHAR(minus_char (data, x2.data));}

inline CHAR & CHAR :: operator -= (const CHAR & x2)
{ data = minus_char (data, x2.data); return *this;}

inline CHAR CHAR :: operator - (const CHAR & x2) const
{ return CHAR(minus_char (data, x2.data));}

inline STR & STR :: ovwrt1 (const NAT1 & x2, const CHAR & x3)
{ data = ovwrt1_str (data, x2.data, x3.data); return *this;}

inline BOOL STR :: is_gr (const STR & x2) const
{ return BOOL(is_gr_str (data, x2.data));}

inline BOOL STR :: operator > (const STR & x2) const
{ return BOOL(is_gr_str (data, x2.data));}

inline STR & STR :: appr (const CHAR & x2)
{ data = appr_str (data, x2.data); return *this;}

inline STR & STR :: operator += (const CHAR & x2)
{ data = appr_str (data, x2.data); return *this;}

inline STR STR :: operator + (const CHAR & x2) const
{ STR tmp=*this; tmp.data=appr_str(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline CHAR STR :: hd () const
{ return CHAR(hd_str (data));}
inline STR :: STR (const NILETC & x1)
{ data = mk_empty_str ();}
inline void STR :: cpc (char * x2) const
{ cpc_str (data,x2);}

/* === Member function 'del' not required for automem implementations === */

inline NAT0 STR :: len () const
{ return NAT0(len_str (data));}
inline STR & STR :: sub_tup (const NAT1 & x2, const NAT0 & x3)
{ data = sub_tup_str (data, x2.data, x3.data); return *this;}
inline NAT0 STR :: index (const STR & x2, const NAT1 x3) const
{ return NAT0(index_list_from_str (data, x2.data, x3.data));}

inline STR & STR :: fread (const STR & x1)
{del_str(data);
{ data = fread_str (x1.data); return *this;}
}

inline BOOL STR :: fwrite (const STR & x2) const
{ return BOOL(fwrite_str (data, x2.data));}
inline NAT0 STR :: index (const STR & x2) const
{ return NAT0(index_list_str (data, x2.data));}

inline STR & STR :: conc_path (const STR & x2)

{ data = conc_path_auto_str (data, x2.data); return *this;}

inline STR :: STR (const STR & x1, const NAT1 & x2, const NAT0 & x3)
{ data = mk_sub_tup_str (x1.data, x2.data, x3.data);}
inline void STR :: fpr (ostream & x1) const
{ fpr_str (x1, data);}
inline ostream & operator << (ostream & x1, const STR & x2)
{ fpr_str (x1,x2.data); return x1; }

/* NOTE: Do not generate 'fpr' together with 'fprint' for C++ */
/* since both will be mapped to the operator '<<' !!! */

inline STR :: STR (const CHAR & x1, const NAT0 & x2)
{ data = mkn_str (x1.data, x2.data);}
inline void STR :: puts (ostream & x2) const
{ puts_str (data, x2);}

inline NAT0 STR :: index (const CHAR & x2) const
{ return NAT0(index_str (data, x2.data));}

inline STR & STR :: conc (const STR & x2)
{ data = conc_auto_str (data, x2.data); return *this;}

inline STR & STR :: operator += (const STR & x2)
{ data = conc_auto_str (data, x2.data); return *this;}

inline STR STR :: operator + (const STR & x2) const
{ STR tmp=*this; tmp.data=conc_auto_str(tmp.data,x2.data); return tmp; }

/* === Member function 'copy' not required for automem implementations === */
inline STR :: STR (char * x1)
{ data = mkc_str (x1);}

inline BOOL STR :: is_empty () const
{ return BOOL(is_empty_str (data));}

inline BOOL STR :: operator ! () const
{ return BOOL(! is_empty_str (data));}

inline STR & STR :: appl (const CHAR & x1)
{ data = appl_str (x1.data, data); return *this;}
inline STR operator + (const CHAR & x1, STR & x2)
{STR tmp = x2; tmp.data = appl_str(x1.data, tmp.data); return tmp;}

/* Member function 'del1' not required for automem implementations */

inline STR & STR :: tl ()
{ data = tl_str (data); return *this;}
inline STR :: STR (const CHAR & x1)
{ data = mk1_str (x1.data);}

inline CHAR STR :: sel (const NAT1 & x2) const
{ return CHAR(sel_str (data, x2.data));}
inline CHAR STR :: operator [] (const NAT1 & x2) const
{ return CHAR(sel_str (data,x2.data));}

inline BOOL STR :: is_eq (const STR & x2) const
{ return BOOL(is_eq_str (data, x2.data));}

inline BOOL STR :: operator == (const STR & x2) const
{ return BOOL(is_eq_str (data, x2.data));}

inline BOOL STR :: operator != (const STR & x2) const
{ return BOOL((Bool)! is_eq_str (data, x2.data));}

inline void OUTBYTES :: del1 ()
{ del1_outbytes (data);}

inline BOOL OUTBYTES :: fwrite (const STR & x2) const
{ return BOOL(fwrite_outbytes (data, x2.data));}

inline OUTBYTES & OUTBYTES :: appr (const BYTE & x2)
{ data = appr_outbytes (data, x2.data); return *this;}

inline OUTBYTES & OUTBYTES :: operator + (const BYTE & x2)
{ data = appr_outbytes (data, x2.data); return *this;}

inline OUTBYTES & OUTBYTES :: operator += (const BYTE & x2)
{ data = appr_outbytes (data, x2.data); return *this;}

inline OUTBYTES :: OUTBYTES (const NILETC & x1)
{ data = mk_empty_outbytes ();}

inline INBYTES & INBYTES :: tld ()
{ data = tld_inbytes (data); return *this;}

inline void INBYTES :: del ()
{ del_inbytes (data);}

inline BOOL INBYTES :: is_empty () const
{ return BOOL(is_empty_inbytes (data));}

inline BOOL INBYTES :: operator ! () const
{ return BOOL(! is_empty_inbytes (data));}

inline void INBYTES :: del1 ()
{ del1_inbytes (data);}

inline INBYTES & INBYTES :: fread (const STR & x1)
{ data = fread_inbytes (x1.data); return *this;}
inline BYTE INBYTES :: hd () const
{ return BYTE(hd_inbytes (data));}
inline INBYTES & INBYTES :: tl ()
{ data = tl_inbytes (data); return *this;}
inline NAT0 INBYTES :: len () const
{ return NAT0(len_inbytes (data));}

inline
NAT0 :: NAT0 (const INTG & x1)
{
data = Nat0(x1.data);
}

inline NAT0 NAT0 :: pred ()
{ return NAT0(pred_nat0 (data));}

inline NAT0 & NAT0 :: operator -- ()
{ data = pred_nat0 (data); return *this;}

inline NAT0 NAT0 :: operator -- (int)
{ NAT0 tmp=*this; { data = pred_nat0 (data);}; return tmp; }

inline BOOL NAT0 :: is_eq (const NAT0 & x2) const
{ return BOOL(is_eq_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator == (const NAT0 & x2) const
{ return BOOL(is_eq_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator != (const NAT0 & x2) const
{ return BOOL((Bool)! is_eq_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator ! () const
{ return BOOL((Bool)! is_eq_nat0 (data,((Nat0)0)));}

inline BOOL NAT0 :: is_lt (const NAT0 & x2) const
{ return BOOL(is_lt_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator < (const NAT0 & x2) const
{ return BOOL(is_lt_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_ge (const NAT0 & x2) const
{ return BOOL(is_ge_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator >= (const NAT0 & x2) const
{ return BOOL(is_ge_nat0 (data, x2.data));}

inline NAT0 NAT0 :: times (const NAT0 & x2) const
{ return NAT0(times_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator *= (const NAT0 & x2)
{ data = times_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator * (const NAT0 & x2) const
{ return NAT0(times_nat0 (data, x2.data));}

inline NAT0 NAT0 :: plus (const NAT0 & x2) const
{ return NAT0(plus_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator += (const NAT0 & x2)
{ data = plus_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator + (const NAT0 & x2) const
{ return NAT0(plus_nat0 (data, x2.data));}

inline NAT0 NAT0 :: succ ()
{ return NAT0(succ_nat0 (data));}

inline NAT0 & NAT0 :: operator ++ ()
{ data = succ_nat0 (data); return *this;}

inline NAT0 NAT0 :: operator ++ (int)
{ NAT0 tmp=*this; { data = succ_nat0 (data);}; return tmp; }

inline NAT0 NAT0 :: mod (const NAT0 & x2) const
{ return NAT0(mod_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator %= (const NAT0 & x2)
{ data = mod_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator % (const NAT0 & x2) const
{ return NAT0(mod_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_le (const NAT0 & x2) const
{ return BOOL(is_le_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator <= (const NAT0 & x2) const
{ return BOOL(is_le_nat0 (data, x2.data));}

inline BOOL NAT0 :: is_gr (const NAT0 & x2) const
{ return BOOL(is_gr_nat0 (data, x2.data));}

inline BOOL NAT0 :: operator > (const NAT0 & x2) const
{ return BOOL(is_gr_nat0 (data, x2.data));}

inline NAT0 NAT0 :: div (const NAT0 & x2) const
{ return NAT0(div_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator /= (const NAT0 & x2)
{ data = div_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator / (const NAT0 & x2) const
{ return NAT0(div_nat0 (data, x2.data));}

inline NAT0 NAT0 :: minus (const NAT0 & x2) const
{ return NAT0(minus_nat0 (data, x2.data));}

inline NAT0 & NAT0 :: operator -= (const NAT0 & x2)
{ data = minus_nat0 (data, x2.data); return *this;}

inline NAT0 NAT0 :: operator - (const NAT0 & x2) const
{ return NAT0(minus_nat0 (data, x2.data));}

/* === Member function 'del' not required for automem implementations === */

inline STRINGL :: STRINGL (const STR & x1)
{ data = mk1_stringl (x1.data);}

inline STR STRINGL :: sel (const NAT1 & x2) const
{ return STR(sel_stringl (data, x2.data));}
inline STR STRINGL :: operator [] (const NAT1 & x2) const
{ return STR(sel_stringl (data,x2.data));}
inline STRINGL & STRINGL :: tl ()
{ data = tl_stringl (data); return *this;}

/* Member function 'del1' not required for automem implementations */

inline STRINGL & STRINGL :: conc (const STRINGL & x2)
{ data = conc_stringl (data, x2.data); return *this;}

inline STRINGL & STRINGL :: operator += (const STRINGL & x2)
{ data = conc_stringl (data, x2.data); return *this;}

inline STRINGL STRINGL :: operator + (const STRINGL & x2) const
{ STRINGL tmp=*this; tmp.data=conc_stringl(tmp.data,x2.data); return tmp; }

inline STR STRINGL :: hd () const
{ return STR(hd_stringl (data));}
inline STRINGL :: STRINGL (const NILETC & x1)
{ data = mk_empty_stringl ();}
inline STRINGL & STRINGL :: sub_tup (const NAT1 & x2, const NAT0 & x3)
{ data = sub_tup_stringl (data, x2.data, x3.data); return *this;}

inline BOOL STRINGL :: is_empty () const
{ return BOOL(is_empty_stringl (data));}

inline BOOL STRINGL :: operator ! () const
{ return BOOL(! is_empty_stringl (data));}

inline STRINGL & STRINGL :: appl (const STR & x1)
{ data = appl_stringl (x1.data, data); return *this;}
inline STRINGL operator + (const STR & x1, STRINGL & x2)
{STRINGL tmp = x2; tmp.data = appl_stringl(x1.data, tmp.data); return tmp;}

/* Member function 'copy1' not required for automem implementations */

inline STRINGL & STRINGL :: appr (const STR & x2)
{ data = appr_stringl (data, x2.data); return *this;}

inline STRINGL & STRINGL :: operator += (const STR & x2)
{ data = appr_stringl (data, x2.data); return *this;}

inline STRINGL STRINGL :: operator + (const STR & x2) const
{ STRINGL tmp=*this; tmp.data=appr_stringl(tmp.data,x2.data); return tmp; }

inline NAT0 STRINGL :: len () const
{ return NAT0(len_stringl (data));}
inline BOOL ITER_STR :: is_empty ()
{ return BOOL(is_empty_iter_str (&(data)));}

inline BOOL ITER_STR :: operator ! ()
{ return BOOL(! is_empty_iter_str (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_STR :: ITER_STR (STR x1)
{ data = mk_iter_str (x1.data);}
inline CHAR ITER_STR :: sel ()
{ return CHAR(sel_iter_str (&(data)));}
inline void ITER_STR :: next ()
{ next_iter_str (&(data));}

inline void ITER_STR :: operator ++ ()
{ next_iter_str (&(data));}

inline void ITER_STR :: operator ++ (int)
{ next_iter_str (&(data));}
inline BOOL ITER_STRINGL :: is_empty ()
{ return BOOL(is_empty_iter_stringl (&(data)));}

inline BOOL ITER_STRINGL :: operator ! ()
{ return BOOL(! is_empty_iter_stringl (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_STRINGL :: ITER_STRINGL (STRINGL x1)
{ data = mk_iter_stringl (x1.data);}
inline STR ITER_STRINGL :: sel ()
{ return STR(sel_iter_stringl (&(data)));}
inline void ITER_STRINGL :: next ()
{ next_iter_stringl (&(data));}

inline void ITER_STRINGL :: operator ++ ()
{ next_iter_stringl (&(data));}

inline void ITER_STRINGL :: operator ++ (int)
{ next_iter_stringl (&(data));}

inline BOOL STRINGS :: is_eq (const STRINGS & x2) const
{ return BOOL(is_eq_strings (data, x2.data));}

inline BOOL STRINGS :: operator == (const STRINGS & x2) const
{ return BOOL(is_eq_strings (data, x2.data));}

inline BOOL STRINGS :: operator != (const STRINGS & x2) const
{ return BOOL((Bool)! is_eq_strings (data, x2.data));}

/* === Member function 'del' not required for automem implementations === */

inline STRINGS :: STRINGS (const STR & x1)
{ data = mk1_strings (x1.data);}

inline STRINGS & STRINGS :: plus1 (const STR & x2)
{ data = union1_strings (data, x2.data); return *this;}

inline STRINGS & STRINGS :: operator |= (const STR & x2)
{ data = union1_strings (data, x2.data); return *this;}

inline STRINGS STRINGS :: operator | (const STR & x2) const
{ STRINGS tmp=*this; tmp.data=union1_strings(tmp.data,x2.data); return tmp; }

inline STRINGS & STRINGS :: inters (const STRINGS & x2)
{ data = inters_strings (data, x2.data); return *this;}

inline STRINGS & STRINGS :: operator &= (const STRINGS & x2)
{ data = inters_strings (data, x2.data); return *this;}

inline STRINGS STRINGS :: operator & (const STRINGS & x2) const
{ STRINGS tmp=*this; tmp.data=inters_strings(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline STRINGS & STRINGS :: diff (const STRINGS & x2)
{ data = diff_strings (data, x2.data); return *this;}

inline STRINGS & STRINGS :: operator -= (const STRINGS & x2)
{ data = diff_strings (data, x2.data); return *this;}

inline STRINGS STRINGS :: operator - (const STRINGS & x2) const
{ STRINGS tmp=*this; tmp.data=diff_strings(tmp.data,x2.data); return tmp; }

inline NAT0 STRINGS :: card () const
{ return NAT0(card_strings (data));}

inline STRINGS :: STRINGS (const NILETC & x1)
{ data = mk_empty_strings ();}

inline STRINGL STRINGS :: sort () const
{ return STRINGL(sort_strings (data));}

inline BOOL STRINGS :: is_empty () const
{ return BOOL(is_empty_strings (data));}

inline BOOL STRINGS :: operator ! () const
{ return BOOL(! is_empty_strings (data));}

inline STRINGS & STRINGS :: sub1 (const STR & x2)
{ data = sub1_strings (data, x2.data); return *this;}

inline STRINGS & STRINGS :: operator -= (const STR & x2)
{ data = sub1_strings (data, x2.data); return *this;}

inline STRINGS STRINGS :: operator - (const STR & x2) const
{ STRINGS tmp=*this; tmp.data=sub1_strings(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline STRINGS & STRINGS :: plus (const STRINGS & x2)
{ data = union_strings (data, x2.data); return *this;}

inline STRINGS & STRINGS :: operator |= (const STRINGS & x2)
{ data = union_strings (data, x2.data); return *this;}

inline STRINGS STRINGS :: operator | (const STRINGS & x2) const
{ STRINGS tmp=*this; tmp.data=union_strings(tmp.data,x2.data); return tmp; }

inline BOOL STRINGS :: is_in (const STR & x1) const
{ return BOOL(is_in_strings (x1.data, data));}
/* === Member function 'copy' not required for automem implementations === */
inline BOOL ITER_STRINGS :: is_empty ()
{ return BOOL(is_empty_iter_strings (&(data)));}

inline BOOL ITER_STRINGS :: operator ! ()
{ return BOOL(! is_empty_iter_strings (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_STRINGS :: ITER_STRINGS (STRINGS x1)
{ data = mk_iter_strings (x1.data);}
inline STR ITER_STRINGS :: sel ()
{ return STR(sel_iter_strings (&(data)));}
inline void ITER_STRINGS :: next ()
{ next_iter_strings (&(data));}

inline void ITER_STRINGS :: operator ++ ()
{ next_iter_strings (&(data));}

inline void ITER_STRINGS :: operator ++ (int)
{ next_iter_strings (&(data));}

inline BOOL CONTEXT :: is_eq (const CONTEXT & x2) const
{ return BOOL(is_eq_context (data, x2.data));}

inline BOOL CONTEXT :: operator == (const CONTEXT & x2) const
{ return BOOL(is_eq_context (data, x2.data));}

inline BOOL CONTEXT :: operator != (const CONTEXT & x2) const
{ return BOOL((Bool)! is_eq_context (data, x2.data));}

/* === Member function 'copy' not required for automem implementations === */

/* Member function 'copy1' not required for automem implementations */

inline CONTEXT & CONTEXT :: chg_adttypes (const STRINGS & x2)
{ data = chg_adttypes_context (data, x2.data); return *this;}

inline CONTEXT & CONTEXT :: chg_special_impl (const STRINGS & x2)
{ data = chg_special_impl_context (data, x2.data); return *this;}

inline CONTEXT & CONTEXT :: chg_special_ops (const STRINGS & x2)
{ data = chg_special_ops_context (data, x2.data); return *this;}

inline CONTEXT & CONTEXT :: chg_filter_adts (const STRINGS & x2)
{ data = chg_filter_adts_context (data, x2.data); return *this;}

inline CONTEXT & CONTEXT :: chg_filter_impl (const STRINGS & x2)
{ data = chg_filter_impl_context (data, x2.data); return *this;}

inline CONTEXT & CONTEXT :: chg_filter_oper (const STRINGS & x2)
{ data = chg_filter_oper_context (data, x2.data); return *this;}

inline CONTEXT & CONTEXT :: chg_filter_comp (const STRINGS & x2)
{ data = chg_filter_comp_context (data, x2.data); return *this;}

inline CONTEXT & CONTEXT :: chg_filter_params (const STRINGS & x2)
{ data = chg_filter_params_context (data, x2.data); return *this;}

inline CONTEXT & CONTEXT :: chg_sign_comps (const STRINGS & x2)
{ data = chg_sign_comps_context (data, x2.data); return *this;}

inline CONTEXT & CONTEXT :: chg_operationtype (const STR & x2)
{ data = chg_operationtype_context (data, x2.data); return *this;}

inline CONTEXT :: CONTEXT
(

const STRINGS & x_adttypes_context
,
const STRINGS & x_special_impl_context
,
const STRINGS & x_special_ops_context
,
const STRINGS & x_filter_adts_context
,
const STRINGS & x_filter_impl_context
,
const STRINGS & x_filter_oper_context
,
const STRINGS & x_filter_comp_context
,
const STRINGS & x_filter_params_context
,
const STRINGS & x_sign_comps_context

,
const STR & x_operationtype_context

)
{ data = mk_context (

x_adttypes_context.data
,
x_special_impl_context.data
,
x_special_ops_context.data
,
x_filter_adts_context.data
,
x_filter_impl_context.data
,
x_filter_oper_context.data
,
x_filter_comp_context.data
,
x_filter_params_context.data
,
x_sign_comps_context.data

,
x_operationtype_context.data

);}

/* Member function 'del1' not required for automem implementations */

inline STRINGS CONTEXT :: adttypes () const
{ return STRINGS(s_adttypes_context (data));}

inline STRINGS CONTEXT :: special_impl () const
{ return STRINGS(s_special_impl_context (data));}

inline STRINGS CONTEXT :: special_ops () const
{ return STRINGS(s_special_ops_context (data));}

inline STRINGS CONTEXT :: filter_adts () const
{ return STRINGS(s_filter_adts_context (data));}

inline STRINGS CONTEXT :: filter_impl () const
{ return STRINGS(s_filter_impl_context (data));}

inline STRINGS CONTEXT :: filter_oper () const
{ return STRINGS(s_filter_oper_context (data));}

inline STRINGS CONTEXT :: filter_comp () const
{ return STRINGS(s_filter_comp_context (data));}

inline STRINGS CONTEXT :: filter_params () const
{ return STRINGS(s_filter_params_context (data));}

inline STRINGS CONTEXT :: sign_comps () const
{ return STRINGS(s_sign_comps_context (data));}

inline STR CONTEXT :: operationtype () const
{ return STR(s_operationtype_context (data));}

/* === Member function 'del' not required for automem implementations === */

class PAIR_OPERATION {
friend class OPERATION;
COMPNAME lx1;
COMPONENT lx2;
public:
PAIR_OPERATION(const COMPNAME & x1, const COMPONENT & x2)
: lx1(x1),lx2(x2)
{ }
};

inline BOOL OPERATION :: is_eq (const OPERATION & x2) const
{ return BOOL(is_eq_operation (data, x2.data));}

inline BOOL OPERATION :: operator == (const OPERATION & x2) const
{ return BOOL(is_eq_operation (data, x2.data));}

inline BOOL OPERATION :: operator != (const OPERATION & x2) const
{ return BOOL((Bool)! is_eq_operation (data, x2.data));}

/* === Member function 'del' not required for automem implementations === */

inline OPERATION :: OPERATION (const COMPNAME & x1, const COMPONENT & x2)
{ data = mk1_operation (x1.data, x2.data);}
inline NAT0 OPERATION :: card () const
{ return NAT0(card_operation (data));}

inline OPERATION & OPERATION :: sub1 (const COMPNAME & x2)
{ data = sub1_operation (data, x2.data); return *this;}

inline OPERATION & OPERATION :: operator -= (const COMPNAME & x2)
{ data = sub1_operation (data, x2.data); return *this;}

inline OPERATION OPERATION :: operator - (const COMPNAME & x2) const
{ OPERATION tmp=*this; tmp.data=sub1_operation(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline OPERATION & OPERATION :: ovwrt1 (const COMPNAME & x2, const COMPONENT & x3)
{ data = ovwrt1_operation (data, x2.data, x3.data); return *this;}

inline OPERATION & OPERATION :: operator += (const PAIR_OPERATION & x2)
{ data = ovwrt1_operation (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL OPERATION :: is_in_dom (const COMPNAME & x1, COMPONENT & x3) const
{ return BOOL(is_in_dom_operation (x1.data,data,&(x3.data)));}

inline OPERATION :: OPERATION (const NILETC & x1)
{ data = mk_empty_operation ();}
inline STRINGS OPERATION :: dom () const
{ return STRINGS(dom_operation (data));}

inline BOOL OPERATION :: is_empty () const
{ return BOOL(is_empty_operation (data));}

inline BOOL OPERATION :: operator ! () const
{ return BOOL(! is_empty_operation (data));}

inline COMPONENT OPERATION :: sel (const COMPNAME & x2) const
{ return COMPONENT(sel_operation (data, x2.data));}

inline COMPONENT OPERATION :: operator [] (const COMPNAME & x2) const
{ return COMPONENT(sel_operation (data,x2.data));}

inline OPERATION & OPERATION :: plus (const OPERATION & x2)
{ data = union_operation (data, x2.data); return *this;}

inline OPERATION & OPERATION :: operator |= (const OPERATION & x2)
{ data = union_operation (data, x2.data); return *this;}

inline OPERATION OPERATION :: operator | (const OPERATION & x2) const
{ OPERATION tmp=*this; tmp.data=union_operation(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline OPERATION & OPERATION :: ovwrt (const OPERATION & x2)
{ data = ovwrt_operation (data, x2.data); return *this;}

inline OPERATION & OPERATION :: operator += (const OPERATION & x2)
{ data = ovwrt_operation (data, x2.data); return *this;}

inline OPERATION OPERATION :: operator + (const OPERATION & x2) const
{ OPERATION tmp=*this; tmp.data=ovwrt_operation(tmp.data,x2.data); return tmp; }

inline OPERATION & OPERATION :: plus1 (const COMPNAME & x2, const COMPONENT & x3)
{ data = union1_operation (data, x2.data, x3.data); return *this;}

inline OPERATION & OPERATION :: operator |= (const PAIR_OPERATION & x2)
{ data = union1_operation (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL OPERATION :: is_in (const COMPNAME & x1) const
{ return BOOL(is_in_operation (x1.data, data));}
/* === Member function 'copy' not required for automem implementations === */
inline BOOL ITER_OPERATION :: is_empty ()
{ return BOOL(is_empty_iter_operation (&(data)));}

inline BOOL ITER_OPERATION :: operator ! ()
{ return BOOL(! is_empty_iter_operation (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_OPERATION :: ITER_OPERATION (OPERATION x1)
{ data = mk_iter_operation (x1.data);}
inline COMPNAME ITER_OPERATION :: sel (COMPONENT & x2)
{Component lx3; Compname lx2; del_component(x2.data); lx2 = sel_iter_operation(&data,&lx3); x2.data = copy_component(lx3); return lx2; }
inline void ITER_OPERATION :: next ()
{ next_iter_operation (&(data));}

inline void ITER_OPERATION :: operator ++ ()
{ next_iter_operation (&(data));}

inline void ITER_OPERATION :: operator ++ (int)
{ next_iter_operation (&(data));}

class PAIR_CONTEXTMAP {
friend class CONTEXTMAP;
INTG lx1;
CONTEXT lx2;
public:
PAIR_CONTEXTMAP(const INTG & x1, const CONTEXT & x2)
: lx1(x1),lx2(x2)
{ }
};

/* === Member function 'del' not required for automem implementations === */

inline CONTEXTMAP :: CONTEXTMAP (const INTG & x1, const CONTEXT & x2)
{ data = mk1_contextmap (x1.data, x2.data);}
inline NAT0 CONTEXTMAP :: card () const
{ return NAT0(card_contextmap (data));}

inline CONTEXTMAP & CONTEXTMAP :: sub1 (const INTG & x2)
{ data = sub1_contextmap (data, x2.data); return *this;}

inline CONTEXTMAP & CONTEXTMAP :: operator -= (const INTG & x2)
{ data = sub1_contextmap (data, x2.data); return *this;}

inline CONTEXTMAP CONTEXTMAP :: operator - (const INTG & x2) const
{ CONTEXTMAP tmp=*this; tmp.data=sub1_contextmap(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline CONTEXTMAP & CONTEXTMAP :: ovwrt1 (const INTG & x2, const CONTEXT & x3)
{ data = ovwrt1_contextmap (data, x2.data, x3.data); return *this;}

inline CONTEXTMAP & CONTEXTMAP :: operator += (const PAIR_CONTEXTMAP & x2)
{ data = ovwrt1_contextmap (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL CONTEXTMAP :: is_in_dom (const INTG & x1, CONTEXT & x3) const
{ return BOOL(is_in_dom_contextmap (x1.data,data,&(x3.data)));}

inline CONTEXTMAP :: CONTEXTMAP (const NILETC & x1)
{ data = mk_empty_contextmap ();}

inline BOOL CONTEXTMAP :: is_empty () const
{ return BOOL(is_empty_contextmap (data));}

inline BOOL CONTEXTMAP :: operator ! () const
{ return BOOL(! is_empty_contextmap (data));}

inline CONTEXT CONTEXTMAP :: sel (const INTG & x2) const
{ return CONTEXT(sel_contextmap (data, x2.data));}

inline CONTEXT CONTEXTMAP :: operator [] (const INTG & x2) const
{ return CONTEXT(sel_contextmap (data,x2.data));}

inline CONTEXTMAP & CONTEXTMAP :: plus (const CONTEXTMAP & x2)
{ data = union_contextmap (data, x2.data); return *this;}

inline CONTEXTMAP & CONTEXTMAP :: operator |= (const CONTEXTMAP & x2)
{ data = union_contextmap (data, x2.data); return *this;}

inline CONTEXTMAP CONTEXTMAP :: operator | (const CONTEXTMAP & x2) const
{ CONTEXTMAP tmp=*this; tmp.data=union_contextmap(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline CONTEXTMAP & CONTEXTMAP :: ovwrt (const CONTEXTMAP & x2)
{ data = ovwrt_contextmap (data, x2.data); return *this;}

inline CONTEXTMAP & CONTEXTMAP :: operator += (const CONTEXTMAP & x2)
{ data = ovwrt_contextmap (data, x2.data); return *this;}

inline CONTEXTMAP CONTEXTMAP :: operator + (const CONTEXTMAP & x2) const
{ CONTEXTMAP tmp=*this; tmp.data=ovwrt_contextmap(tmp.data,x2.data); return tmp; }

inline CONTEXTMAP & CONTEXTMAP :: plus1 (const INTG & x2, const CONTEXT & x3)
{ data = union1_contextmap (data, x2.data, x3.data); return *this;}

inline CONTEXTMAP & CONTEXTMAP :: operator |= (const PAIR_CONTEXTMAP & x2)
{ data = union1_contextmap (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL CONTEXTMAP :: is_in (const INTG & x1) const
{ return BOOL(is_in_contextmap (x1.data, data));}

class PAIR_IMPL {
friend class IMPL;
OPNAME lx1;
OPERATION lx2;
public:
PAIR_IMPL(const OPNAME & x1, const OPERATION & x2)
: lx1(x1),lx2(x2)
{ }
};

inline BOOL IMPL :: is_eq (const IMPL & x2) const
{ return BOOL(is_eq_impl (data, x2.data));}

inline BOOL IMPL :: operator == (const IMPL & x2) const
{ return BOOL(is_eq_impl (data, x2.data));}

inline BOOL IMPL :: operator != (const IMPL & x2) const
{ return BOOL((Bool)! is_eq_impl (data, x2.data));}

/* === Member function 'del' not required for automem implementations === */

inline IMPL :: IMPL (const OPNAME & x1, const OPERATION & x2)
{ data = mk1_impl (x1.data, x2.data);}
inline NAT0 IMPL :: card () const
{ return NAT0(card_impl (data));}

inline IMPL & IMPL :: sub1 (const OPNAME & x2)
{ data = sub1_impl (data, x2.data); return *this;}

inline IMPL & IMPL :: operator -= (const OPNAME & x2)
{ data = sub1_impl (data, x2.data); return *this;}

inline IMPL IMPL :: operator - (const OPNAME & x2) const
{ IMPL tmp=*this; tmp.data=sub1_impl(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline IMPL & IMPL :: ovwrt1 (const OPNAME & x2, const OPERATION & x3)
{ data = ovwrt1_impl (data, x2.data, x3.data); return *this;}

inline IMPL & IMPL :: operator += (const PAIR_IMPL & x2)
{ data = ovwrt1_impl (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL IMPL :: is_in_dom (const OPNAME & x1, OPERATION & x3) const
{ return BOOL(is_in_dom_impl (x1.data,data,&(x3.data)));}

inline IMPL :: IMPL (const NILETC & x1)
{ data = mk_empty_impl ();}
inline STRINGS IMPL :: dom () const
{ return STRINGS(dom_impl (data));}

inline BOOL IMPL :: is_empty () const
{ return BOOL(is_empty_impl (data));}

inline BOOL IMPL :: operator ! () const
{ return BOOL(! is_empty_impl (data));}

inline OPERATION IMPL :: sel (const OPNAME & x2) const
{ return OPERATION(sel_impl (data, x2.data));}

inline OPERATION IMPL :: operator [] (const OPNAME & x2) const
{ return OPERATION(sel_impl (data,x2.data));}

inline IMPL & IMPL :: plus (const IMPL & x2)
{ data = union_impl (data, x2.data); return *this;}

inline IMPL & IMPL :: operator |= (const IMPL & x2)
{ data = union_impl (data, x2.data); return *this;}

inline IMPL IMPL :: operator | (const IMPL & x2) const
{ IMPL tmp=*this; tmp.data=union_impl(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline IMPL & IMPL :: ovwrt (const IMPL & x2)
{ data = ovwrt_impl (data, x2.data); return *this;}

inline IMPL & IMPL :: operator += (const IMPL & x2)
{ data = ovwrt_impl (data, x2.data); return *this;}

inline IMPL IMPL :: operator + (const IMPL & x2) const
{ IMPL tmp=*this; tmp.data=ovwrt_impl(tmp.data,x2.data); return tmp; }

inline IMPL & IMPL :: plus1 (const OPNAME & x2, const OPERATION & x3)
{ data = union1_impl (data, x2.data, x3.data); return *this;}

inline IMPL & IMPL :: operator |= (const PAIR_IMPL & x2)
{ data = union1_impl (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL IMPL :: is_in (const OPNAME & x1) const
{ return BOOL(is_in_impl (x1.data, data));}
/* === Member function 'copy' not required for automem implementations === */
inline BOOL ITER_CONTEXTMAP :: is_empty ()
{ return BOOL(is_empty_iter_contextmap (&(data)));}

inline BOOL ITER_CONTEXTMAP :: operator ! ()
{ return BOOL(! is_empty_iter_contextmap (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_CONTEXTMAP :: ITER_CONTEXTMAP (CONTEXTMAP x1)
{ data = mk_iter_contextmap (x1.data);}
inline INTG ITER_CONTEXTMAP :: sel (CONTEXT & x2)
{Context lx3; Intg lx2; del_context(x2.data); lx2 = sel_iter_contextmap(&data,&lx3); x2.data = copy_context(lx3); return lx2; }
inline void ITER_CONTEXTMAP :: next ()
{ next_iter_contextmap (&(data));}

inline void ITER_CONTEXTMAP :: operator ++ ()
{ next_iter_contextmap (&(data));}

inline void ITER_CONTEXTMAP :: operator ++ (int)
{ next_iter_contextmap (&(data));}
inline BOOL ITER_IMPL :: is_empty ()
{ return BOOL(is_empty_iter_impl (&(data)));}

inline BOOL ITER_IMPL :: operator ! ()
{ return BOOL(! is_empty_iter_impl (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_IMPL :: ITER_IMPL (IMPL x1)
{ data = mk_iter_impl (x1.data);}
inline OPNAME ITER_IMPL :: sel (OPERATION & x2)
{Operation lx3; Opname lx2; del_operation(x2.data); lx2 = sel_iter_impl(&data,&lx3); x2.data = copy_operation(lx3); return lx2; }
inline void ITER_IMPL :: next ()
{ next_iter_impl (&(data));}

inline void ITER_IMPL :: operator ++ ()
{ next_iter_impl (&(data));}

inline void ITER_IMPL :: operator ++ (int)
{ next_iter_impl (&(data));}

class PAIR_ADT {
friend class ADT;
IMPLNAME lx1;
IMPL lx2;
public:
PAIR_ADT(const IMPLNAME & x1, const IMPL & x2)
: lx1(x1),lx2(x2)
{ }
};

inline BOOL ADT :: is_eq (const ADT & x2) const
{ return BOOL(is_eq_adt (data, x2.data));}

inline BOOL ADT :: operator == (const ADT & x2) const
{ return BOOL(is_eq_adt (data, x2.data));}

inline BOOL ADT :: operator != (const ADT & x2) const
{ return BOOL((Bool)! is_eq_adt (data, x2.data));}

/* === Member function 'del' not required for automem implementations === */

inline ADT :: ADT (const IMPLNAME & x1, const IMPL & x2)
{ data = mk1_adt (x1.data, x2.data);}
inline NAT0 ADT :: card () const
{ return NAT0(card_adt (data));}

inline ADT & ADT :: sub1 (const IMPLNAME & x2)
{ data = sub1_adt (data, x2.data); return *this;}

inline ADT & ADT :: operator -= (const IMPLNAME & x2)
{ data = sub1_adt (data, x2.data); return *this;}

inline ADT ADT :: operator - (const IMPLNAME & x2) const
{ ADT tmp=*this; tmp.data=sub1_adt(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline ADT & ADT :: ovwrt1 (const IMPLNAME & x2, const IMPL & x3)
{ data = ovwrt1_adt (data, x2.data, x3.data); return *this;}

inline ADT & ADT :: operator += (const PAIR_ADT & x2)
{ data = ovwrt1_adt (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL ADT :: is_in_dom (const IMPLNAME & x1, IMPL & x3) const
{ return BOOL(is_in_dom_adt (x1.data,data,&(x3.data)));}

inline ADT :: ADT (const NILETC & x1)
{ data = mk_empty_adt ();}
inline STRINGS ADT :: dom () const
{ return STRINGS(dom_adt (data));}

inline BOOL ADT :: is_empty () const
{ return BOOL(is_empty_adt (data));}

inline BOOL ADT :: operator ! () const
{ return BOOL(! is_empty_adt (data));}

inline IMPL ADT :: sel (const IMPLNAME & x2) const
{ return IMPL(sel_adt (data, x2.data));}

inline IMPL ADT :: operator [] (const IMPLNAME & x2) const
{ return IMPL(sel_adt (data,x2.data));}

inline ADT & ADT :: plus (const ADT & x2)
{ data = union_adt (data, x2.data); return *this;}

inline ADT & ADT :: operator |= (const ADT & x2)
{ data = union_adt (data, x2.data); return *this;}

inline ADT ADT :: operator | (const ADT & x2) const
{ ADT tmp=*this; tmp.data=union_adt(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline ADT & ADT :: ovwrt (const ADT & x2)
{ data = ovwrt_adt (data, x2.data); return *this;}

inline ADT & ADT :: operator += (const ADT & x2)
{ data = ovwrt_adt (data, x2.data); return *this;}

inline ADT ADT :: operator + (const ADT & x2) const
{ ADT tmp=*this; tmp.data=ovwrt_adt(tmp.data,x2.data); return tmp; }

inline ADT & ADT :: plus1 (const IMPLNAME & x2, const IMPL & x3)
{ data = union1_adt (data, x2.data, x3.data); return *this;}

inline ADT & ADT :: operator |= (const PAIR_ADT & x2)
{ data = union1_adt (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL ADT :: is_in (const IMPLNAME & x1) const
{ return BOOL(is_in_adt (x1.data, data));}
/* === Member function 'copy' not required for automem implementations === */
inline BOOL ITER_ADT :: is_empty ()
{ return BOOL(is_empty_iter_adt (&(data)));}

inline BOOL ITER_ADT :: operator ! ()
{ return BOOL(! is_empty_iter_adt (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_ADT :: ITER_ADT (ADT x1)
{ data = mk_iter_adt (x1.data);}
inline IMPLNAME ITER_ADT :: sel (IMPL & x2)
{Impl lx3; Implname lx2; del_impl(x2.data); lx2 = sel_iter_adt(&data,&lx3); x2.data = copy_impl(lx3); return lx2; }
inline void ITER_ADT :: next ()
{ next_iter_adt (&(data));}

inline void ITER_ADT :: operator ++ ()
{ next_iter_adt (&(data));}

inline void ITER_ADT :: operator ++ (int)
{ next_iter_adt (&(data));}

class PAIR_VDMDB {
friend class VDMDB;
ADTNAME lx1;
ADT lx2;
public:
PAIR_VDMDB(const ADTNAME & x1, const ADT & x2)
: lx1(x1),lx2(x2)
{ }
};

/* === Member function 'del' not required for automem implementations === */

inline VDMDB :: VDMDB (const ADTNAME & x1, const ADT & x2)
{ data = mk1_vdmdb (x1.data, x2.data);}
inline NAT0 VDMDB :: card () const
{ return NAT0(card_vdmdb (data));}

inline VDMDB & VDMDB :: sub1 (const ADTNAME & x2)
{ data = sub1_vdmdb (data, x2.data); return *this;}

inline VDMDB & VDMDB :: operator -= (const ADTNAME & x2)
{ data = sub1_vdmdb (data, x2.data); return *this;}

inline VDMDB VDMDB :: operator - (const ADTNAME & x2) const
{ VDMDB tmp=*this; tmp.data=sub1_vdmdb(tmp.data,x2.data); return tmp; }

/* Member function 'copy1' not required for automem implementations */

inline VDMDB & VDMDB :: ovwrt1 (const ADTNAME & x2, const ADT & x3)
{ data = ovwrt1_vdmdb (data, x2.data, x3.data); return *this;}

inline VDMDB & VDMDB :: operator += (const PAIR_VDMDB & x2)
{ data = ovwrt1_vdmdb (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL VDMDB :: is_in_dom (const ADTNAME & x1, ADT & x3) const
{ return BOOL(is_in_dom_vdmdb (x1.data,data,&(x3.data)));}

inline VDMDB :: VDMDB (const NILETC & x1)
{ data = mk_empty_vdmdb ();}

inline OUTBYTES VDMDB :: cvtotupl ()
{ return OUTBYTES(cvtotupl_vdmdb (data));}

inline STRINGS VDMDB :: dom () const
{ return STRINGS(dom_vdmdb (data));}

inline VDMDB & VDMDB :: cvfromtupl (INBYTES & x1)
{del_vdmdb(data);
{ data = cvfromtupl_vdmdb (x1.data);x1.data=0 ; return *this;}}

inline BOOL VDMDB :: is_empty () const
{ return BOOL(is_empty_vdmdb (data));}

inline BOOL VDMDB :: operator ! () const
{ return BOOL(! is_empty_vdmdb (data));}

inline ADT VDMDB :: sel (const ADTNAME & x2) const
{ return ADT(sel_vdmdb (data, x2.data));}

inline ADT VDMDB :: operator [] (const ADTNAME & x2) const
{ return ADT(sel_vdmdb (data,x2.data));}

inline VDMDB & VDMDB :: plus (const VDMDB & x2)
{ data = union_vdmdb (data, x2.data); return *this;}

inline VDMDB & VDMDB :: operator |= (const VDMDB & x2)
{ data = union_vdmdb (data, x2.data); return *this;}

inline VDMDB VDMDB :: operator | (const VDMDB & x2) const
{ VDMDB tmp=*this; tmp.data=union_vdmdb(tmp.data,x2.data); return tmp; }

/* Member function 'del1' not required for automem implementations */

inline VDMDB & VDMDB :: ovwrt (const VDMDB & x2)
{ data = ovwrt_vdmdb (data, x2.data); return *this;}

inline VDMDB & VDMDB :: operator += (const VDMDB & x2)
{ data = ovwrt_vdmdb (data, x2.data); return *this;}

inline VDMDB VDMDB :: operator + (const VDMDB & x2) const
{ VDMDB tmp=*this; tmp.data=ovwrt_vdmdb(tmp.data,x2.data); return tmp; }

inline VDMDB & VDMDB :: plus1 (const ADTNAME & x2, const ADT & x3)
{ data = union1_vdmdb (data, x2.data, x3.data); return *this;}

inline VDMDB & VDMDB :: operator |= (const PAIR_VDMDB & x2)
{ data = union1_vdmdb (data, x2.lx1.data, x2.lx2.data); return *this;}

inline BOOL VDMDB :: is_in (const ADTNAME & x1) const
{ return BOOL(is_in_vdmdb (x1.data, data));}
inline BOOL ITER_VDMDB :: is_empty ()
{ return BOOL(is_empty_iter_vdmdb (&(data)));}

inline BOOL ITER_VDMDB :: operator ! ()
{ return BOOL(! is_empty_iter_vdmdb (&(data)));}

/* === Member function 'del' not required for automem implementations === */

inline ITER_VDMDB :: ITER_VDMDB (VDMDB x1)
{ data = mk_iter_vdmdb (x1.data);}
inline ADTNAME ITER_VDMDB :: sel (ADT & x2)
{Adt lx3; Adtname lx2; del_adt(x2.data); lx2 = sel_iter_vdmdb(&data,&lx3); x2.data = copy_adt(lx3); return lx2; }
inline void ITER_VDMDB :: next ()
{ next_iter_vdmdb (&(data));}

inline void ITER_VDMDB :: operator ++ ()
{ next_iter_vdmdb (&(data));}

inline void ITER_VDMDB :: operator ++ (int)
{ next_iter_vdmdb (&(data));}

/* ------- PHASEEND ------------------ */

#endif
