# $Id: control.tcl,v 1.1 1996/09/05 07:03:38 vdm Exp $

# global defaultdatabase
# global databaseloaded
# global status_serverRPCup

proc control_status {} {
    global defaultdatabase
    global databaseloaded
    global status_serverRPCup
    global status_serverTELNETup

    puts "VDM Database Server Configuration\n"
    puts "RPC Server Status: [expr $status_serverRPCup?"up":"down"]"
    puts "TELNET Server Status: [expr $status_serverTELNETup?"up":"down"]"
    puts "defaultdatabase: $defaultdatabase"
    puts "databaseloaded: $databaseloaded"
}

proc control {} {
    while {1} {
	puts "\nVDM Database Server Control"
	puts "1...Server Configuration"
	puts "2...Server Status"
	puts "3...Start RPC Server"
	puts "4...Stop RPC Server"	 
	puts "5...Start TELNET Server"
	puts "6...Stop TELNET Server"
	puts "q...Exit"
	puts -nonewline "Choice: "
	gets stdin x
	switch $x {
	    1 { exec more -10 << [config_info] }
	    2 { control_status }
	    3 { server_RPCInit 4711 }
	    4 { server_RPCDown }
	    5 { server_TELNETInit 4713 }
	    6 { server_TELNETDown }
	    q break
	}
    }
}
