# $Id: language.tcl,v 1.1 1996/09/05 07:03:40 vdm Exp $

global language
set language "A++"

proc language_init {} {
    setlanguage "C"
}

proc setlanguage lang {
    global language
    set language [string toupper "$lang"]
    switch $language {
	C {}
	C\+\+ {}
	A\+\+ {}
	default { set language "C" }
    }
    operationtype1 $language

    select adttypes
    select adttypes REAL
    select specialimpl
    select specialimpl com sign aux
    select specialops
    select specialops basic rename signature gcinfo automemresult
    select specialops cvfromtup1 cvtotup1 mk_one mkn__empty mfold

    if {"$language"=="C"} {
    } else {
	select specialops domresby domresto ranresby ranresto
    }
    if {"$language"=="C++"} { }
    if {"$language"=="A++"} {
	select specialimpl automem ptr heap heapmap
	select specialops copy copy1 del del1
	select specialops diffd intersd sub1alld sub1d sub1nd subd
	select specialops union1d union1nd uniond ovwrt1d ovwrtd
    }
}
