# loaddb.tcl,v 1.3 1994/07/15 13:44:31 vdm Exp
# loaddb command with argument check
# if flat database implemetation file <db>.s is searched
# otherwise directory <db> is used

proc loaddb {{db ""}} {
  global env databaseloaded defaultdatabase

  if [string compare $db ""]==0 { set db $databaseloaded }

  if [string compare $db ""]==0 { set db $defaultdatabase }

  if [string compare [databaseimplementation] flat]==0 {
     if [file readable $db.s]==0 { error "VDM database file \"$db.s\" not found" }
     loaddatabase "$db.s"
  } else {
     if [file isdirectory $db]==0 { error "VDM database directory \"$db\" not found" }
     loaddatabase $db
  }

  set databaseloaded $db
}
