
# vdmdbmtext.tcl,v 1.5 1995/02/01 11:40:58 vdm Exp

proc vdmdbmtext { } {
    MessageBox "
VDM Class Library Database Browser

The left list titled \"ADT\" shows the names of the \
abstract datatype directory. Select one of the entries by a left button \
double click of the mouse. The selected \"ADT\" is shown in the label field \
at the top of the list.

The list in the second place titled \"Implementations\" will then \
show the implementations directory for the selected ADT. Select \
one of these Implementations by a left button double click \
of the mouse. The selected implementation is shown in the label field \
at the top of the list.

The third list titled \"Operations\" shows the operations \
directory for the selected implementation. When selecting one of them \
by a left button double click, the list of components will \
appear in the right row. The selected operation is shown in the label field \
at the top of the list.

The right list titled \"Components\" shows the components of an operation. \
A component can be again \
selected by a double click. The selected component is shown in the label field \
at the top of the list.

To leave the browser or any subwindow, \
click at the \"ok\" button.
" "ok" "VDM DB Help" "120"
}

# -------------------------------------------------------------------------------

proc vdmdbmtextDatabase { } {
    MessageBox "
Database Menue

\"Export to file\"
export the currently loaded database into a flat file \
representation, the currently used format is a shell script with inline \
documents for the components.

\"Import from file\"
inverse operation to \"export to file\", all components given in the shell script \
as inline documents are loaded into the database, all existing components are \
overwritten.

\"Load database\"
load a new database, if another database is already loaded, it is discarded before \
loading the new one.

\"Store database\"
stores the currently loaded database into a file, the filename is \
automatically extended with the suffix \".s\".

\"Clear database\"
the currently loaded database is discarded.

\"Database loaded\"
shows the filename of the currently loaded database.

\"Quit\"
exit VDM Database Manager.
" "ok" "VDM DB Help" "120"
}

# -------------------------------------------------------------------------------

proc vdmdbmtextADTs { } {
   MessageBox "
ADTs Menue

\"Export ADT\"
exports the components of the currently selected ADT to a flat file, \
the flat file format is the same as in \"Export database\". For global \
changes in the sources of an ADT, e.g. renaming, editing can be done with \
the flat file and the changed components can be imported with \"Import from file\".

\"New ADT\"
creates a new ADT.

\"Remove ADT\"
deletes the currently selected ADT inclusive all implementations, \
operations and components.
" "ok" "VDM DB Help" "120"
}

# -------------------------------------------------------------------------------

proc vdmdbmtextImpl { } {
   MessageBox "
Implementations Menu

\"Export implementation\"
exports the components of the currently selected ADT and implementation to a flat \
file (like \"Export ADT\").

\"Export implementation for all ADTs\"
exports the components of the currently selected implementation for all ADTs to a flat \
file.

\"New implementation\"
creates a new implementation for the currently selected ADT.

\"Remove implementation\"
deletes the selected implementation for the currently selected ADT.

" "ok" "VDM DB Help" "120"
}

# -------------------------------------------------------------------------------

proc vdmdbmtextOper { } {
   MessageBox "          
Operations Menu

\"Export operation\"
exports the components of the currently selected operation to a flat file \
(like \"Export implementation\").

\"export operation for all Implementations\"
exports the components of the currently selected operation of all \
implementations to a flat file.

\"export operation for all ADTs\"
exports the components of the currently selected operation of all \
implementations of all ADTs to a flat file.

\"New operation\"
creates a new operation for the currently selected ADT and implementation.

\"Remove operation\"
deletes the selected operation for the currently selected ADT and implementation.
" "ok" "VDM DB Help" "120"                                         
}                         

# -------------------------------------------------------------------------------

proc vdmdbmtextComp { } {
   MessageBox "          
Components Menu

\"Export component\"
exports the currently selected component to a flat file \
(like \"Export operation\").

\"eDit component\"
takes the currently selected component, writes it to a tmpfile and calls \
an editor with that tmpfile. If the environment variable \"EDITOR\" is set, \
it determines the called editor, else \"xedit\" is taken. \
When editing is finished and the tmpfile has been changed, \
the component is read into the database.

\"New component\"
creates a new component for the currently selected ADT, implementation and \
operation.

\"Remove component\"
deletes the currently selected component.
" "ok" "VDM DB Help" "120"                                                       
}                         

# -------------------------------------------------------------------------------

