#!/bin/sh

if [ -z $VDMROOT ] 
then
	echo "VDMROOT environment var not set !"
	exit 1
fi

echo "edit wish path in tk scripts"
WISH=`whereis wish | cut -d' ' -f2` 
if [ "$WISH" != "wish:" ] 
then	for i in bin/vdmhelp bin/vdmdbm 
	do 
		echo $i
		sed 's|^#!/usr.*/wish -f|#!'"$WISH"' -f|' $i > $i.inst 
		rm -f $i
		mv $i.inst $i
		chmod +x $i
	done 
else 
	echo "can't find wish" 
	exit 1 
fi 
echo ok

echo "edit tclsh path in dbmc script"
TCLSH=`whereis tclsh | cut -d' ' -f2` 
if [ "$TCLSH" != "tclsh:" ] 
then	for i in bin/dbmc lib/vdm/dbmc 
	do 
		sed 's|^exec /usr.*/tclsh |exec '"$TCLSH"' |' $i > $i.inst
		rm -f $i 
		mv $i.inst $i
		chmod +x $i
	done 
else 
	echo "can't find tclsh" 
	exit 1 
fi 

echo ok
echo "make tclIndex"
cd $VDMROOT/lib/vdm
echo "auto_mkindex . *tcl" |tclsh 
echo ok

