#ifndef SEMOTH_H
#define SEMOTH_H

#include "semantic.hpp"
#include "semaux.hpp"

extern nat0 inv_init(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt);

extern nat0 inv_pattern(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt);

extern nat0 val_def(const nodeseq & terms,
	     node * adr, const parse_typ & t_akt);

extern nat0 expression_list1(const nodeseq & terms,
		     node * adr, const parse_typ & t_akt);

extern nat0 expression_list2(const nodeseq & terms,
		     node * adr, const parse_typ & t_akt);

extern nat0 expression(const nodeseq & terms,
		node * adr, const parse_typ & t_akt);

extern nat0 let_expression(const nodeseq & terms,
		    node * adr, const parse_typ & t_akt);

extern nat0 let_be_expression(const nodeseq & terms,
		    node * adr, const parse_typ & t_akt);

extern nat0 loc_def_list(const nodeseq & terms,
		  node * adr, const parse_typ & t_akt);

extern nat0 if_expression(const nodeseq & terms,
		   node * adr, const parse_typ & t_akt);

extern nat0 elseif_list(const nodeseq & terms,
		 node * adr, const parse_typ & t_akt);

extern nat0 elseif_expression(const nodeseq & terms,
		       node * adr, const parse_typ & t_akt);

extern nat0 cases_expression(const nodeseq & terms,
		      node * adr, const parse_typ & t_akt);

extern nat0 alternatives(const nodeseq & terms,
		  node * adr, const parse_typ & t_akt);

extern nat0 alternative(const nodeseq & terms,
		 node * adr, const parse_typ & t_akt);

extern nat0 all_expression(const nodeseq & terms,
		    node * adr, const parse_typ & t_akt);

extern nat0 exist_expression(const nodeseq & terms,
		      node * adr, const parse_typ & t_akt);

extern nat0 exist1_expression(const nodeseq & terms,
		       node * adr, const parse_typ & t_akt);

extern nat0 iota_expression(const nodeseq & terms,
		     node * adr, const parse_typ & t_akt);

extern nat0 set_enum(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt);

extern nat0 set_comp(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt);

extern nat0 set_range(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt);

extern nat0 seq_enum(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt);

extern nat0 seq_comp(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt);

extern nat0 subseq(const nodeseq & terms,
	    node * adr, const parse_typ & t_akt);

extern nat0 map_enum(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt);

extern nat0 maplet_list(const nodeseq & terms,
		 node * adr, const parse_typ & t_akt);

extern nat0 maplet(const nodeseq & terms,
	    node * adr, const parse_typ & t_akt);

extern nat0 map_comp(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt);

extern nat0 tuple(const nodeseq & terms,
	   node * adr, const parse_typ & t_akt);

extern nat0 record(const nodeseq & terms,
	   node * adr, const parse_typ & t_akt);

extern nat0 record_mod(const nodeseq & terms,
		node * adr, const parse_typ & t_akt);

extern nat0 recmod_list(const nodeseq & terms,
		 node * adr, const parse_typ & t_akt);

extern nat0 rec_mod(const nodeseq & terms,
	     node * adr, const parse_typ & t_akt);

extern nat0 apply(const nodeseq & terms,
	   node * adr, const parse_typ & t_akt);

extern nat0 field_sel(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt);

extern nat0 type_inst(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt);

extern nat0 type_list(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt);

extern nat0 lambda_expression(const nodeseq & terms,
		       node * adr, const parse_typ & t_akt);

extern nat0 is_expression1(const nodeseq & terms,
		   node * adr, const parse_typ & t_akt);

extern nat0 is_expression2(const nodeseq & terms,
		   node * adr, const parse_typ & t_akt);

#endif