#ifndef SEMTYPES_H
#define SEMTYPES_H

#include "semantic.hpp"
#include "semaux.hpp"

extern nat0 type_definition1(const nodeseq & terms,
		      node * adr, const parse_typ & t_akt);

extern nat0 type_definition2(const nodeseq & terms,
		      node * adr, const parse_typ & t_akt);

extern nat0 quote_type(const nodeseq & terms,
		node * adr, const parse_typ & t_akt);

extern nat0 composite_type(const nodeseq & terms,
		    node * adr, const parse_typ & t_akt);

extern nat0 field_list1(const nodeseq & terms,
		 node * adr, const parse_typ & t_akt);

extern nat0 field_list2(const nodeseq & terms,
		 node * adr, const parse_typ & t_akt);

extern nat0 field_list3(const nodeseq & terms,
		 node * adr, const parse_typ & t_akt);

extern nat0 field(const nodeseq & terms,
	   node * adr, const parse_typ & t_akt);

extern nat0 union_type1(const nodeseq & terms,
		 node * adr, const parse_typ & t_akt);

extern nat0 union_type2(const nodeseq & terms,
		 node * adr, const parse_typ & t_akt);

extern nat0 product_type1(const nodeseq & terms,
		   node * adr, const parse_typ & t_akt);

extern nat0 product_type2(const nodeseq & terms,
		   node * adr, const parse_typ & t_akt);

extern nat0 optional_type(const nodeseq & terms,
		   node * adr, const parse_typ & t_akt);

extern nat0 set_type(const nodeseq & terms,
	      node * adr, const parse_typ & t_akt);

extern nat0 seq_type1(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt);

extern nat0 seq_type2(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt);

extern nat0 general_map_type(const nodeseq & terms,
		      node * adr, const parse_typ & t_akt);

extern nat0 injective_map_type(const nodeseq & terms,
			node * adr, const parse_typ & t_akt);

extern nat0 partial_function_type1(const nodeseq & terms,
			    node * adr, const parse_typ & t_akt);

extern nat0 partial_function_type2(const nodeseq & terms,
			    node * adr, const parse_typ & t_akt);

extern nat0 total_function_type1(const nodeseq & terms,
			  node * adr, const parse_typ & t_akt);

extern nat0 total_function_type2(const nodeseq & terms,
			  node * adr, const parse_typ & t_akt);

extern nat0 type_name(const nodeseq & terms,
	       node * adr, const parse_typ & t_akt);

extern nat0 type_variable(const nodeseq & terms,
		   node * adr, const parse_typ & t_akt);

#endif