#include "typesrec.hpp"
extern bool VDM_TRACE;

types::types(const types & t)
{
 operator = (t);
}

nat0 types::pop(bool nur_id)
{
 if (VDM_TRACE) cout << "\n-------------------\nlsche Level\n\n";
 if (nur_id)
 {
  if (ts.len() > 0)
  {
   for(nat0 i = len(); i > ts.get(ts.len()); i--)
   {
    if(get(i).tk == T_ID)
     get(i).tn = get(i).tk;
   }
  }
 }
 else
 {
  if (ts.len() > 0)
  {
   while(len() > ts.get(ts.len()))
     del(len());
  }
 }
 return ts.del(ts.len());
}

nat0 types::add(const nat0seq & ns, const t_typ & t,
		const nat0 & s, node * adr, const short & st)
{
 return typeseq::add(typerec(ns,t,s,adr,st));
}

nat0 types::put(const nat0 & i, const nat0seq & ns, const t_typ & t,
		const nat0 & s, node * adr, const short & st)
{
 return 0;
}

t_typ types::seek(const String & s)
{
 nat0 i = len();
 while(i > 0)
 {
  if((LEXEMS.get(get(i).tn) == s) && (get(i).tk != T_FIELD))
  {
//   if (tk.get(i) == T_ID) return (t_typ)i;    // vorhandener Typname
//   else if(tk.get(i) == T_COMP) return T_COMP; // vorhandenes tag-field
   return (t_typ)i;    // vorhandener Typname oder Tagfield
  }
  i--;
 }
 return UNKNOWN;
}

t_typ types::seektag(const String & s)
{
 nat0 i = len();
 while(i > 0)
 {
  if((LEXEMS.get(get(i).tn) == s) && (get(i).tk == T_COMP))
   return (t_typ)i;    // vorhandenes Tagfield
  i--;
 }
 return UNKNOWN;
}

t_typ types::seekid(const String & s)
{
 nat0 i = len();
 while(i > 0)
 {
  if((LEXEMS.get(get(i).tn) == s) && (get(i).tk == T_ID))
   return (t_typ)i;    // vorhandener Typname
  i--;
 }
 return UNKNOWN;
}

t_typ types::layer_seek(const String & s)
{
 nat0 i = len();
 while(i > ts.get(ts.len()))
 {
  if(LEXEMS.get(get(i).tn) == s)
  {
//   if (tk.get(i) == T_ID) return (t_typ)i;    // vorhandener Typname
//   else if(tk.get(i) == T_COMP) return T_COMP; // vorhandenes tag-field
   return (t_typ)i;    // vorhandener Typname oder Tagfield
  }
  i--;
 }
 return UNKNOWN;
}

types & types::operator = (const types & t)
{
 typeseq::operator = (t);
 ts = t.ts;
 return *this;
}
bool types::operator == (const types & t)
{
 return bool((*this == t) && (ts == t.ts));
}
bool types::operator != (const types & t)
{
 return bool(!(operator == (t)));
}
